(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    266624,       8022]
NotebookOptionsPosition[    264392,       7945]
NotebookOutlinePosition[    264740,       7960]
CellTagsIndexPosition[    264697,       7957]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"Get", "[", 
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
    "\"\<PolyLogToolsLite.m\>\""}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.6975618189424686`*^9, 3.697561823181487*^9}, 
   3.69760437515477*^9, {3.697611715649382*^9, 3.6976117160556364`*^9}, {
   3.6976155302123637`*^9, 3.697615531806689*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Using", " ", "a", " ", "pattern", " ", "to", " ", "make", " ", "a", " ", 
    "pattern", " ", "not", " ", "a", " ", 
    RowBox[{
     RowBox[{"pattern", "!"}], "?"}]}], "*)"}], 
  RowBox[{
   RowBox[{
    RowBox[{"lhsRule", "[", 
     RowBox[{"RuleDelayed", "[", 
      RowBox[{"lhs_", ",", "rhs_"}], "]"}], "]"}], ":=", 
    RowBox[{"lhs", "/.", 
     RowBox[{
      RowBox[{"HoldPattern", "[", "w_Pattern", "]"}], "\[RuleDelayed]", 
      RowBox[{"w", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}]}]}], "\n", 
   RowBox[{
    RowBox[{"rhsRule", "[", 
     RowBox[{"RuleDelayed", "[", 
      RowBox[{"lhs_", ",", "rhs_"}], "]"}], "]"}], ":=", 
    RowBox[{"Expand", "[", "rhs", "]"}]}], "\[IndentingNewLine]", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"ruleToIdentity", "[", "expr_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"lhsRule", "[", "expr", "]"}], "-", 
       RowBox[{"rhsRule", "[", "expr", "]"}]}], "//", "Expand"}]}], 
    ";"}]}]}]], "Input",
 CellChangeTimes->{{3.6975998566124477`*^9, 3.697599856628066*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"cr", "[", 
    RowBox[{"{", 
     RowBox[{"a_", ",", "b_", ",", "c_", ",", "d_"}], "}"}], "]"}], " ", ":=",
    " ", 
   RowBox[{"Limit", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a", " ", "-", " ", "c"}], ")"}], "/", 
       RowBox[{"(", 
        RowBox[{"a", " ", "-", " ", "d"}], ")"}]}], " ", "/", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"b", " ", "-", " ", "c"}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"b", "-", "d"}], ")"}]}], ")"}]}], ",", " ", 
     RowBox[{"Inf", "\[Rule]", "Infinity"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"cr", "[", "l_List", "]"}], " ", ":=", " ", 
   RowBox[{"Sequence", "@@", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"cr", "[", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{"l", "[", 
           RowBox[{"[", 
            RowBox[{"1", ";;", "3"}], "]"}], "]"}], ",", " ", 
          RowBox[{"{", "#", "}"}]}], "]"}], "]"}], "&"}], "/@", 
      RowBox[{"l", "[", 
       RowBox[{"[", 
        RowBox[{"4", ";;", "All"}], "]"}], "]"}]}], ")"}]}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.6975619746562567`*^9, 3.6975620142885017`*^9}, {
  3.6975620983564434`*^9, 3.6975621036729717`*^9}, {3.697562161927788*^9, 
  3.6975621760368257`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"II", "[", 
    RowBox[{"indices_List", ",", "arguments_List"}], "]"}], "/;", 
   RowBox[{
    RowBox[{
     RowBox[{"Length", "[", "indices", "]"}], "\[Equal]", 
     RowBox[{"Length", "[", "arguments", "]"}]}], "&&", 
    RowBox[{"VectorQ", "[", 
     RowBox[{"indices", ",", 
      RowBox[{
       RowBox[{
        RowBox[{"IntegerQ", "[", "#", "]"}], "&&", 
        RowBox[{"#", "\[GreaterEqual]", "1"}]}], "&"}]}], "]"}]}]}], ":=", 
  RowBox[{"G", "@@", 
   RowBox[{"Flatten", "[", 
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{"0", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"indices", "[", 
               RowBox[{"[", "j", "]"}], "]"}], "-", "1"}], "}"}]}], "]"}], 
          ",", 
          RowBox[{"{", 
           RowBox[{"arguments", "[", 
            RowBox[{"[", "j", "]"}], "]"}], "}"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", 
          RowBox[{"Length", "[", "indices", "]"}], ",", "1", ",", 
          RowBox[{"-", "1"}]}], "}"}]}], "]"}], ",", 
      RowBox[{"{", "1", "}"}]}], "]"}], "]"}]}]}]], "Input"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"--", 
    RowBox[{"--", " ", "check"}]}], " ", "the", " ", "I31", " ", "functional",
    " ", "equations", " ", "from", " ", 
   RowBox[{
    RowBox[{"Gangl", " ", "--"}], "--"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.6976332640443544`*^9, 3.697633274222515*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Get", "[", 
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", "\"\<wt4_fe_i31.m\>\""}], 
   "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.6975618552590733`*^9, 3.6975618933071313`*^9}, {
  3.6975997652052317`*^9, 3.6975997776164637`*^9}, {3.697632411363182*^9, 
  3.6976324175712533`*^9}, {3.697633278395752*^9, 3.6976332817415037`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"I31ab", "[", 
       RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e"}], "]"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", "\[Rule]", "Inf"}], ",", 
        RowBox[{"b", "\[Rule]", "0"}], ",", 
        RowBox[{"c", "\[Rule]", "1"}], ",", 
        RowBox[{"cri", "\[Rule]", "cr"}], ",", 
        RowBox[{"IIi", "\[Rule]", "II"}]}], "}"}]}], "//", "CreateTensor"}], "//",
     "sh"}], "//", "flatTensor"}], "//", "Expand"}]], "Input",
 CellChangeTimes->{{3.697633287355257*^9, 3.6976332897002635`*^9}, {
  3.6976333340991096`*^9, 3.697633365580142*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.697633351207366*^9, 3.697633366455123*^9}, 
   3.6976334989387813`*^9, 3.6976409895133657`*^9, 3.697642539424114*^9, 
   3.697642665145589*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"I31bc", "[", 
       RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e"}], "]"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", "\[Rule]", "Inf"}], ",", 
        RowBox[{"b", "\[Rule]", "0"}], ",", 
        RowBox[{"c", "\[Rule]", "1"}], ",", 
        RowBox[{"cri", "\[Rule]", "cr"}], ",", 
        RowBox[{"IIi", "\[Rule]", "II"}]}], "}"}]}], "//", "CreateTensor"}], "//",
     "sh"}], "//", "flatTensor"}], "//", "Expand"}]], "Input",
 CellChangeTimes->{{3.697633287355257*^9, 3.6976332897002635`*^9}, {
  3.6976333340991096`*^9, 3.6976333831061773`*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.697633351207366*^9, 3.6976333835607214`*^9}, 
   3.6976334990793896`*^9, 3.697640989678483*^9, 3.697642539587229*^9, 
   3.6976426653017*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"I31de", "[", 
       RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e"}], "]"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", "\[Rule]", "Inf"}], ",", 
        RowBox[{"b", "\[Rule]", "0"}], ",", 
        RowBox[{"c", "\[Rule]", "1"}], ",", 
        RowBox[{"cri", "\[Rule]", "cr"}], ",", 
        RowBox[{"IIi", "\[Rule]", "II"}]}], "}"}]}], "//", "CreateTensor"}], "//",
     "sh"}], "//", "flatTensor"}], "//", "Expand"}]], "Input",
 CellChangeTimes->{{3.697633287355257*^9, 3.6976332897002635`*^9}, {
  3.6976333340991096`*^9, 3.6976333793375854`*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.697633351207366*^9, 3.697633384060728*^9}, 
   3.697633499126281*^9, 3.6976409897205124`*^9, 3.6976425396252427`*^9, 
   3.6976426653387256`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"I31cyc", "[", 
       RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e"}], "]"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", "\[Rule]", "Inf"}], ",", 
        RowBox[{"b", "\[Rule]", "0"}], ",", 
        RowBox[{"c", "\[Rule]", "1"}], ",", 
        RowBox[{"cri", "\[Rule]", "cr"}], ",", 
        RowBox[{"IIi", "\[Rule]", "II"}]}], "}"}]}], "//", "CreateTensor"}], "//",
     "sh"}], "//", "flatTensor"}], "//", "Expand"}]], "Input",
 CellChangeTimes->{{3.697633287355257*^9, 3.6976332897002635`*^9}, {
  3.6976333340991096`*^9, 3.6976333855778*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.697633351207366*^9, 3.6976333862027683`*^9}, 
   3.6976334993606415`*^9, 3.6976409900297313`*^9, 3.6976425398924503`*^9, 
   3.6976426655959044`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "check", " ", "the", " ", "cyclic", " ", "symmetry", " ", "of", " ", "the", 
   " ", "reductions"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.697640951265602*^9, 3.697640959625519*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Get", "[", 
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
    "\"\<wt4_dan_precomputed.m\>\""}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.69764097964014*^9, 3.6976409822720027`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"wt4danStructuredLowerPrecomputed", " ", "-", " ", 
  RowBox[{"(", 
   RowBox[{"wt4danStructuredLowerPrecomputed", "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"a", "\[Rule]", "b"}], ",", 
      RowBox[{"b", "\[Rule]", "c"}], ",", 
      RowBox[{"c", "\[Rule]", "d"}], ",", 
      RowBox[{"d", "\[Rule]", "e"}], ",", 
      RowBox[{"e", "\[Rule]", "a"}]}], "}"}]}], ")"}]}]], "Input",
 CellChangeTimes->{{3.6976368644172926`*^9, 3.697636875691719*^9}, {
  3.6976369309593897`*^9, 3.6976369333684163`*^9}, {3.6976410375363536`*^9, 
  3.6976410376704483`*^9}, {3.6976410707929564`*^9, 3.6976410724030976`*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.6976368763323393`*^9, 3.6976369339308786`*^9, {3.697640983347762*^9, 
   3.697640990131805*^9}, {3.697641045600058*^9, 3.697641073273712*^9}, 
   3.6976413249064846`*^9, 3.6976425400265465`*^9, 3.697642665727997*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "The", " ", "functions", " ", "f", " ", "and", " ", "phi4", " ", "are", " ",
    "not", " ", "equal"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.6976427166610456`*^9, 3.697642724774788*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
      "wt4danStructuredLowerPrecomputed", " ", "-", " ", 
       "wt4DanAllNLoweras31and4Precomputed"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cri", "\[Rule]", "cr"}], ",", 
        RowBox[{"IIi", "\[Rule]", "II"}]}], "}"}]}], "//", "CreateTensor"}], "//",
     "sh"}], "//", "flatTensor"}], "//", "Expand"}]], "Input",
 CellChangeTimes->{{3.697642657360093*^9, 3.6976426631932106`*^9}, {
  3.6976427083561687`*^9, 3.6976427145615606`*^9}}],

Cell[BoxData[
 InterpretationBox[
  TagBox[
   FrameBox[GridBox[{
      {
       ItemBox[
        TagBox[
         RowBox[{
          RowBox[{
           RowBox[{"-", 
            FractionBox["3", "2"]}], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "c"}], ")"}]}]}], "+", 
          RowBox[{
           FractionBox["7", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "d"}], ")"}]}]}], "+", 
          RowBox[{
           FractionBox["5", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "c"}], "+", "d"}], ")"}]}]}], "+", 
          RowBox[{
           FractionBox["1", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "e"}], ")"}]}]}], "+", 
          RowBox[{
           FractionBox["1", "4"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "c"}], "+", "e"}], ")"}]}]}], "-", 
          RowBox[{
           FractionBox["3", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "d"}], "+", "e"}], ")"}]}]}], "+", 
          RowBox[{
           FractionBox["7", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "c"}], ")"}]}]}], "-", 
          RowBox[{
           FractionBox["7", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "d"}], ")"}]}]}], "-", 
          RowBox[{
           FractionBox["3", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "c"}], "+", "e"}], ")"}]}]}], "+", 
          RowBox[{
           FractionBox["3", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "d"}], "+", "e"}], ")"}]}]}], "+", 
          TemplateBox[{"1012"},
           "OutputSizeLimit`Skeleton",
           DisplayFunction->(FrameBox[
             RowBox[{"\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}], 
             Background -> GrayLevel[0.75], 
             BaseStyle -> {
              "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
               ShowStringCharacters -> False}, BaselinePosition -> Baseline, 
             ContentPadding -> False, FrameMargins -> {{1, 1}, {1, 2}}, 
             FrameStyle -> None, RoundingRadius -> 7]& )], "+", 
          RowBox[{
           FractionBox["1", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "c"}], "+", "e"}], ")"}]}]}], "+", 
          RowBox[{
           FractionBox["1", "4"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "d"}], "+", "e"}], ")"}]}]}], "+", 
          RowBox[{
           FractionBox["3", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "c"}], ")"}]}]}], "-", 
          RowBox[{
           FractionBox["3", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "d"}], ")"}]}]}], "-", 
          RowBox[{
           FractionBox["5", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "c"}], ")"}]}]}], "+", 
          RowBox[{
           FractionBox["1", "2"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "d"}], ")"}]}]}], "+", 
          RowBox[{
           FractionBox["1", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "e"}], ")"}]}]}]}],
         Short[#, 5]& ],
        BaseStyle->{Deployed -> False},
        StripOnInput->False]},
      {GridBox[{
         {
          TagBox[
           TooltipBox[
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource[
                "FEStrings", "sizeBriefExplanation"], StandardForm],
               ImageSizeCache->{65., {3., 9.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarCategory",
             StripOnInput->False],
            StyleBox[
             DynamicBox[
              ToBoxes[
               FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"], 
               StandardForm]], DynamicUpdating -> True, StripOnInput -> 
             False]],
           Annotation[#, 
            Style[
             Dynamic[
              FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"]], 
             DynamicUpdating -> True], "Tooltip"]& ], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm],
               ImageSizeCache->{52., {1., 9.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 28, 20691859497331325086, 5/2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm],
               ImageSizeCache->{62., {1., 9.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 28, 20691859497331325086, 5 2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm],
               ImageSizeCache->{44., {1., 9.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 28, 20691859497331325086, Infinity],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm],
               ImageSizeCache->{78., {1., 9.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           ButtonFunction:>FrontEndExecute[{
              FrontEnd`SetOptions[
              FrontEnd`$FrontEnd, 
               FrontEnd`PreferencesSettings -> {"Page" -> "Evaluation"}], 
              FrontEnd`FrontEndToken["PreferencesDialog"]}],
           Evaluator->None,
           Method->"Preemptive"]}
        },
        AutoDelete->False,
        FrameStyle->GrayLevel[0.85],
        GridBoxDividers->{"Columns" -> {False, {True}}},
        GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
        GridBoxSpacings->{"Columns" -> {{2}}}]}
     },
     DefaultBaseStyle->"Column",
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {{False}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], 
         Offset[1.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Background->RGBColor[0.9657, 0.9753, 0.9802],
    FrameMargins->{{12, 12}, {0, 15}},
    FrameStyle->GrayLevel[0.85],
    RoundingRadius->5,
    StripOnInput->False],
   Deploy,
   DefaultBaseStyle->"Deploy"],
  Out[28]]], "Output",
 CellChangeTimes->{3.6976427546115685`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
     "wt4danStructuredLowerPrecomputed", " ", "-", " ", 
      "wt4DanAllNLoweras31and4Precomputed"}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "\[Rule]", "cr"}], ",", 
       RowBox[{"IIi", "\[Rule]", "II"}]}], "}"}]}], "//", "CreateTensor"}], "//",
    "del"}], "//", "Expand"}]], "Input",
 CellChangeTimes->{{3.697642657360093*^9, 3.6976426631932106`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "c"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["1", "8"], " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}]}]], "Output",
 CellChangeTimes->{3.6976426804574194`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "The", " ", "function", " ", "phi4", " ", "is", " ", "not", " ", "even", 
   " ", "cyclically", " ", "symmetric"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.697642730549548*^9, 3.6976427381239133`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"wt4DanAllNLoweras31and4Precomputed", " ", "-", " ", 
       RowBox[{"(", 
        RowBox[{"wt4DanAllNLoweras31and4Precomputed", "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"a", "\[Rule]", "b"}], ",", 
           RowBox[{"b", "\[Rule]", "c"}], ",", 
           RowBox[{"c", "\[Rule]", "d"}], ",", 
           RowBox[{"d", "\[Rule]", "e"}], ",", 
           RowBox[{"e", "\[Rule]", "a"}]}], "}"}]}], ")"}]}], ")"}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "\[Rule]", "cr"}], ",", 
       RowBox[{"IIi", "\[Rule]", "II"}]}], "}"}]}], "//", "CreateTensor"}], "//",
    "del"}], "//", "Expand"}]], "Input",
 CellChangeTimes->{{3.6976368885152435`*^9, 3.697636976975946*^9}, {
   3.697637049428828*^9, 3.697637055918098*^9}, {3.6976370903168263`*^9, 
   3.697637146292317*^9}, {3.6976375177828817`*^9, 3.6976375191429663`*^9}, 
   3.697637866176285*^9}],

Cell[BoxData[
 InterpretationBox[
  TagBox[
   FrameBox[GridBox[{
      {
       ItemBox[
        TagBox[
         RowBox[{
          RowBox[{
           RowBox[{"-", 
            FractionBox["1", "8"]}], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "a"}], "+", "c"}], ")"}], "\[CircleTimes]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "a"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "a"}], "+", "c"}], ")"}], "\[CircleTimes]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "a"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
          RowBox[{
           FractionBox["1", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "a"}], "+", "c"}], ")"}], "\[CircleTimes]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "a"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "a"}], "+", "c"}], ")"}], "\[CircleTimes]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
          RowBox[{
           FractionBox["1", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "a"}], "+", "c"}], ")"}], "\[CircleTimes]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "a"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "a"}], "+", "d"}], ")"}], "\[CircleTimes]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "a"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
          RowBox[{
           FractionBox["1", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "a"}], "+", "c"}], ")"}], "\[CircleTimes]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "a"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "a"}], "+", "d"}], ")"}], "\[CircleTimes]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
          RowBox[{
           FractionBox["1", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "a"}], "+", "c"}], ")"}], "\[CircleTimes]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "a"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
          RowBox[{
           FractionBox["1", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "a"}], "+", "c"}], ")"}], "\[CircleTimes]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "a"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "c"}], "+", "d"}], ")"}], "\[CircleTimes]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "d"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
          RowBox[{
           FractionBox["1", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "a"}], "+", "c"}], ")"}], "\[CircleTimes]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "a"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "a"}], "+", "e"}], ")"}], "\[CircleTimes]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "a"}], "+", "c"}], ")"}]}], ")"}]}]}], "-", 
          RowBox[{
           FractionBox["1", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "a"}], "+", "c"}], ")"}], "\[CircleTimes]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "a"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "a"}], "+", "e"}], ")"}], "\[CircleTimes]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "a"}], "+", "d"}], ")"}]}], ")"}]}]}], "-", 
          RowBox[{
           FractionBox["1", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "a"}], "+", "c"}], ")"}], "\[CircleTimes]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "a"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "a"}], "+", "e"}], ")"}], "\[CircleTimes]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "+", 
          TemplateBox[{"620"},
           "OutputSizeLimit`Skeleton",
           DisplayFunction->(FrameBox[
             RowBox[{"\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}], 
             Background -> GrayLevel[0.75], 
             BaseStyle -> {
              "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
               ShowStringCharacters -> False}, BaselinePosition -> Baseline, 
             ContentPadding -> False, FrameMargins -> {{1, 1}, {1, 2}}, 
             FrameStyle -> None, RoundingRadius -> 7]& )], "+", 
          RowBox[{
           FractionBox["1", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "a"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
          RowBox[{
           FractionBox["1", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}]}]}], "+", 
          RowBox[{
           FractionBox["1", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "b"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
          RowBox[{
           FractionBox["1", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "a"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
          RowBox[{
           FractionBox["1", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "c"}], "+", "d"}], ")"}]}], ")"}], "\[Wedge]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
          RowBox[{
           FractionBox["1", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "a"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}], "-", 
          RowBox[{
           FractionBox["1", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "b"}], "+", "e"}], ")"}]}], ")"}], "\[Wedge]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "c"}], "+", "e"}], ")"}]}], ")"}]}]}]}],
         Short[#, 5]& ],
        BaseStyle->{Deployed -> False},
        StripOnInput->False]},
      {GridBox[{
         {
          TagBox[
           TooltipBox[
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource[
                "FEStrings", "sizeBriefExplanation"], StandardForm],
               ImageSizeCache->{65., {3., 9.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarCategory",
             StripOnInput->False],
            StyleBox[
             DynamicBox[
              ToBoxes[
               FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"], 
               StandardForm]], DynamicUpdating -> True, StripOnInput -> 
             False]],
           Annotation[#, 
            Style[
             Dynamic[
              FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"]], 
             DynamicUpdating -> True], "Tooltip"]& ], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm],
               ImageSizeCache->{52., {1., 9.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 18, 20691859497331325086, 5/2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm],
               ImageSizeCache->{62., {1., 9.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 18, 20691859497331325086, 5 2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm],
               ImageSizeCache->{44., {1., 9.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 18, 20691859497331325086, Infinity],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm],
               ImageSizeCache->{78., {1., 9.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           ButtonFunction:>FrontEndExecute[{
              FrontEnd`SetOptions[
              FrontEnd`$FrontEnd, 
               FrontEnd`PreferencesSettings -> {"Page" -> "Evaluation"}], 
              FrontEnd`FrontEndToken["PreferencesDialog"]}],
           Evaluator->None,
           Method->"Preemptive"]}
        },
        AutoDelete->False,
        FrameStyle->GrayLevel[0.85],
        GridBoxDividers->{"Columns" -> {False, {True}}},
        GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
        GridBoxSpacings->{"Columns" -> {{2}}}]}
     },
     DefaultBaseStyle->"Column",
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {{False}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], 
         Offset[1.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Background->RGBColor[0.9657, 0.9753, 0.9802],
    FrameMargins->{{12, 12}, {0, 15}},
    FrameStyle->GrayLevel[0.85],
    RoundingRadius->5,
    StripOnInput->False],
   Deploy,
   DefaultBaseStyle->"Deploy"],
  Out[18]]], "Output",
 CellChangeTimes->{3.6976377402064276`*^9, 3.697641006707534*^9, 
  3.6976410928126535`*^9, 3.6976413344282227`*^9, 3.697642549041925*^9, 
  3.6976426893297043`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"wt4DanAllNLoweras31and4Precomputed", " ", "-", " ", 
        RowBox[{"(", 
         RowBox[{"wt4DanAllNLoweras31and4Precomputed", "/.", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"a", "\[Rule]", "b"}], ",", 
            RowBox[{"b", "\[Rule]", "c"}], ",", 
            RowBox[{"c", "\[Rule]", "d"}], ",", 
            RowBox[{"d", "\[Rule]", "e"}], ",", 
            RowBox[{"e", "\[Rule]", "a"}]}], "}"}]}], ")"}]}], ")"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cri", "\[Rule]", "cr"}], ",", 
        RowBox[{"IIi", "\[Rule]", "II"}]}], "}"}]}], "//", "CreateTensor"}], "//",
     "sh"}], "//", "flatTensor"}], "//", "Expand"}]], "Input",
 CellChangeTimes->{{3.6976368885152435`*^9, 3.697636976975946*^9}, {
   3.697637049428828*^9, 3.697637055918098*^9}, {3.6976370903168263`*^9, 
   3.697637146292317*^9}, {3.6976375177828817`*^9, 3.6976375191429663`*^9}, 
   3.697637866176285*^9, {3.6976410003030024`*^9, 3.69764100199221*^9}}],

Cell[BoxData[
 InterpretationBox[
  TagBox[
   FrameBox[GridBox[{
      {
       ItemBox[
        TagBox[
         RowBox[{
          RowBox[{
           RowBox[{"-", 
            FractionBox["3", "8"]}], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "c"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "d"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "c"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "c"}], ")"}]}]}], "+", 
          RowBox[{
           FractionBox["3", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "c"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "d"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "c"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "d"}], ")"}]}]}], "-", 
          RowBox[{
           FractionBox["1", "4"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "c"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "d"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "c"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "e"}], ")"}]}]}], "+", 
          RowBox[{
           FractionBox["1", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "c"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "d"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "c"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "c"}], "+", "e"}], ")"}]}]}], "+", 
          RowBox[{
           FractionBox["1", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "c"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "d"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "c"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "d"}], "+", "e"}], ")"}]}]}], "+", 
          RowBox[{
           FractionBox["3", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "c"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "d"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "d"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "c"}], ")"}]}]}], "-", 
          RowBox[{
           FractionBox["1", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "c"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "d"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "d"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "d"}], ")"}]}]}], "-", 
          RowBox[{
           FractionBox["1", "4"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "c"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "d"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "d"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "c"}], "+", "d"}], ")"}]}]}], "-", 
          RowBox[{
           FractionBox["1", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "c"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "d"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "d"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "e"}], ")"}]}]}], "+", 
          TemplateBox[{"2039"},
           "OutputSizeLimit`Skeleton",
           DisplayFunction->(FrameBox[
             RowBox[{"\" \[CenterEllipsis]\"", #, "\"\[CenterEllipsis] \""}], 
             Background -> GrayLevel[0.75], 
             BaseStyle -> {
              "Deploy", FontColor -> GrayLevel[1], FontSize -> Smaller, 
               ShowStringCharacters -> False}, BaselinePosition -> Baseline, 
             ContentPadding -> False, FrameMargins -> {{1, 1}, {1, 2}}, 
             FrameStyle -> None, RoundingRadius -> 7]& )], "+", 
          RowBox[{
           FractionBox["3", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "d"}], ")"}]}]}], "-", 
          RowBox[{
           FractionBox["7", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "c"}], "+", "d"}], ")"}]}]}], "-", 
          RowBox[{
           FractionBox["3", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "e"}], ")"}]}]}], "+", 
          RowBox[{
           FractionBox["7", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "c"}], "+", "e"}], ")"}]}]}], "+", 
          RowBox[{
           FractionBox["1", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "c"}], ")"}]}]}], "+", 
          RowBox[{
           FractionBox["5", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "c"}], ")"}]}]}], "-", 
          RowBox[{
           FractionBox["1", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "a"}], "+", "d"}], ")"}]}]}], "-", 
          RowBox[{
           FractionBox["1", "2"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "d"}], ")"}]}]}], "-", 
          RowBox[{
           FractionBox["5", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "c"}], "+", "d"}], ")"}]}]}], "-", 
          RowBox[{
           FractionBox["1", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "b"}], "+", "e"}], ")"}]}]}], "+", 
          RowBox[{
           FractionBox["5", "8"], " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "c"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "d"}], "+", "e"}], ")"}], "\[CircleTimes]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "d"}], "+", "e"}], ")"}]}]}]}],
         Short[#, 5]& ],
        BaseStyle->{Deployed -> False},
        StripOnInput->False]},
      {GridBox[{
         {
          TagBox[
           TooltipBox[
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource[
                "FEStrings", "sizeBriefExplanation"], StandardForm],
               ImageSizeCache->{65., {3., 9.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarCategory",
             StripOnInput->False],
            StyleBox[
             DynamicBox[
              ToBoxes[
               FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"], 
               StandardForm]], DynamicUpdating -> True, StripOnInput -> 
             False]],
           Annotation[#, 
            Style[
             Dynamic[
              FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"]], 
             DynamicUpdating -> True], "Tooltip"]& ], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm],
               ImageSizeCache->{52., {1., 9.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 19, 20691859497331325086, 5/2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm],
               ImageSizeCache->{62., {1., 9.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 19, 20691859497331325086, 5 2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm],
               ImageSizeCache->{44., {1., 9.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 19, 20691859497331325086, Infinity],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm],
               ImageSizeCache->{78., {1., 9.}}],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True], "SuggestionsBarControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, 25}],
           Appearance->None,
           ButtonFunction:>FrontEndExecute[{
              FrontEnd`SetOptions[
              FrontEnd`$FrontEnd, 
               FrontEnd`PreferencesSettings -> {"Page" -> "Evaluation"}], 
              FrontEnd`FrontEndToken["PreferencesDialog"]}],
           Evaluator->None,
           Method->"Preemptive"]}
        },
        AutoDelete->False,
        FrameStyle->GrayLevel[0.85],
        GridBoxDividers->{"Columns" -> {False, {True}}},
        GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
        GridBoxSpacings->{"Columns" -> {{2}}}]}
     },
     DefaultBaseStyle->"Column",
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {{False}}, "ColumnsIndexed" -> {}, "Rows" -> {{False}}, 
       "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], 
         Offset[1.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Background->RGBColor[0.9657, 0.9753, 0.9802],
    FrameMargins->{{12, 12}, {0, 15}},
    FrameStyle->GrayLevel[0.85],
    RoundingRadius->5,
    StripOnInput->False],
   Deploy,
   DefaultBaseStyle->"Deploy"],
  Out[19]]], "Output",
 CellChangeTimes->{3.697641026937851*^9, 3.697641113637497*^9, 
  3.6976413461485167`*^9, 3.6976425606932883`*^9, 3.6976427009669347`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "Now", " ", "decompose", " ", "the", " ", "I31", " ", "functional", " ", 
   "equation"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.697642545383336*^9, 3.697642557608989*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"i31fe", " ", "=", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"wt4danStructuredLowerPrecomputed", " ", "-", " ", 
      RowBox[{"(", 
       RowBox[{"wt4danStructuredLowerPrecomputed", "/.", 
        RowBox[{"{", 
         RowBox[{"a", "\[Rule]", "f"}], "}"}]}], ")"}]}], ")"}], " ", "-", 
    " ", 
    RowBox[{"(", 
     RowBox[{"wt4DanAllNLoweras31and4Precomputed", " ", "-", " ", 
      RowBox[{"(", 
       RowBox[{"wt4DanAllNLoweras31and4Precomputed", "/.", 
        RowBox[{"a", "\[Rule]", "f"}]}], ")"}]}], ")"}]}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6976410254748154`*^9, 3.697641031848328*^9}, {
   3.697641079402048*^9, 3.6976411022993674`*^9}, 3.6976413592137656`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"i31fe", "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cri", "\[Rule]", "cr"}], ",", 
        RowBox[{"IIi", "\[Rule]", "II"}]}], "}"}]}], "//", "CreateTensor"}], "//",
     "sh"}], "//", "flatTensor"}], "//", "Expand"}]], "Input",
 CellChangeTimes->{{3.6976411038794856`*^9, 3.697641109383382*^9}, {
  3.6976413612151814`*^9, 3.6976413809058523`*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.6976413684432945`*^9, 3.6976414155080757`*^9, 
  3.6976425952677712`*^9, 3.6976427349766693`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["danI31feasGangl"], "Input",
 CellChangeTimes->{{3.697642100975524*^9, 3.6976421064853954`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"I31abi", "[", 
   RowBox[{"a", ",", "b", ",", "c", ",", "e", ",", "d"}], "]"}], "-", 
  RowBox[{"I31abi", "[", 
   RowBox[{"a", ",", "b", ",", "c", ",", "e", ",", "Inf"}], "]"}], "-", 
  RowBox[{"I31abi", "[", 
   RowBox[{"a", ",", "b", ",", "c", ",", "Inf", ",", "d"}], "]"}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "b", ",", "d", ",", "e", ",", "c"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "b", ",", "d", ",", "e", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"13", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "b", ",", "d", ",", "Inf", ",", "c"}], "]"}]}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "b", ",", "d", ",", "Inf", ",", "e"}], "]"}]}], "-", 
  RowBox[{"9", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "b", ",", "e", ",", "d", ",", "c"}], "]"}]}], "-", 
  RowBox[{"I31abi", "[", 
   RowBox[{"a", ",", "b", ",", "e", ",", "d", ",", "Inf"}], "]"}], "+", 
  RowBox[{"9", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "b", ",", "e", ",", "Inf", ",", "c"}], "]"}]}], "+", 
  RowBox[{"19", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "b", ",", "Inf", ",", "d", ",", "c"}], "]"}]}], "-", 
  RowBox[{"20", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "b", ",", "Inf", ",", "d", ",", "e"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "b", ",", "Inf", ",", "e", ",", "c"}], "]"}]}], "-", 
  RowBox[{"I31abi", "[", 
   RowBox[{"a", ",", "b", ",", "Inf", ",", "e", ",", "d"}], "]"}], "+", 
  RowBox[{"5", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "c", ",", "d", ",", "b", ",", "e"}], "]"}]}], "+", 
  RowBox[{"25", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "c", ",", "d", ",", "b", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "c", ",", "d", ",", "e", ",", "b"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "c", ",", "d", ",", "e", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "c", ",", "d", ",", "Inf", ",", "b"}], "]"}]}], "-", 
  RowBox[{"7", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "c", ",", "d", ",", "Inf", ",", "e"}], "]"}]}], "-", 
  RowBox[{"4", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "c", ",", "e", ",", "b", ",", "d"}], "]"}]}], "+", 
  RowBox[{"4", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "c", ",", "e", ",", "b", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "c", ",", "e", ",", "d", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"34", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "c", ",", "Inf", ",", "b", ",", "d"}], "]"}]}], "-", 
  RowBox[{"5", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "c", ",", "Inf", ",", "b", ",", "e"}], "]"}]}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "c", ",", "Inf", ",", "d", ",", "e"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "c", ",", "Inf", ",", "e", ",", "b"}], "]"}]}], "-", 
  RowBox[{"I31abi", "[", 
   RowBox[{"a", ",", "c", ",", "Inf", ",", "e", ",", "d"}], "]"}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "d", ",", "b", ",", "c", ",", "e"}], "]"}]}], "+", 
  RowBox[{"22", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "d", ",", "b", ",", "c", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "d", ",", "e", ",", "b", ",", "c"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "d", ",", "e", ",", "b", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "d", ",", "e", ",", "c", ",", "b"}], "]"}]}], "+", 
  RowBox[{"18", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "d", ",", "e", ",", "c", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"I31abi", "[", 
   RowBox[{"a", ",", "d", ",", "e", ",", "Inf", ",", "c"}], "]"}], "+", 
  RowBox[{"27", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "d", ",", "Inf", ",", "b", ",", "c"}], "]"}]}], "-", 
  RowBox[{"5", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "d", ",", "Inf", ",", "b", ",", "e"}], "]"}]}], "+", 
  RowBox[{"28", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "d", ",", "Inf", ",", "c", ",", "b"}], "]"}]}], "+", 
  RowBox[{"22", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "d", ",", "Inf", ",", "c", ",", "e"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "d", ",", "Inf", ",", "e", ",", "b"}], "]"}]}], "-", 
  RowBox[{"5", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "e", ",", "b", ",", "c", ",", "d"}], "]"}]}], "-", 
  RowBox[{"5", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "e", ",", "b", ",", "c", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"4", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "e", ",", "b", ",", "d", ",", "c"}], "]"}]}], "-", 
  RowBox[{"4", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "e", ",", "b", ",", "d", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"I31abi", "[", 
   RowBox[{"a", ",", "e", ",", "b", ",", "Inf", ",", "d"}], "]"}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "e", ",", "c", ",", "b", ",", "d"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "e", ",", "c", ",", "b", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "e", ",", "c", ",", "d", ",", "b"}], "]"}]}], "+", 
  RowBox[{"18", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "e", ",", "c", ",", "d", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "e", ",", "c", ",", "Inf", ",", "d"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "e", ",", "Inf", ",", "b", ",", "c"}], "]"}]}], "-", 
  RowBox[{"9", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "e", ",", "Inf", ",", "b", ",", "d"}], "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "e", ",", "Inf", ",", "c", ",", "b"}], "]"}]}], "+", 
  RowBox[{"15", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "e", ",", "Inf", ",", "c", ",", "d"}], "]"}]}], "-", 
  RowBox[{"12", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "e", ",", "Inf", ",", "d", ",", "b"}], "]"}]}], "+", 
  RowBox[{"16", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "e", ",", "Inf", ",", "d", ",", "c"}], "]"}]}], "+", 
  RowBox[{"25", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "Inf", ",", "b", ",", "c", ",", "d"}], "]"}]}], "-", 
  RowBox[{"8", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "Inf", ",", "b", ",", "c", ",", "e"}], "]"}]}], "+", 
  RowBox[{"6", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "Inf", ",", "b", ",", "d", ",", "c"}], "]"}]}], "+", 
  RowBox[{"12", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "Inf", ",", "b", ",", "d", ",", "e"}], "]"}]}], "-", 
  RowBox[{"14", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "Inf", ",", "b", ",", "e", ",", "c"}], "]"}]}], "-", 
  RowBox[{"6", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "Inf", ",", "b", ",", "e", ",", "d"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "Inf", ",", "c", ",", "b", ",", "d"}], "]"}]}], "+", 
  RowBox[{"28", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "Inf", ",", "c", ",", "d", ",", "b"}], "]"}]}], "+", 
  RowBox[{"22", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "Inf", ",", "c", ",", "d", ",", "e"}], "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "Inf", ",", "c", ",", "e", ",", "b"}], "]"}]}], "+", 
  RowBox[{"14", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "Inf", ",", "c", ",", "e", ",", "d"}], "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "Inf", ",", "d", ",", "e", ",", "b"}], "]"}]}], "+", 
  RowBox[{"19", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"a", ",", "Inf", ",", "d", ",", "e", ",", "c"}], "]"}]}], "-", 
  RowBox[{"I31abi", "[", 
   RowBox[{"a", ",", "Inf", ",", "e", ",", "d", ",", "c"}], "]"}], "+", 
  RowBox[{"I31abi", "[", 
   RowBox[{"b", ",", "c", ",", "a", ",", "e", ",", "d"}], "]"}], "-", 
  RowBox[{"I31abi", "[", 
   RowBox[{"b", ",", "c", ",", "a", ",", "e", ",", "Inf"}], "]"}], "-", 
  RowBox[{"I31abi", "[", 
   RowBox[{"b", ",", "c", ",", "a", ",", "Inf", ",", "d"}], "]"}], "+", 
  RowBox[{"I31abi", "[", 
   RowBox[{"b", ",", "c", ",", "d", ",", "a", ",", "e"}], "]"}], "-", 
  RowBox[{"11", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "c", ",", "d", ",", "a", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"I31abi", "[", 
   RowBox[{"b", ",", "c", ",", "d", ",", "f", ",", "e"}], "]"}], "+", 
  RowBox[{"11", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "c", ",", "d", ",", "f", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"7", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "c", ",", "e", ",", "a", ",", "d"}], "]"}]}], "-", 
  RowBox[{"7", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "c", ",", "e", ",", "a", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"7", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "c", ",", "e", ",", "f", ",", "d"}], "]"}]}], "+", 
  RowBox[{"7", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "c", ",", "e", ",", "f", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"I31abi", "[", 
   RowBox[{"b", ",", "c", ",", "f", ",", "e", ",", "d"}], "]"}], "+", 
  RowBox[{"I31abi", "[", 
   RowBox[{"b", ",", "c", ",", "f", ",", "e", ",", "Inf"}], "]"}], "+", 
  RowBox[{"I31abi", "[", 
   RowBox[{"b", ",", "c", ",", "f", ",", "Inf", ",", "d"}], "]"}], "-", 
  RowBox[{"17", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "c", ",", "Inf", ",", "a", ",", "d"}], "]"}]}], "-", 
  RowBox[{"I31abi", "[", 
   RowBox[{"b", ",", "c", ",", "Inf", ",", "a", ",", "e"}], "]"}], "+", 
  RowBox[{"17", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "c", ",", "Inf", ",", "f", ",", "d"}], "]"}]}], "+", 
  RowBox[{"I31abi", "[", 
   RowBox[{"b", ",", "c", ",", "Inf", ",", "f", ",", "e"}], "]"}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "d", ",", "c", ",", "a", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "d", ",", "c", ",", "f", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"7", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "d", ",", "e", ",", "a", ",", "c"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "d", ",", "e", ",", "a", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "d", ",", "e", ",", "c", ",", "a"}], "]"}]}], "+", 
  RowBox[{"5", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "d", ",", "e", ",", "c", ",", "f"}], "]"}]}], "+", 
  RowBox[{"7", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "d", ",", "e", ",", "f", ",", "c"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "d", ",", "e", ",", "f", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "d", ",", "e", ",", "Inf", ",", "a"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "d", ",", "e", ",", "Inf", ",", "f"}], "]"}]}], "+", 
  RowBox[{"4", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "d", ",", "f", ",", "c", ",", "e"}], "]"}]}], "+", 
  RowBox[{"6", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "d", ",", "f", ",", "c", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"13", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "d", ",", "Inf", ",", "a", ",", "c"}], "]"}]}], "-", 
  RowBox[{"11", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "d", ",", "Inf", ",", "a", ",", "e"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "d", ",", "Inf", ",", "c", ",", "a"}], "]"}]}], "+", 
  RowBox[{"25", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "d", ",", "Inf", ",", "c", ",", "f"}], "]"}]}], "+", 
  RowBox[{"13", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "d", ",", "Inf", ",", "f", ",", "c"}], "]"}]}], "+", 
  RowBox[{"11", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "d", ",", "Inf", ",", "f", ",", "e"}], "]"}]}], "+", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "e", ",", "c", ",", "a", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "e", ",", "c", ",", "d", ",", "f"}], "]"}]}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "e", ",", "c", ",", "f", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "e", ",", "d", ",", "a", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "e", ",", "d", ",", "f", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"7", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "e", ",", "f", ",", "c", ",", "d"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "e", ",", "f", ",", "c", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "e", ",", "f", ",", "d", ",", "c"}], "]"}]}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "e", ",", "f", ",", "d", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"I31abi", "[", 
   RowBox[{"b", ",", "e", ",", "f", ",", "Inf", ",", "d"}], "]"}], "+", 
  RowBox[{"7", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "e", ",", "Inf", ",", "a", ",", "c"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "e", ",", "Inf", ",", "c", ",", "a"}], "]"}]}], "-", 
  RowBox[{"5", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "e", ",", "Inf", ",", "c", ",", "f"}], "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "e", ",", "Inf", ",", "d", ",", "f"}], "]"}]}], "-", 
  RowBox[{"7", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "e", ",", "Inf", ",", "f", ",", "c"}], "]"}]}], "+", 
  RowBox[{"5", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "f", ",", "c", ",", "d", ",", "e"}], "]"}]}], "+", 
  RowBox[{"5", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "f", ",", "c", ",", "d", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"6", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "f", ",", "c", ",", "e", ",", "d"}], "]"}]}], "+", 
  RowBox[{"4", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "f", ",", "c", ",", "e", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"I31abi", "[", 
   RowBox[{"b", ",", "f", ",", "c", ",", "Inf", ",", "e"}], "]"}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "f", ",", "d", ",", "c", ",", "e"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "f", ",", "d", ",", "c", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "f", ",", "d", ",", "e", ",", "c"}], "]"}]}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "f", ",", "d", ",", "e", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "f", ",", "d", ",", "Inf", ",", "e"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "f", ",", "Inf", ",", "c", ",", "d"}], "]"}]}], "+", 
  RowBox[{"9", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "f", ",", "Inf", ",", "c", ",", "e"}], "]"}]}], "+", 
  RowBox[{"22", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "f", ",", "Inf", ",", "d", ",", "c"}], "]"}]}], "-", 
  RowBox[{"15", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "f", ",", "Inf", ",", "d", ",", "e"}], "]"}]}], "+", 
  RowBox[{"12", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "f", ",", "Inf", ",", "e", ",", "c"}], "]"}]}], "+", 
  RowBox[{"4", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "f", ",", "Inf", ",", "e", ",", "d"}], "]"}]}], "+", 
  RowBox[{"20", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "Inf", ",", "a", ",", "d", ",", "c"}], "]"}]}], "-", 
  RowBox[{"20", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "Inf", ",", "a", ",", "d", ",", "e"}], "]"}]}], "-", 
  RowBox[{"I31abi", "[", 
   RowBox[{"b", ",", "Inf", ",", "a", ",", "e", ",", "d"}], "]"}], "+", 
  RowBox[{"28", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "Inf", ",", "c", ",", "d", ",", "f"}], "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "Inf", ",", "c", ",", "e", ",", "f"}], "]"}]}], "+", 
  RowBox[{"4", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "Inf", ",", "c", ",", "f", ",", "d"}], "]"}]}], "+", 
  RowBox[{"6", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "Inf", ",", "c", ",", "f", ",", "e"}], "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "Inf", ",", "d", ",", "e", ",", "f"}], "]"}]}], "+", 
  RowBox[{"22", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "Inf", ",", "d", ",", "f", ",", "c"}], "]"}]}], "-", 
  RowBox[{"14", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "Inf", ",", "d", ",", "f", ",", "e"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "Inf", ",", "e", ",", "a", ",", "d"}], "]"}]}], "+", 
  RowBox[{"12", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "Inf", ",", "e", ",", "f", ",", "c"}], "]"}]}], "+", 
  RowBox[{"I31abi", "[", 
   RowBox[{"b", ",", "Inf", ",", "e", ",", "f", ",", "d"}], "]"}], "-", 
  RowBox[{"20", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "Inf", ",", "f", ",", "d", ",", "c"}], "]"}]}], "+", 
  RowBox[{"20", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"b", ",", "Inf", ",", "f", ",", "d", ",", "e"}], "]"}]}], "+", 
  RowBox[{"I31abi", "[", 
   RowBox[{"b", ",", "Inf", ",", "f", ",", "e", ",", "d"}], "]"}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "d", ",", "a", ",", "b", ",", "e"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "d", ",", "a", ",", "b", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "d", ",", "a", ",", "Inf", ",", "e"}], "]"}]}], "+", 
  RowBox[{"I31abi", "[", 
   RowBox[{"c", ",", "d", ",", "b", ",", "a", ",", "e"}], "]"}], "-", 
  RowBox[{"11", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "d", ",", "b", ",", "a", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"I31abi", "[", 
   RowBox[{"c", ",", "d", ",", "b", ",", "f", ",", "e"}], "]"}], "+", 
  RowBox[{"11", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "d", ",", "b", ",", "f", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "d", ",", "e", ",", "a", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"I31abi", "[", 
   RowBox[{"c", ",", "d", ",", "e", ",", "b", ",", "a"}], "]"}], "-", 
  RowBox[{"I31abi", "[", 
   RowBox[{"c", ",", "d", ",", "e", ",", "b", ",", "f"}], "]"}], "+", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "d", ",", "e", ",", "f", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"I31abi", "[", 
   RowBox[{"c", ",", "d", ",", "e", ",", "Inf", ",", "a"}], "]"}], "+", 
  RowBox[{"I31abi", "[", 
   RowBox[{"c", ",", "d", ",", "e", ",", "Inf", ",", "f"}], "]"}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "d", ",", "f", ",", "b", ",", "e"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "d", ",", "f", ",", "b", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "d", ",", "f", ",", "Inf", ",", "e"}], "]"}]}], "-", 
  RowBox[{"20", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "d", ",", "Inf", ",", "a", ",", "b"}], "]"}]}], "-", 
  RowBox[{"11", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "d", ",", "Inf", ",", "a", ",", "e"}], "]"}]}], "-", 
  RowBox[{"I31abi", "[", 
   RowBox[{"c", ",", "d", ",", "Inf", ",", "b", ",", "a"}], "]"}], "+", 
  RowBox[{"I31abi", "[", 
   RowBox[{"c", ",", "d", ",", "Inf", ",", "b", ",", "f"}], "]"}], "+", 
  RowBox[{"20", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "d", ",", "Inf", ",", "f", ",", "b"}], "]"}]}], "+", 
  RowBox[{"11", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "d", ",", "Inf", ",", "f", ",", "e"}], "]"}]}], "+", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "e", ",", "b", ",", "a", ",", "d"}], "]"}]}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "e", ",", "b", ",", "a", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "e", ",", "b", ",", "f", ",", "d"}], "]"}]}], "+", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "e", ",", "b", ",", "f", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "e", ",", "d", ",", "a", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "e", ",", "d", ",", "f", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "e", ",", "f", ",", "b", ",", "d"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "e", ",", "f", ",", "b", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "e", ",", "f", ",", "d", ",", "b"}], "]"}]}], "-", 
  RowBox[{"7", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "e", ",", "f", ",", "d", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "e", ",", "f", ",", "Inf", ",", "b"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "e", ",", "f", ",", "Inf", ",", "d"}], "]"}]}], "-", 
  RowBox[{"I31abi", "[", 
   RowBox[{"c", ",", "e", ",", "Inf", ",", "b", ",", "a"}], "]"}], "+", 
  RowBox[{"I31abi", "[", 
   RowBox[{"c", ",", "e", ",", "Inf", ",", "b", ",", "f"}], "]"}], "+", 
  RowBox[{"14", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "e", ",", "Inf", ",", "d", ",", "f"}], "]"}]}], "-", 
  RowBox[{"4", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "f", ",", "d", ",", "e", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "f", ",", "Inf", ",", "b", ",", "d"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "f", ",", "Inf", ",", "d", ",", "b"}], "]"}]}], "-", 
  RowBox[{"9", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "f", ",", "Inf", ",", "d", ",", "e"}], "]"}]}], "+", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "Inf", ",", "a", ",", "b", ",", "d"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "Inf", ",", "a", ",", "b", ",", "e"}], "]"}]}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "Inf", ",", "a", ",", "d", ",", "e"}], "]"}]}], "-", 
  RowBox[{"I31abi", "[", 
   RowBox[{"c", ",", "Inf", ",", "b", ",", "a", ",", "e"}], "]"}], "+", 
  RowBox[{"I31abi", "[", 
   RowBox[{"c", ",", "Inf", ",", "b", ",", "f", ",", "e"}], "]"}], "+", 
  RowBox[{"I31abi", "[", 
   RowBox[{"c", ",", "Inf", ",", "d", ",", "e", ",", "a"}], "]"}], "+", 
  RowBox[{"13", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "Inf", ",", "d", ",", "e", ",", "f"}], "]"}]}], "-", 
  RowBox[{"8", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "Inf", ",", "d", ",", "f", ",", "e"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "Inf", ",", "e", ",", "d", ",", "a"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "Inf", ",", "e", ",", "d", ",", "f"}], "]"}]}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "Inf", ",", "f", ",", "b", ",", "d"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "Inf", ",", "f", ",", "b", ",", "e"}], "]"}]}], "+", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"c", ",", "Inf", ",", "f", ",", "d", ",", "e"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"d", ",", "e", ",", "b", ",", "c", ",", "a"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"d", ",", "e", ",", "b", ",", "c", ",", "f"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"d", ",", "e", ",", "b", ",", "Inf", ",", "a"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"d", ",", "e", ",", "b", ",", "Inf", ",", "f"}], "]"}]}], "+", 
  RowBox[{"I31abi", "[", 
   RowBox[{"d", ",", "e", ",", "c", ",", "b", ",", "a"}], "]"}], "-", 
  RowBox[{"I31abi", "[", 
   RowBox[{"d", ",", "e", ",", "c", ",", "b", ",", "f"}], "]"}], "-", 
  RowBox[{"I31abi", "[", 
   RowBox[{"d", ",", "e", ",", "c", ",", "Inf", ",", "a"}], "]"}], "+", 
  RowBox[{"I31abi", "[", 
   RowBox[{"d", ",", "e", ",", "c", ",", "Inf", ",", "f"}], "]"}], "-", 
  RowBox[{"I31abi", "[", 
   RowBox[{"d", ",", "e", ",", "f", ",", "c", ",", "b"}], "]"}], "+", 
  RowBox[{"I31abi", "[", 
   RowBox[{"d", ",", "e", ",", "f", ",", "c", ",", "Inf"}], "]"}], "+", 
  RowBox[{"I31abi", "[", 
   RowBox[{"d", ",", "e", ",", "f", ",", "Inf", ",", "b"}], "]"}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"d", ",", "e", ",", "f", ",", "Inf", ",", "c"}], "]"}]}], "+", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"d", ",", "e", ",", "Inf", ",", "a", ",", "b"}], "]"}]}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"d", ",", "e", ",", "Inf", ",", "a", ",", "c"}], "]"}]}], "-", 
  RowBox[{"I31abi", "[", 
   RowBox[{"d", ",", "e", ",", "Inf", ",", "b", ",", "a"}], "]"}], "+", 
  RowBox[{"I31abi", "[", 
   RowBox[{"d", ",", "e", ",", "Inf", ",", "b", ",", "f"}], "]"}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"d", ",", "e", ",", "Inf", ",", "c", ",", "a"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"d", ",", "e", ",", "Inf", ",", "c", ",", "f"}], "]"}]}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"d", ",", "e", ",", "Inf", ",", "f", ",", "b"}], "]"}]}], "+", 
  RowBox[{"8", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"d", ",", "e", ",", "Inf", ",", "f", ",", "c"}], "]"}]}], "+", 
  RowBox[{"I31abi", "[", 
   RowBox[{"d", ",", "f", ",", "Inf", ",", "c", ",", "b"}], "]"}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"d", ",", "f", ",", "Inf", ",", "c", ",", "e"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"d", ",", "f", ",", "Inf", ",", "e", ",", "c"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"d", ",", "Inf", ",", "a", ",", "e", ",", "b"}], "]"}]}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"d", ",", "Inf", ",", "b", ",", "a", ",", "e"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"d", ",", "Inf", ",", "b", ",", "c", ",", "a"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"d", ",", "Inf", ",", "b", ",", "c", ",", "f"}], "]"}]}], "+", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"d", ",", "Inf", ",", "b", ",", "f", ",", "e"}], "]"}]}], "-", 
  RowBox[{"20", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"d", ",", "Inf", ",", "c", ",", "a", ",", "b"}], "]"}]}], "-", 
  RowBox[{"I31abi", "[", 
   RowBox[{"d", ",", "Inf", ",", "c", ",", "b", ",", "a"}], "]"}], "+", 
  RowBox[{"I31abi", "[", 
   RowBox[{"d", ",", "Inf", ",", "c", ",", "b", ",", "f"}], "]"}], "+", 
  RowBox[{"20", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"d", ",", "Inf", ",", "c", ",", "f", ",", "b"}], "]"}]}], "-", 
  RowBox[{"9", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"d", ",", "Inf", ",", "e", ",", "a", ",", "b"}], "]"}]}], "+", 
  RowBox[{"9", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"d", ",", "Inf", ",", "e", ",", "f", ",", "b"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"d", ",", "Inf", ",", "f", ",", "e", ",", "b"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"e", ",", "f", ",", "c", ",", "d", ",", "b"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"e", ",", "f", ",", "c", ",", "d", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"e", ",", "f", ",", "c", ",", "Inf", ",", "b"}], "]"}]}], "-", 
  RowBox[{"I31abi", "[", 
   RowBox[{"e", ",", "f", ",", "d", ",", "c", ",", "b"}], "]"}], "+", 
  RowBox[{"I31abi", "[", 
   RowBox[{"e", ",", "f", ",", "d", ",", "c", ",", "Inf"}], "]"}], "+", 
  RowBox[{"I31abi", "[", 
   RowBox[{"e", ",", "f", ",", "d", ",", "Inf", ",", "b"}], "]"}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"e", ",", "f", ",", "d", ",", "Inf", ",", "c"}], "]"}]}], "+", 
  RowBox[{"I31abi", "[", 
   RowBox[{"e", ",", "f", ",", "Inf", ",", "c", ",", "b"}], "]"}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"e", ",", "f", ",", "Inf", ",", "d", ",", "b"}], "]"}]}], "-", 
  RowBox[{"I31abi", "[", 
   RowBox[{"e", ",", "f", ",", "Inf", ",", "d", ",", "c"}], "]"}], "+", 
  RowBox[{"I31abi", "[", 
   RowBox[{"e", ",", "Inf", ",", "a", ",", "b", ",", "c"}], "]"}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"e", ",", "Inf", ",", "b", ",", "a", ",", "c"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"e", ",", "Inf", ",", "b", ",", "f", ",", "c"}], "]"}]}], "+", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"e", ",", "Inf", ",", "c", ",", "a", ",", "b"}], "]"}]}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"e", ",", "Inf", ",", "c", ",", "a", ",", "d"}], "]"}]}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"e", ",", "Inf", ",", "c", ",", "f", ",", "b"}], "]"}]}], "+", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"e", ",", "Inf", ",", "c", ",", "f", ",", "d"}], "]"}]}], "+", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"e", ",", "Inf", ",", "d", ",", "a", ",", "b"}], "]"}]}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"e", ",", "Inf", ",", "d", ",", "a", ",", "c"}], "]"}]}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"e", ",", "Inf", ",", "d", ",", "f", ",", "b"}], "]"}]}], "+", 
  RowBox[{"10", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"e", ",", "Inf", ",", "d", ",", "f", ",", "c"}], "]"}]}], "-", 
  RowBox[{"I31abi", "[", 
   RowBox[{"e", ",", "Inf", ",", "f", ",", "b", ",", "c"}], "]"}], "-", 
  RowBox[{"I31abi", "[", 
   RowBox[{"f", ",", "Inf", ",", "b", ",", "c", ",", "d"}], "]"}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"f", ",", "Inf", ",", "c", ",", "b", ",", "d"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31abi", "[", 
    RowBox[{"f", ",", "Inf", ",", "d", ",", "e", ",", "c"}], "]"}]}], "-", 
  RowBox[{"I31abi", "[", 
   RowBox[{"f", ",", "Inf", ",", "e", ",", "d", ",", "c"}], "]"}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"a", ",", "b", ",", "d", ",", "c", ",", "e"}], "]"}]}], "+", 
  RowBox[{"22", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"a", ",", "b", ",", "d", ",", "c", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"5", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"a", ",", "b", ",", "e", ",", "c", ",", "d"}], "]"}]}], "-", 
  RowBox[{"5", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"a", ",", "b", ",", "e", ",", "c", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"4", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"a", ",", "b", ",", "e", ",", "d", ",", "c"}], "]"}]}], "-", 
  RowBox[{"4", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"a", ",", "b", ",", "e", ",", "d", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"I31bci", "[", 
   RowBox[{"a", ",", "b", ",", "e", ",", "Inf", ",", "d"}], "]"}], "+", 
  RowBox[{"25", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"a", ",", "b", ",", "Inf", ",", "c", ",", "d"}], "]"}]}], "-", 
  RowBox[{"8", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"a", ",", "b", ",", "Inf", ",", "c", ",", "e"}], "]"}]}], "+", 
  RowBox[{"6", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"a", ",", "b", ",", "Inf", ",", "d", ",", "c"}], "]"}]}], "+", 
  RowBox[{"12", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"a", ",", "b", ",", "Inf", ",", "d", ",", "e"}], "]"}]}], "-", 
  RowBox[{"14", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"a", ",", "b", ",", "Inf", ",", "e", ",", "c"}], "]"}]}], "-", 
  RowBox[{"6", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"a", ",", "b", ",", "Inf", ",", "e", ",", "d"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"a", ",", "c", ",", "e", ",", "b", ",", "d"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"a", ",", "c", ",", "e", ",", "b", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"I31bci", "[", 
   RowBox[{"a", ",", "c", ",", "e", ",", "d", ",", "b"}], "]"}], "+", 
  RowBox[{"21", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"a", ",", "c", ",", "e", ",", "d", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"a", ",", "c", ",", "e", ",", "Inf", ",", "b"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"a", ",", "c", ",", "e", ",", "Inf", ",", "d"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"a", ",", "c", ",", "Inf", ",", "b", ",", "d"}], "]"}]}], "+", 
  RowBox[{"31", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"a", ",", "c", ",", "Inf", ",", "d", ",", "b"}], "]"}]}], "+", 
  RowBox[{"23", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"a", ",", "c", ",", "Inf", ",", "d", ",", "e"}], "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"a", ",", "c", ",", "Inf", ",", "e", ",", "b"}], "]"}]}], "+", 
  RowBox[{"14", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"a", ",", "c", ",", "Inf", ",", "e", ",", "d"}], "]"}]}], "+", 
  RowBox[{"I31bci", "[", 
   RowBox[{"a", ",", "d", ",", "e", ",", "c", ",", "b"}], "]"}], "-", 
  RowBox[{"I31bci", "[", 
   RowBox[{"a", ",", "d", ",", "e", ",", "c", ",", "Inf"}], "]"}], "-", 
  RowBox[{"I31bci", "[", 
   RowBox[{"a", ",", "d", ",", "e", ",", "Inf", ",", "b"}], "]"}], "-", 
  RowBox[{"I31bci", "[", 
   RowBox[{"a", ",", "d", ",", "Inf", ",", "c", ",", "b"}], "]"}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"a", ",", "d", ",", "Inf", ",", "c", ",", "e"}], "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"a", ",", "d", ",", "Inf", ",", "e", ",", "b"}], "]"}]}], "+", 
  RowBox[{"19", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"a", ",", "d", ",", "Inf", ",", "e", ",", "c"}], "]"}]}], "-", 
  RowBox[{"I31bci", "[", 
   RowBox[{"a", ",", "e", ",", "Inf", ",", "d", ",", "c"}], "]"}], "+", 
  RowBox[{"I31bci", "[", 
   RowBox[{"b", ",", "a", ",", "c", ",", "e", ",", "d"}], "]"}], "-", 
  RowBox[{"I31bci", "[", 
   RowBox[{"b", ",", "a", ",", "c", ",", "e", ",", "Inf"}], "]"}], "-", 
  RowBox[{"I31bci", "[", 
   RowBox[{"b", ",", "a", ",", "c", ",", "Inf", ",", "d"}], "]"}], "+", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "a", ",", "d", ",", "Inf", ",", "c"}], "]"}]}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "a", ",", "d", ",", "Inf", ",", "e"}], "]"}]}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "a", ",", "e", ",", "d", ",", "c"}], "]"}]}], "+", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "a", ",", "e", ",", "Inf", ",", "c"}], "]"}]}], "+", 
  RowBox[{"20", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "a", ",", "Inf", ",", "d", ",", "c"}], "]"}]}], "-", 
  RowBox[{"20", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "a", ",", "Inf", ",", "d", ",", "e"}], "]"}]}], "-", 
  RowBox[{"I31bci", "[", 
   RowBox[{"b", ",", "a", ",", "Inf", ",", "e", ",", "d"}], "]"}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "c", ",", "d", ",", "a", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "c", ",", "d", ",", "f", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "c", ",", "e", ",", "a", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "c", ",", "e", ",", "d", ",", "f"}], "]"}]}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "c", ",", "e", ",", "f", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"5", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "c", ",", "f", ",", "d", ",", "e"}], "]"}]}], "+", 
  RowBox[{"5", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "c", ",", "f", ",", "d", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"6", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "c", ",", "f", ",", "e", ",", "d"}], "]"}]}], "+", 
  RowBox[{"4", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "c", ",", "f", ",", "e", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"I31bci", "[", 
   RowBox[{"b", ",", "c", ",", "f", ",", "Inf", ",", "e"}], "]"}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "c", ",", "Inf", ",", "a", ",", "d"}], "]"}]}], "+", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "c", ",", "Inf", ",", "a", ",", "e"}], "]"}]}], "+", 
  RowBox[{"28", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "c", ",", "Inf", ",", "d", ",", "f"}], "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "c", ",", "Inf", ",", "e", ",", "f"}], "]"}]}], "+", 
  RowBox[{"14", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "c", ",", "Inf", ",", "f", ",", "d"}], "]"}]}], "-", 
  RowBox[{"4", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "c", ",", "Inf", ",", "f", ",", "e"}], "]"}]}], "+", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "d", ",", "e", ",", "a", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "d", ",", "e", ",", "f", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "d", ",", "f", ",", "c", ",", "e"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "d", ",", "f", ",", "c", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"I31bci", "[", 
   RowBox[{"b", ",", "d", ",", "f", ",", "e", ",", "c"}], "]"}], "-", 
  RowBox[{"I31bci", "[", 
   RowBox[{"b", ",", "d", ",", "f", ",", "e", ",", "Inf"}], "]"}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "d", ",", "f", ",", "Inf", ",", "c"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "d", ",", "f", ",", "Inf", ",", "e"}], "]"}]}], "+", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "d", ",", "Inf", ",", "a", ",", "c"}], "]"}]}], "+", 
  RowBox[{"I31bci", "[", 
   RowBox[{"b", ",", "d", ",", "Inf", ",", "e", ",", "a"}], "]"}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "d", ",", "Inf", ",", "e", ",", "f"}], "]"}]}], "+", 
  RowBox[{"12", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "d", ",", "Inf", ",", "f", ",", "c"}], "]"}]}], "-", 
  RowBox[{"14", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "d", ",", "Inf", ",", "f", ",", "e"}], "]"}]}], "-", 
  RowBox[{"I31bci", "[", 
   RowBox[{"b", ",", "e", ",", "f", ",", "d", ",", "c"}], "]"}], "+", 
  RowBox[{"I31bci", "[", 
   RowBox[{"b", ",", "e", ",", "f", ",", "d", ",", "Inf"}], "]"}], "+", 
  RowBox[{"I31bci", "[", 
   RowBox[{"b", ",", "e", ",", "f", ",", "Inf", ",", "c"}], "]"}], "+", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "e", ",", "Inf", ",", "a", ",", "c"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "e", ",", "Inf", ",", "a", ",", "d"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "e", ",", "Inf", ",", "d", ",", "a"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "e", ",", "Inf", ",", "d", ",", "f"}], "]"}]}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "e", ",", "Inf", ",", "f", ",", "c"}], "]"}]}], "+", 
  RowBox[{"I31bci", "[", 
   RowBox[{"b", ",", "e", ",", "Inf", ",", "f", ",", "d"}], "]"}], "-", 
  RowBox[{"20", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "f", ",", "Inf", ",", "d", ",", "c"}], "]"}]}], "+", 
  RowBox[{"20", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"b", ",", "f", ",", "Inf", ",", "d", ",", "e"}], "]"}]}], "+", 
  RowBox[{"I31bci", "[", 
   RowBox[{"b", ",", "f", ",", "Inf", ",", "e", ",", "d"}], "]"}], "+", 
  RowBox[{"5", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "a", ",", "d", ",", "b", ",", "e"}], "]"}]}], "+", 
  RowBox[{"25", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "a", ",", "d", ",", "b", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "a", ",", "d", ",", "e", ",", "b"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "a", ",", "d", ",", "e", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "a", ",", "d", ",", "Inf", ",", "b"}], "]"}]}], "-", 
  RowBox[{"7", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "a", ",", "d", ",", "Inf", ",", "e"}], "]"}]}], "-", 
  RowBox[{"4", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "a", ",", "e", ",", "b", ",", "d"}], "]"}]}], "+", 
  RowBox[{"4", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "a", ",", "e", ",", "b", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "a", ",", "e", ",", "d", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"34", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "a", ",", "Inf", ",", "b", ",", "d"}], "]"}]}], "-", 
  RowBox[{"5", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "a", ",", "Inf", ",", "b", ",", "e"}], "]"}]}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "a", ",", "Inf", ",", "d", ",", "e"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "a", ",", "Inf", ",", "e", ",", "b"}], "]"}]}], "-", 
  RowBox[{"I31bci", "[", 
   RowBox[{"c", ",", "a", ",", "Inf", ",", "e", ",", "d"}], "]"}], "+", 
  RowBox[{"I31bci", "[", 
   RowBox[{"c", ",", "b", ",", "d", ",", "a", ",", "e"}], "]"}], "-", 
  RowBox[{"11", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "b", ",", "d", ",", "a", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"I31bci", "[", 
   RowBox[{"c", ",", "b", ",", "d", ",", "f", ",", "e"}], "]"}], "+", 
  RowBox[{"11", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "b", ",", "d", ",", "f", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "b", ",", "e", ",", "a", ",", "d"}], "]"}]}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "b", ",", "e", ",", "a", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "b", ",", "e", ",", "f", ",", "d"}], "]"}]}], "+", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "b", ",", "e", ",", "f", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"20", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "b", ",", "Inf", ",", "a", ",", "d"}], "]"}]}], "-", 
  RowBox[{"I31bci", "[", 
   RowBox[{"c", ",", "b", ",", "Inf", ",", "a", ",", "e"}], "]"}], "+", 
  RowBox[{"20", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "b", ",", "Inf", ",", "f", ",", "d"}], "]"}]}], "+", 
  RowBox[{"I31bci", "[", 
   RowBox[{"c", ",", "b", ",", "Inf", ",", "f", ",", "e"}], "]"}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "d", ",", "e", ",", "a", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "d", ",", "e", ",", "f", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"4", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "d", ",", "f", ",", "e", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "d", ",", "Inf", ",", "a", ",", "b"}], "]"}]}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "d", ",", "Inf", ",", "a", ",", "e"}], "]"}]}], "+", 
  RowBox[{"I31bci", "[", 
   RowBox[{"c", ",", "d", ",", "Inf", ",", "e", ",", "a"}], "]"}], "+", 
  RowBox[{"13", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "d", ",", "Inf", ",", "e", ",", "f"}], "]"}]}], "+", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "d", ",", "Inf", ",", "f", ",", "b"}], "]"}]}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "d", ",", "Inf", ",", "f", ",", "e"}], "]"}]}], "+", 
  RowBox[{"I31bci", "[", 
   RowBox[{"c", ",", "e", ",", "Inf", ",", "a", ",", "b"}], "]"}], "-", 
  RowBox[{"17", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "e", ",", "Inf", ",", "a", ",", "d"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "e", ",", "Inf", ",", "d", ",", "a"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "e", ",", "Inf", ",", "d", ",", "f"}], "]"}]}], "-", 
  RowBox[{"I31bci", "[", 
   RowBox[{"c", ",", "e", ",", "Inf", ",", "f", ",", "b"}], "]"}], "+", 
  RowBox[{"17", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "e", ",", "Inf", ",", "f", ",", "d"}], "]"}]}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "f", ",", "Inf", ",", "b", ",", "d"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "f", ",", "Inf", ",", "b", ",", "e"}], "]"}]}], "+", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "f", ",", "Inf", ",", "d", ",", "e"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"c", ",", "f", ",", "Inf", ",", "e", ",", "b"}], "]"}]}], "+", 
  RowBox[{"I31bci", "[", 
   RowBox[{"c", ",", "f", ",", "Inf", ",", "e", ",", "d"}], "]"}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"d", ",", "a", ",", "e", ",", "b", ",", "c"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"d", ",", "a", ",", "e", ",", "b", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"d", ",", "a", ",", "e", ",", "c", ",", "b"}], "]"}]}], "+", 
  RowBox[{"18", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"d", ",", "a", ",", "e", ",", "c", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"I31bci", "[", 
   RowBox[{"d", ",", "a", ",", "e", ",", "Inf", ",", "c"}], "]"}], "+", 
  RowBox[{"27", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"d", ",", "a", ",", "Inf", ",", "b", ",", "c"}], "]"}]}], "-", 
  RowBox[{"5", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"d", ",", "a", ",", "Inf", ",", "b", ",", "e"}], "]"}]}], "+", 
  RowBox[{"28", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"d", ",", "a", ",", "Inf", ",", "c", ",", "b"}], "]"}]}], "+", 
  RowBox[{"22", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"d", ",", "a", ",", "Inf", ",", "c", ",", "e"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"d", ",", "a", ",", "Inf", ",", "e", ",", "b"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"d", ",", "b", ",", "e", ",", "a", ",", "c"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"d", ",", "b", ",", "e", ",", "a", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"d", ",", "b", ",", "e", ",", "c", ",", "a"}], "]"}]}], "+", 
  RowBox[{"5", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"d", ",", "b", ",", "e", ",", "c", ",", "f"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"d", ",", "b", ",", "e", ",", "f", ",", "c"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"d", ",", "b", ",", "e", ",", "f", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"d", ",", "b", ",", "e", ",", "Inf", ",", "a"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"d", ",", "b", ",", "e", ",", "Inf", ",", "f"}], "]"}]}], "+", 
  RowBox[{"4", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"d", ",", "b", ",", "f", ",", "c", ",", "e"}], "]"}]}], "+", 
  RowBox[{"6", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"d", ",", "b", ",", "f", ",", "c", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"d", ",", "b", ",", "Inf", ",", "a", ",", "c"}], "]"}]}], "-", 
  RowBox[{"11", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"d", ",", "b", ",", "Inf", ",", "a", ",", "e"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"d", ",", "b", ",", "Inf", ",", "c", ",", "a"}], "]"}]}], "+", 
  RowBox[{"25", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"d", ",", "b", ",", "Inf", ",", "c", ",", "f"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"d", ",", "b", ",", "Inf", ",", "f", ",", "c"}], "]"}]}], "+", 
  RowBox[{"11", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"d", ",", "b", ",", "Inf", ",", "f", ",", "e"}], "]"}]}], "+", 
  RowBox[{"I31bci", "[", 
   RowBox[{"d", ",", "c", ",", "e", ",", "b", ",", "a"}], "]"}], "-", 
  RowBox[{"I31bci", "[", 
   RowBox[{"d", ",", "c", ",", "e", ",", "b", ",", "f"}], "]"}], "-", 
  RowBox[{"I31bci", "[", 
   RowBox[{"d", ",", "c", ",", "e", ",", "Inf", ",", "a"}], "]"}], "+", 
  RowBox[{"I31bci", "[", 
   RowBox[{"d", ",", "c", ",", "e", ",", "Inf", ",", "f"}], "]"}], "-", 
  RowBox[{"20", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"d", ",", "c", ",", "Inf", ",", "a", ",", "b"}], "]"}]}], "-", 
  RowBox[{"I31bci", "[", 
   RowBox[{"d", ",", "c", ",", "Inf", ",", "b", ",", "a"}], "]"}], "+", 
  RowBox[{"I31bci", "[", 
   RowBox[{"d", ",", "c", ",", "Inf", ",", "b", ",", "f"}], "]"}], "+", 
  RowBox[{"20", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"d", ",", "c", ",", "Inf", ",", "f", ",", "b"}], "]"}]}], "-", 
  RowBox[{"9", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"d", ",", "e", ",", "Inf", ",", "a", ",", "b"}], "]"}]}], "+", 
  RowBox[{"9", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"d", ",", "e", ",", "Inf", ",", "f", ",", "b"}], "]"}]}], "-", 
  RowBox[{"21", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"d", ",", "f", ",", "Inf", ",", "b", ",", "c"}], "]"}]}], "+", 
  RowBox[{"17", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"d", ",", "f", ",", "Inf", ",", "b", ",", "e"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"d", ",", "f", ",", "Inf", ",", "e", ",", "b"}], "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"d", ",", "f", ",", "Inf", ",", "e", ",", "c"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"e", ",", "a", ",", "Inf", ",", "b", ",", "c"}], "]"}]}], "-", 
  RowBox[{"6", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"e", ",", "a", ",", "Inf", ",", "b", ",", "d"}], "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"e", ",", "a", ",", "Inf", ",", "c", ",", "b"}], "]"}]}], "+", 
  RowBox[{"14", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"e", ",", "a", ",", "Inf", ",", "c", ",", "d"}], "]"}]}], "-", 
  RowBox[{"12", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"e", ",", "a", ",", "Inf", ",", "d", ",", "b"}], "]"}]}], "+", 
  RowBox[{"16", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"e", ",", "a", ",", "Inf", ",", "d", ",", "c"}], "]"}]}], "+", 
  RowBox[{"7", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"e", ",", "b", ",", "f", ",", "c", ",", "d"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"e", ",", "b", ",", "f", ",", "c", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"e", ",", "b", ",", "f", ",", "d", ",", "c"}], "]"}]}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"e", ",", "b", ",", "f", ",", "d", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"I31bci", "[", 
   RowBox[{"e", ",", "b", ",", "f", ",", "Inf", ",", "d"}], "]"}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"e", ",", "b", ",", "Inf", ",", "a", ",", "c"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"e", ",", "b", ",", "Inf", ",", "c", ",", "a"}], "]"}]}], "-", 
  RowBox[{"5", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"e", ",", "b", ",", "Inf", ",", "c", ",", "f"}], "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"e", ",", "b", ",", "Inf", ",", "d", ",", "f"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"e", ",", "b", ",", "Inf", ",", "f", ",", "c"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"e", ",", "c", ",", "f", ",", "b", ",", "d"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"e", ",", "c", ",", "f", ",", "b", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"e", ",", "c", ",", "f", ",", "d", ",", "b"}], "]"}]}], "-", 
  RowBox[{"7", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"e", ",", "c", ",", "f", ",", "d", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"e", ",", "c", ",", "f", ",", "Inf", ",", "b"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"e", ",", "c", ",", "f", ",", "Inf", ",", "d"}], "]"}]}], "+", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"e", ",", "c", ",", "Inf", ",", "a", ",", "b"}], "]"}]}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"e", ",", "c", ",", "Inf", ",", "a", ",", "d"}], "]"}]}], "-", 
  RowBox[{"I31bci", "[", 
   RowBox[{"e", ",", "c", ",", "Inf", ",", "b", ",", "a"}], "]"}], "+", 
  RowBox[{"I31bci", "[", 
   RowBox[{"e", ",", "c", ",", "Inf", ",", "b", ",", "f"}], "]"}], "+", 
  RowBox[{"14", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"e", ",", "c", ",", "Inf", ",", "d", ",", "f"}], "]"}]}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"e", ",", "c", ",", "Inf", ",", "f", ",", "b"}], "]"}]}], "+", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"e", ",", "c", ",", "Inf", ",", "f", ",", "d"}], "]"}]}], "-", 
  RowBox[{"I31bci", "[", 
   RowBox[{"e", ",", "d", ",", "f", ",", "c", ",", "b"}], "]"}], "+", 
  RowBox[{"I31bci", "[", 
   RowBox[{"e", ",", "d", ",", "f", ",", "c", ",", "Inf"}], "]"}], "+", 
  RowBox[{"I31bci", "[", 
   RowBox[{"e", ",", "d", ",", "f", ",", "Inf", ",", "b"}], "]"}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"e", ",", "d", ",", "f", ",", "Inf", ",", "c"}], "]"}]}], "+", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"e", ",", "d", ",", "Inf", ",", "a", ",", "b"}], "]"}]}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"e", ",", "d", ",", "Inf", ",", "a", ",", "c"}], "]"}]}], "-", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"e", ",", "d", ",", "Inf", ",", "f", ",", "b"}], "]"}]}], "+", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"e", ",", "d", ",", "Inf", ",", "f", ",", "c"}], "]"}]}], "-", 
  RowBox[{"11", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"e", ",", "f", ",", "Inf", ",", "b", ",", "c"}], "]"}]}], "+", 
  RowBox[{"10", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"e", ",", "f", ",", "Inf", ",", "d", ",", "b"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"f", ",", "b", ",", "Inf", ",", "c", ",", "d"}], "]"}]}], "+", 
  RowBox[{"6", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"f", ",", "b", ",", "Inf", ",", "c", ",", "e"}], "]"}]}], "+", 
  RowBox[{"22", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"f", ",", "b", ",", "Inf", ",", "d", ",", "c"}], "]"}]}], "-", 
  RowBox[{"14", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"f", ",", "b", ",", "Inf", ",", "d", ",", "e"}], "]"}]}], "+", 
  RowBox[{"12", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"f", ",", "b", ",", "Inf", ",", "e", ",", "c"}], "]"}]}], "+", 
  RowBox[{"4", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"f", ",", "b", ",", "Inf", ",", "e", ",", "d"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"f", ",", "c", ",", "Inf", ",", "b", ",", "d"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"f", ",", "c", ",", "Inf", ",", "d", ",", "b"}], "]"}]}], "-", 
  RowBox[{"9", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"f", ",", "c", ",", "Inf", ",", "d", ",", "e"}], "]"}]}], "+", 
  RowBox[{"I31bci", "[", 
   RowBox[{"f", ",", "d", ",", "Inf", ",", "c", ",", "b"}], "]"}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"f", ",", "d", ",", "Inf", ",", "c", ",", "e"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31bci", "[", 
    RowBox[{"f", ",", "d", ",", "Inf", ",", "e", ",", "c"}], "]"}]}], "-", 
  RowBox[{"I31bci", "[", 
   RowBox[{"f", ",", "e", ",", "Inf", ",", "d", ",", "c"}], "]"}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e"}], "]"}]}], "+", 
  RowBox[{"22", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"4", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"a", ",", "b", ",", "c", ",", "e", ",", "d"}], "]"}]}], "-", 
  RowBox[{"6", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"a", ",", "b", ",", "c", ",", "e", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"24", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"a", ",", "b", ",", "c", ",", "Inf", ",", "d"}], "]"}]}], "-", 
  RowBox[{"8", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"a", ",", "b", ",", "c", ",", "Inf", ",", "e"}], "]"}]}], "+", 
  RowBox[{"4", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"a", ",", "b", ",", "d", ",", "e", ",", "c"}], "]"}]}], "-", 
  RowBox[{"4", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"a", ",", "b", ",", "d", ",", "e", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"6", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"a", ",", "b", ",", "d", ",", "Inf", ",", "c"}], "]"}]}], "+", 
  RowBox[{"12", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"a", ",", "b", ",", "d", ",", "Inf", ",", "e"}], "]"}]}], "-", 
  RowBox[{"14", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"a", ",", "b", ",", "e", ",", "Inf", ",", "c"}], "]"}]}], "-", 
  RowBox[{"6", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"a", ",", "b", ",", "e", ",", "Inf", ",", "d"}], "]"}]}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"a", ",", "c", ",", "d", ",", "e", ",", "b"}], "]"}]}], "+", 
  RowBox[{"18", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"a", ",", "c", ",", "d", ",", "e", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"28", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"a", ",", "c", ",", "d", ",", "Inf", ",", "b"}], "]"}]}], "+", 
  RowBox[{"22", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"a", ",", "c", ",", "d", ",", "Inf", ",", "e"}], "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"a", ",", "c", ",", "e", ",", "Inf", ",", "b"}], "]"}]}], "+", 
  RowBox[{"14", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"a", ",", "c", ",", "e", ",", "Inf", ",", "d"}], "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"a", ",", "d", ",", "e", ",", "Inf", ",", "b"}], "]"}]}], "+", 
  RowBox[{"16", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"a", ",", "d", ",", "e", ",", "Inf", ",", "c"}], "]"}]}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"b", ",", "c", ",", "d", ",", "e", ",", "f"}], "]"}]}], "+", 
  RowBox[{"4", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"b", ",", "c", ",", "d", ",", "f", ",", "e"}], "]"}]}], "+", 
  RowBox[{"6", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"b", ",", "c", ",", "d", ",", "f", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"28", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"b", ",", "c", ",", "d", ",", "Inf", ",", "f"}], "]"}]}], "+", 
  RowBox[{"6", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"b", ",", "c", ",", "e", ",", "f", ",", "d"}], "]"}]}], "+", 
  RowBox[{"4", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"b", ",", "c", ",", "e", ",", "f", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"b", ",", "c", ",", "e", ",", "Inf", ",", "f"}], "]"}]}], "+", 
  RowBox[{"4", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"b", ",", "c", ",", "f", ",", "Inf", ",", "d"}], "]"}]}], "+", 
  RowBox[{"6", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"b", ",", "c", ",", "f", ",", "Inf", ",", "e"}], "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"b", ",", "d", ",", "e", ",", "f", ",", "c"}], "]"}]}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"b", ",", "d", ",", "e", ",", "f", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"b", ",", "d", ",", "e", ",", "Inf", ",", "f"}], "]"}]}], "+", 
  RowBox[{"22", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"b", ",", "d", ",", "f", ",", "Inf", ",", "c"}], "]"}]}], "-", 
  RowBox[{"14", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"b", ",", "d", ",", "f", ",", "Inf", ",", "e"}], "]"}]}], "+", 
  RowBox[{"12", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"b", ",", "e", ",", "f", ",", "Inf", ",", "c"}], "]"}]}], "+", 
  RowBox[{"4", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"b", ",", "e", ",", "f", ",", "Inf", ",", "d"}], "]"}]}], "-", 
  RowBox[{"4", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"c", ",", "d", ",", "e", ",", "f", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"14", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"c", ",", "d", ",", "e", ",", "Inf", ",", "f"}], "]"}]}], "-", 
  RowBox[{"8", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"c", ",", "d", ",", "f", ",", "Inf", ",", "e"}], "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"I31cyci", "[", 
    RowBox[{"d", ",", "Inf", ",", "f", ",", "e", ",", "c"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e"}], "]"}]}], "-", 
  RowBox[{"23", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"7", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"a", ",", "b", ",", "c", ",", "e", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"I31dei", "[", 
   RowBox[{"a", ",", "b", ",", "d", ",", "c", ",", "e"}], "]"}], "-", 
  RowBox[{"19", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"a", ",", "b", ",", "d", ",", "c", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"I31dei", "[", 
   RowBox[{"a", ",", "b", ",", "d", ",", "e", ",", "Inf"}], "]"}], "+", 
  RowBox[{"5", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"a", ",", "b", ",", "e", ",", "c", ",", "d"}], "]"}]}], "+", 
  RowBox[{"5", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"a", ",", "b", ",", "e", ",", "c", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"5", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"a", ",", "b", ",", "e", ",", "d", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"25", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"a", ",", "b", ",", "Inf", ",", "c", ",", "d"}], "]"}]}], "+", 
  RowBox[{"11", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"a", ",", "b", ",", "Inf", ",", "c", ",", "e"}], "]"}]}], "+", 
  RowBox[{"7", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"a", ",", "b", ",", "Inf", ",", "d", ",", "e"}], "]"}]}], "-", 
  RowBox[{"5", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"a", ",", "c", ",", "d", ",", "b", ",", "e"}], "]"}]}], "-", 
  RowBox[{"25", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"a", ",", "c", ",", "d", ",", "b", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"15", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"a", ",", "c", ",", "d", ",", "e", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"I31dei", "[", 
   RowBox[{"a", ",", "c", ",", "e", ",", "b", ",", "d"}], "]"}], "-", 
  RowBox[{"I31dei", "[", 
   RowBox[{"a", ",", "c", ",", "e", ",", "b", ",", "Inf"}], "]"}], "-", 
  RowBox[{"11", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"a", ",", "c", ",", "e", ",", "d", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"31", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"a", ",", "c", ",", "Inf", ",", "b", ",", "d"}], "]"}]}], "+", 
  RowBox[{"5", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"a", ",", "c", ",", "Inf", ",", "b", ",", "e"}], "]"}]}], "-", 
  RowBox[{"13", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"a", ",", "c", ",", "Inf", ",", "d", ",", "e"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"a", ",", "d", ",", "e", ",", "b", ",", "c"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"a", ",", "d", ",", "e", ",", "b", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"17", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"a", ",", "d", ",", "e", ",", "c", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"27", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"a", ",", "d", ",", "Inf", ",", "b", ",", "c"}], "]"}]}], "+", 
  RowBox[{"5", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"a", ",", "d", ",", "Inf", ",", "b", ",", "e"}], "]"}]}], "-", 
  RowBox[{"19", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"a", ",", "d", ",", "Inf", ",", "c", ",", "e"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"a", ",", "e", ",", "Inf", ",", "b", ",", "c"}], "]"}]}], "+", 
  RowBox[{"9", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"a", ",", "e", ",", "Inf", ",", "b", ",", "d"}], "]"}]}], "-", 
  RowBox[{"15", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"a", ",", "e", ",", "Inf", ",", "c", ",", "d"}], "]"}]}], "+", 
  RowBox[{"I31dei", "[", 
   RowBox[{"b", ",", "c", ",", "d", ",", "a", ",", "e"}], "]"}], "-", 
  RowBox[{"I31dei", "[", 
   RowBox[{"b", ",", "c", ",", "d", ",", "a", ",", "Inf"}], "]"}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"b", ",", "c", ",", "d", ",", "e", ",", "f"}], "]"}]}], "-", 
  RowBox[{"27", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"b", ",", "c", ",", "d", ",", "f", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"b", ",", "c", ",", "e", ",", "a", ",", "d"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"b", ",", "c", ",", "e", ",", "a", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"I31dei", "[", 
   RowBox[{"b", ",", "c", ",", "e", ",", "d", ",", "f"}], "]"}], "-", 
  RowBox[{"I31dei", "[", 
   RowBox[{"b", ",", "c", ",", "e", ",", "f", ",", "Inf"}], "]"}], "-", 
  RowBox[{"5", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"b", ",", "c", ",", "f", ",", "d", ",", "e"}], "]"}]}], "-", 
  RowBox[{"5", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"b", ",", "c", ",", "f", ",", "d", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"5", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"b", ",", "c", ",", "f", ",", "e", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"b", ",", "c", ",", "Inf", ",", "a", ",", "d"}], "]"}]}], "-", 
  RowBox[{"I31dei", "[", 
   RowBox[{"b", ",", "c", ",", "Inf", ",", "a", ",", "e"}], "]"}], "-", 
  RowBox[{"31", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"b", ",", "c", ",", "Inf", ",", "d", ",", "f"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"b", ",", "c", ",", "Inf", ",", "e", ",", "f"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"b", ",", "d", ",", "e", ",", "a", ",", "c"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"b", ",", "d", ",", "e", ",", "a", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"5", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"b", ",", "d", ",", "e", ",", "c", ",", "f"}], "]"}]}], "+", 
  RowBox[{"5", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"b", ",", "d", ",", "e", ",", "f", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"I31dei", "[", 
   RowBox[{"b", ",", "d", ",", "f", ",", "c", ",", "e"}], "]"}], "-", 
  RowBox[{"9", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"b", ",", "d", ",", "f", ",", "c", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"I31dei", "[", 
   RowBox[{"b", ",", "d", ",", "f", ",", "e", ",", "Inf"}], "]"}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"b", ",", "d", ",", "Inf", ",", "a", ",", "c"}], "]"}]}], "-", 
  RowBox[{"I31dei", "[", 
   RowBox[{"b", ",", "d", ",", "Inf", ",", "a", ",", "e"}], "]"}], "-", 
  RowBox[{"25", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"b", ",", "d", ",", "Inf", ",", "c", ",", "f"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"b", ",", "d", ",", "Inf", ",", "e", ",", "f"}], "]"}]}], "-", 
  RowBox[{"7", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"b", ",", "e", ",", "f", ",", "c", ",", "d"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"b", ",", "e", ",", "f", ",", "c", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"b", ",", "e", ",", "f", ",", "d", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"b", ",", "e", ",", "Inf", ",", "a", ",", "c"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"b", ",", "e", ",", "Inf", ",", "a", ",", "d"}], "]"}]}], "+", 
  RowBox[{"5", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"b", ",", "e", ",", "Inf", ",", "c", ",", "f"}], "]"}]}], "-", 
  RowBox[{"I31dei", "[", 
   RowBox[{"b", ",", "e", ",", "Inf", ",", "d", ",", "f"}], "]"}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"b", ",", "f", ",", "Inf", ",", "c", ",", "d"}], "]"}]}], "-", 
  RowBox[{"9", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"b", ",", "f", ",", "Inf", ",", "c", ",", "e"}], "]"}]}], "-", 
  RowBox[{"5", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"b", ",", "f", ",", "Inf", ",", "d", ",", "e"}], "]"}]}], "-", 
  RowBox[{"I31dei", "[", 
   RowBox[{"c", ",", "d", ",", "e", ",", "a", ",", "b"}], "]"}], "+", 
  RowBox[{"I31dei", "[", 
   RowBox[{"c", ",", "d", ",", "e", ",", "a", ",", "Inf"}], "]"}], "-", 
  RowBox[{"I31dei", "[", 
   RowBox[{"c", ",", "d", ",", "e", ",", "b", ",", "f"}], "]"}], "-", 
  RowBox[{"15", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"c", ",", "d", ",", "e", ",", "f", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"c", ",", "d", ",", "f", ",", "b", ",", "e"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"c", ",", "d", ",", "f", ",", "b", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"I31dei", "[", 
   RowBox[{"c", ",", "d", ",", "f", ",", "e", ",", "Inf"}], "]"}], "+", 
  RowBox[{"I31dei", "[", 
   RowBox[{"c", ",", "d", ",", "Inf", ",", "a", ",", "b"}], "]"}], "-", 
  RowBox[{"I31dei", "[", 
   RowBox[{"c", ",", "d", ",", "Inf", ",", "a", ",", "e"}], "]"}], "-", 
  RowBox[{"29", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"c", ",", "d", ",", "Inf", ",", "b", ",", "f"}], "]"}]}], "-", 
  RowBox[{"13", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"c", ",", "d", ",", "Inf", ",", "e", ",", "f"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"c", ",", "e", ",", "f", ",", "b", ",", "d"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"c", ",", "e", ",", "f", ",", "b", ",", "Inf"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"c", ",", "e", ",", "f", ",", "d", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"I31dei", "[", 
   RowBox[{"c", ",", "e", ",", "Inf", ",", "a", ",", "b"}], "]"}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"c", ",", "e", ",", "Inf", ",", "a", ",", "d"}], "]"}]}], "+", 
  RowBox[{"I31dei", "[", 
   RowBox[{"c", ",", "e", ",", "Inf", ",", "b", ",", "f"}], "]"}], "-", 
  RowBox[{"17", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"c", ",", "e", ",", "Inf", ",", "d", ",", "f"}], "]"}]}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"c", ",", "f", ",", "Inf", ",", "b", ",", "d"}], "]"}]}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"c", ",", "f", ",", "Inf", ",", "b", ",", "e"}], "]"}]}], "-", 
  RowBox[{"I31dei", "[", 
   RowBox[{"c", ",", "f", ",", "Inf", ",", "d", ",", "e"}], "]"}], "+", 
  RowBox[{"I31dei", "[", 
   RowBox[{"d", ",", "e", ",", "f", ",", "b", ",", "c"}], "]"}], "-", 
  RowBox[{"I31dei", "[", 
   RowBox[{"d", ",", "e", ",", "f", ",", "b", ",", "Inf"}], "]"}], "+", 
  RowBox[{"3", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"d", ",", "e", ",", "f", ",", "c", ",", "Inf"}], "]"}]}], "+", 
  RowBox[{"I31dei", "[", 
   RowBox[{"d", ",", "e", ",", "Inf", ",", "a", ",", "b"}], "]"}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"d", ",", "e", ",", "Inf", ",", "a", ",", "c"}], "]"}]}], "+", 
  RowBox[{"I31dei", "[", 
   RowBox[{"d", ",", "e", ",", "Inf", ",", "b", ",", "f"}], "]"}], "-", 
  RowBox[{"11", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"d", ",", "e", ",", "Inf", ",", "c", ",", "f"}], "]"}]}], "-", 
  RowBox[{"I31dei", "[", 
   RowBox[{"d", ",", "f", ",", "Inf", ",", "b", ",", "c"}], "]"}], "-", 
  RowBox[{"3", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"d", ",", "f", ",", "Inf", ",", "b", ",", "e"}], "]"}]}], "+", 
  RowBox[{"5", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"d", ",", "f", ",", "Inf", ",", "c", ",", "e"}], "]"}]}], "-", 
  RowBox[{"I31dei", "[", 
   RowBox[{"e", ",", "f", ",", "Inf", ",", "b", ",", "c"}], "]"}], "-", 
  RowBox[{"7", " ", 
   RowBox[{"I31dei", "[", 
    RowBox[{"e", ",", "f", ",", "Inf", ",", "b", ",", "d"}], "]"}]}], "+", 
  RowBox[{"I31dei", "[", 
   RowBox[{"e", ",", "f", ",", "Inf", ",", "c", ",", "d"}], "]"}]}]], "Output",
 CellChangeTimes->{{3.69764210219337*^9, 3.697642106894697*^9}, 
   3.6976425954158735`*^9, 3.697642735167816*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"danI31feasGangl", "//", "Length"}]], "Input",
 CellChangeTimes->{{3.697641661862898*^9, 3.697641667069584*^9}, {
  3.697641849566143*^9, 3.6976418525802746`*^9}}],

Cell[BoxData["629"], "Output",
 CellChangeTimes->{3.697641667459858*^9, 3.6976417022509375`*^9, 
  3.6976418590148277`*^9, 3.6976425954899263`*^9, 3.697642735204848*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"canonicalI4", "[", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", "4", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a_", ",", "b_", ",", "c_", ",", "d_"}], "}"}], "]"}], 
      "}"}]}], "]"}], "]"}], " ", ":=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"#", "[", 
      RowBox[{"[", "2", "]"}], "]"}], 
     RowBox[{"IIi", "[", 
      RowBox[{
       RowBox[{"{", "4", "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"cri", "[", 
         RowBox[{"#", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "]"}], "}"}]}], "]"}]}], "&"}], "@", 
   RowBox[{
    RowBox[{"SortBy", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}], ",", "1"}], 
         "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"b", ",", "a", ",", "d", ",", "c"}], "}"}], ",", "1"}], 
         "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"c", ",", "d", ",", "a", ",", "b"}], "}"}], ",", "1"}], 
         "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"d", ",", "c", ",", "b", ",", "a"}], "}"}], ",", "1"}], 
         "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"b", ",", "a", ",", "c", ",", "d"}], "}"}], ",", 
          RowBox[{"-", "1"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"a", ",", "b", ",", "d", ",", "c"}], "}"}], ",", 
          RowBox[{"-", "1"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"d", ",", "c", ",", "a", ",", "b"}], "}"}], ",", 
          RowBox[{"-", "1"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"c", ",", "d", ",", "b", ",", "a"}], "}"}], ",", 
          RowBox[{"-", "1"}]}], "}"}]}], "}"}], ",", " ", 
      RowBox[{
       RowBox[{"#", "[", 
        RowBox[{"[", "1", "]"}], "]"}], "&"}]}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.6976421267387466`*^9, 3.697642218450658*^9}, {
  3.697642294013438*^9, 3.69764243904554*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"-", "20"}], " ", "i31fe"}], " ", "+", " ", "danI31feasGangl"}],
     "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"I31abi", "\[Rule]", "I31ab"}], ",", 
      RowBox[{"I31bci", "\[Rule]", "I31bc"}], ",", 
      RowBox[{"I31dei", "\[Rule]", "I31de"}], ",", 
      RowBox[{"I31cyci", "\[Rule]", "I31cyc"}]}], "}"}]}], "/.", 
   RowBox[{
    RowBox[{"w", ":", 
     RowBox[{"IIi", "[", 
      RowBox[{
       RowBox[{"{", "4", "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"cri", "[", 
         RowBox[{"{", 
          RowBox[{"a_", ",", "b_", ",", "c_", ",", "d_"}], "}"}], "]"}], 
        "}"}]}], "]"}]}], "\[RuleDelayed]", 
    RowBox[{"canonicalI4", "[", "w", "]"}]}]}], "//", "Expand"}]], "Input",
 CellChangeTimes->{{3.6674770013211193`*^9, 3.667477008616356*^9}, {
  3.667477067326096*^9, 3.6674770989612617`*^9}, {3.697641476705083*^9, 
  3.69764151659131*^9}, {3.6976416147334948`*^9, 3.6976416265278416`*^9}, {
  3.697641709937377*^9, 3.697641711810705*^9}, {3.6976417931555834`*^9, 
  3.6976418106419287`*^9}, {3.6976418638382473`*^9, 3.6976419101850433`*^9}, {
  3.6976420716347528`*^9, 3.697642077290722*^9}, {3.6976421149374056`*^9, 
  3.6976421160041437`*^9}, {3.697642276136759*^9, 3.697642277718907*^9}, {
  3.697642445689239*^9, 3.6976425171302624`*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.697642072134111*^9, 3.6976421168977757`*^9, 3.6976422781041613`*^9, {
   3.697642490557976*^9, 3.6976425175885563`*^9}, 3.6976425956059957`*^9, 
   3.69764273534793*^9}]
}, Open  ]]
},
WindowSize->{1536, 794},
WindowMargins->{{-8, Automatic}, {Automatic, -8}},
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 363, 8, 30, "Input"],
Cell[924, 30, 1102, 31, 88, "Input"],
Cell[2029, 63, 1404, 43, 50, "Input"],
Cell[3436, 108, 1268, 37, 50, "Input"],
Cell[4707, 147, 330, 8, 30, "Input"],
Cell[5040, 157, 385, 8, 30, "Input"],
Cell[CellGroupData[{
Cell[5450, 169, 664, 17, 30, "Input"],
Cell[6117, 188, 194, 3, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6348, 196, 666, 17, 30, "Input"],
Cell[7017, 215, 192, 3, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7246, 223, 666, 17, 30, "Input"],
Cell[7915, 242, 196, 3, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8148, 250, 663, 17, 30, "Input"],
Cell[8814, 269, 200, 3, 30, "Output"]
}, Open  ]],
Cell[9029, 275, 237, 5, 30, "Input"],
Cell[9269, 282, 240, 6, 30, "Input"],
Cell[CellGroupData[{
Cell[9534, 292, 639, 13, 30, "Input"],
Cell[10176, 307, 269, 4, 30, "Output"]
}, Open  ]],
Cell[10460, 314, 242, 5, 30, "Input"],
Cell[CellGroupData[{
Cell[10727, 323, 551, 15, 30, "Input"],
Cell[11281, 340, 17059, 455, 163, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[28377, 800, 455, 13, 30, "Input"],
Cell[28835, 815, 114554, 4106, 1739, "Output"]
}, Open  ]],
Cell[143404, 4924, 254, 5, 30, "Input"],
Cell[CellGroupData[{
Cell[143683, 4933, 988, 24, 30, "Input"],
Cell[144674, 4959, 18742, 506, 163, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[163453, 5470, 1086, 25, 50, "Input"],
Cell[164542, 5497, 18804, 501, 187, "Output"]
}, Open  ]],
Cell[183361, 6001, 227, 5, 30, "Input"],
Cell[183591, 6008, 726, 17, 30, "Input"],
Cell[CellGroupData[{
Cell[184342, 6029, 439, 12, 30, "Input"],
Cell[184784, 6043, 147, 2, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[184968, 6050, 109, 1, 30, "Input"],
Cell[185080, 6053, 74885, 1759, 1684, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[260002, 7817, 186, 3, 30, "Input"],
Cell[260191, 7822, 169, 2, 30, "Output"]
}, Open  ]],
Cell[260375, 7827, 2381, 73, 69, "Input"],
Cell[CellGroupData[{
Cell[262781, 7904, 1370, 32, 30, "Input"],
Cell[264154, 7938, 222, 4, 30, "Output"]
}, Open  ]]
}
]
*)

