(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    199274,       4842]
NotebookOptionsPosition[    195265,       4706]
NotebookOutlinePosition[    195631,       4722]
CellTagsIndexPosition[    195588,       4719]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"<<", "TeXUtilities`"}]], "Input",
 CellChangeTimes->{{3.6576231620347567`*^9, 3.657623167774674*^9}, {
  3.69752451959698*^9, 3.6975245257731028`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Get", "[", 
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
    "\"\<dan_procedure.m\>\""}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.697598984782219*^9, 3.69759900807892*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"TeX", " ", "Formatting"}], "*)"}], 
  RowBox[{
   RowBox[{
    RowBox[{"Format", "[", 
     RowBox[{
      RowBox[{"a", "[", "i_", "]"}], ",", "TraditionalForm"}], "]"}], ":=", 
    RowBox[{"Subscript", "[", 
     RowBox[{"a", ",", "i"}], "]"}]}], "\n", 
   RowBox[{
    RowBox[{"Format", "[", 
     RowBox[{"Inf", ",", "TeXForm"}], "]"}], ":=", 
    RowBox[{"TeXCommand", "[", "\"\<infty\>\"", "]"}]}], "\n", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"myFold", "[", 
     RowBox[{"f_", ",", "l_List"}], "]"}], ":=", 
    RowBox[{"Fold", "[", 
     RowBox[{"f", ",", 
      RowBox[{"l", "[", 
       RowBox[{"[", "1", "]"}], "]"}], ",", 
      RowBox[{"l", "[", 
       RowBox[{"[", 
        RowBox[{"2", ";;", "All"}], "]"}], "]"}]}], "]"}]}], "\n", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"myTeXList", "[", "l_List", "]"}], ":=", 
    RowBox[{"TeXForm", "[", 
     RowBox[{"TeXVerbatim", "[", 
      RowBox[{"myFold", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"#1", "<>", "\"\<, \>\"", "<>", "#2"}], "&"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"ToString", "[", 
           RowBox[{"TeXForm", "[", "#", "]"}], "]"}], "&"}], "/@", "l"}]}], 
       "]"}], "]"}], "]"}]}], "\n", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Format", "[", 
     RowBox[{
      RowBox[{"cri", "[", "l_List", "]"}], ",", "TeXForm"}], "]"}], ":=", 
    RowBox[{"TeXVerbatim", "[", 
     RowBox[{"myFold", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"#1", "<>", "\"\< \>\"", "<>", "#2"}], "&"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"ToString", "[", 
          RowBox[{"TeXForm", "[", "#", "]"}], "]"}], "&"}], "/@", "l"}]}], 
      "]"}], "]"}]}], "\n", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Format", "[", 
     RowBox[{
      RowBox[{"IIi", "[", 
       RowBox[{"inds_List", ",", "args_List"}], "]"}], ",", "TeXForm"}], 
     "]"}], ":=", 
    RowBox[{"TeXVerbatim", "[", 
     RowBox[{"\"\<I_{\>\"", "<>", 
      RowBox[{"ToString", "[", 
       RowBox[{"myTeXList", "[", "inds", "]"}], "]"}], "<>", "\"\<}(\>\"", "<>", 
      RowBox[{"ToString", "[", 
       RowBox[{"myTeXList", "[", "args", "]"}], "]"}], "<>", "\"\<)\>\""}], 
     "]"}]}], "\n", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Format", "[", 
      RowBox[{
       RowBox[{"H", "[", 
        RowBox[{"a0_", ",", "alist_List", ",", "x_", ",", "alast_"}], "]"}], 
       ",", "TeXForm"}], "]"}], ":=", 
     RowBox[{"TeXVerbatim", "[", 
      RowBox[{"\"\<H(\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"TeXForm", "[", "a0", "]"}], "]"}], "<>", "\"\< \\\\mid \>\"",
        "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"myTeXList", "[", "alist", "]"}], "]"}], "<>", 
       "\"\< \\\\dblslash \>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"TeXForm", "[", "x", "]"}], "]"}], "<>", "\"\< \\\\mid \>\"", 
       "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"TeXForm", "[", "alast", "]"}], "]"}], "<>", "\"\<)\>\""}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{"manipulate", " ", "and", " ", "LaTeX", " ", "results"}], "*)"}], 
   "\n", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"gatherIntegrals", "[", "expr_", "]"}], ":=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Head", "[", "expr", "]"}], "===", "Plus"}], ",", 
           RowBox[{"List", "@@", "expr"}], ",", 
           RowBox[{"{", "expr", "}"}]}], "]"}], ")"}], "//", 
        RowBox[{
         RowBox[{"GatherBy", "[", 
          RowBox[{"#", ",", 
           RowBox[{
            RowBox[{"indices", "[", "#", "]"}], "&"}]}], "]"}], "&"}]}], 
       ")"}], "//", "Reverse"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"gatherIntegrals", "[", 
      RowBox[{"expr_", ",", "function_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Head", "[", "expr", "]"}], "===", "Plus"}], ",", 
           RowBox[{"List", "@@", "expr"}], ",", 
           RowBox[{"{", "expr", "}"}]}], "]"}], ")"}], "//", 
        RowBox[{
         RowBox[{"GatherBy", "[", 
          RowBox[{"#", ",", "function"}], "]"}], "&"}]}], ")"}], "//", 
      "Reverse"}]}], ";"}], "\n", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"countIntegrals", "[", "expr_", "]"}], ":=", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Length", "[", "#", "]"}], ",", "#"}], "}"}], "&"}], "/@", 
        "expr"}], ")"}], "//", "ColumnForm"}], "//", "Print"}]}], "\n", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"texCountIntegrals", "[", "expr_", "]"}], ":=", 
     RowBox[{"\"\<Integral & Number in expression\>\"", "<>", 
      RowBox[{"Fold", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"#1", "<>", "\"\< \\\\\\\\ \\n\>\"", "<>", "#2"}], "&"}], 
        ",", "\"\<\>\"", ",", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"\"\<$ I_\>\"", "<>", 
            RowBox[{"ToString", "[", 
             RowBox[{"indices", "[", 
              RowBox[{"#", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], "]"}], "<>", 
            "\"\< $ & \>\"", "<>", 
            RowBox[{"ToString", "[", 
             RowBox[{"Length", "[", "#", "]"}], "]"}]}], "}"}], "&"}], "/@", 
         "expr"}]}], "]"}], "<>", "\"\< \\\\\\\\ \\nTotal & \>\"", "<>", 
      RowBox[{"ToString", "[", 
       RowBox[{"Total", "[", 
        RowBox[{"Length", "/@", "expr"}], "]"}], "]"}]}]}], ";"}], "\n", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"texCountIntegrals", "[", 
      RowBox[{"expr_", ",", "function_"}], "]"}], ":=", 
     RowBox[{"\"\<Type & Number in expression\>\"", "<>", 
      RowBox[{"Fold", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"#1", "<>", "\"\< \\\\\\\\ \\n\>\"", "<>", "#2"}], "&"}], 
        ",", "\"\<\>\"", ",", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Fold", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"#1", "<>", "\"\< \>\"", "<>", "#2"}], "&"}], ",", 
              RowBox[{"ToString", "/@", 
               RowBox[{"function", "[", 
                RowBox[{"#", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "]"}]}]}], "]"}], "<>", 
            "\"\< $ & \>\"", "<>", 
            RowBox[{"ToString", "[", 
             RowBox[{"Length", "[", "#", "]"}], "]"}]}], "}"}], "&"}], "/@", 
         "expr"}]}], "]"}], "<>", "\"\< \\\\\\\\ \\nTotal & \>\"", "<>", 
      RowBox[{"ToString", "[", 
       RowBox[{"Total", "[", 
        RowBox[{"Length", "/@", "expr"}], "]"}], "]"}]}]}], ";"}], "\n", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"texIntegralsSingleLine", "[", "expr_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\"\<I_{\>\"", "<>", 
        RowBox[{
         RowBox[{"StringCases", "[", 
          RowBox[{"#", ",", 
           RowBox[{
            RowBox[{"\"\<I_{\>\"", "~~", 
             RowBox[{"index", ":", 
              RowBox[{"Shortest", "[", "___", "]"}]}], "~~", "\"\<}\>\""}], 
            "\[RuleDelayed]", "index"}]}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], "<>", "\"\<}( \>\"", "<>", 
        RowBox[{"StringReplace", "[", 
         RowBox[{"#", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"\"\<I_{\>\"", "~~", 
              RowBox[{"Shortest", "[", "___", "]"}], "~~", "\"\<}\>\""}], 
             "\[Rule]", "\"\<\>\""}], ",", 
            RowBox[{"\"\<(\>\"", "\[Rule]", "\"\<[\>\""}], ",", 
            RowBox[{"\"\<)\>\"", "\[Rule]", "\"\<]\>\""}]}], "}"}]}], "]"}], 
        "<>", "\"\< )\>\""}], "&"}], "@", 
      RowBox[{"(", 
       RowBox[{"StringReplace", "[", 
        RowBox[{"expr", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"\"\<)-\>\"", "\[Rule]", "\"\<) \\n - \>\""}], ",", 
           RowBox[{"\"\<)+\>\"", "\[Rule]", "\"\<) \\n + \>\""}]}], "}"}]}], 
        "]"}], ")"}]}]}], ";"}], "\n", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"texJoinIntegrals", "[", "expr_", "]"}], ":=", 
    RowBox[{"Fold", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"#1", "<>", "\"\< + {} \\\\\\\\ \\n & {} + \>\"", "<>", "#2"}],
        "&"}], ",", "expr"}], "]"}]}], "\n", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"texIntegralsWithFracGath", "[", "expr_", "]"}], ":=", 
    RowBox[{"texJoinIntegrals", "[", 
     RowBox[{"texIntegralsSingleLine", "/@", 
      RowBox[{"ToString", "/@", 
       RowBox[{"TeXForm", "/@", 
        RowBox[{"(", 
         RowBox[{"expr", "/.", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Rational", "[", 
             RowBox[{"a_", ",", "b_"}], "]"}], "\[RuleDelayed]", 
            RowBox[{
             RowBox[{"Sign", "[", 
              RowBox[{"a", "/", "b"}], "]"}], " ", 
             RowBox[{"HoldForm", "[", 
              RowBox[{"Evaluate", "[", 
               RowBox[{"Abs", "[", 
                RowBox[{"Divide", "[", 
                 RowBox[{"a", ",", "b"}], "]"}], "]"}], "]"}], "]"}]}]}], 
           "}"}]}], ")"}]}]}]}], "]"}]}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"texIntegralsWithFrac", "[", "expr_", "]"}], ":=", 
     RowBox[{"texIntegralsWithFracGath", "[", 
      RowBox[{"Total", "/@", 
       RowBox[{"gatherIntegrals", "[", "expr", "]"}]}], "]"}]}], ";"}], "\n", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"texIntegralsGath", "[", "expr_List", "]"}], ":=", 
    RowBox[{"texJoinIntegrals", "[", 
     RowBox[{"texIntegralsSingleLine", "/@", 
      RowBox[{"ToString", "/@", 
       RowBox[{"TeXForm", "/@", 
        RowBox[{"(", "expr", ")"}]}]}]}], "]"}]}], "\n", 
   RowBox[{
    RowBox[{"texIntegralsGath", "[", 
     RowBox[{"expr_List", ",", "scaling_"}], "]"}], ":=", 
    RowBox[{"texJoinIntegrals", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"#", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "\[NotEqual]", "1"}], ",", 
           RowBox[{
            RowBox[{"ToString", "[", 
             RowBox[{"TeXForm", "[", 
              RowBox[{"1", "/", 
               RowBox[{"#", "[", 
                RowBox[{"[", "2", "]"}], "]"}]}], "]"}], "]"}], "<>", 
            "\"\< \>\""}], ",", "\"\<\>\""}], "]"}], "<>", 
         RowBox[{"#", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ")"}], "&"}], "/@", 
      RowBox[{"MapThread", "[", 
       RowBox[{"List", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"texIntegralsSingleLine", "/@", 
           RowBox[{"ToString", "/@", 
            RowBox[{"TeXForm", "/@", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"scaling", "*", "expr"}], "//", "Expand"}], 
              ")"}]}]}]}], ",", "scaling"}], "}"}]}], "]"}]}], "]"}]}], "\n", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"texIntegralsByCoeff", "[", "expr_", "]"}], ":=", 
     RowBox[{"Block", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"gath", "=", 
         RowBox[{"gatherIntegrals", "[", 
          RowBox[{"expr", ",", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"indices", "[", "#", "]"}], ",", 
              RowBox[{"denominator", "[", "#", "]"}]}], "}"}], "&"}]}], 
          "]"}]}], "}"}], ",", 
       RowBox[{"texIntegralsGath", "[", 
        RowBox[{
         RowBox[{"Total", "/@", "gath"}], ",", 
         RowBox[{"denominator", "/@", 
          RowBox[{"gath", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "1"}], "]"}], "]"}]}]}], "]"}]}], "]"}]}], 
    ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"texIntegrals", "[", "expr_", "]"}], ":=", 
     RowBox[{"Block", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"gath", "=", 
         RowBox[{"gatherIntegrals", "[", "expr", "]"}]}], "}"}], ",", 
       RowBox[{"texIntegralsGath", "[", 
        RowBox[{"Total", "/@", "gath"}], "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\n", 
   RowBox[{"(*", 
    RowBox[{
    "Using", " ", "a", " ", "pattern", " ", "to", " ", "make", " ", "a", " ", 
     "pattern", " ", "not", " ", "a", " ", 
     RowBox[{
      RowBox[{"pattern", "!"}], "?"}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"lhsRule", "[", 
     RowBox[{"RuleDelayed", "[", 
      RowBox[{"lhs_", ",", "rhs_"}], "]"}], "]"}], ":=", 
    RowBox[{"lhs", "/.", 
     RowBox[{
      RowBox[{"HoldPattern", "[", "w_Pattern", "]"}], "\[RuleDelayed]", 
      RowBox[{"w", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}]}]}], "\n", 
   RowBox[{
    RowBox[{"rhsRule", "[", 
     RowBox[{"RuleDelayed", "[", 
      RowBox[{"lhs_", ",", "rhs_"}], "]"}], "]"}], ":=", 
    RowBox[{"Expand", "[", "rhs", "]"}]}], "\n", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ruleToIdentity", "[", "expr_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"lhsRule", "[", "expr", "]"}], "-", 
       RowBox[{"rhsRule", "[", "expr", "]"}]}], "//", "Expand"}]}], ";"}], 
   "\n", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"texRule", "[", "expr_", "]"}], ":=", 
     RowBox[{"Block", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"gath", "=", 
         RowBox[{"gatherIntegrals", "[", 
          RowBox[{"Expand", "@", 
           RowBox[{"rhsRule", "[", "expr", "]"}]}], "]"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"ToString", "[", 
         RowBox[{"TeXForm", "[", 
          RowBox[{"lhsRule", "[", "expr", "]"}], "]"}], "]"}], "<>", 
        "\"\< & {} = \>\"", "<>", 
        RowBox[{"texIntegralsGath", "[", 
         RowBox[{"Total", "/@", "gath"}], "]"}]}]}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"texRuleWithFrac", "[", "expr_", "]"}], ":=", 
     RowBox[{"Block", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"gath", "=", 
         RowBox[{"gatherIntegrals", "[", 
          RowBox[{"Expand", "@", 
           RowBox[{"rhsRule", "[", "expr", "]"}]}], "]"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"ToString", "[", 
         RowBox[{"TeXForm", "[", 
          RowBox[{"lhsRule", "[", "expr", "]"}], "]"}], "]"}], "<>", 
        "\"\< & {} = \>\"", "<>", 
        RowBox[{"texIntegralsWithFracGath", "[", 
         RowBox[{"Total", "/@", "gath"}], "]"}]}]}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"texRuleByCoeff", "[", "expr_", "]"}], ":=", 
     RowBox[{"Block", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"gath", "=", 
         RowBox[{"gatherIntegrals", "[", 
          RowBox[{
           RowBox[{"Expand", "@", 
            RowBox[{"rhsRule", "[", "expr", "]"}]}], ",", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"indices", "[", "#", "]"}], ",", 
              RowBox[{"denominator", "[", "#", "]"}]}], "}"}], "&"}]}], 
          "]"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"ToString", "[", 
         RowBox[{"TeXForm", "[", 
          RowBox[{"lhsRule", "[", "expr", "]"}], "]"}], "]"}], "<>", 
        "\"\< & {} = \>\"", "<>", 
        RowBox[{"texIntegralsGath", "[", 
         RowBox[{
          RowBox[{"Total", "/@", "gath"}], ",", 
          RowBox[{"denominator", "/@", 
           RowBox[{"gath", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "1"}], "]"}], "]"}]}]}], "]"}]}]}], "]"}]}], 
    ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"texRuleByCR", "[", "expr_", "]"}], ":=", 
     RowBox[{"Block", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"gath", "=", 
         RowBox[{"Reverse", "@", 
          RowBox[{"gatherIntegrals", "[", 
           RowBox[{
            RowBox[{"Expand", "@", 
             RowBox[{"rhsRule", "[", "expr", "]"}]}], ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"indices", "[", "#", "]"}], ",", 
               RowBox[{"denominator", "[", "#", "]"}], ",", 
               RowBox[{
                RowBox[{"args", "[", "#", "]"}], "//", "Length"}], ",", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"Union", "@@", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"args", "[", "#", "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "1"}], "]"}], "]"}], ")"}]}], ")"}], "//",
                 "Length"}]}], "}"}], "&"}]}], "]"}]}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"ToString", "[", 
         RowBox[{"TeXForm", "[", 
          RowBox[{"lhsRule", "[", "expr", "]"}], "]"}], "]"}], "<>", 
        "\"\< & {} = \>\"", "<>", 
        RowBox[{"texIntegralsGath", "[", 
         RowBox[{
          RowBox[{"Total", "/@", "gath"}], ",", 
          RowBox[{"denominator", "/@", 
           RowBox[{"gath", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "1"}], "]"}], "]"}]}]}], "]"}]}]}], "]"}]}], 
    ";"}]}]}]], "Input",
 CellChangeTimes->{{3.697644205820937*^9, 3.697644205845941*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Load", " ", "precomputed", " ", "results", " ", "to", " ", "check", " ", 
    "later"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Get", "[", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
     "\"\<wt4_dan_precomputed.m\>\""}], "]"}], ";"}]}]], "Input",
 CellChangeTimes->{{3.697599051790345*^9, 3.697599063237075*^9}, {
  3.6975994686062803`*^9, 3.6975994702639437`*^9}, {3.697602550513105*^9, 
  3.6976025651452227`*^9}, {3.697602753883231*^9, 3.6976027625747285`*^9}, {
  3.6976300857138042`*^9, 3.6976300857918997`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"--", 
   RowBox[{"--", "--"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.697525923879716*^9, 3.6975259257636223`*^9}, {
  3.6975994958065605`*^9, 3.6975994965253487`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"wt4VarsToABC", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"a", "[", "i_", "]"}], "\[RuleDelayed]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], 
        "}"}], "[", 
       RowBox[{"[", 
        RowBox[{"i", "+", "1"}], "]"}], "]"}]}], ",", " ", 
     RowBox[{"x", "\[Rule]", "Inf"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"canonicalCR", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a_", ",", "b_", ",", "c_", ",", "d_"}], "}"}], "]"}], 
     "\[RuleDelayed]", 
     RowBox[{"cri", "[", 
      RowBox[{"crOrbit", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}], "]"}], "]"}]}], 
    "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.6975258965009623`*^9, 3.697525916828238*^9}, {
  3.697526197772664*^9, 3.6975262352827177`*^9}, {3.6975276207863693`*^9, 
  3.6975276217531137`*^9}, {3.6975566747688217`*^9, 3.6975566835903435`*^9}, {
  3.6976300892001467`*^9, 3.6976300931724615`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"in4Dan", " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"Asymb", "[", 
     RowBox[{"4", ",", "1", ",", "2"}], "]"}], "/.", "wt4VarsToABC"}], "//", 
   "TeXForm"}]}]], "Input",
 CellChangeTimes->{{3.697525953475912*^9, 3.697525970522691*^9}, 
   3.697526038593132*^9, {3.697527624825776*^9, 3.697527624953837*^9}, {
   3.697534964626761*^9, 3.697534977585638*^9}, {3.697630095392771*^9, 
   3.69763010256199*^9}}],

Cell["H(a \\mid b, c, d, e \\dblslash \\infty \\mid f)", "Output",
 CellChangeTimes->{{3.697525950078225*^9, 3.697525980503378*^9}, 
   3.6975260392841663`*^9, 3.69752703329508*^9, 3.697527625484969*^9, 
   3.6975322929099703`*^9, {3.697534961874489*^9, 3.6975349778372602`*^9}, 
   3.6975350638330793`*^9, 3.6975548163934045`*^9, 3.697556684684046*^9, 
   3.6975633436990175`*^9, {3.697599501326394*^9, 3.6975995146651907`*^9}, 
   3.6976025703779964`*^9, {3.6976124524613757`*^9, 3.6976124687994537`*^9}, 
   3.697616055513669*^9, {3.697630098114431*^9, 3.697630103155736*^9}, 
   3.6976412323147945`*^9, 3.6976412883666253`*^9, 3.697644210854469*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"in4Polylog", " ", "=", " ", 
   RowBox[{
    RowBox[{"iToCcr", "@", 
     RowBox[{"hToI", "@", 
      RowBox[{"hCrSimp", "[", 
       RowBox[{"Asymb", "[", 
        RowBox[{"4", ",", "1", ",", "2"}], "]"}], "]"}]}]}], "/.", 
    "wt4VarsToABC"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"%", "//", "TeXForm"}]}], "Input",
 CellChangeTimes->{{3.657352131949285*^9, 3.657352147617848*^9}, {
   3.657352549486443*^9, 3.6573526108128433`*^9}, {3.65735267326958*^9, 
   3.657352673349101*^9}, {3.657690322744503*^9, 3.6576903488893175`*^9}, {
   3.659091519477152*^9, 3.659091519565649*^9}, {3.6711879043747396`*^9, 
   3.671187923058796*^9}, {3.697525856502245*^9, 3.697525888949885*^9}, {
   3.6975259280282393`*^9, 3.697525932571065*^9}, {3.697525977194881*^9, 
   3.697525978178672*^9}, 3.697526040272935*^9, {3.69752761722637*^9, 
   3.697527627139942*^9}, {3.697534970370522*^9, 3.697534990721616*^9}, {
   3.6976301123363495`*^9, 3.697630114979351*^9}, 3.697630174241907*^9}],

Cell["I_{1, 1, 1, 1}(\\infty a f b c d e)", "Output",
 CellChangeTimes->{
  3.697534992060092*^9, 3.697535063888892*^9, 3.6975548194031157`*^9, 
   3.6975566854041185`*^9, 3.6975633437302814`*^9, 3.697599515776038*^9, 
   3.697602570831111*^9, {3.697612452477*^9, 3.697612468830721*^9}, 
   3.6976160561869965`*^9, 3.6976301152761993`*^9, 3.697630176713584*^9, 
   3.697641232343815*^9, 3.697641288394645*^9, 3.697644210885504*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"out4AllN", " ", "=", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"iToCcr", "@", 
      RowBox[{"hToI", "@", 
       RowBox[{"hCrSimp", "@", 
        RowBox[{"Expand", "@", 
         RowBox[{"reduceAll", "[", "4", "]"}]}]}]}]}], "/.", "wt4VarsToABC"}],
     "//", "Expand"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.697525275693885*^9, 3.697525311397773*^9}, {
   3.69752539230795*^9, 3.697525393331551*^9}, {3.697525544511775*^9, 
   3.697525545311083*^9}, 3.6975255787951097`*^9, {3.697525622691525*^9, 
   3.6975256229473343`*^9}, {3.6975257002509193`*^9, 3.697525748995326*^9}, 
   3.697525938052705*^9, {3.697525982586339*^9, 3.697526042160902*^9}, {
   3.697526217307646*^9, 3.6975262184674187`*^9}, {3.697527609948696*^9, 
   3.697527615385573*^9}, {3.697556657612116*^9, 3.6975566634914985`*^9}, {
   3.6975567744312897`*^9, 3.6975567829856997`*^9}, {3.697630119193522*^9, 
   3.6976301240251145`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"out4AllNLower", " ", "=", " ", 
   RowBox[{
    RowBox[{"Select", "[", 
     RowBox[{"out4AllN", ",", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"Position", "[", 
         RowBox[{"#", ",", " ", "a"}], "]"}], "\[NotEqual]", 
        RowBox[{"{", "}"}]}], "&"}]}], "]"}], "/.", "canonicalCR"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.6975261391398783`*^9, 3.6975261859800367`*^9}, {
  3.69752633152815*^9, 3.697526334071616*^9}, {3.697527640463204*^9, 
  3.697527647466877*^9}, {3.6975567935427074`*^9, 3.697556794091116*^9}, {
  3.6976301274968624`*^9, 3.69763012998341*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"out4AllN", " ", "-", " ", 
    RowBox[{"(", 
     RowBox[{"out4AllNLower", " ", "-", " ", 
      RowBox[{"(", 
       RowBox[{"out4AllNLower", "/.", 
        RowBox[{"a", "\[Rule]", "f"}]}], ")"}]}], ")"}]}], "/.", 
   "canonicalCR"}], "//", "Expand"}]], "Input",
 CellChangeTimes->{{3.697526335455419*^9, 3.69752639615788*^9}, {
  3.697526920486521*^9, 3.697526931318369*^9}, {3.697527651505542*^9, 
  3.69752765370453*^9}, {3.697556760088269*^9, 3.697556798970463*^9}, {
  3.6976301363643103`*^9, 3.6976301474679613`*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.697526390517892*^9, 3.697526396780108*^9}, 
   3.6975269320551662`*^9, 3.697527654303132*^9, 3.697532293200407*^9, 
   3.69753499832206*^9, 3.697535064128533*^9, 3.6975548238942876`*^9, 
   3.69755669665574*^9, {3.6975567646082478`*^9, 3.6975567995329275`*^9}, 
   3.6975633441833963`*^9, 3.697599525267686*^9, 3.6976025736761355`*^9, {
   3.697612452773879*^9, 3.6976124690182033`*^9}, 3.6976160586727724`*^9, 
   3.6976301479366612`*^9, 3.6976412324388824`*^9, 3.6976412884877114`*^9, 
   3.697644210984561*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"wt4DanAllNPrecomputed", " ", "==", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"in4Polylog", " ", "-", " ", 
       RowBox[{"(", 
        RowBox[{"out4AllNLower", " ", "-", " ", 
         RowBox[{"(", 
          RowBox[{"out4AllNLower", "/.", 
           RowBox[{"a", "\[Rule]", "f"}]}], ")"}]}], ")"}]}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", "\[Rule]", "0"}], ",", 
        RowBox[{"f", "\[Rule]", "1"}]}], "}"}]}], "/.", "canonicalCR"}], "//",
     "Expand"}], ")"}]}]], "Input",
 CellChangeTimes->{{3.6975418299919577`*^9, 3.697542016701066*^9}, {
   3.69754206739629*^9, 3.6975420787709827`*^9}, {3.697556440706278*^9, 
   3.6975564421608105`*^9}, 3.6975568553198547`*^9, {3.697559767857934*^9, 
   3.697559770374942*^9}, {3.697602576286768*^9, 3.6976025900270505`*^9}, {
   3.6976124848842154`*^9, 3.6976124855254126`*^9}, {3.697616101916132*^9, 
   3.6976161159117737`*^9}, {3.6976304790063095`*^9, 
   3.6976304829792557`*^9}, {3.6976316101184683`*^9, 3.697631611494102*^9}, 
   3.6976412276945295`*^9}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{
  3.697602591215184*^9, {3.697612452789505*^9, 3.6976124690494556`*^9}, {
   3.6976160599086947`*^9, 3.6976161162242327`*^9}, 3.697630484730638*^9, 
   3.697631620846608*^9, 3.697631661647601*^9, 3.697641232467903*^9, 
   3.6976412885167313`*^9, 3.697644211016594*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"out4AllNLowerGathered", " ", "=", " ", 
   RowBox[{"gatherIntegrals", "[", "out4AllNLower", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.670915222347866*^9, 3.670915289663663*^9}, {
  3.670915332846138*^9, 3.67091535581328*^9}, {3.670916219945907*^9, 
  3.670916221082815*^9}, {3.670916333281445*^9, 3.670916344666979*^9}, {
  3.6709189674655952`*^9, 3.670919042204668*^9}, {3.6709258128572893`*^9, 
  3.670925813211691*^9}, {3.67118350918089*^9, 3.671183531116184*^9}, {
  3.671183581222713*^9, 3.6711835985946093`*^9}, {3.671185477981173*^9, 
  3.671185488930788*^9}, {3.6711866229772873`*^9, 3.671186625444181*^9}, {
  3.697526489797328*^9, 3.69752652016094*^9}, {3.697526563194475*^9, 
  3.6975266037261*^9}, {3.697526670126646*^9, 3.697526734427701*^9}, {
  3.697526796050971*^9, 3.697526882791471*^9}, {3.697527778452664*^9, 
  3.6975277802290154`*^9}, {3.6975311529386387`*^9, 3.697531158768909*^9}, {
  3.697630556027529*^9, 3.697630563657201*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"countIntegrals", "[", "out4AllNLowerGathered", "]"}]], "Input",
 CellChangeTimes->{
  3.697526887879635*^9, {3.6975311604902887`*^9, 3.697531165857418*^9}, {
   3.6976305676770864`*^9, 3.697630573369017*^9}}],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{"{", 
      RowBox[{"14", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "c", ",", "e"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "Inf", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "e", ",", "a", ",", "d", ",", "c"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"b", ",", "e", ",", "a", ",", "Inf", ",", "c"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "d", ",", "a", ",", "b", ",", "e"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "d", ",", "a", ",", "Inf", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["3", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "b", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"e", ",", "Inf", ",", "a", ",", "b", ",", "c"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "Inf", ",", "a", ",", "d", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "c", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "d", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "d", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "e", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["3", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "c", ",", "a", ",", "d", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}]}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"16", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "c", ",", "e"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "Inf", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "e", ",", "a", ",", "Inf", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "d", ",", "a", ",", "Inf", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "e", ",", "a", ",", "b", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "e", ",", "a", ",", "d", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "b", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "b", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "Inf", ",", "a", ",", "b", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "Inf", ",", "a", ",", "d", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "Inf", ",", "a", ",", "d", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "c", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "d", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "e", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "c", ",", "a", ",", "b", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "c", ",", "a", ",", "d", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}]}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"13", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "c", ",", "e"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "e", ",", "a", ",", "d", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "d", ",", "a", ",", "b", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "e", ",", "a", ",", "b", ",", "d"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "3"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"c", ",", "e", ",", "a", ",", "d", ",", "Inf"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "b", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "Inf", ",", "a", ",", "b", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "Inf", ",", "a", ",", "b", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "c", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "d", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "e", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "c", ",", "a", ",", "b", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "c", ",", "a", ",", "d", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}]}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"20", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "b", ",", "c", ",", "e"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"2", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "b", ",", "d", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "b", ",", "e", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["3", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "c", ",", "b", ",", "d"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "c", ",", "b", ",", "e"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", "4", "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"a", ",", "c", ",", "e", ",", "Inf"}], "}"}], "]"}], 
            "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "c", ",", "Inf", ",", "b"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "d", ",", "b", ",", "e"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["3", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "d", ",", "c", ",", "e"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", "4", "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"a", ",", "d", ",", "e", ",", "Inf"}], "}"}], "]"}], 
            "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", "4", "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"a", ",", "d", ",", "Inf", ",", "b"}], "}"}], "]"}], 
            "}"}]}], "]"}], ",", 
         RowBox[{"3", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "d", ",", "Inf", ",", "c"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "e", ",", "b", ",", "d"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "e", ",", "c", ",", "d"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "e", ",", "Inf", ",", "b"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "Inf", ",", "b", ",", "d"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["3", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "Inf", ",", "b", ",", "e"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["3", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "Inf", ",", "c", ",", "d"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["3", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "Inf", ",", "c", ",", "e"}], "}"}], "]"}], 
             "}"}]}], "]"}]}]}], "}"}]}], "}"}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  ColumnForm[{{14, {Rational[-1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`c, $CellContext`e}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`e}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`e, $CellContext`a, \
$CellContext`d, $CellContext`c}]}], 
      $CellContext`IIi[{3, 1}, {
        $CellContext`cri[{$CellContext`b, $CellContext`e, $CellContext`a, \
$CellContext`Inf, $CellContext`c}]}], Rational[1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`c, $CellContext`d, $CellContext`a, \
$CellContext`b, $CellContext`e}]}], -$CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`c, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`e}]}], 
      Rational[-3, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`e}]}], 
      $CellContext`IIi[{3, 1}, {
        $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`d, $CellContext`c}]}], Rational[1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`c, $CellContext`e}]}], Rational[1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`c}]}], -$CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`e}]}], Rational[1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`e, $CellContext`c}]}], 
      Rational[-3, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`c, $CellContext`a, \
$CellContext`d, $CellContext`e}]}]}}, {
    16, {Rational[-1, 2] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`c, $CellContext`e}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`c}]}], Rational[1, 2] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`e, $CellContext`a, \
$CellContext`Inf, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`c, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`e}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`c, $CellContext`e, $CellContext`a, \
$CellContext`b, $CellContext`Inf}]}], Rational[1, 2] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`c, $CellContext`e, $CellContext`a, \
$CellContext`d, $CellContext`Inf}]}], -$CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`e}]}], Rational[1, 2] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c}]}], Rational[1, 2] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`d, $CellContext`b}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`d, $CellContext`c}]}], Rational[1, 2] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`c, $CellContext`e}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`c}]}], Rational[1, 2] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`e, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`c, $CellContext`a, \
$CellContext`b, $CellContext`d}]}], -$CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`c, $CellContext`a, \
$CellContext`d, $CellContext`e}]}]}}, {
    13, {Rational[-1, 2] $CellContext`IIi[{1, 3}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`c, $CellContext`e}]}], 
      Rational[-1, 2] $CellContext`IIi[{1, 3}, {
         $CellContext`cri[{$CellContext`b, $CellContext`e, $CellContext`a, \
$CellContext`d, $CellContext`Inf}]}], Rational[1, 2] $CellContext`IIi[{1, 3}, {
         $CellContext`cri[{$CellContext`c, $CellContext`d, $CellContext`a, \
$CellContext`b, $CellContext`Inf}]}], 
      Rational[-1, 2] $CellContext`IIi[{1, 3}, {
         $CellContext`cri[{$CellContext`c, $CellContext`e, $CellContext`a, \
$CellContext`b, $CellContext`d}]}], 
      $CellContext`IIi[{1, 3}, {
        $CellContext`cri[{$CellContext`c, $CellContext`e, $CellContext`a, \
$CellContext`d, $CellContext`Inf}]}], -$CellContext`IIi[{1, 3}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c}]}], Rational[1, 2] $CellContext`IIi[{1, 3}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c}]}], Rational[1, 2] $CellContext`IIi[{1, 3}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`d}]}], Rational[1, 2] $CellContext`IIi[{1, 3}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`c, $CellContext`e}]}], -$CellContext`IIi[{1, 3}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`c}]}], Rational[1, 2] $CellContext`IIi[{1, 3}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`e, $CellContext`c}]}], Rational[1, 2] $CellContext`IIi[{1, 3}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`c, $CellContext`a, \
$CellContext`b, $CellContext`d}]}], 
      Rational[-1, 2] $CellContext`IIi[{1, 3}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`c, $CellContext`a, \
$CellContext`d, $CellContext`e}]}]}}, {
    20, {Rational[-1, 2] $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`b, $CellContext`c, \
$CellContext`d}]}], Rational[1, 2] $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`b, $CellContext`c, \
$CellContext`e}]}], 2 $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`b, $CellContext`d, \
$CellContext`Inf}]}], (-2) $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`b, $CellContext`e, \
$CellContext`Inf}]}], Rational[3, 2] $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`c, $CellContext`b, \
$CellContext`d}]}], Rational[-1, 2] $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`c, $CellContext`b, \
$CellContext`e}]}], 
      $CellContext`IIi[{4}, {
        $CellContext`cri[{$CellContext`a, $CellContext`c, $CellContext`e, \
$CellContext`Inf}]}], -$CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`c, $CellContext`Inf, \
$CellContext`b}]}], Rational[1, 2] $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`d, $CellContext`b, \
$CellContext`e}]}], Rational[-3, 2] $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`d, $CellContext`c, \
$CellContext`e}]}], 
      $CellContext`IIi[{4}, {
        $CellContext`cri[{$CellContext`a, $CellContext`d, $CellContext`e, \
$CellContext`Inf}]}], 
      $CellContext`IIi[{4}, {
        $CellContext`cri[{$CellContext`a, $CellContext`d, $CellContext`Inf, \
$CellContext`b}]}], 3 $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`d, $CellContext`Inf, \
$CellContext`c}]}], Rational[-1, 2] $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`e, $CellContext`b, \
$CellContext`d}]}], Rational[1, 2] $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`e, $CellContext`c, \
$CellContext`d}]}], -$CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`e, $CellContext`Inf, \
$CellContext`b}]}], Rational[1, 2] $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`Inf, $CellContext`b, \
$CellContext`d}]}], Rational[-3, 2] $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`Inf, $CellContext`b, \
$CellContext`e}]}], Rational[3, 2] $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`Inf, $CellContext`c, \
$CellContext`d}]}], Rational[3, 2] $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`Inf, $CellContext`c, \
$CellContext`e}]}]}}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.6976124691744757`*^9, 3.697616063741351*^9, 3.6976161175381856`*^9, {
   3.697630565033531*^9, 3.6976305736658335`*^9}, 3.6976316633833528`*^9, 
   3.6976412325379524`*^9, 3.6976412885847797`*^9, 3.697644211098654*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"texCountIntegrals", "[", "out4AllNLowerGathered", "]"}]], "Input",
 CellChangeTimes->{{3.697531169131065*^9, 3.697531176585211*^9}, {
   3.697538854472363*^9, 3.697538855200598*^9}, 3.6976305802033367`*^9}],

Cell[BoxData["\<\"Integral & Number in expression \\\\\\\\ \\n$ I_{3, 1} $ & \
14 \\\\\\\\ \\n$ I_{2, 2} $ & 16 \\\\\\\\ \\n$ I_{1, 3} $ & 13 \\\\\\\\ \\n$ \
I_{4} $ & 20 \\\\\\\\ \\nTotal & 63\"\>"], "Output",
 CellChangeTimes->{
  3.6975268918505983`*^9, 3.697526936476169*^9, 3.697527662164844*^9, 
   3.697527783374353*^9, 3.697531176921974*^9, 3.6975317746006823`*^9, 
   3.69753230698015*^9, 3.697533993800804*^9, 3.6975341028944283`*^9, 
   3.697535069937953*^9, 3.6975380754407454`*^9, {3.697538855591337*^9, 
   3.697538882491431*^9}, 3.6975406058393993`*^9, 3.697541463567626*^9, 
   3.697554830823242*^9, 3.6975568057103405`*^9, 3.6975633444490232`*^9, 
   3.697599525423956*^9, 3.6976025969946327`*^9, {3.697612453023903*^9, 
   3.6976124692213306`*^9}, 3.697616065774077*^9, 3.697616117897561*^9, 
   3.69763058073459*^9, 3.697631664258362*^9, 3.6976412325719767`*^9, 
   3.6976412886198044`*^9, 3.69764421113468*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"texIntegrals", "[", 
  RowBox[{
   RowBox[{"2", "*", "out4AllNLower"}], "//", "Expand"}], "]"}]], "Input",
 CellChangeTimes->{
  3.697526887879635*^9, {3.6975311604902887`*^9, 3.697531165857418*^9}, {
   3.697538138813191*^9, 3.697538216883462*^9}, 3.697538270739386*^9, {
   3.697538337360173*^9, 3.697538337711383*^9}, {3.69753857632196*^9, 
   3.697538576849647*^9}, {3.69753892282316*^9, 3.697538980876439*^9}, {
   3.697539012467823*^9, 3.6975390132822638`*^9}, {3.6975395697486267`*^9, 
   3.6975395816937637`*^9}, {3.69753964480942*^9, 3.697539645025524*^9}, {
   3.6975399013220043`*^9, 3.697539904290333*^9}, {3.697540001060424*^9, 
   3.6975400078139353`*^9}, {3.697630583815894*^9, 3.697630586177535*^9}}],

Cell[BoxData["\<\"I_{3, 1}( -[b d a c e] \\n - [b d a \\\\infty e] \\n - [b e \
a d c] \\n + 2 [b e a \\\\infty c] \\n + [c d a b e] \\n - 2 [c d a \\\\infty \
e] \\n - 3 [d \\\\infty a b e] \\n + 2 [e \\\\infty a b c] \\n - [e \\\\infty \
a d c] \\n + [\\\\infty b a c e] \\n + [\\\\infty b a d c] \\n - 2 [\\\\infty \
b a d e] \\n + [\\\\infty b a e c] \\n - 3 [\\\\infty c a d e] ) + {} \
\\\\\\\\ \\n & {} + I_{2, 2}( -[b d a c e] \\n - [b d a \\\\infty c] \\n + [b \
e a \\\\infty c] \\n - [c d a \\\\infty e] \\n - [c e a b \\\\infty] \\n + [c \
e a d \\\\infty] \\n - 2 [d \\\\infty a b c] \\n - [d \\\\infty a b e] \\n + \
[e \\\\infty a b c] \\n + [e \\\\infty a d b] \\n - [e \\\\infty a d c] \\n + \
[\\\\infty b a c e] \\n - [\\\\infty b a d c] \\n + [\\\\infty b a e c] \\n - \
[\\\\infty c a b d] \\n - 2 [\\\\infty c a d e] ) + {} \\\\\\\\ \\n & {} + \
I_{1, 3}( -[b d a c e] \\n - [b e a d \\\\infty] \\n + [c d a b \\\\infty] \
\\n - [c e a b d] \\n + 2 [c e a d \\\\infty] \\n - 2 [d \\\\infty a b c] \\n \
+ [e \\\\infty a b c] \\n + [e \\\\infty a b d] \\n + [\\\\infty b a c e] \\n \
- 2 [\\\\infty b a d c] \\n + [\\\\infty b a e c] \\n + [\\\\infty c a b d] \
\\n - [\\\\infty c a d e] ) + {} \\\\\\\\ \\n & {} + I_{4}( -[a b c d] \\n + \
[a b c e] \\n + 4 [a b d \\\\infty] \\n - 4 [a b e \\\\infty] \\n + 3 [a c b \
d] \\n - [a c b e] \\n + 2 [a c e \\\\infty] \\n - 2 [a c \\\\infty b] \\n + \
[a d b e] \\n - 3 [a d c e] \\n + 2 [a d e \\\\infty] \\n + 2 [a d \\\\infty \
b] \\n + 6 [a d \\\\infty c] \\n - [a e b d] \\n + [a e c d] \\n - 2 [a e \
\\\\infty b] \\n + [a \\\\infty b d] \\n - 3 [a \\\\infty b e] \\n + 3 [a \
\\\\infty c d] \\n + 3 [a \\\\infty c e] )\"\>"], "Output",
 CellChangeTimes->{
  3.697539909007635*^9, {3.6975399960830297`*^9, 3.6975400105367126`*^9}, 
   3.6975406099586906`*^9, 3.697541388142503*^9, 3.697554839001501*^9, 
   3.6975568136229243`*^9, 3.697563346450122*^9, 3.69759952720568*^9, {
   3.6976026001834145`*^9, 3.697602611469016*^9}, {3.697612453117652*^9, 
   3.697612471362584*^9}, 3.697616120196397*^9, 3.6976305867556205`*^9, 
   3.6976316654316545`*^9, 3.697641232924226*^9, 3.697641288983062*^9, 
   3.697644211513945*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"texIntegralsByCoeff", "[", 
  RowBox[{"out4AllNLower", "//", "Expand"}], "]"}]], "Input",
 CellChangeTimes->{
  3.697526887879635*^9, {3.6975311604902887`*^9, 3.697531165857418*^9}, {
   3.697538138813191*^9, 3.697538216883462*^9}, 3.697538270739386*^9, {
   3.697538337360173*^9, 3.697538337711383*^9}, {3.69753857632196*^9, 
   3.697538576849647*^9}, {3.69753892282316*^9, 3.697538980876439*^9}, {
   3.697539012467823*^9, 3.6975390132822638`*^9}, {3.6975395697486267`*^9, 
   3.6975395816937637`*^9}, {3.69753964480942*^9, 3.697539645025524*^9}, {
   3.6975399013220043`*^9, 3.697539904290333*^9}, {3.697540001060424*^9, 
   3.6975400078139353`*^9}, {3.697630583815894*^9, 3.697630586177535*^9}, {
   3.6976306171097116`*^9, 3.6976306201126537`*^9}}],

Cell[BoxData["\<\"I_{3, 1}( [b e a \\\\infty c] \\n - [c d a \\\\infty e] \\n \
+ [e \\\\infty a b c] \\n - [\\\\infty b a d e] ) + {} \\\\\\\\ \\n & {} + \\\
\\frac{1}{2} I_{3, 1}( -[b d a c e] \\n - [b d a \\\\infty e] \\n - [b e a d \
c] \\n + [c d a b e] \\n - 3 [d \\\\infty a b e] \\n - [e \\\\infty a d c] \
\\n + [\\\\infty b a c e] \\n + [\\\\infty b a d c] \\n + [\\\\infty b a e c] \
\\n - 3 [\\\\infty c a d e] ) + {} \\\\\\\\ \\n & {} + I_{2, 2}( -[d \
\\\\infty a b c] \\n - [\\\\infty c a d e] ) + {} \\\\\\\\ \\n & {} + \
\\\\frac{1}{2} I_{2, 2}( -[b d a c e] \\n - [b d a \\\\infty c] \\n + [b e a \
\\\\infty c] \\n - [c d a \\\\infty e] \\n - [c e a b \\\\infty] \\n + [c e a \
d \\\\infty] \\n - [d \\\\infty a b e] \\n + [e \\\\infty a b c] \\n + [e \
\\\\infty a d b] \\n - [e \\\\infty a d c] \\n + [\\\\infty b a c e] \\n - \
[\\\\infty b a d c] \\n + [\\\\infty b a e c] \\n - [\\\\infty c a b d] ) + \
{} \\\\\\\\ \\n & {} + I_{1, 3}( [c e a d \\\\infty] \\n - [d \\\\infty a b \
c] \\n - [\\\\infty b a d c] ) + {} \\\\\\\\ \\n & {} + \\\\frac{1}{2} I_{1, \
3}( -[b d a c e] \\n - [b e a d \\\\infty] \\n + [c d a b \\\\infty] \\n - [c \
e a b d] \\n + [e \\\\infty a b c] \\n + [e \\\\infty a b d] \\n + [\\\\infty \
b a c e] \\n + [\\\\infty b a e c] \\n + [\\\\infty c a b d] \\n - [\\\\infty \
c a d e] ) + {} \\\\\\\\ \\n & {} + I_{4}( 2 [a b d \\\\infty] \\n - 2 [a b e \
\\\\infty] \\n + [a c e \\\\infty] \\n - [a c \\\\infty b] \\n + [a d e \
\\\\infty] \\n + [a d \\\\infty b] \\n + 3 [a d \\\\infty c] \\n - [a e \
\\\\infty b] ) + {} \\\\\\\\ \\n & {} + \\\\frac{1}{2} I_{4}( -[a b c d] \\n \
+ [a b c e] \\n + 3 [a c b d] \\n - [a c b e] \\n + [a d b e] \\n - 3 [a d c \
e] \\n - [a e b d] \\n + [a e c d] \\n + [a \\\\infty b d] \\n - 3 [a \
\\\\infty b e] \\n + 3 [a \\\\infty c d] \\n + 3 [a \\\\infty c e] )\"\>"], \
"Output",
 CellChangeTimes->{3.697630621239028*^9, 3.697631666307223*^9, 
  3.69764123326847*^9, 3.697641289337312*^9, 3.6976442119242268`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"texIntegralsWithFrac", "[", 
  RowBox[{"out4AllNLower", "//", "Expand"}], "]"}]], "Input",
 CellChangeTimes->{
  3.697526887879635*^9, {3.6975311604902887`*^9, 3.697531165857418*^9}, {
   3.697538138813191*^9, 3.697538216883462*^9}, 3.697538270739386*^9, {
   3.697538337360173*^9, 3.697538337711383*^9}, {3.69753857632196*^9, 
   3.697538576849647*^9}, {3.69753892282316*^9, 3.697538980876439*^9}, {
   3.697539012467823*^9, 3.6975390132822638`*^9}, {3.6975395697486267`*^9, 
   3.6975395816937637`*^9}, {3.69753964480942*^9, 3.697539645025524*^9}, {
   3.6975399013220043`*^9, 3.697539904290333*^9}, {3.697540001060424*^9, 
   3.6975400078139353`*^9}, {3.697630583815894*^9, 3.697630586177535*^9}, {
   3.6976306278378296`*^9, 3.6976306302782507`*^9}}],

Cell[BoxData["\<\"I_{3, 1}( -\\\\frac{1}{2} [b d a c e] \\n - \\\\frac{1}{2} \
[b d a \\\\infty e] \\n - \\\\frac{1}{2} [b e a d c] \\n + [b e a \\\\infty \
c] \\n + \\\\frac{1}{2} [c d a b e] \\n - [c d a \\\\infty e] \\n - \
\\\\frac{3}{2} [d \\\\infty a b e] \\n + [e \\\\infty a b c] \\n - \
\\\\frac{1}{2} [e \\\\infty a d c] \\n + \\\\frac{1}{2} [\\\\infty b a c e] \
\\n + \\\\frac{1}{2} [\\\\infty b a d c] \\n - [\\\\infty b a d e] \\n + \
\\\\frac{1}{2} [\\\\infty b a e c] \\n - \\\\frac{3}{2} [\\\\infty c a d e] ) \
+ {} \\\\\\\\ \\n & {} + I_{2, 2}( -\\\\frac{1}{2} [b d a c e] \\n - \
\\\\frac{1}{2} [b d a \\\\infty c] \\n + \\\\frac{1}{2} [b e a \\\\infty c] \
\\n - \\\\frac{1}{2} [c d a \\\\infty e] \\n - \\\\frac{1}{2} [c e a b \
\\\\infty] \\n + \\\\frac{1}{2} [c e a d \\\\infty] \\n - [d \\\\infty a b c] \
\\n - \\\\frac{1}{2} [d \\\\infty a b e] \\n + \\\\frac{1}{2} [e \\\\infty a \
b c] \\n + \\\\frac{1}{2} [e \\\\infty a d b] \\n - \\\\frac{1}{2} [e \
\\\\infty a d c] \\n + \\\\frac{1}{2} [\\\\infty b a c e] \\n - \
\\\\frac{1}{2} [\\\\infty b a d c] \\n + \\\\frac{1}{2} [\\\\infty b a e c] \
\\n - \\\\frac{1}{2} [\\\\infty c a b d] \\n - [\\\\infty c a d e] ) + {} \
\\\\\\\\ \\n & {} + I_{1, 3}( -\\\\frac{1}{2} [b d a c e] \\n - \
\\\\frac{1}{2} [b e a d \\\\infty] \\n + \\\\frac{1}{2} [c d a b \\\\infty] \
\\n - \\\\frac{1}{2} [c e a b d] \\n + [c e a d \\\\infty] \\n - [d \\\\infty \
a b c] \\n + \\\\frac{1}{2} [e \\\\infty a b c] \\n + \\\\frac{1}{2} [e \
\\\\infty a b d] \\n + \\\\frac{1}{2} [\\\\infty b a c e] \\n - [\\\\infty b \
a d c] \\n + \\\\frac{1}{2} [\\\\infty b a e c] \\n + \\\\frac{1}{2} \
[\\\\infty c a b d] \\n - \\\\frac{1}{2} [\\\\infty c a d e] ) + {} \\\\\\\\ \
\\n & {} + I_{4}( -\\\\frac{1}{2} [a b c d] \\n + \\\\frac{1}{2} [a b c e] \
\\n + 2 [a b d \\\\infty] \\n - 2 [a b e \\\\infty] \\n + \\\\frac{3}{2} [a c \
b d] \\n - \\\\frac{1}{2} [a c b e] \\n + [a c e \\\\infty] \\n - [a c \
\\\\infty b] \\n + \\\\frac{1}{2} [a d b e] \\n - \\\\frac{3}{2} [a d c e] \
\\n + [a d e \\\\infty] \\n + [a d \\\\infty b] \\n + 3 [a d \\\\infty c] \\n \
- \\\\frac{1}{2} [a e b d] \\n + \\\\frac{1}{2} [a e c d] \\n - [a e \
\\\\infty b] \\n + \\\\frac{1}{2} [a \\\\infty b d] \\n - \\\\frac{3}{2} [a \
\\\\infty b e] \\n + \\\\frac{3}{2} [a \\\\infty c d] \\n + \\\\frac{3}{2} [a \
\\\\infty c e] )\"\>"], "Output",
 CellChangeTimes->{3.6976306310438433`*^9, 3.697631667213481*^9, 
  3.697641233705779*^9, 3.697641289777624*^9, 3.697644212383569*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "Now", " ", "we", " ", "use", " ", "some", " ", "identities", " ", "to", 
   " ", "write", " ", "everything", " ", "in", " ", "terms", " ", "of", " ", 
   "I31", " ", "and", " ", "I4"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.697529025044095*^9, 3.6975290390957727`*^9}, {
  3.6976306533435144`*^9, 3.6976306551262016`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Get", "[", 
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
    "\"\<wt4_rules_to_i31_i4.m\>\""}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.6975995688855553`*^9, 3.697599593032262*^9}, {
  3.697630658864037*^9, 3.697630665415249*^9}, {3.6976309907138023`*^9, 
  3.6976309912302465`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"texRuleByCoeff", "[", "rule13to31", "]"}]], "Input",
 CellChangeTimes->{{3.697533168654767*^9, 3.6975332150532827`*^9}, {
  3.697533285979505*^9, 3.697533290459104*^9}, {3.697533721440003*^9, 
  3.697533744270117*^9}, {3.697535132649744*^9, 3.69753513367642*^9}, {
  3.697540292159876*^9, 3.697540294414844*^9}, {3.697630994107314*^9, 
  3.6976310025521183`*^9}}],

Cell[BoxData["\<\"I_{1, 3}(a b c d e) & {} = I_{3, 1}( -[b a d c e] ) + {} \\\
\\\\\\ \\n & {} + I_{4}( [a b c d] )\"\>"], "Output",
 CellChangeTimes->{{3.697533171635413*^9, 3.697533215363018*^9}, {
   3.697533300515257*^9, 3.697533307945298*^9}, {3.6975333406152573`*^9, 
   3.6975333880920277`*^9}, 3.697533427442638*^9, 3.697533648447213*^9, {
   3.6975337266290493`*^9, 3.6975337445875263`*^9}, 3.69753435852728*^9, {
   3.697535123186822*^9, 3.6975351340025187`*^9}, 3.6975400947845793`*^9, {
   3.697540294889286*^9, 3.697540307098394*^9}, 3.697540705065556*^9, 
   3.697540739068193*^9, 3.697541515017982*^9, 3.6975415557781773`*^9, 
   3.6975548585650387`*^9, 3.6975569186779046`*^9, 3.6975633512331977`*^9, 
   3.6975995953930454`*^9, 3.697602638295951*^9, {3.697612453668228*^9, 
   3.6976124765214005`*^9}, 3.6976161399615936`*^9, 3.697631003068336*^9, 
   3.6976316694350753`*^9, 3.697641233789838*^9, 3.697641289859682*^9, 
   3.697644212478636*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"texRuleByCoeff", "[", "rule22to13and31", "]"}]], "Input",
 CellChangeTimes->{{3.697533787212222*^9, 3.697533798356614*^9}, {
   3.697535135779728*^9, 3.697535136468616*^9}, 3.697540313788288*^9, {
   3.697631006758732*^9, 3.6976310187389565`*^9}}],

Cell[BoxData["\<\"I_{2, 2}(a b c d e) & {} = I_{3, 1}( -[a b c d e] ) + {} \\\
\\\\\\ \\n & {} + I_{1, 3}( -[a b c d e] \\n - [a b c e d] )\"\>"], "Output",
 CellChangeTimes->{{3.6975337897078733`*^9, 3.6975337986814423`*^9}, 
   3.69753435948752*^9, 3.697535136773245*^9, 3.697540314495534*^9, 
   3.6975407406765003`*^9, 3.697541515108055*^9, 3.697541555866744*^9, 
   3.6975548609194374`*^9, 3.697556918834156*^9, 3.6975633512644477`*^9, 
   3.6975995960039005`*^9, 3.6976026388272247`*^9, {3.697612453715104*^9, 
   3.697612476552635*^9}, 3.697616140633462*^9, 3.6976310197707777`*^9, 
   3.6976316699975777`*^9, 3.6976412338228636`*^9, 3.6976412898937063`*^9, 
   3.697644212511655*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"texRuleByCoeff", "[", "rule31to22", "]"}]], "Input",
 CellChangeTimes->{{3.6975338102513113`*^9, 3.697533813219574*^9}, {
  3.697631023038546*^9, 3.6976310309360657`*^9}}],

Cell[BoxData["\<\"I_{3, 1}(a b c d e) & {} = \\\\frac{1}{2} I_{2, 2}( [a b c \
e d] \\n - [a b c d e] )\"\>"], "Output",
 CellChangeTimes->{
  3.697533813492608*^9, 3.6975343609547977`*^9, 3.697535138708061*^9, 
   3.697540321731565*^9, 3.697540741624073*^9, 3.6975415151696863`*^9, 
   3.6975415559373913`*^9, 3.697554861546013*^9, 3.697556918959159*^9, 
   3.697563351295698*^9, 3.6975995967226553`*^9, 3.6976026409072394`*^9, {
   3.697612453730729*^9, 3.6976124765838814`*^9}, 3.6976161411661606`*^9, 
   3.6976310312016478`*^9, 3.697631670466318*^9, 3.697641233851882*^9, 
   3.6976412899227266`*^9, 3.697644212544664*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{
   "Apply", " ", "these", " ", "rules", " ", "to", " ", "write", " ", 
    "I11111", " ", "as", " ", "I311"}], ",", " ", 
   RowBox[{"I32", " ", "and", " ", "I5"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.697529241868978*^9, 3.697529243537937*^9}, {
  3.697556125326988*^9, 3.697556139527169*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"out4AllNLoweras31and4", "=", " ", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"out4AllNLower", "/.", "rule22to13and31"}], "/.", 
      "rule13to31"}], "/.", "canonicalCR"}], "//", "Expand"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.671372160128628*^9, 3.671372174663937*^9}, {
   3.6713723371125727`*^9, 3.6713724219982147`*^9}, {3.671372465261487*^9, 
   3.6713724679748373`*^9}, {3.6713726009752693`*^9, 3.671372625813992*^9}, {
   3.6975351977871447`*^9, 3.697535232842347*^9}, 3.697541072905052*^9, {
   3.697542343220536*^9, 3.697542364706523*^9}, {3.6975565765419846`*^9, 
   3.6975566149451275`*^9}, {3.6975569264195986`*^9, 3.697556928717916*^9}, {
   3.6976310480071497`*^9, 3.6976310714214954`*^9}, {3.6976311354782743`*^9, 
   3.697631165106877*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"wt4DanAllNLoweras31and4Precomputed", " ", "\[Equal]", " ", 
  "out4AllNLoweras31and4"}]], "Input",
 CellChangeTimes->{{3.6976354276302996`*^9, 3.6976354334001603`*^9}, 
   3.6976413010816255`*^9}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{
  3.6976354744150295`*^9, 3.697641233953954*^9, {3.697641290038809*^9, 
   3.6976413018821898`*^9}, 3.697644212634742*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"out4AllNLoweras31and4gathered", " ", "=", " ", 
   RowBox[{"gatherIntegrals", "[", "out4AllNLoweras31and4", "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.697541078808*^9, 3.697541102903522*^9}, {
  3.697542349764102*^9, 3.697542362019065*^9}, {3.6976310767384243`*^9, 
  3.697631081445033*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "[", "out4AllNLoweras31and4", "]"}]], "Input",
 CellChangeTimes->{{3.697542270714327*^9, 3.697542278373323*^9}, {
  3.697542353489497*^9, 3.697542355754746*^9}, {3.697631085121324*^9, 
  3.6976310852150583`*^9}}],

Cell[BoxData["66"], "Output",
 CellChangeTimes->{{3.697542274962091*^9, 3.6975422790174093`*^9}, 
   3.697542366093031*^9, 3.697554868114072*^9, 3.6975565877881737`*^9, 
   3.697556934150905*^9, 3.6975633516707015`*^9, 3.697599604495513*^9, 
   3.6976026475818653`*^9, {3.697612453840123*^9, 3.6976124770057735`*^9}, 
   3.697616146529151*^9, 3.6976310859806643`*^9, {3.6976311497962217`*^9, 
   3.6976311671408443`*^9}, 3.6976316728739877`*^9, 3.697641234013997*^9, {
   3.6976412900998516`*^9, 3.6976413043089075`*^9}, 3.6976442126947885`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"wt4DanAllNas31and4Precomputed", "  ", "==", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"in4Polylog", " ", "-", " ", 
       RowBox[{"(", 
        RowBox[{"out4AllNLoweras31and4", " ", "-", " ", 
         RowBox[{"(", 
          RowBox[{"out4AllNLoweras31and4", "/.", 
           RowBox[{"a", "\[Rule]", "f"}]}], ")"}]}], ")"}]}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", "\[Rule]", "0"}], ",", 
        RowBox[{"f", "\[Rule]", "1"}]}], "}"}]}], "/.", "canonicalCR"}], "//",
     "Expand"}], ")"}]}]], "Input",
 CellChangeTimes->{{3.69754229151503*^9, 3.6975423349585238`*^9}, {
   3.697542368989965*^9, 3.6975423825362864`*^9}, 3.697556938421156*^9, {
   3.697559779352412*^9, 3.697559780619249*^9}, {3.6976026488013225`*^9, 
   3.6976026601650906`*^9}, {3.6976027001466837`*^9, 3.697602714340189*^9}, {
   3.697612490667964*^9, 3.6976124910117364`*^9}, {3.6976312998448763`*^9, 
   3.6976313152025895`*^9}, {3.697631432237675*^9, 3.697631444108037*^9}, {
   3.6976316778117256`*^9, 3.697631679016344*^9}}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{
  3.697602714996428*^9, {3.6976124538713555`*^9, 3.6976124770214005`*^9}, 
   3.6976161473276033`*^9, 3.6976314445460763`*^9, {3.6976316737973795`*^9, 
   3.697631679547574*^9}, 3.6976412340440187`*^9, {3.6976412901288724`*^9, 
   3.697641304824272*^9}, 3.697644212726802*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"countIntegrals", "[", "out4AllNLoweras31and4gathered", 
  "]"}]], "Input",
 CellChangeTimes->{{3.697541104968307*^9, 3.697541115863147*^9}, {
  3.69763109400301*^9, 3.6976310966135473`*^9}}],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{"{", 
      RowBox[{"45", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "Inf", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "Inf", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "e", ",", "a", ",", "d", ",", "c"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "e", ",", "a", ",", "Inf", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "Inf", ",", "c", ",", "a", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "Inf", ",", "c", ",", "a", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "Inf", ",", "d", ",", "a", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "Inf", ",", "e", ",", "a", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "d", ",", "a", ",", "b", ",", "e"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "d", ",", "a", ",", "Inf", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "e", ",", "a", ",", "b", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "e", ",", "a", ",", "d", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "Inf", ",", "b", ",", "a", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "Inf", ",", "d", ",", "a", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "Inf", ",", "d", ",", "a", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "Inf", ",", "e", ",", "a", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "b", ",", "c", ",", "a", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "b", ",", "e", ",", "a", ",", "c"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "b", ",", "Inf", ",", "a", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "c", ",", "b", ",", "a", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "c", ",", "e", ",", "a", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "c", ",", "Inf", ",", "a", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"d", ",", "Inf", ",", "a", ",", "b", ",", "c"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "b", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "b", ",", "c", ",", "a", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "b", ",", "d", ",", "a", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "b", ",", "Inf", ",", "a", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "c", ",", "b", ",", "a", ",", "d"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "c", ",", "b", ",", "a", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "c", ",", "d", ",", "a", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "c", ",", "Inf", ",", "a", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "c", ",", "Inf", ",", "a", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "Inf", ",", "a", ",", "b", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "Inf", ",", "a", ",", "d", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"Inf", ",", "b", ",", "a", ",", "d", ",", "c"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "d", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "c", ",", "a", ",", "b", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "c", ",", "a", ",", "d", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "d", ",", "b", ",", "a", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "d", ",", "c", ",", "a", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "d", ",", "e", ",", "a", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "e", ",", "c", ",", "a", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "e", ",", "c", ",", "a", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "e", ",", "d", ",", "a", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "e", ",", "d", ",", "a", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}]}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"21", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "b", ",", "c", ",", "e"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["5", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "b", ",", "d", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "b", ",", "e", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", "4", "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"a", ",", "b", ",", "Inf", ",", "c"}], "}"}], "]"}], 
            "}"}]}], "]"}], ",", 
         RowBox[{"2", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "c", ",", "b", ",", "d"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "c", ",", "b", ",", "e"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", "4", "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"a", ",", "c", ",", "d", ",", "Inf"}], "}"}], "]"}], 
            "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", "4", "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"a", ",", "c", ",", "e", ",", "Inf"}], "}"}], "]"}], 
            "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "c", ",", "Inf", ",", "b"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "d", ",", "c", ",", "e"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", "4", "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"a", ",", "d", ",", "e", ",", "Inf"}], "}"}], "]"}], 
            "}"}]}], "]"}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "d", ",", "Inf", ",", "b"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"4", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "d", ",", "Inf", ",", "c"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", "4", "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"a", ",", "e", ",", "c", ",", "d"}], "}"}], "]"}], 
            "}"}]}], "]"}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "e", ",", "d", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["3", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "e", ",", "Inf", ",", "b"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", "4", "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"a", ",", "e", ",", "Inf", ",", "c"}], "}"}], "]"}], 
            "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", "4", "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"a", ",", "Inf", ",", "b", ",", "d"}], "}"}], "]"}], 
            "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "Inf", ",", "b", ",", "e"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"2", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "Inf", ",", "c", ",", "d"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["3", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "Inf", ",", "c", ",", "e"}], "}"}], "]"}], 
             "}"}]}], "]"}]}]}], "}"}]}], "}"}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  ColumnForm[{{45, {Rational[1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`e}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`e, $CellContext`a, \
$CellContext`d, $CellContext`c}]}], Rational[1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`e, $CellContext`a, \
$CellContext`Inf, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`Inf, $CellContext`c, \
$CellContext`a, $CellContext`d}]}], Rational[1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`Inf, $CellContext`c, \
$CellContext`a, $CellContext`e}]}], Rational[1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`Inf, $CellContext`d, \
$CellContext`a, $CellContext`c}]}], Rational[1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`Inf, $CellContext`e, \
$CellContext`a, $CellContext`c}]}], Rational[1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`c, $CellContext`d, $CellContext`a, \
$CellContext`b, $CellContext`e}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`c, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`e}]}], Rational[1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`c, $CellContext`e, $CellContext`a, \
$CellContext`b, $CellContext`Inf}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`c, $CellContext`e, $CellContext`a, \
$CellContext`d, $CellContext`Inf}]}], -$CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`c, $CellContext`Inf, $CellContext`b, \
$CellContext`a, $CellContext`d}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`c, $CellContext`Inf, $CellContext`d, \
$CellContext`a, $CellContext`b}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`c, $CellContext`Inf, $CellContext`d, \
$CellContext`a, $CellContext`e}]}], -$CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`c, $CellContext`Inf, $CellContext`e, \
$CellContext`a, $CellContext`d}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`d, $CellContext`b, $CellContext`c, \
$CellContext`a, $CellContext`Inf}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`d, $CellContext`b, $CellContext`e, \
$CellContext`a, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`d, $CellContext`b, $CellContext`Inf, \
$CellContext`a, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`d, $CellContext`c, $CellContext`b, \
$CellContext`a, $CellContext`Inf}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`d, $CellContext`c, $CellContext`e, \
$CellContext`a, $CellContext`Inf}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`d, $CellContext`c, $CellContext`Inf, \
$CellContext`a, $CellContext`e}]}], 
      $CellContext`IIi[{3, 1}, {
        $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c}]}], -$CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`e}]}], Rational[1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`e, $CellContext`b, $CellContext`c, \
$CellContext`a, $CellContext`Inf}]}], Rational[1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`e, $CellContext`b, $CellContext`d, \
$CellContext`a, $CellContext`Inf}]}], Rational[1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`e, $CellContext`b, $CellContext`Inf, \
$CellContext`a, $CellContext`c}]}], Rational[1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`e, $CellContext`c, $CellContext`b, \
$CellContext`a, $CellContext`d}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`e, $CellContext`c, $CellContext`b, \
$CellContext`a, $CellContext`Inf}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`e, $CellContext`c, $CellContext`d, \
$CellContext`a, $CellContext`Inf}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`e, $CellContext`c, $CellContext`Inf, \
$CellContext`a, $CellContext`b}]}], Rational[1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`e, $CellContext`c, $CellContext`Inf, \
$CellContext`a, $CellContext`d}]}], Rational[1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`d, $CellContext`b}]}], 
      $CellContext`IIi[{3, 1}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`c}]}], -$CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`e}]}], Rational[1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`c, $CellContext`a, \
$CellContext`b, $CellContext`d}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`c, $CellContext`a, \
$CellContext`d, $CellContext`e}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`d, $CellContext`b, \
$CellContext`a, $CellContext`e}]}], -$CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`d, $CellContext`c, \
$CellContext`a, $CellContext`b}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`d, $CellContext`e, \
$CellContext`a, $CellContext`b}]}], Rational[1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`e, $CellContext`c, \
$CellContext`a, $CellContext`b}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`e, $CellContext`c, \
$CellContext`a, $CellContext`d}]}], Rational[1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`e, $CellContext`d, \
$CellContext`a, $CellContext`b}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`e, $CellContext`d, \
$CellContext`a, $CellContext`c}]}]}}, {
    21, {Rational[1, 2] $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`b, $CellContext`c, \
$CellContext`e}]}], Rational[5, 2] $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`b, $CellContext`d, \
$CellContext`Inf}]}], (-2) $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`b, $CellContext`e, \
$CellContext`Inf}]}], 
      $CellContext`IIi[{4}, {
        $CellContext`cri[{$CellContext`a, $CellContext`b, $CellContext`Inf, \
$CellContext`c}]}], 2 $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`c, $CellContext`b, \
$CellContext`d}]}], -$CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`c, $CellContext`b, \
$CellContext`e}]}], 
      $CellContext`IIi[{4}, {
        $CellContext`cri[{$CellContext`a, $CellContext`c, $CellContext`d, \
$CellContext`Inf}]}], 
      $CellContext`IIi[{4}, {
        $CellContext`cri[{$CellContext`a, $CellContext`c, $CellContext`e, \
$CellContext`Inf}]}], -$CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`c, $CellContext`Inf, \
$CellContext`b}]}], -$CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`d, $CellContext`c, \
$CellContext`e}]}], 
      $CellContext`IIi[{4}, {
        $CellContext`cri[{$CellContext`a, $CellContext`d, $CellContext`e, \
$CellContext`Inf}]}], Rational[1, 2] $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`d, $CellContext`Inf, \
$CellContext`b}]}], 4 $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`d, $CellContext`Inf, \
$CellContext`c}]}], 
      $CellContext`IIi[{4}, {
        $CellContext`cri[{$CellContext`a, $CellContext`e, $CellContext`c, \
$CellContext`d}]}], Rational[1, 2] $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`e, $CellContext`d, \
$CellContext`Inf}]}], Rational[-3, 2] $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`e, $CellContext`Inf, \
$CellContext`b}]}], 
      $CellContext`IIi[{4}, {
        $CellContext`cri[{$CellContext`a, $CellContext`e, $CellContext`Inf, \
$CellContext`c}]}], 
      $CellContext`IIi[{4}, {
        $CellContext`cri[{$CellContext`a, $CellContext`Inf, $CellContext`b, \
$CellContext`d}]}], (-2) $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`Inf, $CellContext`b, \
$CellContext`e}]}], 2 $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`Inf, $CellContext`c, \
$CellContext`d}]}], Rational[3, 2] $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`Inf, $CellContext`c, \
$CellContext`e}]}]}}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.6976124770995116`*^9, 3.697616148610265*^9, 3.6976310971141596`*^9, {
   3.6976311450175066`*^9, 3.697631153017918*^9}, 3.6976314472819486`*^9, 
   3.697631680563813*^9, 3.69764123408905*^9, {3.6976412901739044`*^9, 
   3.697641305432703*^9}, 3.69764421277485*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"texCountIntegrals", "[", "out4AllNLoweras31and4gathered", 
  "]"}]], "Input",
 CellChangeTimes->{{3.697541176944091*^9, 3.697541183844907*^9}, 
   3.697631180296958*^9}],

Cell[BoxData["\<\"Integral & Number in expression \\\\\\\\ \\n$ I_{3, 1} $ & \
45 \\\\\\\\ \\n$ I_{4} $ & 21 \\\\\\\\ \\nTotal & 66\"\>"], "Output",
 CellChangeTimes->{
  3.697541184578389*^9, 3.6975415625748787`*^9, 3.6975423881706247`*^9, 
   3.697554872942132*^9, 3.697556942533373*^9, 3.6975633519519544`*^9, 
   3.697599612345704*^9, 3.697602717279029*^9, {3.6976124540588703`*^9, 
   3.697612477115136*^9}, 3.6976161496571493`*^9, 3.6976311809389687`*^9, 
   3.6976314572767124`*^9, 3.697631681126315*^9, 3.697641234122073*^9, 
   3.6976412902069273`*^9, 3.6976442128108664`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"texIntegralsByCoeff", "[", 
  RowBox[{
   RowBox[{"2", "*", "out4AllNLoweras31and4"}], "//", "Expand"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.6975412338845387`*^9, 3.6975412460026407`*^9}, {
  3.697541316714067*^9, 3.697541324473263*^9}, {3.697631183065037*^9, 
  3.6976311886958523`*^9}}],

Cell[BoxData["\<\"I_{3, 1}( [b d a \\\\infty c] \\n - [b d a \\\\infty e] \\n \
- [b e a d c] \\n + [b e a \\\\infty c] \\n - [b \\\\infty c a d] \\n + [b \\\
\\infty c a e] \\n + [b \\\\infty d a c] \\n + [b \\\\infty e a c] \\n + [c d \
a b e] \\n - [c d a \\\\infty e] \\n + [c e a b \\\\infty] \\n - [c e a d \
\\\\infty] \\n - 2 [c \\\\infty b a d] \\n - [c \\\\infty d a b] \\n - [c \
\\\\infty d a e] \\n - 2 [c \\\\infty e a d] \\n - [d b c a \\\\infty] \\n - \
[d b e a c] \\n - [d b \\\\infty a c] \\n - [d c b a \\\\infty] \\n - [d c e \
a \\\\infty] \\n - [d c \\\\infty a e] \\n + 2 [d \\\\infty a b c] \\n - 2 [d \
\\\\infty a b e] \\n + [e b c a \\\\infty] \\n + [e b d a \\\\infty] \\n + [e \
b \\\\infty a c] \\n + [e c b a d] \\n - [e c b a \\\\infty] \\n - [e c d a \
\\\\infty] \\n - [e c \\\\infty a b] \\n + [e c \\\\infty a d] \\n + [e \
\\\\infty a b c] \\n - [e \\\\infty a d b] \\n + 2 [\\\\infty b a d c] \\n - \
2 [\\\\infty b a d e] \\n + [\\\\infty c a b d] \\n - [\\\\infty c a d e] \\n \
- [\\\\infty d b a e] \\n - 2 [\\\\infty d c a b] \\n - [\\\\infty d e a b] \
\\n + [\\\\infty e c a b] \\n - [\\\\infty e c a d] \\n + [\\\\infty e d a b] \
\\n - [\\\\infty e d a c] ) + {} \\\\\\\\ \\n & {} + I_{4}( [a b c e] \\n + 5 \
[a b d \\\\infty] \\n - 4 [a b e \\\\infty] \\n + 2 [a b \\\\infty c] \\n + 4 \
[a c b d] \\n - 2 [a c b e] \\n + 2 [a c d \\\\infty] \\n + 2 [a c e \
\\\\infty] \\n - 2 [a c \\\\infty b] \\n - 2 [a d c e] \\n + 2 [a d e \
\\\\infty] \\n + [a d \\\\infty b] \\n + 8 [a d \\\\infty c] \\n + 2 [a e c \
d] \\n + [a e d \\\\infty] \\n - 3 [a e \\\\infty b] \\n + 2 [a e \\\\infty \
c] \\n + 2 [a \\\\infty b d] \\n - 4 [a \\\\infty b e] \\n + 4 [a \\\\infty c \
d] \\n + 3 [a \\\\infty c e] )\"\>"], "Output",
 CellChangeTimes->{
  3.697541248314834*^9, 3.697541326371251*^9, 3.697541565501934*^9, 
   3.697554878556632*^9, 3.697556957000516*^9, 3.697563353327479*^9, 
   3.69759961475397*^9, 3.697602719732797*^9, {3.697612454137001*^9, 
   3.6976124786782722`*^9}, 3.6976161519248233`*^9, 3.697631189352126*^9, 
   3.697631459716313*^9, 3.6976316820800033`*^9, 3.697641234494337*^9, 
   3.6976412905942016`*^9, 3.69764421317813*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"convert", " ", "to", " ", "I22", " ", "and", " ", "I4"}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.697631738797825*^9, 3.6976317435820713`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Get", "[", 
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
    "\"\<wt4_rules_to_i31_i4.m\>\""}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.6975995688855553`*^9, 3.697599593032262*^9}, {
  3.697630658864037*^9, 3.697630665415249*^9}, {3.6976309907138023`*^9, 
  3.6976309912302465`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"texRuleByCoeff", "[", "rule13to31", "]"}]], "Input",
 CellChangeTimes->{{3.697533168654767*^9, 3.6975332150532827`*^9}, {
  3.697533285979505*^9, 3.697533290459104*^9}, {3.697533721440003*^9, 
  3.697533744270117*^9}, {3.697535132649744*^9, 3.69753513367642*^9}, {
  3.697540292159876*^9, 3.697540294414844*^9}, {3.697630994107314*^9, 
  3.6976310025521183`*^9}}],

Cell[BoxData["\<\"I_{1, 3}(a b c d e) & {} = I_{3, 1}( -[b a d c e] ) + {} \\\
\\\\\\ \\n & {} + I_{4}( [a b c d] )\"\>"], "Output",
 CellChangeTimes->{{3.697533171635413*^9, 3.697533215363018*^9}, {
   3.697533300515257*^9, 3.697533307945298*^9}, {3.6975333406152573`*^9, 
   3.6975333880920277`*^9}, 3.697533427442638*^9, 3.697533648447213*^9, {
   3.6975337266290493`*^9, 3.6975337445875263`*^9}, 3.69753435852728*^9, {
   3.697535123186822*^9, 3.6975351340025187`*^9}, 3.6975400947845793`*^9, {
   3.697540294889286*^9, 3.697540307098394*^9}, 3.697540705065556*^9, 
   3.697540739068193*^9, 3.697541515017982*^9, 3.6975415557781773`*^9, 
   3.6975548585650387`*^9, 3.6975569186779046`*^9, 3.6975633512331977`*^9, 
   3.6975995953930454`*^9, 3.697602638295951*^9, {3.697612453668228*^9, 
   3.6976124765214005`*^9}, 3.6976161399615936`*^9, 3.697631003068336*^9, 
   3.6976316694350753`*^9, 3.697641234622428*^9, 3.697641290727296*^9, 
   3.697644213326231*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"texRuleByCoeff", "[", "rule22to13and31", "]"}]], "Input",
 CellChangeTimes->{{3.697533787212222*^9, 3.697533798356614*^9}, {
   3.697535135779728*^9, 3.697535136468616*^9}, 3.697540313788288*^9, {
   3.697631006758732*^9, 3.6976310187389565`*^9}}],

Cell[BoxData["\<\"I_{2, 2}(a b c d e) & {} = I_{3, 1}( -[a b c d e] ) + {} \\\
\\\\\\ \\n & {} + I_{1, 3}( -[a b c d e] \\n - [a b c e d] )\"\>"], "Output",
 CellChangeTimes->{{3.6975337897078733`*^9, 3.6975337986814423`*^9}, 
   3.69753435948752*^9, 3.697535136773245*^9, 3.697540314495534*^9, 
   3.6975407406765003`*^9, 3.697541515108055*^9, 3.697541555866744*^9, 
   3.6975548609194374`*^9, 3.697556918834156*^9, 3.6975633512644477`*^9, 
   3.6975995960039005`*^9, 3.6976026388272247`*^9, {3.697612453715104*^9, 
   3.697612476552635*^9}, 3.697616140633462*^9, 3.6976310197707777`*^9, 
   3.6976316699975777`*^9, 3.6976412346564517`*^9, 3.6976412907703266`*^9, 
   3.697644213376266*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"texRuleByCoeff", "[", "rule31to22", "]"}]], "Input",
 CellChangeTimes->{{3.6975338102513113`*^9, 3.697533813219574*^9}, {
  3.697631023038546*^9, 3.6976310309360657`*^9}}],

Cell[BoxData["\<\"I_{3, 1}(a b c d e) & {} = \\\\frac{1}{2} I_{2, 2}( [a b c \
e d] \\n - [a b c d e] )\"\>"], "Output",
 CellChangeTimes->{
  3.697533813492608*^9, 3.6975343609547977`*^9, 3.697535138708061*^9, 
   3.697540321731565*^9, 3.697540741624073*^9, 3.6975415151696863`*^9, 
   3.6975415559373913`*^9, 3.697554861546013*^9, 3.697556918959159*^9, 
   3.697563351295698*^9, 3.6975995967226553`*^9, 3.6976026409072394`*^9, {
   3.697612453730729*^9, 3.6976124765838814`*^9}, 3.6976161411661606`*^9, 
   3.6976310312016478`*^9, 3.697631670466318*^9, 3.6976412346854725`*^9, 
   3.697641290799347*^9, 3.6976442134092875`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{
   "Apply", " ", "these", " ", "rules", " ", "to", " ", "write", " ", 
    "I11111", " ", "as", " ", "I311"}], ",", " ", 
   RowBox[{"I32", " ", "and", " ", "I5"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.697529241868978*^9, 3.697529243537937*^9}, {
  3.697556125326988*^9, 3.697556139527169*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"out4AllNLoweras22and4", "=", " ", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"out4AllNLower", "/.", "rule22to13and31"}], "/.", 
       "rule13to31"}], "/.", "rule31to22"}], "/.", "canonicalCR"}], "//", 
    "Expand"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.671372160128628*^9, 3.671372174663937*^9}, {
   3.6713723371125727`*^9, 3.6713724219982147`*^9}, {3.671372465261487*^9, 
   3.6713724679748373`*^9}, {3.6713726009752693`*^9, 3.671372625813992*^9}, {
   3.6975351977871447`*^9, 3.697535232842347*^9}, 3.697541072905052*^9, {
   3.697542343220536*^9, 3.697542364706523*^9}, {3.6975565765419846`*^9, 
   3.6975566149451275`*^9}, {3.6975569264195986`*^9, 3.697556928717916*^9}, {
   3.6976310480071497`*^9, 3.6976310714214954`*^9}, {3.6976311354782743`*^9, 
   3.697631165106877*^9}, {3.697631752354129*^9, 3.69763176408312*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"out4AllNLoweras22and4gathered", " ", "=", " ", 
   RowBox[{"gatherIntegrals", "[", "out4AllNLoweras22and4", "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.697541078808*^9, 3.697541102903522*^9}, {
  3.697542349764102*^9, 3.697542362019065*^9}, {3.6976310767384243`*^9, 
  3.697631081445033*^9}, {3.697631769319475*^9, 3.697631771711565*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "[", "out4AllNLoweras22and4", "]"}]], "Input",
 CellChangeTimes->{{3.697542270714327*^9, 3.697542278373323*^9}, {
  3.697542353489497*^9, 3.697542355754746*^9}, {3.697631085121324*^9, 
  3.6976310852150583`*^9}, {3.6976317806716843`*^9, 3.697631781077937*^9}}],

Cell[BoxData["111"], "Output",
 CellChangeTimes->{{3.697542274962091*^9, 3.6975422790174093`*^9}, 
   3.697542366093031*^9, 3.697554868114072*^9, 3.6975565877881737`*^9, 
   3.697556934150905*^9, 3.6975633516707015`*^9, 3.697599604495513*^9, 
   3.6976026475818653`*^9, {3.697612453840123*^9, 3.6976124770057735`*^9}, 
   3.697616146529151*^9, 3.6976310859806643`*^9, {3.6976311497962217`*^9, 
   3.6976311671408443`*^9}, 3.6976316728739877`*^9, 3.6976317813295045`*^9, 
   3.6976412347965508`*^9, 3.697641290905422*^9, 3.6976442135273604`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"wt4DanAllNas22and4Precomputed", "  ", "==", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"in4Polylog", " ", "-", " ", 
       RowBox[{"(", 
        RowBox[{"out4AllNLoweras22and4", " ", "-", " ", 
         RowBox[{"(", 
          RowBox[{"out4AllNLoweras22and4", "/.", 
           RowBox[{"a", "\[Rule]", "f"}]}], ")"}]}], ")"}]}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", "\[Rule]", "0"}], ",", 
        RowBox[{"f", "\[Rule]", "1"}]}], "}"}]}], "/.", "canonicalCR"}], "//",
     "Expand"}], ")"}]}]], "Input",
 CellChangeTimes->{{3.69754229151503*^9, 3.6975423349585238`*^9}, {
   3.697542368989965*^9, 3.6975423825362864`*^9}, 3.697556938421156*^9, {
   3.697559779352412*^9, 3.697559780619249*^9}, {3.6976026488013225`*^9, 
   3.6976026601650906`*^9}, {3.6976027001466837`*^9, 3.697602714340189*^9}, {
   3.697612490667964*^9, 3.6976124910117364`*^9}, {3.6976312998448763`*^9, 
   3.6976313152025895`*^9}, {3.697631432237675*^9, 3.697631444108037*^9}, {
   3.6976316778117256`*^9, 3.697631679016344*^9}, {3.697631784457573*^9, 
   3.6976317924210353`*^9}}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{
  3.697602714996428*^9, {3.6976124538713555`*^9, 3.6976124770214005`*^9}, 
   3.6976161473276033`*^9, 3.6976314445460763`*^9, {3.6976316737973795`*^9, 
   3.697631679547574*^9}, 3.6976318676740537`*^9, 3.6976412348285737`*^9, 
   3.6976412909364443`*^9, 3.697644213559383*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"countIntegrals", "[", "out4AllNLoweras22and4gathered", 
  "]"}]], "Input",
 CellChangeTimes->{{3.697541104968307*^9, 3.697541115863147*^9}, {
   3.69763109400301*^9, 3.6976310966135473`*^9}, 3.6976318750077205`*^9}],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{"{", 
      RowBox[{"90", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "c", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "e", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "Inf", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "Inf", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "e", ",", "a", ",", "c", ",", "d"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "e", ",", "a", ",", "c", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "e", ",", "a", ",", "d", ",", "c"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "e", ",", "a", ",", "Inf", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "Inf", ",", "c", ",", "a", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "Inf", ",", "c", ",", "a", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "Inf", ",", "c", ",", "d", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "Inf", ",", "c", ",", "e", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "Inf", ",", "d", ",", "a", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "Inf", ",", "d", ",", "c", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "Inf", ",", "e", ",", "a", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "Inf", ",", "e", ",", "c", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "d", ",", "a", ",", "b", ",", "e"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "d", ",", "a", ",", "e", ",", "b"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "d", ",", "a", ",", "e", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "d", ",", "a", ",", "Inf", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "e", ",", "a", ",", "b", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "e", ",", "a", ",", "d", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "e", ",", "a", ",", "Inf", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "e", ",", "a", ",", "Inf", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "Inf", ",", "b", ",", "a", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "Inf", ",", "b", ",", "d", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "Inf", ",", "d", ",", "a", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "Inf", ",", "d", ",", "a", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "Inf", ",", "d", ",", "b", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "Inf", ",", "d", ",", "e", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "Inf", ",", "e", ",", "a", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "Inf", ",", "e", ",", "d", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "b", ",", "c", ",", "a", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "b", ",", "c", ",", "Inf", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "b", ",", "e", ",", "a", ",", "c"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "b", ",", "e", ",", "c", ",", "a"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "b", ",", "Inf", ",", "a", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "b", ",", "Inf", ",", "c", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "c", ",", "b", ",", "a", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "c", ",", "b", ",", "Inf", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "c", ",", "e", ",", "a", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "c", ",", "e", ",", "Inf", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "c", ",", "Inf", ",", "a", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "c", ",", "Inf", ",", "e", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "b", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "b", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "c", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "e", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "b", ",", "c", ",", "a", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "b", ",", "c", ",", "Inf", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "b", ",", "d", ",", "a", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "b", ",", "d", ",", "Inf", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "b", ",", "Inf", ",", "a", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "b", ",", "Inf", ",", "c", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "c", ",", "b", ",", "a", ",", "d"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "c", ",", "b", ",", "a", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "c", ",", "b", ",", "d", ",", "a"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "c", ",", "b", ",", "Inf", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "c", ",", "d", ",", "a", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "c", ",", "d", ",", "Inf", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "c", ",", "Inf", ",", "a", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "c", ",", "Inf", ",", "a", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "c", ",", "Inf", ",", "b", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "c", ",", "Inf", ",", "d", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "Inf", ",", "a", ",", "b", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "Inf", ",", "a", ",", "b", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "Inf", ",", "a", ",", "c", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "Inf", ",", "a", ",", "d", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "c", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "d", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "d", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "e", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "c", ",", "a", ",", "b", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "c", ",", "a", ",", "d", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "c", ",", "a", ",", "d", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "c", ",", "a", ",", "e", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "d", ",", "b", ",", "a", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "d", ",", "b", ",", "e", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "d", ",", "c", ",", "a", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "d", ",", "c", ",", "b", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "d", ",", "e", ",", "a", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "d", ",", "e", ",", "b", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "e", ",", "c", ",", "a", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "e", ",", "c", ",", "a", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "e", ",", "c", ",", "b", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "e", ",", "c", ",", "d", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "e", ",", "d", ",", "a", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "e", ",", "d", ",", "a", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "4"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "e", ",", "d", ",", "b", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "4"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "e", ",", "d", ",", "c", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}]}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"21", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "b", ",", "c", ",", "e"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["5", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "b", ",", "d", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "b", ",", "e", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", "4", "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"a", ",", "b", ",", "Inf", ",", "c"}], "}"}], "]"}], 
            "}"}]}], "]"}], ",", 
         RowBox[{"2", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "c", ",", "b", ",", "d"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "c", ",", "b", ",", "e"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", "4", "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"a", ",", "c", ",", "d", ",", "Inf"}], "}"}], "]"}], 
            "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", "4", "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"a", ",", "c", ",", "e", ",", "Inf"}], "}"}], "]"}], 
            "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "c", ",", "Inf", ",", "b"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "d", ",", "c", ",", "e"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", "4", "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"a", ",", "d", ",", "e", ",", "Inf"}], "}"}], "]"}], 
            "}"}]}], "]"}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "d", ",", "Inf", ",", "b"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"4", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "d", ",", "Inf", ",", "c"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", "4", "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"a", ",", "e", ",", "c", ",", "d"}], "}"}], "]"}], 
            "}"}]}], "]"}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "e", ",", "d", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["3", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "e", ",", "Inf", ",", "b"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", "4", "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"a", ",", "e", ",", "Inf", ",", "c"}], "}"}], "]"}], 
            "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", "4", "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"a", ",", "Inf", ",", "b", ",", "d"}], "}"}], "]"}], 
            "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "Inf", ",", "b", ",", "e"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"2", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "Inf", ",", "c", ",", "d"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["3", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "4", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "Inf", ",", "c", ",", "e"}], "}"}], "]"}], 
             "}"}]}], "]"}]}]}], "}"}]}], "}"}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  ColumnForm[{{90, {Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`c, $CellContext`Inf}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`e, $CellContext`Inf}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`c}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`e}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`e, $CellContext`a, \
$CellContext`c, $CellContext`d}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`e, $CellContext`a, \
$CellContext`c, $CellContext`Inf}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`e, $CellContext`a, \
$CellContext`d, $CellContext`c}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`e, $CellContext`a, \
$CellContext`Inf, $CellContext`c}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`Inf, $CellContext`c, \
$CellContext`a, $CellContext`d}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`Inf, $CellContext`c, \
$CellContext`a, $CellContext`e}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`Inf, $CellContext`c, \
$CellContext`d, $CellContext`a}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`Inf, $CellContext`c, \
$CellContext`e, $CellContext`a}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`Inf, $CellContext`d, \
$CellContext`a, $CellContext`c}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`Inf, $CellContext`d, \
$CellContext`c, $CellContext`a}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`Inf, $CellContext`e, \
$CellContext`a, $CellContext`c}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`Inf, $CellContext`e, \
$CellContext`c, $CellContext`a}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`c, $CellContext`d, $CellContext`a, \
$CellContext`b, $CellContext`e}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`c, $CellContext`d, $CellContext`a, \
$CellContext`e, $CellContext`b}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`c, $CellContext`d, $CellContext`a, \
$CellContext`e, $CellContext`Inf}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`c, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`e}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`c, $CellContext`e, $CellContext`a, \
$CellContext`b, $CellContext`Inf}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`c, $CellContext`e, $CellContext`a, \
$CellContext`d, $CellContext`Inf}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`c, $CellContext`e, $CellContext`a, \
$CellContext`Inf, $CellContext`b}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`c, $CellContext`e, $CellContext`a, \
$CellContext`Inf, $CellContext`d}]}], Rational[1, 2] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`c, $CellContext`Inf, $CellContext`b, \
$CellContext`a, $CellContext`d}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`c, $CellContext`Inf, $CellContext`b, \
$CellContext`d, $CellContext`a}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`c, $CellContext`Inf, $CellContext`d, \
$CellContext`a, $CellContext`b}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`c, $CellContext`Inf, $CellContext`d, \
$CellContext`a, $CellContext`e}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`c, $CellContext`Inf, $CellContext`d, \
$CellContext`b, $CellContext`a}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`c, $CellContext`Inf, $CellContext`d, \
$CellContext`e, $CellContext`a}]}], Rational[1, 2] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`c, $CellContext`Inf, $CellContext`e, \
$CellContext`a, $CellContext`d}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`c, $CellContext`Inf, $CellContext`e, \
$CellContext`d, $CellContext`a}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`b, $CellContext`c, \
$CellContext`a, $CellContext`Inf}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`b, $CellContext`c, \
$CellContext`Inf, $CellContext`a}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`b, $CellContext`e, \
$CellContext`a, $CellContext`c}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`b, $CellContext`e, \
$CellContext`c, $CellContext`a}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`b, $CellContext`Inf, \
$CellContext`a, $CellContext`c}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`b, $CellContext`Inf, \
$CellContext`c, $CellContext`a}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`c, $CellContext`b, \
$CellContext`a, $CellContext`Inf}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`c, $CellContext`b, \
$CellContext`Inf, $CellContext`a}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`c, $CellContext`e, \
$CellContext`a, $CellContext`Inf}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`c, $CellContext`e, \
$CellContext`Inf, $CellContext`a}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`c, $CellContext`Inf, \
$CellContext`a, $CellContext`e}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`c, $CellContext`Inf, \
$CellContext`e, $CellContext`a}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c}]}], Rational[1, 2] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`e}]}], Rational[1, 2] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`c, $CellContext`b}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`e, $CellContext`b}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`e, $CellContext`b, $CellContext`c, \
$CellContext`a, $CellContext`Inf}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`e, $CellContext`b, $CellContext`c, \
$CellContext`Inf, $CellContext`a}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`e, $CellContext`b, $CellContext`d, \
$CellContext`a, $CellContext`Inf}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`e, $CellContext`b, $CellContext`d, \
$CellContext`Inf, $CellContext`a}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`e, $CellContext`b, $CellContext`Inf, \
$CellContext`a, $CellContext`c}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`e, $CellContext`b, $CellContext`Inf, \
$CellContext`c, $CellContext`a}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`e, $CellContext`c, $CellContext`b, \
$CellContext`a, $CellContext`d}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`e, $CellContext`c, $CellContext`b, \
$CellContext`a, $CellContext`Inf}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`e, $CellContext`c, $CellContext`b, \
$CellContext`d, $CellContext`a}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`e, $CellContext`c, $CellContext`b, \
$CellContext`Inf, $CellContext`a}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`e, $CellContext`c, $CellContext`d, \
$CellContext`a, $CellContext`Inf}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`e, $CellContext`c, $CellContext`d, \
$CellContext`Inf, $CellContext`a}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`e, $CellContext`c, $CellContext`Inf, \
$CellContext`a, $CellContext`b}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`e, $CellContext`c, $CellContext`Inf, \
$CellContext`a, $CellContext`d}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`e, $CellContext`c, $CellContext`Inf, \
$CellContext`b, $CellContext`a}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`e, $CellContext`c, $CellContext`Inf, \
$CellContext`d, $CellContext`a}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`d}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`c, $CellContext`b}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`d, $CellContext`b}]}], Rational[1, 2] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`c, $CellContext`d}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`c}]}], Rational[1, 2] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`e}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`e, $CellContext`d}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`c, $CellContext`a, \
$CellContext`b, $CellContext`d}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`c, $CellContext`a, \
$CellContext`d, $CellContext`b}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`c, $CellContext`a, \
$CellContext`d, $CellContext`e}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`c, $CellContext`a, \
$CellContext`e, $CellContext`d}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`d, $CellContext`b, \
$CellContext`a, $CellContext`e}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`d, $CellContext`b, \
$CellContext`e, $CellContext`a}]}], Rational[1, 2] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`d, $CellContext`c, \
$CellContext`a, $CellContext`b}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`d, $CellContext`c, \
$CellContext`b, $CellContext`a}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`d, $CellContext`e, \
$CellContext`a, $CellContext`b}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`d, $CellContext`e, \
$CellContext`b, $CellContext`a}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`e, $CellContext`c, \
$CellContext`a, $CellContext`b}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`e, $CellContext`c, \
$CellContext`a, $CellContext`d}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`e, $CellContext`c, \
$CellContext`b, $CellContext`a}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`e, $CellContext`c, \
$CellContext`d, $CellContext`a}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`e, $CellContext`d, \
$CellContext`a, $CellContext`b}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`e, $CellContext`d, \
$CellContext`a, $CellContext`c}]}], Rational[1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`e, $CellContext`d, \
$CellContext`b, $CellContext`a}]}], 
      Rational[-1, 4] $CellContext`IIi[{2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`e, $CellContext`d, \
$CellContext`c, $CellContext`a}]}]}}, {
    21, {Rational[1, 2] $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`b, $CellContext`c, \
$CellContext`e}]}], Rational[5, 2] $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`b, $CellContext`d, \
$CellContext`Inf}]}], (-2) $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`b, $CellContext`e, \
$CellContext`Inf}]}], 
      $CellContext`IIi[{4}, {
        $CellContext`cri[{$CellContext`a, $CellContext`b, $CellContext`Inf, \
$CellContext`c}]}], 2 $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`c, $CellContext`b, \
$CellContext`d}]}], -$CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`c, $CellContext`b, \
$CellContext`e}]}], 
      $CellContext`IIi[{4}, {
        $CellContext`cri[{$CellContext`a, $CellContext`c, $CellContext`d, \
$CellContext`Inf}]}], 
      $CellContext`IIi[{4}, {
        $CellContext`cri[{$CellContext`a, $CellContext`c, $CellContext`e, \
$CellContext`Inf}]}], -$CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`c, $CellContext`Inf, \
$CellContext`b}]}], -$CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`d, $CellContext`c, \
$CellContext`e}]}], 
      $CellContext`IIi[{4}, {
        $CellContext`cri[{$CellContext`a, $CellContext`d, $CellContext`e, \
$CellContext`Inf}]}], Rational[1, 2] $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`d, $CellContext`Inf, \
$CellContext`b}]}], 4 $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`d, $CellContext`Inf, \
$CellContext`c}]}], 
      $CellContext`IIi[{4}, {
        $CellContext`cri[{$CellContext`a, $CellContext`e, $CellContext`c, \
$CellContext`d}]}], Rational[1, 2] $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`e, $CellContext`d, \
$CellContext`Inf}]}], Rational[-3, 2] $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`e, $CellContext`Inf, \
$CellContext`b}]}], 
      $CellContext`IIi[{4}, {
        $CellContext`cri[{$CellContext`a, $CellContext`e, $CellContext`Inf, \
$CellContext`c}]}], 
      $CellContext`IIi[{4}, {
        $CellContext`cri[{$CellContext`a, $CellContext`Inf, $CellContext`b, \
$CellContext`d}]}], (-2) $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`Inf, $CellContext`b, \
$CellContext`e}]}], 2 $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`Inf, $CellContext`c, \
$CellContext`d}]}], Rational[3, 2] $CellContext`IIi[{4}, {
         $CellContext`cri[{$CellContext`a, $CellContext`Inf, $CellContext`c, \
$CellContext`e}]}]}}}],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.6976124770995116`*^9, 3.697616148610265*^9, 3.6976310971141596`*^9, {
   3.6976311450175066`*^9, 3.697631153017918*^9}, 3.6976314472819486`*^9, 
   3.697631680563813*^9, 3.6976318755561295`*^9, 3.697641234887615*^9, 
   3.6976412909954853`*^9, 3.6976442136194315`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"texCountIntegrals", "[", "out4AllNLoweras22and4gathered", 
  "]"}]], "Input",
 CellChangeTimes->{{3.697541176944091*^9, 3.697541183844907*^9}, 
   3.697631180296958*^9, 3.697631880357469*^9}],

Cell[BoxData["\<\"Integral & Number in expression \\\\\\\\ \\n$ I_{2, 2} $ & \
90 \\\\\\\\ \\n$ I_{4} $ & 21 \\\\\\\\ \\nTotal & 111\"\>"], "Output",
 CellChangeTimes->{
  3.697541184578389*^9, 3.6975415625748787`*^9, 3.6975423881706247`*^9, 
   3.697554872942132*^9, 3.697556942533373*^9, 3.6975633519519544`*^9, 
   3.697599612345704*^9, 3.697602717279029*^9, {3.6976124540588703`*^9, 
   3.697612477115136*^9}, 3.6976161496571493`*^9, 3.6976311809389687`*^9, 
   3.6976314572767124`*^9, 3.697631681126315*^9, 3.6976318808730392`*^9, 
   3.6976412349276433`*^9, 3.697641291053527*^9, 3.6976442136614676`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"texIntegralsByCoeff", "[", 
  RowBox[{
   RowBox[{"4", "*", "out4AllNLoweras22and4"}], "//", "Expand"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.6975412338845387`*^9, 3.6975412460026407`*^9}, {
  3.697541316714067*^9, 3.697541324473263*^9}, {3.697631183065037*^9, 
  3.6976311886958523`*^9}, {3.6976318841556644`*^9, 3.6976319258510995`*^9}}],

Cell[BoxData["\<\"I_{2, 2}( [b d a c \\\\infty] \\n - [b d a e \\\\infty] \\n \
- [b d a \\\\infty c] \\n + [b d a \\\\infty e] \\n - [b e a c d] \\n + [b e \
a c \\\\infty] \\n + [b e a d c] \\n - [b e a \\\\infty c] \\n + [b \\\\infty \
c a d] \\n - [b \\\\infty c a e] \\n - [b \\\\infty c d a] \\n + [b \\\\infty \
c e a] \\n - [b \\\\infty d a c] \\n + [b \\\\infty d c a] \\n - [b \\\\infty \
e a c] \\n + [b \\\\infty e c a] \\n - [c d a b e] \\n + [c d a e b] \\n - [c \
d a e \\\\infty] \\n + [c d a \\\\infty e] \\n - [c e a b \\\\infty] \\n + [c \
e a d \\\\infty] \\n + [c e a \\\\infty b] \\n - [c e a \\\\infty d] \\n + 2 \
[c \\\\infty b a d] \\n - 2 [c \\\\infty b d a] \\n + [c \\\\infty d a b] \\n \
+ [c \\\\infty d a e] \\n - [c \\\\infty d b a] \\n - [c \\\\infty d e a] \\n \
+ 2 [c \\\\infty e a d] \\n - 2 [c \\\\infty e d a] \\n + [d b c a \\\\infty] \
\\n - [d b c \\\\infty a] \\n + [d b e a c] \\n - [d b e c a] \\n + [d b \
\\\\infty a c] \\n - [d b \\\\infty c a] \\n + [d c b a \\\\infty] \\n - [d c \
b \\\\infty a] \\n + [d c e a \\\\infty] \\n - [d c e \\\\infty a] \\n + [d c \
\\\\infty a e] \\n - [d c \\\\infty e a] \\n - 2 [d \\\\infty a b c] \\n + 2 \
[d \\\\infty a b e] \\n + 2 [d \\\\infty a c b] \\n - 2 [d \\\\infty a e b] \
\\n - [e b c a \\\\infty] \\n + [e b c \\\\infty a] \\n - [e b d a \\\\infty] \
\\n + [e b d \\\\infty a] \\n - [e b \\\\infty a c] \\n + [e b \\\\infty c a] \
\\n - [e c b a d] \\n + [e c b a \\\\infty] \\n + [e c b d a] \\n - [e c b \\\
\\infty a] \\n + [e c d a \\\\infty] \\n - [e c d \\\\infty a] \\n + [e c \
\\\\infty a b] \\n - [e c \\\\infty a d] \\n - [e c \\\\infty b a] \\n + [e c \
\\\\infty d a] \\n - [e \\\\infty a b c] \\n - [e \\\\infty a b d] \\n + [e \
\\\\infty a c b] \\n + [e \\\\infty a d b] \\n + 2 [\\\\infty b a c d] \\n - \
2 [\\\\infty b a d c] \\n + 2 [\\\\infty b a d e] \\n - 2 [\\\\infty b a e d] \
\\n - [\\\\infty c a b d] \\n + [\\\\infty c a d b] \\n + [\\\\infty c a d e] \
\\n - [\\\\infty c a e d] \\n + [\\\\infty d b a e] \\n - [\\\\infty d b e a] \
\\n + 2 [\\\\infty d c a b] \\n - 2 [\\\\infty d c b a] \\n + [\\\\infty d e \
a b] \\n - [\\\\infty d e b a] \\n - [\\\\infty e c a b] \\n + [\\\\infty e c \
a d] \\n + [\\\\infty e c b a] \\n - [\\\\infty e c d a] \\n - [\\\\infty e d \
a b] \\n + [\\\\infty e d a c] \\n + [\\\\infty e d b a] \\n - [\\\\infty e d \
c a] ) + {} \\\\\\\\ \\n & {} + I_{4}( 2 [a b c e] \\n + 10 [a b d \\\\infty] \
\\n - 8 [a b e \\\\infty] \\n + 4 [a b \\\\infty c] \\n + 8 [a c b d] \\n - 4 \
[a c b e] \\n + 4 [a c d \\\\infty] \\n + 4 [a c e \\\\infty] \\n - 4 [a c \\\
\\infty b] \\n - 4 [a d c e] \\n + 4 [a d e \\\\infty] \\n + 2 [a d \\\\infty \
b] \\n + 16 [a d \\\\infty c] \\n + 4 [a e c d] \\n + 2 [a e d \\\\infty] \\n \
- 6 [a e \\\\infty b] \\n + 4 [a e \\\\infty c] \\n + 4 [a \\\\infty b d] \\n \
- 8 [a \\\\infty b e] \\n + 8 [a \\\\infty c d] \\n + 6 [a \\\\infty c e] )\"\
\>"], "Output",
 CellChangeTimes->{
  3.697541248314834*^9, 3.697541326371251*^9, 3.697541565501934*^9, 
   3.697554878556632*^9, 3.697556957000516*^9, 3.697563353327479*^9, 
   3.69759961475397*^9, 3.697602719732797*^9, {3.697612454137001*^9, 
   3.6976124786782722`*^9}, 3.6976161519248233`*^9, 3.697631189352126*^9, 
   3.697631459716313*^9, 3.6976316820800033`*^9, {3.697631888722457*^9, 
   3.697631926835442*^9}, 3.6976412355781174`*^9, 3.6976412916949806`*^9, 
   3.6976442143069296`*^9}]
}, Open  ]]
},
WindowSize->{752, 778},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
ShowSelection->True,
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 175, 3, 30, "Input"],
Cell[735, 25, 232, 6, 30, "Input"],
Cell[970, 33, 17466, 472, 1716, "Input"],
Cell[18439, 507, 625, 14, 50, "Input"],
Cell[19067, 523, 222, 5, 30, "Input"],
Cell[19292, 530, 1141, 30, 50, "Input"],
Cell[CellGroupData[{
Cell[20458, 564, 441, 10, 30, "Input"],
Cell[20902, 576, 653, 8, 44, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21592, 589, 1015, 19, 50, "Input"],
Cell[22610, 610, 431, 6, 44, "Output"]
}, Open  ]],
Cell[23056, 619, 945, 19, 30, "Input"],
Cell[24004, 640, 625, 15, 30, "Input"],
Cell[CellGroupData[{
Cell[24654, 659, 571, 13, 30, "Input"],
Cell[25228, 674, 564, 8, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25829, 687, 1092, 24, 69, "Input"],
Cell[26924, 713, 320, 5, 30, "Output"]
}, Open  ]],
Cell[27259, 721, 994, 15, 30, "Input"],
Cell[CellGroupData[{
Cell[28278, 740, 232, 4, 30, "Input"],
Cell[28513, 746, 34397, 856, 101, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[62947, 1607, 230, 3, 30, "Input"],
Cell[63180, 1612, 930, 13, 126, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[64147, 1630, 740, 12, 30, "Input"],
Cell[64890, 1644, 2194, 29, 1209, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[67121, 1678, 777, 12, 30, "Input"],
Cell[67901, 1692, 2004, 26, 1209, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[69942, 1723, 778, 12, 30, "Input"],
Cell[70723, 1737, 2513, 33, 1209, "Output"]
}, Open  ]],
Cell[73251, 1773, 378, 7, 30, "Input"],
Cell[73632, 1782, 343, 8, 30, "Input"],
Cell[CellGroupData[{
Cell[74000, 1794, 387, 6, 30, "Input"],
Cell[74390, 1802, 963, 13, 50, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[75390, 1820, 271, 4, 30, "Input"],
Cell[75664, 1826, 691, 9, 69, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[76392, 1840, 195, 3, 30, "Input"],
Cell[76590, 1845, 627, 9, 50, "Output"]
}, Open  ]],
Cell[77232, 1857, 362, 8, 30, "Input"],
Cell[77597, 1867, 810, 16, 50, "Input"],
Cell[CellGroupData[{
Cell[78432, 1887, 220, 4, 30, "Input"],
Cell[78655, 1893, 174, 3, 30, "Output"]
}, Open  ]],
Cell[78844, 1899, 334, 7, 30, "Input"],
Cell[CellGroupData[{
Cell[79203, 1910, 245, 4, 30, "Input"],
Cell[79451, 1916, 545, 7, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[80033, 1928, 1085, 23, 69, "Input"],
Cell[81121, 1953, 328, 5, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[81486, 1963, 214, 4, 30, "Input"],
Cell[81703, 1969, 35601, 886, 53, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[117341, 2860, 193, 4, 30, "Input"],
Cell[117537, 2866, 585, 8, 88, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[118159, 2879, 318, 7, 30, "Input"],
Cell[118480, 2888, 2189, 29, 1266, "Output"]
}, Open  ]],
Cell[120684, 2920, 197, 4, 30, "Input"],
Cell[120884, 2926, 343, 8, 30, "Input"],
Cell[CellGroupData[{
Cell[121252, 2938, 387, 6, 30, "Input"],
Cell[121642, 2946, 963, 13, 50, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[122642, 2964, 271, 4, 30, "Input"],
Cell[122916, 2970, 691, 9, 69, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[123644, 2984, 195, 3, 30, "Input"],
Cell[123842, 2989, 629, 9, 50, "Output"]
}, Open  ]],
Cell[124486, 3001, 362, 8, 30, "Input"],
Cell[124851, 3011, 896, 17, 50, "Input"],
Cell[125750, 3030, 380, 7, 30, "Input"],
Cell[CellGroupData[{
Cell[126155, 3041, 293, 4, 30, "Input"],
Cell[126451, 3047, 544, 7, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[127032, 3059, 1137, 24, 69, "Input"],
Cell[128172, 3085, 328, 5, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[128537, 3095, 239, 4, 30, "Input"],
Cell[128779, 3101, 61763, 1524, 53, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[190579, 4630, 215, 4, 30, "Input"],
Cell[190797, 4636, 610, 8, 88, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[191444, 4649, 368, 7, 30, "Input"],
Cell[191815, 4658, 3434, 45, 2121, "Output"]
}, Open  ]]
}
]
*)

