(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     16195,        380]
NotebookOptionsPosition[     15306,        348]
NotebookOutlinePosition[     15654,        363]
CellTagsIndexPosition[     15611,        360]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"Get", "[", 
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
    "\"\<PolyLogToolsLite.m\>\""}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.6976173541529036`*^9, 3.6976173672567277`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Get", "[", 
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
    "\"\<wt5_bruteforce_i32_as_i41_and_li5.m\>\""}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.6976220878118963`*^9, 3.697622088509391*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"I32", "[", 
    RowBox[{"x_", ",", "y_"}], "]"}], " ", ":=", " ", 
   RowBox[{"G", "[", 
    RowBox[{
    "0", ",", "y", ",", " ", "0", ",", " ", "0", ",", " ", "x", ",", " ", 
     "1"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"I41", "[", 
    RowBox[{"x_", ",", "y_"}], "]"}], " ", ":=", " ", 
   RowBox[{"G", "[", 
    RowBox[{
    "y", ",", "0", ",", " ", "0", ",", " ", "0", ",", " ", "x", ",", " ", 
     "1"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"L5", "[", "x_", "]"}], " ", ":=", " ", 
   RowBox[{"-", 
    RowBox[{"G", "[", 
     RowBox[{"0", ",", " ", "0", ",", " ", "0", ",", " ", "0", ",", " ", 
      RowBox[{"1", "/", "x"}], ",", " ", "1"}], "]"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.6976173788308344`*^9, 3.697617431423377*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"leading", " ", "=", " ", "wt5i32asi41idleading"}], ";"}]], "Input",
 CellChangeTimes->{{3.697622096755226*^9, 3.6976221096663632`*^9}, {
   3.697622174606318*^9, 3.6976221761453853`*^9}, 3.697622459194351*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"li5s", " ", "=", " ", 
   RowBox[{"wt5i32asi41idli5s", "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"L5c", "[", 
       RowBox[{"a_", ",", "b_", ",", "c_"}], "]"}], "\[RuleDelayed]", 
      RowBox[{"a", " ", 
       RowBox[{"L5i", "[", 
        RowBox[{"b", " ", 
         RowBox[{"Times", "@@", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"x", ",", " ", 
              RowBox[{"1", "-", "x"}], ",", " ", "y", ",", " ", 
              RowBox[{"1", "-", "y"}], ",", 
              RowBox[{"x", "-", "y"}]}], "}"}], "^", "c"}], ")"}]}]}], 
        "]"}]}]}], "}"}]}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6976221158347282`*^9, 3.6976221777395077`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"leading", " ", "-", " ", "li5s"}], ")"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"I32i", "\[Rule]", "I32"}], ",", 
        RowBox[{"I41i", "\[Rule]", "I41"}], ",", 
        RowBox[{"L5i", "\[Rule]", "L5"}]}], "}"}]}], "//", "CreateTensor"}], "//",
     "sh"}], "//", "flatTensor"}], "//", "Expand"}]], "Input",
 CellChangeTimes->{{3.69761745536693*^9, 3.697617469725366*^9}, {
   3.697622186865965*^9, 3.697622197644594*^9}, {3.6976905037383127`*^9, 
   3.69769050433338*^9}, 3.6976906013849154`*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.697617485950771*^9, 3.69762341326241*^9, 
  3.6976248096602297`*^9, 3.6976893166200585`*^9, 3.6976903235013027`*^9, 
  3.697690622984213*^9, 3.697691596153693*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Now", " ", "LaTeX", " ", "the", " ", "results"}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.6976251011451397`*^9, 3.6976251103263288`*^9}}],

Cell[BoxData[
 RowBox[{"<<", "TeXUtilities`"}]], "Input",
 CellChangeTimes->{{3.6976251560505433`*^9, 3.69762515920988*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"myFold", "[", 
   RowBox[{"f_", ",", "l_List"}], "]"}], ":=", 
  RowBox[{"Fold", "[", 
   RowBox[{"f", ",", 
    RowBox[{"l", "[", 
     RowBox[{"[", "1", "]"}], "]"}], ",", 
    RowBox[{"l", "[", 
     RowBox[{"[", 
      RowBox[{"2", ";;", "All"}], "]"}], "]"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"myTeXList", "[", "l_List", "]"}], ":=", 
  RowBox[{"TeXForm", "[", 
   RowBox[{"TeXVerbatim", "[", 
    RowBox[{"myFold", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"#1", "<>", "\"\<, \>\"", "<>", "#2"}], "&"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"ToString", "[", 
         RowBox[{"TeXForm", "[", "#", "]"}], "]"}], "&"}], "/@", "l"}]}], 
     "]"}], "]"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.697625246529936*^9, 3.697625249621313*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Format", "[", 
    RowBox[{
     RowBox[{"L5c", "[", 
      RowBox[{"coeff_", ",", "sgn_", ",", "factors_List"}], "]"}], ",", 
     "TeXForm"}], "]"}], ":=", 
   RowBox[{"TeXVerbatim", "[", 
    RowBox[{"\"\<\\\\{\>\"", "<>", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{"sgn", " ", "===", " ", "1"}], ",", " ", "\"\<+\>\"", ",", 
       " ", "\"\<-\>\""}], "]"}], "<>", "\"\<; \>\"", "<>", 
     RowBox[{"ToString", "[", 
      RowBox[{"myTeXList", "[", "factors", "]"}], "]"}], "<>", 
     "\"\<\\\\}\>\""}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6976251607894325`*^9, 3.6976253101809573`*^9}, 
   3.6976253493624525`*^9, {3.6976258202954006`*^9, 3.6976258236421647`*^9}, {
   3.6976272395608034`*^9, 3.6976272496623883`*^9}, {3.6976515673690767`*^9, 
   3.6976515674731507`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"arg", "[", 
    RowBox[{"L5c", "[", 
     RowBox[{"a_", ",", "b_", ",", "c_"}], "]"}], "]"}], " ", ":=", " ", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"arg", "[", 
    RowBox[{
     RowBox[{"q_", "?", "NumericQ"}], " ", 
     RowBox[{"L5c", "[", 
      RowBox[{"a_", ",", "b_", ",", "c_"}], "]"}]}], "]"}], " ", ":=", " ", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c"}], "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.6976254298825903`*^9, 3.6976254549351125`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"gath", " ", "=", " ", 
   RowBox[{"GatherBy", "[", 
    RowBox[{
     RowBox[{"List", "@@", "wt5i32asi41idli5s"}], ",", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"arg", "[", "#", "]"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}], "&"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6976254124922905`*^9, 3.6976254266467075`*^9}, {
  3.697625460269111*^9, 3.6976255160676966`*^9}, {3.6976257843518386`*^9, 
  3.697625804601339*^9}, {3.697626157285527*^9, 3.6976261586151495`*^9}, {
  3.697626504238899*^9, 3.6976265058653536`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"texLi5s", " ", ":=", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"arg", "[", 
          RowBox[{"#", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", "\[Equal]", "1"}], ",", " ", 
       "\"\<\>\"", ",", " ", 
       RowBox[{
        RowBox[{"ToString", "[", 
         RowBox[{"TeXForm", "[", 
          RowBox[{
           RowBox[{"arg", "[", 
            RowBox[{"#", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "]"}], "[", 
           RowBox[{"[", "1", "]"}], "]"}], "]"}], "]"}], " ", "<>", " ", 
        "\"\< \>\""}]}], "]"}], " ", "<>", "\"\<\\\\Li_5( \>\"", "<>", 
     "\[IndentingNewLine]", 
     RowBox[{"StringReplace", "[", 
      RowBox[{
       RowBox[{"ToString", "[", 
        RowBox[{"TeXForm", "[", 
         RowBox[{"Total", "[", "#", "]"}], "]"}], "]"}], ",", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
         "\"\<\\\\}+\\\\{\>\"", "\[Rule]", "\"\<\\\\}\\n + \\\\{\>\""}], ",", 
         RowBox[{
         "\"\<\\\\}-\\\\{\>\"", "\[Rule]", "\"\<\\\\}\\n - \\\\{\>\""}]}], 
        "}"}]}], "]"}], "<>", "\"\< )\>\""}], "&"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6976262044030867`*^9, 3.697626217570462*^9}, {
  3.6976263697343683`*^9, 3.697626370296877*^9}, {3.6976264964660892`*^9, 
  3.697626515529951*^9}, {3.69762724425217*^9, 3.697627288948786*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Fold", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
    "#1", " ", "<>", " ", "\"\< + {} \\\\\\\\ \\n & {} + \>\"", " ", "<>", 
     " ", "#2"}], "&"}], ",", " ", 
   RowBox[{"texLi5s", "/@", "gath"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6976257635679035`*^9, 3.697625800317798*^9}, {
  3.697625845348943*^9, 3.6976259317269154`*^9}, {3.697625966082904*^9, 
  3.697626110486187*^9}, {3.6976262005253*^9, 3.69762622900082*^9}, {
  3.6976263104523807`*^9, 3.6976263348338547`*^9}, {3.69762713714233*^9, 
  3.6976271433344283`*^9}}],

Cell[BoxData["\<\"\\\\frac{1}{9} \\\\Li_5( \\\\{+; 0, 1, -1, -3, 1\\\\}\\n + \
\\\\{+; 0, 1, -1, 3, -2\\\\}\\n + \\\\{+; 0, 2, -2, 0, -1\\\\}\\n + \\\\{+; \
0, 2, -2, 0, 1\\\\}\\n - \\\\{+; 0, -2, -3, 1, 3\\\\}\\n + \\\\{+; 0, -3, -1, \
-1, 2\\\\}\\n + \\\\{-; 1, 0, 0, -1, -2\\\\}\\n + \\\\{-; 1, 0, 0, -1, 2\\\\}\
\\n + \\\\{+; 1, 0, -3, 2, 1\\\\}\\n - \\\\{+; -1, -1, 0, -3, 2\\\\}\\n - \
\\\\{-; 1, 1, -1, 2, 0\\\\}\\n - \\\\{-; -1, 1, -1, -2, 3\\\\}\\n - \\\\{+; \
-1, 2, -2, 1, 0\\\\}\\n - \\\\{+; 1, 2, -2, -1, 0\\\\}\\n - \\\\{-; 1, -2, \
-3, 0, 1\\\\}\\n + \\\\{-; -1, 3, 0, -2, 1\\\\}\\n - \\\\{+; -1, -3, -1, 0, 3\
\\\\}\\n - \\\\{-; 1, -3, -2, 3, 0\\\\}\\n - \\\\{-; 2, 0, -1, 3, -3\\\\}\\n \
+ \\\\{-; 2, 0, -3, 1, -1\\\\}\\n - \\\\{-; -2, 1, -1, -1, 0\\\\}\\n - \
\\\\{-; 2, 1, -1, 1, -3\\\\}\\n - \\\\{-; 2, -1, -3, 3, -1\\\\}\\n + \\\\{+; \
-2, 3, 0, -1, -1\\\\}\\n + \\\\{+; 3, 0, -1, 2, -1\\\\}\\n - \\\\{-; -3, -1, \
0, -1, 3\\\\}\\n + \\\\{+; 3, 1, -1, 0, -1\\\\}\\n + \\\\{+; -3, 1, -1, 0, \
2\\\\}\\n - \\\\{-; 3, -1, -3, 2, 0\\\\}\\n + \\\\{+; 3, -3, -2, 1, 1\\\\} ) \
+ {} \\\\\\\\ \\n & {} + \\\\frac{1}{6} \\\\Li_5( \\\\{+; 1, 0, -1, 0, 0\\\\} \
) + {} \\\\\\\\ \\n & {} + \\\\frac{5}{27} \\\\Li_5( \\\\{-; -1, 0, -1, -3, 3\
\\\\}\\n + \\\\{+; 1, -3, -2, 0, 3\\\\}\\n + \\\\{-; 2, -3, -1, 3, 0\\\\} ) + \
{} \\\\\\\\ \\n & {} + \\\\frac{5}{18} \\\\Li_5( -\\\\{+; 0, -2, -1, 0, \
2\\\\}\\n - \\\\{+; -1, 0, 0, -2, 2\\\\} ) + {} \\\\\\\\ \\n & {} + \
\\\\frac{7}{18} \\\\Li_5( \\\\{+; 0, 0, -1, 0, 0\\\\}\\n - \\\\{+; 1, -2, -1, \
2, 0\\\\} ) + {} \\\\\\\\ \\n & {} + \\\\frac{4}{9} \\\\Li_5( -\\\\{-; 0, 0, \
-1, 2, -1\\\\}\\n - \\\\{+; 0, 0, 2, -1, -1\\\\}\\n + \\\\{+; 0, -1, 0, -1, 0\
\\\\}\\n - \\\\{-; 0, 1, -1, 0, -1\\\\}\\n - \\\\{-; 0, 1, -1, 0, 1\\\\}\\n - \
\\\\{-; 0, -2, -1, 0, 1\\\\}\\n - \\\\{+; 1, 0, 0, -1, -1\\\\}\\n - \\\\{+; \
1, 0, 0, -1, 1\\\\}\\n + \\\\{-; 1, 1, 0, 0, -2\\\\}\\n + \\\\{+; -1, 1, -1, \
1, 0\\\\}\\n + \\\\{+; 1, 1, -1, -1, 0\\\\}\\n + \\\\{-; 1, -1, -2, 2, 0\\\\}\
\\n - \\\\{+; -2, 0, 0, -1, 1\\\\}\\n + \\\\{+; 2, -1, -2, 1, 0\\\\} ) + {} \
\\\\\\\\ \\n & {} + \\\\frac{5}{9} \\\\Li_5( \\\\{-; 0, 0, 1, 1, -2\\\\}\\n - \
\\\\{+; 0, 1, 0, -2, 0\\\\}\\n + \\\\{-; 0, -1, -2, 0, 1\\\\}\\n + \\\\{+; 0, \
-1, -2, 0, 2\\\\}\\n - \\\\{+; 0, 2, 0, -1, 0\\\\}\\n + \\\\{+; -1, 0, 0, -2, \
1\\\\}\\n - \\\\{+; -1, 2, 0, 0, -1\\\\}\\n + \\\\{+; -2, 0, 0, -1, 2\\\\}\\n \
- \\\\{-; 2, -1, 0, 0, -1\\\\}\\n - \\\\{-; 2, -2, -1, 1, 0\\\\} ) + {} \
\\\\\\\\ \\n & {} + \\\\frac{2}{3} \\\\Li_5( \\\\{+; 0, 0, 0, 0, -1\\\\}\\n + \
\\\\{+; 0, 0, 0, 1, -1\\\\}\\n + \\\\{+; 0, -1, -1, 1, 0\\\\}\\n - \\\\{-; 0, \
-1, -1, 1, 1\\\\}\\n + \\\\{-; 1, 0, 0, -1, 0\\\\}\\n - \\\\{+; 1, 0, 0, -1, \
0\\\\}\\n + \\\\{+; -1, 0, -1, 0, 1\\\\}\\n - \\\\{-; 1, -1, -1, 0, 0\\\\}\\n \
+ \\\\{+; 1, -1, -1, 1, 0\\\\} ) + {} \\\\\\\\ \\n & {} + \\\\Li_5( -\\\\{+; \
0, 0, 0, -2, 1\\\\}\\n - \\\\{-; 0, 0, 1, -1, -1\\\\}\\n - \\\\{+; 0, 1, 0, \
-1, 1\\\\}\\n - \\\\{+; 0, 1, -1, -1, 0\\\\}\\n + \\\\{-; 0, 1, -1, 1, 0\\\\}\
\\n + \\\\{-; 0, -1, -1, -1, 1\\\\}\\n + \\\\{-; 0, 1, -1, -1, 1\\\\}\\n - \\\
\\{+; 0, 1, -1, 1, -1\\\\}\\n + \\\\{-; 0, -2, -1, 1, 1\\\\}\\n + \\\\{+; -1, \
0, 0, -1, 0\\\\}\\n + \\\\{+; -1, 0, 0, -1, 2\\\\}\\n - \\\\{+; 1, 0, -1, 0, \
-1\\\\}\\n + \\\\{-; 1, 0, -1, 2, -1\\\\}\\n - \\\\{-; 1, 0, -2, 1, 0\\\\}\\n \
- \\\\{-; -1, 1, 0, 0, -1\\\\}\\n - \\\\{+; -1, -1, 0, -1, 1\\\\}\\n + \
\\\\{-; -1, -1, 0, -1, 2\\\\}\\n + \\\\{-; -1, 1, -1, 0, 0\\\\}\\n - \\\\{+; \
1, 1, -1, 0, 0\\\\}\\n - \\\\{+; -1, 1, -1, 0, 1\\\\}\\n + \\\\{-; 1, 1, -1, \
0, -1\\\\}\\n + \\\\{-; -1, -1, -1, 0, 2\\\\}\\n + \\\\{+; 1, -1, -1, 2, -1\\\
\\}\\n + \\\\{+; 1, -1, -2, 1, 0\\\\}\\n + \\\\{-; 1, -1, -2, 1, 1\\\\}\\n - \
\\\\{-; -1, 2, 0, -1, 0\\\\}\\n - \\\\{+; 1, -2, -1, 0, 1\\\\}\\n - \\\\{+; \
2, 0, 0, 0, -1\\\\}\\n + \\\\{+; 2, 0, -1, 1, -1\\\\}\\n - \\\\{+; 2, -1, -1, \
1, 0\\\\} ) + {} \\\\\\\\ \\n & {} + \\\\frac{23}{18} \\\\Li_5( -\\\\{+; -1, \
0, 0, 0, 0\\\\} ) + {} \\\\\\\\ \\n & {} + \\\\frac{4}{3} \\\\Li_5( -\\\\{-; \
0, -1, -1, 0, 1\\\\}\\n - \\\\{+; -1, 0, 0, -1, 1\\\\} ) + {} \\\\\\\\ \\n & \
{} + \\\\frac{5}{3} \\\\Li_5( -\\\\{+; 0, 0, -1, -1, 1\\\\}\\n - \\\\{+; 0, \
1, 0, 0, 0\\\\}\\n + \\\\{-; 0, 1, 0, 0, -1\\\\}\\n + \\\\{+; 0, -1, 0, -1, 1\
\\\\}\\n + \\\\{+; 0, -1, -1, 1, 1\\\\}\\n - \\\\{-; 0, -1, -1, -1, 2\\\\}\\n \
- \\\\{-; -1, 0, -1, 0, 1\\\\}\\n + \\\\{-; 1, 1, 0, 0, -1\\\\}\\n - \\\\{+; \
-1, 1, 0, -1, 0\\\\}\\n - \\\\{-; -1, 1, 0, -1, 1\\\\}\\n + \\\\{+; -1, 1, 0, \
-1, 1\\\\}\\n - \\\\{+; -1, 1, 0, -2, 1\\\\}\\n + \\\\{+; 1, -1, -1, 0, \
0\\\\}\\n - \\\\{-; 1, -1, -1, 0, 1\\\\}\\n - \\\\{-; 1, -2, -1, 1, 1\\\\} ) \
+ {} \\\\\\\\ \\n & {} + \\\\frac{103}{54} \\\\Li_5( -\\\\{+; -1, 0, -1, 0, 0\
\\\\} ) + {} \\\\\\\\ \\n & {} + \\\\frac{107}{54} \\\\Li_5( \\\\{+; 1, 0, \
-2, 0, 0\\\\} ) + {} \\\\\\\\ \\n & {} + \\\\frac{8}{3} \\\\Li_5( -\\\\{-; 0, \
0, 0, 0, -1\\\\}\\n + \\\\{-; 0, 0, -1, 0, 1\\\\}\\n + \\\\{+; 0, 1, 0, -1, 0\
\\\\}\\n - \\\\{-; 0, -1, 0, -1, 1\\\\}\\n - \\\\{-; 0, 1, -1, 0, 0\\\\}\\n + \
\\\\{+; 0, 1, -1, 0, 0\\\\}\\n + \\\\{-; 1, 0, -1, 1, 0\\\\}\\n - \\\\{+; 1, \
0, -1, 1, 0\\\\}\\n + \\\\{+; 1, 0, -1, 1, -1\\\\} ) + {} \\\\\\\\ \\n & {} + \
\\\\frac{157}{54} \\\\Li_5( -\\\\{+; 2, 0, -1, 0, 0\\\\} ) + {} \\\\\\\\ \\n \
& {} + 3 \\\\Li_5( \\\\{-; 1, 0, -1, 1, -1\\\\}\\n + \\\\{+; 1, 1, 0, 0, -1\\\
\\} ) + {} \\\\\\\\ \\n & {} + \\\\frac{11}{3} \\\\Li_5( \\\\{+; 0, 0, 0, 1, \
0\\\\}\\n - \\\\{-; 0, 0, -1, 1, 0\\\\}\\n - \\\\{+; 1, 0, 0, 0, -1\\\\}\\n - \
\\\\{-; -1, 1, 0, -1, 0\\\\} ) + {} \\\\\\\\ \\n & {} + 4 \\\\Li_5( \\\\{-; \
0, -1, -1, 1, 0\\\\} ) + {} \\\\\\\\ \\n & {} + \\\\frac{14}{3} \\\\Li_5( -\\\
\\{-; 0, 0, -1, -1, 1\\\\}\\n - \\\\{+; 1, -1, -1, 0, 1\\\\} ) + {} \\\\\\\\ \
\\n & {} + \\\\frac{20}{3} \\\\Li_5( \\\\{-; -1, 1, 0, 0, 0\\\\} )\"\>"], \
"Output",
 CellChangeTimes->{{3.6976263163646317`*^9, 3.697626337100851*^9}, 
   3.697626372267604*^9, {3.697626509415167*^9, 3.6976265167814255`*^9}, {
   3.697627134218196*^9, 3.6976271447568407`*^9}, {3.697627271320699*^9, 
   3.697627290214924*^9}, 3.697659774283899*^9, 3.697689319573766*^9, 
   3.697691596748002*^9}]
}, Open  ]]
},
WindowSize->{1536, 794},
WindowMargins->{{-8, Automatic}, {Automatic, -8}},
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 240, 6, 30, "Input"],
Cell[801, 28, 255, 6, 30, "Input"],
Cell[1059, 36, 870, 24, 69, "Input"],
Cell[1932, 62, 244, 4, 30, "Input"],
Cell[2179, 68, 745, 20, 30, "Input"],
Cell[CellGroupData[{
Cell[2949, 92, 630, 16, 30, "Input"],
Cell[3582, 110, 213, 3, 30, "Output"]
}, Open  ]],
Cell[3810, 116, 191, 4, 30, "Input"],
Cell[4004, 122, 124, 2, 30, "Input"],
Cell[4131, 126, 830, 25, 50, "Input"],
Cell[4964, 153, 850, 20, 30, "Input"],
Cell[5817, 175, 612, 17, 50, "Input"],
Cell[6432, 194, 579, 13, 30, "Input"],
Cell[7014, 209, 1480, 38, 50, "Input"],
Cell[CellGroupData[{
Cell[8519, 251, 555, 12, 30, "Input"],
Cell[9077, 265, 6213, 80, 2691, "Output"]
}, Open  ]]
}
]
*)

