(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     58650,       1936]
NotebookOptionsPosition[     56166,       1846]
NotebookOutlinePosition[     56514,       1861]
CellTagsIndexPosition[     56471,       1858]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"Get", "[", 
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
    "\"\<PolyLogToolsLite.m\>\""}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.6975618189424686`*^9, 3.697561823181487*^9}, 
   3.69760437515477*^9, {3.697611715649382*^9, 3.6976117160556364`*^9}, {
   3.6976155302123637`*^9, 3.697615531806689*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "Using", " ", "a", " ", "pattern", " ", "to", " ", "make", " ", "a", " ", 
    "pattern", " ", "not", " ", "a", " ", 
    RowBox[{
     RowBox[{"pattern", "!"}], "?"}]}], "*)"}], 
  RowBox[{
   RowBox[{
    RowBox[{"lhsRule", "[", 
     RowBox[{"RuleDelayed", "[", 
      RowBox[{"lhs_", ",", "rhs_"}], "]"}], "]"}], ":=", 
    RowBox[{"lhs", "/.", 
     RowBox[{
      RowBox[{"HoldPattern", "[", "w_Pattern", "]"}], "\[RuleDelayed]", 
      RowBox[{"w", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}]}]}], "\n", 
   RowBox[{
    RowBox[{"rhsRule", "[", 
     RowBox[{"RuleDelayed", "[", 
      RowBox[{"lhs_", ",", "rhs_"}], "]"}], "]"}], ":=", 
    RowBox[{"Expand", "[", "rhs", "]"}]}], "\n", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ruleToIdentity", "[", "expr_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"lhsRule", "[", "expr", "]"}], "-", 
       RowBox[{"rhsRule", "[", "expr", "]"}]}], "//", "Expand"}]}], 
    ";"}]}]}]], "Input",
 CellChangeTimes->{{3.6975998566124477`*^9, 3.697599856628066*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"cr", "[", 
    RowBox[{"{", 
     RowBox[{"a_", ",", "b_", ",", "c_", ",", "d_"}], "}"}], "]"}], " ", ":=",
    " ", 
   RowBox[{"Limit", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"a", " ", "-", " ", "c"}], ")"}], "/", 
       RowBox[{"(", 
        RowBox[{"a", " ", "-", " ", "d"}], ")"}]}], " ", "/", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"b", " ", "-", " ", "c"}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"b", "-", "d"}], ")"}]}], ")"}]}], ",", " ", 
     RowBox[{"Inf", "\[Rule]", "Infinity"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"cr", "[", "l_List", "]"}], " ", ":=", " ", 
   RowBox[{"Sequence", "@@", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"cr", "[", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{"l", "[", 
           RowBox[{"[", 
            RowBox[{"1", ";;", "3"}], "]"}], "]"}], ",", " ", 
          RowBox[{"{", "#", "}"}]}], "]"}], "]"}], "&"}], "/@", 
      RowBox[{"l", "[", 
       RowBox[{"[", 
        RowBox[{"4", ";;", "All"}], "]"}], "]"}]}], ")"}]}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.6975619746562567`*^9, 3.6975620142885017`*^9}, {
  3.6975620983564434`*^9, 3.6975621036729717`*^9}, {3.697562161927788*^9, 
  3.6975621760368257`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"II", "[", 
    RowBox[{"indices_List", ",", "arguments_List"}], "]"}], "/;", 
   RowBox[{
    RowBox[{
     RowBox[{"Length", "[", "indices", "]"}], "\[Equal]", 
     RowBox[{"Length", "[", "arguments", "]"}]}], "&&", 
    RowBox[{"VectorQ", "[", 
     RowBox[{"indices", ",", 
      RowBox[{
       RowBox[{
        RowBox[{"IntegerQ", "[", "#", "]"}], "&&", 
        RowBox[{"#", "\[GreaterEqual]", "1"}]}], "&"}]}], "]"}]}]}], ":=", 
  RowBox[{"G", "@@", 
   RowBox[{"Flatten", "[", 
    RowBox[{"Join", "[", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{"0", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"indices", "[", 
               RowBox[{"[", "j", "]"}], "]"}], "-", "1"}], "}"}]}], "]"}], 
          ",", 
          RowBox[{"{", 
           RowBox[{"arguments", "[", 
            RowBox[{"[", "j", "]"}], "]"}], "}"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", 
          RowBox[{"Length", "[", "indices", "]"}], ",", "1", ",", 
          RowBox[{"-", "1"}]}], "}"}]}], "]"}], ",", 
      RowBox[{"{", "1", "}"}]}], "]"}], "]"}]}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Get", "[", 
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
    "\"\<wt5_rules_to_i311_i32_i5.m\>\""}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.6975618552590733`*^9, 3.6975618933071313`*^9}, {
  3.6975997652052317`*^9, 3.6975997776164637`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ruleToIdentity", "[", "rule41to32", "]"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e"}], "}"}], "]"}], 
      "}"}]}], "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "c", ",", "e", ",", "d"}], "}"}], "]"}], 
      "}"}]}], "]"}]}], "+", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"4", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e"}], "}"}], "]"}], 
     "}"}]}], "]"}]}]], "Output",
 CellChangeTimes->{3.697599872377677*^9, 3.697599929891759*^9, 
  3.697604385160853*^9, 3.697611679236704*^9, 3.697611725608531*^9, 
  3.697615537872551*^9, 3.6976487682282624`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ruleToIdentity", "[", "rule41to32", "]"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", "\[Rule]", "Inf"}], ",", 
        RowBox[{"b", "\[Rule]", "0"}], ",", 
        RowBox[{"c", "\[Rule]", "1"}], ",", 
        RowBox[{"cri", "\[Rule]", "cr"}], ",", 
        RowBox[{"IIi", "\[Rule]", "II"}]}], "}"}]}], "//", "CreateTensor"}], "//",
     "sh"}], "//", "flatTensor"}], "//", "Expand"}]], "Input",
 CellChangeTimes->{
  3.6975998221962953`*^9, {3.6975998636196985`*^9, 3.6975998709231634`*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.697599829185773*^9, 3.6975998672000685`*^9, 
  3.697599930985521*^9, 3.6976043853870125`*^9, 3.697611679471099*^9, 
  3.6976117261554294`*^9, 3.697615538060053*^9, 3.697648768420415*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ruleToIdentity", "[", "rule14to32", "]"}]], "Input",
 CellChangeTimes->{3.697599890627058*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"4", " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", "5", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "c", ",", "e"}], "}"}], "]"}], "}"}]}], 
    "]"}]}], "+", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", "5", "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "d", ",", "e"}], "}"}], "]"}], "}"}]}], 
   "]"}], "+", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "4"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e"}], "}"}], "]"}], 
     "}"}]}], "]"}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "d", ",", "c", ",", "e"}], "}"}], "]"}], 
      "}"}]}], "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "d", ",", "e", ",", "c"}], "}"}], "]"}], 
      "}"}]}], "]"}]}]}]], "Output",
 CellChangeTimes->{3.697599872377677*^9, 3.6975999314556785`*^9, 
  3.6976043854230385`*^9, 3.697611679486724*^9, 3.6976117261554294`*^9, 
  3.6976155380756807`*^9, 3.697648768474453*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ruleToIdentity", "[", "rule14to32", "]"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", "\[Rule]", "Inf"}], ",", 
        RowBox[{"b", "\[Rule]", "0"}], ",", 
        RowBox[{"c", "\[Rule]", "1"}], ",", 
        RowBox[{"cri", "\[Rule]", "cr"}], ",", 
        RowBox[{"IIi", "\[Rule]", "II"}]}], "}"}]}], "//", "CreateTensor"}], "//",
     "sh"}], "//", "flatTensor"}], "//", "Expand"}]], "Input",
 CellChangeTimes->{
  3.6975998221962953`*^9, {3.6975998636196985`*^9, 3.6975998932701674`*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.697599829185773*^9, 3.6975998672000685`*^9, 
  3.6975999331281085`*^9, 3.697604385661224*^9, 3.6976116796898513`*^9, 
  3.6976117271091533`*^9, 3.697615538278823*^9, 3.697648768683597*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ruleToIdentity", "[", "rule23to32", "]"}]], "Input",
 CellChangeTimes->{3.6975998969293427`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", "5", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}], "]"}], "}"}]}], 
    "]"}]}], "+", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "3"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e"}], "}"}], "]"}], 
     "}"}]}], "]"}], "+", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"b", ",", "a", ",", "d", ",", "c", ",", "e"}], "}"}], "]"}], 
     "}"}]}], "]"}]}]], "Output",
 CellChangeTimes->{3.697599872377677*^9, 3.697599933456236*^9, 
  3.697604385672242*^9, 3.6976116797054725`*^9, 3.697611727156011*^9, 
  3.697615538294448*^9, 3.6976487687196217`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ruleToIdentity", "[", "rule23to32", "]"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", "\[Rule]", "Inf"}], ",", 
        RowBox[{"b", "\[Rule]", "0"}], ",", 
        RowBox[{"c", "\[Rule]", "1"}], ",", 
        RowBox[{"cri", "\[Rule]", "cr"}], ",", 
        RowBox[{"IIi", "\[Rule]", "II"}]}], "}"}]}], "//", "CreateTensor"}], "//",
     "sh"}], "//", "flatTensor"}], "//", "Expand"}]], "Input",
 CellChangeTimes->{
  3.6975998221962953`*^9, {3.6975998636196985`*^9, 3.697599899227111*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.697599829185773*^9, 3.6975998672000685`*^9, 
  3.6975999345505686`*^9, 3.6976043858063393`*^9, 3.697611679814853*^9, 
  3.6976117275154066`*^9, 3.69761553841945*^9, 3.697648768849719*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ruleToIdentity", "[", "rule221to311", "]"}]], "Input",
 CellChangeTimes->{3.697599902838661*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], "}"}],
       "]"}], "}"}]}], "]"}], "+", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], "}"}],
       "]"}], "}"}]}], "]"}], "+", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "f", ",", "e"}], "}"}],
       "]"}], "}"}]}], "]"}], "+", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "c", ",", "f", ",", "d", ",", "e"}], "}"}],
       "]"}], "}"}]}], "]"}], "+", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "c", ",", "f", ",", "e", ",", "d"}], "}"}],
       "]"}], "}"}]}], "]"}]}]], "Output",
 CellChangeTimes->{3.697599872377677*^9, 3.697599935488077*^9, 
  3.6976043858203363`*^9, 3.6976116798304596`*^9, 3.6976117275154066`*^9, 
  3.697615538435057*^9, 3.6976487688867407`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ruleToIdentity", "[", "rule221to311", "]"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", "\[Rule]", "Inf"}], ",", 
        RowBox[{"b", "\[Rule]", "0"}], ",", 
        RowBox[{"c", "\[Rule]", "1"}], ",", 
        RowBox[{"cri", "\[Rule]", "cr"}], ",", 
        RowBox[{"IIi", "\[Rule]", "II"}]}], "}"}]}], "//", "CreateTensor"}], "//",
     "sh"}], "//", "flatTensor"}], "//", "Expand"}]], "Input",
 CellChangeTimes->{
  3.6975998221962953`*^9, {3.6975998636196985`*^9, 3.6975998709231634`*^9}, 
   3.6975999036980877`*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.697599829185773*^9, 3.6975998672000685`*^9, 
  3.6975999392249947`*^9, 3.6976043871412716`*^9, 3.6976116808623466`*^9, 
  3.697611730532119*^9, 3.6976155395293703`*^9, 3.6976487699855227`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ruleToIdentity", "[", "rule131to311", "]"}]], "Input",
 CellChangeTimes->{3.6975999074202924`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "3", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], "}"}],
       "]"}], "}"}]}], "]"}], "-", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "c", ",", "f", ",", "e", ",", "d"}], "}"}],
       "]"}], "}"}]}], "]"}]}]], "Output",
 CellChangeTimes->{3.697599872377677*^9, 3.697599939271859*^9, 
  3.697604387187313*^9, 3.6976116809092083`*^9, 3.697611730563366*^9, 
  3.697615539576226*^9, 3.6976487700835896`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ruleToIdentity", "[", "rule131to311", "]"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", "\[Rule]", "Inf"}], ",", 
        RowBox[{"b", "\[Rule]", "0"}], ",", 
        RowBox[{"c", "\[Rule]", "1"}], ",", 
        RowBox[{"cri", "\[Rule]", "cr"}], ",", 
        RowBox[{"IIi", "\[Rule]", "II"}]}], "}"}]}], "//", "CreateTensor"}], "//",
     "sh"}], "//", "flatTensor"}], "//", "Expand"}]], "Input",
 CellChangeTimes->{
  3.6975998221962953`*^9, {3.6975998636196985`*^9, 3.6975998709231634`*^9}, 
   3.6975999083421664`*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.697599829185773*^9, 3.6975998672000685`*^9, 
  3.6975999412411814`*^9, 3.697604388036917*^9, 3.697611681597332*^9, 
  3.6976117325327663`*^9, 3.697615540305687*^9, 3.697648770792094*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ruleToIdentity", "[", "rule113to311", "]"}]], "Input",
 CellChangeTimes->{3.6975999123759975`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["4", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", "5", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "d", ",", "e"}], "}"}], "]"}], "}"}]}], 
    "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", "5", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "d", ",", "f"}], "}"}], "]"}], "}"}]}], 
    "]"}]}], "+", 
  RowBox[{
   FractionBox["4", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", "5", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "e", ",", "c"}], "}"}], "]"}], "}"}]}], 
    "]"}]}], "-", 
  RowBox[{
   FractionBox["7", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", "5", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "e", ",", "f"}], "}"}], "]"}], "}"}]}], 
    "]"}]}], "-", 
  RowBox[{
   FractionBox["16", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", "5", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "f", ",", "c"}], "}"}], "]"}], "}"}]}], 
    "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "c", ",", "e", ",", "f"}], "}"}], "]"}], 
      "}"}]}], "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "e", ",", "c", ",", "f"}], "}"}], "]"}], 
      "}"}]}], "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "e", ",", "d", ",", "f"}], "}"}], "]"}], 
      "}"}]}], "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "e", ",", "f", ",", "c"}], "}"}], "]"}], 
      "}"}]}], "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"b", ",", "a", ",", "e", ",", "f", ",", "c"}], "}"}], "]"}], 
      "}"}]}], "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"b", ",", "a", ",", "e", ",", "f", ",", "d"}], "}"}], "]"}], 
      "}"}]}], "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"b", ",", "a", ",", "f", ",", "e", ",", "c"}], "}"}], "]"}], 
      "}"}]}], "]"}]}], "+", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", "3"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], "}"}],
       "]"}], "}"}]}], "]"}], "-", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "d", ",", "c", ",", "f", ",", "e"}], "}"}],
       "]"}], "}"}]}], "]"}]}]], "Output",
 CellChangeTimes->{3.697599872377677*^9, 3.6975999412880573`*^9, 
  3.6976043880529284`*^9, 3.6976116816129584`*^9, 3.6976117325639987`*^9, 
  3.697615540321313*^9, 3.697648770832122*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ruleToIdentity", "[", "rule113to311", "]"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", "\[Rule]", "Inf"}], ",", 
        RowBox[{"b", "\[Rule]", "0"}], ",", 
        RowBox[{"c", "\[Rule]", "1"}], ",", 
        RowBox[{"cri", "\[Rule]", "cr"}], ",", 
        RowBox[{"IIi", "\[Rule]", "II"}]}], "}"}]}], "//", "CreateTensor"}], "//",
     "sh"}], "//", "flatTensor"}], "//", "Expand"}]], "Input",
 CellChangeTimes->{
  3.6975998221962953`*^9, {3.6975998636196985`*^9, 3.6975998709231634`*^9}, 
   3.697599913502594*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.697599829185773*^9, 3.6975998672000685`*^9, 
  3.6976000840930743`*^9, 3.6976043907728434`*^9, 3.6976116839261265`*^9, 
  3.6976118732234683`*^9, 3.6976155427595105`*^9, 3.6976487722791276`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ruleToIdentity", "[", "rule122to311", "]"}]], "Input",
 CellChangeTimes->{3.697599919054234*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"12", " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", "5", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "c", ",", "f"}], "}"}], "]"}], "}"}]}], 
    "]"}]}], "+", 
  RowBox[{"6", " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", "5", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "d", ",", "e"}], "}"}], "]"}], "}"}]}], 
    "]"}]}], "+", 
  RowBox[{"6", " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", "5", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "d", ",", "f"}], "}"}], "]"}], "}"}]}], 
    "]"}]}], "+", 
  RowBox[{"6", " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", "5", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "e", ",", "f"}], "}"}], "]"}], "}"}]}], 
    "]"}]}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "c", ",", "e", ",", "f"}], "}"}], "]"}], 
      "}"}]}], "]"}]}], "-", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "c", ",", "f", ",", "e"}], "}"}], "]"}], 
     "}"}]}], "]"}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "e", ",", "c", ",", "f"}], "}"}], "]"}], 
      "}"}]}], "]"}]}], "+", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "e", ",", "f", ",", "d"}], "}"}], "]"}], 
     "}"}]}], "]"}], "+", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "f", ",", "e", ",", "d"}], "}"}], "]"}], 
     "}"}]}], "]"}], "+", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], "}"}],
       "]"}], "}"}]}], "]"}], "+", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "c", ",", "f", ",", "e", ",", "d"}], "}"}],
       "]"}], "}"}]}], "]"}], "+", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "d", ",", "c", ",", "e", ",", "f"}], "}"}],
       "]"}], "}"}]}], "]"}], "+", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "d", ",", "c", ",", "f", ",", "e"}], "}"}],
       "]"}], "}"}]}], "]"}], "+", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "d", ",", "e", ",", "c", ",", "f"}], "}"}],
       "]"}], "}"}]}], "]"}]}]], "Output",
 CellChangeTimes->{3.697599872377677*^9, 3.69760008412431*^9, 
  3.6976043908088655`*^9, 3.6976116839573584`*^9, 3.6976118732547016`*^9, 
  3.697615542775117*^9, 3.697648772378211*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ruleToIdentity", "[", "rule122to311", "]"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", "\[Rule]", "Inf"}], ",", 
        RowBox[{"b", "\[Rule]", "0"}], ",", 
        RowBox[{"c", "\[Rule]", "1"}], ",", 
        RowBox[{"cri", "\[Rule]", "cr"}], ",", 
        RowBox[{"IIi", "\[Rule]", "II"}]}], "}"}]}], "//", "CreateTensor"}], "//",
     "sh"}], "//", "flatTensor"}], "//", "Expand"}]], "Input",
 CellChangeTimes->{
  3.6975998221962953`*^9, {3.6975998636196985`*^9, 3.6975998709231634`*^9}, 
   3.697599920085514*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.697599829185773*^9, 3.6975998672000685`*^9, 
  3.6976000904082294`*^9, 3.697604393025434*^9, 3.6976116858173184`*^9, 
  3.697611879460041*^9, 3.6976155446668587`*^9, 3.6976487744306498`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ruleToIdentity", "[", "rule212to311", "]"}]], "Input",
 CellChangeTimes->{3.6975999587477193`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "12"}], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", "5", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "c", ",", "f"}], "}"}], "]"}], "}"}]}], 
    "]"}]}], "-", 
  RowBox[{"6", " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", "5", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "d", ",", "f"}], "}"}], "]"}], "}"}]}], 
    "]"}]}], "-", 
  RowBox[{"12", " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", "5", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "e", ",", "f"}], "}"}], "]"}], "}"}]}], 
    "]"}]}], "-", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "f"}], "}"}], "]"}], 
     "}"}]}], "]"}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "c", ",", "e", ",", "f"}], "}"}], "]"}], 
      "}"}]}], "]"}]}], "+", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "c", ",", "f", ",", "d"}], "}"}], "]"}], 
     "}"}]}], "]"}], "+", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "c", ",", "f", ",", "e"}], "}"}], "]"}], 
     "}"}]}], "]"}], "-", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "d", ",", "c", ",", "f"}], "}"}], "]"}], 
     "}"}]}], "]"}], "-", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "d", ",", "e", ",", "f"}], "}"}], "]"}], 
     "}"}]}], "]"}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "e", ",", "c", ",", "f"}], "}"}], "]"}], 
      "}"}]}], "]"}]}], "-", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "e", ",", "d", ",", "f"}], "}"}], "]"}], 
     "}"}]}], "]"}], "+", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "e", ",", "f", ",", "c"}], "}"}], "]"}], 
     "}"}]}], "]"}], "+", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "1", ",", "2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], "}"}],
       "]"}], "}"}]}], "]"}], "-", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "f", ",", "e"}], "}"}],
       "]"}], "}"}]}], "]"}], "-", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "c", ",", "f", ",", "d", ",", "e"}], "}"}],
       "]"}], "}"}]}], "]"}], "-", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "c", ",", "f", ",", "e", ",", "d"}], "}"}],
       "]"}], "}"}]}], "]"}], "-", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "d", ",", "c", ",", "e", ",", "f"}], "}"}],
       "]"}], "}"}]}], "]"}], "-", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "d", ",", "e", ",", "c", ",", "f"}], "}"}],
       "]"}], "}"}]}], "]"}], "-", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "e", ",", "d", ",", "c", ",", "f"}], "}"}],
       "]"}], "}"}]}], "]"}]}]], "Output",
 CellChangeTimes->{3.697599872377677*^9, 3.697600090439498*^9, 
  3.6976043930484705`*^9, 3.6976116858485513`*^9, 3.6976118794912744`*^9, 
  3.6976155446980915`*^9, 3.697648774564764*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"ruleToIdentity", "[", "rule212to311", "]"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", "\[Rule]", "Inf"}], ",", 
        RowBox[{"b", "\[Rule]", "0"}], ",", 
        RowBox[{"c", "\[Rule]", "1"}], ",", 
        RowBox[{"cri", "\[Rule]", "cr"}], ",", 
        RowBox[{"IIi", "\[Rule]", "II"}]}], "}"}]}], "//", "CreateTensor"}], "//",
     "sh"}], "//", "flatTensor"}], "//", "Expand"}]], "Input",
 CellChangeTimes->{
  3.6975998221962953`*^9, {3.6975998636196985`*^9, 3.6975998709231634`*^9}, 
   3.6975999596383605`*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.697599829185773*^9, 3.6975998672000685`*^9, 
  3.697600098402921*^9, 3.6976043957974095`*^9, 3.6976116882403584`*^9, 
  3.697611887119023*^9, 3.6976155470893555`*^9, 3.69764877714559*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"--", 
   RowBox[{"--", 
    RowBox[{"--", "-"}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.69756256451105*^9, 3.697562567623335*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ruleToIdentity", "[", "rule311to32", "]"}]], "Input",
 CellChangeTimes->{{3.6975999587477193`*^9, 3.6975999817092514`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    FractionBox["1", "3"]}], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e"}], "}"}], "]"}], 
      "}"}]}], "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "f"}], "}"}], "]"}], 
      "}"}]}], "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "c", ",", "e", ",", "d"}], "}"}], "]"}], 
      "}"}]}], "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "c", ",", "f", ",", "d"}], "}"}], "]"}], 
      "}"}]}], "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "c", ",", "b", ",", "d", ",", "f"}], "}"}], "]"}], 
      "}"}]}], "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "c", ",", "b", ",", "f", ",", "d"}], "}"}], "]"}], 
      "}"}]}], "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "d", ",", "b", ",", "e", ",", "f"}], "}"}], "]"}], 
      "}"}]}], "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "d", ",", "b", ",", "f", ",", "e"}], "}"}], "]"}], 
      "}"}]}], "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"b", ",", "a", ",", "f", ",", "c", ",", "e"}], "}"}], "]"}], 
      "}"}]}], "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"b", ",", "a", ",", "f", ",", "e", ",", "c"}], "}"}], "]"}], 
      "}"}]}], "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"b", ",", "f", ",", "a", ",", "c", ",", "e"}], "}"}], "]"}], 
      "}"}]}], "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"cri", "[", 
       RowBox[{"{", 
        RowBox[{"b", ",", "f", ",", "a", ",", "e", ",", "c"}], "}"}], "]"}], 
      "}"}]}], "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "b", ",", "f", ",", "e"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "b", ",", "c", ",", "e"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "c", ",", "b", ",", "d"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "b", ",", "c", ",", "e"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "d", ",", "b", ",", "c"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "b", ",", "c", ",", "f"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "d", ",", "c", ",", "b"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "b", ",", "d", ",", "f"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "e", ",", "b", ",", "f"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "b", ",", "e", ",", "f"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "b", ",", "d", ",", "c"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "b", ",", "e", ",", "f"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "d", ",", "b", ",", "c"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "b", ",", "e", ",", "f"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "d", ",", "e", ",", "b"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "b", ",", "e", ",", "f"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "e", ",", "d", ",", "b"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "c", ",", "b", ",", "d"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "b", ",", "c", ",", "e"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "c", ",", "b", ",", "d"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "e", ",", "c", ",", "f"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "c", ",", "b", ",", "d"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"b", ",", "c", ",", "e", ",", "f"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "c", ",", "b", ",", "d"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"b", ",", "e", ",", "c", ",", "f"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "c", ",", "d", ",", "f"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "d", ",", "b", ",", "e"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "c", ",", "d", ",", "f"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "e", ",", "b", ",", "d"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "c", ",", "d", ",", "f"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "e", ",", "b", ",", "f"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "c", ",", "e", ",", "f"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "d", ",", "b", ",", "c"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "c", ",", "e", ",", "f"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "d", ",", "b", ",", "e"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "c", ",", "e", ",", "f"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "e", ",", "b", ",", "d"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "d", ",", "b", ",", "c"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "b", ",", "c", ",", "e"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "d", ",", "b", ",", "c"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "b", ",", "e", ",", "f"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "d", ",", "b", ",", "c"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "b", ",", "f", ",", "c"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "d", ",", "b", ",", "c"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "c", ",", "e", ",", "f"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "d", ",", "b", ",", "e"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "b", ",", "f", ",", "e"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "d", ",", "b", ",", "e"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "c", ",", "d", ",", "f"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "d", ",", "b", ",", "e"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "c", ",", "e", ",", "f"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "d", ",", "b", ",", "f"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "e", ",", "b", ",", "d"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "e", ",", "b", ",", "d"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "b", ",", "f", ",", "e"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "e", ",", "b", ",", "d"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "c", ",", "d", ",", "f"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "e", ",", "b", ",", "d"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "c", ",", "e", ",", "f"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "e", ",", "b", ",", "d"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "d", ",", "b", ",", "f"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "e", ",", "b", ",", "f"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "b", ",", "d", ",", "f"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "e", ",", "b", ",", "f"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "c", ",", "d", ",", "f"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "e", ",", "c", ",", "f"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "c", ",", "b", ",", "d"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "f", ",", "b", ",", "e"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"b", ",", "c", ",", "d", ",", "f"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"b", ",", "c", ",", "d", ",", "f"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "f", ",", "b", ",", "e"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"b", ",", "c", ",", "e", ",", "f"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "c", ",", "b", ",", "d"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   RowBox[{"IIi", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"b", ",", "e", ",", "c", ",", "f"}], "}"}], "]"}], ",", 
       RowBox[{"cri", "[", 
        RowBox[{"{", 
         RowBox[{"a", ",", "c", ",", "b", ",", "d"}], "}"}], "]"}]}], "}"}]}],
     "]"}]}], "+", 
  RowBox[{"IIi", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f"}], "}"}],
       "]"}], "}"}]}], "]"}]}]], "Output",
 CellChangeTimes->{3.697599872377677*^9, 3.697600098496684*^9, 
  3.6976043958504477`*^9, 3.697611688287216*^9, 3.69761188719713*^9, 
  3.6976155471362123`*^9, 3.6976487772886915`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ruleToIdentity", "[", "rule311to32", "]"}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"a", "\[Rule]", "Inf"}], ",", 
       RowBox[{"b", "\[Rule]", "0"}], ",", 
       RowBox[{"c", "\[Rule]", "1"}], ",", 
       RowBox[{"cri", "\[Rule]", "cr"}], ",", 
       RowBox[{"IIi", "\[Rule]", "II"}]}], "}"}]}], "//", "CreateTensor"}], "//",
    "del"}], "//", "Expand"}]], "Input",
 CellChangeTimes->{
  3.6975998221962953`*^9, {3.6975998636196985`*^9, 3.6975998709231634`*^9}, {
   3.6975999596383605`*^9, 3.69759998592968*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.697599829185773*^9, 3.6975998672000685`*^9, 3.6976043741280437`*^9, 
   3.697604404716708*^9, 3.697611696102937*^9, {3.697615533776026*^9, 
   3.6976155547953033`*^9}, 3.69765977412763*^9}]
}, Open  ]]
},
WindowSize->{1536, 794},
WindowMargins->{{-8, Automatic}, {Automatic, -8}},
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 363, 8, 30, "Input"],
Cell[924, 30, 1102, 31, 107, "Input"],
Cell[2029, 63, 1404, 43, 50, "Input"],
Cell[3436, 108, 1268, 37, 107, "Input"],
Cell[4707, 147, 301, 7, 30, "Input"],
Cell[CellGroupData[{
Cell[5033, 158, 76, 1, 30, "Input"],
Cell[5112, 161, 1112, 35, 75, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6261, 201, 602, 16, 50, "Input"],
Cell[6866, 219, 236, 3, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7139, 227, 118, 2, 30, "Input"],
Cell[7260, 231, 1601, 52, 81, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8898, 288, 602, 16, 50, "Input"],
Cell[9503, 306, 238, 3, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9778, 314, 120, 2, 30, "Input"],
Cell[9901, 318, 994, 31, 50, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10932, 354, 600, 16, 50, "Input"],
Cell[11535, 372, 237, 3, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11809, 380, 120, 2, 30, "Input"],
Cell[11932, 384, 1643, 49, 69, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13612, 438, 632, 17, 50, "Input"],
Cell[14247, 457, 242, 3, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14526, 465, 122, 2, 30, "Input"],
Cell[14651, 469, 784, 22, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[15472, 496, 632, 17, 50, "Input"],
Cell[16107, 515, 236, 3, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16380, 523, 122, 2, 30, "Input"],
Cell[16505, 527, 4388, 148, 224, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[20930, 680, 630, 17, 50, "Input"],
Cell[21563, 699, 244, 3, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21844, 707, 120, 2, 30, "Input"],
Cell[21967, 711, 4053, 132, 145, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[26057, 848, 630, 17, 50, "Input"],
Cell[26690, 867, 240, 3, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[26967, 875, 122, 2, 30, "Input"],
Cell[27092, 879, 5445, 178, 88, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[32574, 1062, 632, 17, 30, "Input"],
Cell[33209, 1081, 237, 3, 30, "Output"]
}, Open  ]],
Cell[33461, 1087, 186, 5, 30, "Input"],
Cell[CellGroupData[{
Cell[33672, 1096, 147, 2, 30, "Input"],
Cell[33822, 1100, 21436, 716, 491, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[55295, 1821, 610, 16, 30, "Input"],
Cell[55908, 1839, 242, 4, 30, "Output"]
}, Open  ]]
}
]
*)

