(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    564688,      12480]
NotebookOptionsPosition[    559535,      12310]
NotebookOutlinePosition[    559901,      12326]
CellTagsIndexPosition[    559858,      12323]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"<<", "TeXUtilities`"}]], "Input",
 CellChangeTimes->{{3.6576231620347567`*^9, 3.657623167774674*^9}, {
  3.69752451959698*^9, 3.6975245257731028`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Get", "[", 
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
    "\"\<dan_procedure.m\>\""}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.697598984782219*^9, 3.69759900807892*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"TeX", " ", "Formatting"}], "*)"}], 
  RowBox[{
   RowBox[{
    RowBox[{"Format", "[", 
     RowBox[{
      RowBox[{"a", "[", "i_", "]"}], ",", "TraditionalForm"}], "]"}], ":=", 
    RowBox[{"Subscript", "[", 
     RowBox[{"a", ",", "i"}], "]"}]}], "\n", 
   RowBox[{
    RowBox[{"Format", "[", 
     RowBox[{"Inf", ",", "TeXForm"}], "]"}], ":=", 
    RowBox[{"TeXCommand", "[", "\"\<infty\>\"", "]"}]}], 
   "\[IndentingNewLine]", "\n", 
   RowBox[{
    RowBox[{"myFold", "[", 
     RowBox[{"f_", ",", "l_List"}], "]"}], ":=", 
    RowBox[{"Fold", "[", 
     RowBox[{"f", ",", 
      RowBox[{"l", "[", 
       RowBox[{"[", "1", "]"}], "]"}], ",", 
      RowBox[{"l", "[", 
       RowBox[{"[", 
        RowBox[{"2", ";;", "All"}], "]"}], "]"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\n", 
   RowBox[{
    RowBox[{"myTeXList", "[", "l_List", "]"}], ":=", 
    RowBox[{"TeXForm", "[", 
     RowBox[{"TeXVerbatim", "[", 
      RowBox[{"myFold", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"#1", "<>", "\"\<, \>\"", "<>", "#2"}], "&"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"ToString", "[", 
           RowBox[{"TeXForm", "[", "#", "]"}], "]"}], "&"}], "/@", "l"}]}], 
       "]"}], "]"}], "]"}]}], "\[IndentingNewLine]", "\n", 
   RowBox[{
    RowBox[{"Format", "[", 
     RowBox[{
      RowBox[{"cri", "[", "l_List", "]"}], ",", "TeXForm"}], "]"}], ":=", 
    RowBox[{"TeXVerbatim", "[", 
     RowBox[{"myFold", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"#1", "<>", "\"\< \>\"", "<>", "#2"}], "&"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"ToString", "[", 
          RowBox[{"TeXForm", "[", "#", "]"}], "]"}], "&"}], "/@", "l"}]}], 
      "]"}], "]"}]}], "\[IndentingNewLine]", "\n", 
   RowBox[{
    RowBox[{"Format", "[", 
     RowBox[{
      RowBox[{"IIi", "[", 
       RowBox[{"inds_List", ",", "args_List"}], "]"}], ",", "TeXForm"}], 
     "]"}], ":=", 
    RowBox[{"TeXVerbatim", "[", 
     RowBox[{"\"\<I_{\>\"", "<>", 
      RowBox[{"ToString", "[", 
       RowBox[{"myTeXList", "[", "inds", "]"}], "]"}], "<>", "\"\<}(\>\"", "<>", 
      RowBox[{"ToString", "[", 
       RowBox[{"myTeXList", "[", "args", "]"}], "]"}], "<>", "\"\<)\>\""}], 
     "]"}]}], "\[IndentingNewLine]", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"Format", "[", 
      RowBox[{
       RowBox[{"H", "[", 
        RowBox[{"a0_", ",", "alist_List", ",", "x_", ",", "alast_"}], "]"}], 
       ",", "TeXForm"}], "]"}], ":=", 
     RowBox[{"TeXVerbatim", "[", 
      RowBox[{"\"\<H(\>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"TeXForm", "[", "a0", "]"}], "]"}], "<>", "\"\< \\\\mid \>\"",
        "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"myTeXList", "[", "alist", "]"}], "]"}], "<>", 
       "\"\< \\\\dblslash \>\"", "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"TeXForm", "[", "x", "]"}], "]"}], "<>", "\"\< \\\\mid \>\"", 
       "<>", 
       RowBox[{"ToString", "[", 
        RowBox[{"TeXForm", "[", "alast", "]"}], "]"}], "<>", "\"\<)\>\""}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", "\n", 
   RowBox[{"(*", 
    RowBox[{"manipulate", " ", "and", " ", "LaTeX", " ", "results"}], "*)"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"gatherIntegrals", "[", "expr_", "]"}], ":=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Head", "[", "expr", "]"}], "===", "Plus"}], ",", 
           RowBox[{"List", "@@", "expr"}], ",", 
           RowBox[{"{", "expr", "}"}]}], "]"}], ")"}], "//", 
        RowBox[{
         RowBox[{"GatherBy", "[", 
          RowBox[{"#", ",", 
           RowBox[{
            RowBox[{"indices", "[", "#", "]"}], "&"}]}], "]"}], "&"}]}], 
       ")"}], "//", "Reverse"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"gatherIntegrals", "[", 
      RowBox[{"expr_", ",", "function_"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Head", "[", "expr", "]"}], "===", "Plus"}], ",", 
           RowBox[{"List", "@@", "expr"}], ",", 
           RowBox[{"{", "expr", "}"}]}], "]"}], ")"}], "//", 
        RowBox[{
         RowBox[{"GatherBy", "[", 
          RowBox[{"#", ",", "function"}], "]"}], "&"}]}], ")"}], "//", 
      "Reverse"}]}], ";"}], "\[IndentingNewLine]", "\n", 
   RowBox[{
    RowBox[{"countIntegrals", "[", "expr_", "]"}], ":=", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Length", "[", "#", "]"}], ",", "#"}], "}"}], "&"}], "/@", 
        "expr"}], ")"}], "//", "ColumnForm"}], "//", "Print"}]}], 
   "\[IndentingNewLine]", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"texCountIntegrals", "[", "expr_", "]"}], ":=", 
     RowBox[{"\"\<Integral & Number in expression\>\"", "<>", 
      RowBox[{"Fold", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"#1", "<>", "\"\< \\\\\\\\ \\n\>\"", "<>", "#2"}], "&"}], 
        ",", "\"\<\>\"", ",", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"\"\<$ I_\>\"", "<>", 
            RowBox[{"ToString", "[", 
             RowBox[{"indices", "[", 
              RowBox[{"#", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], "]"}], "<>", 
            "\"\< $ & \>\"", "<>", 
            RowBox[{"ToString", "[", 
             RowBox[{"Length", "[", "#", "]"}], "]"}]}], "}"}], "&"}], "/@", 
         "expr"}]}], "]"}], "<>", "\"\< \\\\\\\\ \\nTotal & \>\"", "<>", 
      RowBox[{"ToString", "[", 
       RowBox[{"Total", "[", 
        RowBox[{"Length", "/@", "expr"}], "]"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"texCountIntegrals", "[", 
      RowBox[{"expr_", ",", "function_"}], "]"}], ":=", 
     RowBox[{"\"\<Type & Number in expression\>\"", "<>", 
      RowBox[{"Fold", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"#1", "<>", "\"\< \\\\\\\\ \\n\>\"", "<>", "#2"}], "&"}], 
        ",", "\"\<\>\"", ",", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Fold", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"#1", "<>", "\"\< \>\"", "<>", "#2"}], "&"}], ",", 
              RowBox[{"ToString", "/@", 
               RowBox[{"function", "[", 
                RowBox[{"#", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "]"}]}]}], "]"}], "<>", 
            "\"\< $ & \>\"", "<>", 
            RowBox[{"ToString", "[", 
             RowBox[{"Length", "[", "#", "]"}], "]"}]}], "}"}], "&"}], "/@", 
         "expr"}]}], "]"}], "<>", "\"\< \\\\\\\\ \\nTotal & \>\"", "<>", 
      RowBox[{"ToString", "[", 
       RowBox[{"Total", "[", 
        RowBox[{"Length", "/@", "expr"}], "]"}], "]"}]}]}], ";"}], 
   "\[IndentingNewLine]", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"texIntegralsSingleLine", "[", "expr_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"\"\<I_{\>\"", "<>", 
        RowBox[{
         RowBox[{"StringCases", "[", 
          RowBox[{"#", ",", 
           RowBox[{
            RowBox[{"\"\<I_{\>\"", "~~", 
             RowBox[{"index", ":", 
              RowBox[{"Shortest", "[", "___", "]"}]}], "~~", "\"\<}\>\""}], 
            "\[RuleDelayed]", "index"}]}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], "<>", "\"\<}( \>\"", "<>", 
        RowBox[{"StringReplace", "[", 
         RowBox[{"#", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"\"\<I_{\>\"", "~~", 
              RowBox[{"Shortest", "[", "___", "]"}], "~~", "\"\<}\>\""}], 
             "\[Rule]", "\"\<\>\""}], ",", 
            RowBox[{"\"\<(\>\"", "\[Rule]", "\"\<[\>\""}], ",", 
            RowBox[{"\"\<)\>\"", "\[Rule]", "\"\<]\>\""}]}], "}"}]}], "]"}], 
        "<>", "\"\< )\>\""}], "&"}], "@", 
      RowBox[{"(", 
       RowBox[{"StringReplace", "[", 
        RowBox[{"expr", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"\"\<)-\>\"", "\[Rule]", "\"\<) \\n - \>\""}], ",", 
           RowBox[{"\"\<)+\>\"", "\[Rule]", "\"\<) \\n + \>\""}]}], "}"}]}], 
        "]"}], ")"}]}]}], ";"}], "\[IndentingNewLine]", "\n", 
   RowBox[{
    RowBox[{"texJoinIntegrals", "[", "expr_", "]"}], ":=", 
    RowBox[{"Fold", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"#1", "<>", "\"\< + {} \\\\\\\\ \\n & {} + \>\"", "<>", "#2"}],
        "&"}], ",", "expr"}], "]"}]}], "\[IndentingNewLine]", "\n", 
   RowBox[{
    RowBox[{"texIntegralsWithFracGath", "[", "expr_", "]"}], ":=", 
    RowBox[{"texJoinIntegrals", "[", 
     RowBox[{"texIntegralsSingleLine", "/@", 
      RowBox[{"ToString", "/@", 
       RowBox[{"TeXForm", "/@", 
        RowBox[{"(", 
         RowBox[{"expr", "/.", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Rational", "[", 
             RowBox[{"a_", ",", "b_"}], "]"}], "\[RuleDelayed]", 
            RowBox[{
             RowBox[{"Sign", "[", 
              RowBox[{"a", "/", "b"}], "]"}], " ", 
             RowBox[{"HoldForm", "[", 
              RowBox[{"Evaluate", "[", 
               RowBox[{"Abs", "[", 
                RowBox[{"Divide", "[", 
                 RowBox[{"a", ",", "b"}], "]"}], "]"}], "]"}], "]"}]}]}], 
           "}"}]}], ")"}]}]}]}], "]"}]}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"texIntegralsWithFrac", "[", "expr_", "]"}], ":=", 
     RowBox[{"texIntegralsWithFracGath", "[", 
      RowBox[{"Total", "/@", 
       RowBox[{"gatherIntegrals", "[", "expr", "]"}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\n", 
   RowBox[{
    RowBox[{"texIntegralsGath", "[", "expr_List", "]"}], ":=", 
    RowBox[{"texJoinIntegrals", "[", 
     RowBox[{"texIntegralsSingleLine", "/@", 
      RowBox[{"ToString", "/@", 
       RowBox[{"TeXForm", "/@", 
        RowBox[{"(", "expr", ")"}]}]}]}], "]"}]}], "\n", 
   RowBox[{
    RowBox[{"texIntegralsGath", "[", 
     RowBox[{"expr_List", ",", "scaling_"}], "]"}], ":=", 
    RowBox[{"texJoinIntegrals", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"#", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "\[NotEqual]", "1"}], ",", 
           RowBox[{
            RowBox[{"ToString", "[", 
             RowBox[{"TeXForm", "[", 
              RowBox[{"1", "/", 
               RowBox[{"#", "[", 
                RowBox[{"[", "2", "]"}], "]"}]}], "]"}], "]"}], "<>", 
            "\"\< \>\""}], ",", "\"\<\>\""}], "]"}], "<>", 
         RowBox[{"#", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ")"}], "&"}], "/@", 
      RowBox[{"MapThread", "[", 
       RowBox[{"List", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"texIntegralsSingleLine", "/@", 
           RowBox[{"ToString", "/@", 
            RowBox[{"TeXForm", "/@", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"scaling", "*", "expr"}], "//", "Expand"}], 
              ")"}]}]}]}], ",", "scaling"}], "}"}]}], "]"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"texIntegralsByCoeff", "[", "expr_", "]"}], ":=", 
     RowBox[{"Block", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"gath", "=", 
         RowBox[{"gatherIntegrals", "[", 
          RowBox[{"expr", ",", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"indices", "[", "#", "]"}], ",", 
              RowBox[{"denominator", "[", "#", "]"}]}], "}"}], "&"}]}], 
          "]"}]}], "}"}], ",", 
       RowBox[{"texIntegralsGath", "[", 
        RowBox[{
         RowBox[{"Total", "/@", "gath"}], ",", 
         RowBox[{"denominator", "/@", 
          RowBox[{"gath", "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "1"}], "]"}], "]"}]}]}], "]"}]}], "]"}]}], 
    ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"texIntegrals", "[", "expr_", "]"}], ":=", 
     RowBox[{"Block", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"gath", "=", 
         RowBox[{"gatherIntegrals", "[", "expr", "]"}]}], "}"}], ",", 
       RowBox[{"texIntegralsGath", "[", 
        RowBox[{"Total", "/@", "gath"}], "]"}]}], "]"}]}], ";"}], "\n", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
    "Using", " ", "a", " ", "pattern", " ", "to", " ", "make", " ", "a", " ", 
     "pattern", " ", "not", " ", "a", " ", 
     RowBox[{
      RowBox[{"pattern", "!"}], "?"}]}], "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"lhsRule", "[", 
     RowBox[{"RuleDelayed", "[", 
      RowBox[{"lhs_", ",", "rhs_"}], "]"}], "]"}], ":=", 
    RowBox[{"lhs", "/.", 
     RowBox[{
      RowBox[{"HoldPattern", "[", "w_Pattern", "]"}], "\[RuleDelayed]", 
      RowBox[{"w", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}]}]}], "\n", 
   RowBox[{
    RowBox[{"rhsRule", "[", 
     RowBox[{"RuleDelayed", "[", 
      RowBox[{"lhs_", ",", "rhs_"}], "]"}], "]"}], ":=", 
    RowBox[{"Expand", "[", "rhs", "]"}]}], "\[IndentingNewLine]", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"ruleToIdentity", "[", "expr_", "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"lhsRule", "[", "expr", "]"}], "-", 
       RowBox[{"rhsRule", "[", "expr", "]"}]}], "//", "Expand"}]}], ";"}], 
   "\[IndentingNewLine]", "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"texRule", "[", "expr_", "]"}], ":=", 
     RowBox[{"Block", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"gath", "=", 
         RowBox[{"gatherIntegrals", "[", 
          RowBox[{"Expand", "@", 
           RowBox[{"rhsRule", "[", "expr", "]"}]}], "]"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"ToString", "[", 
         RowBox[{"TeXForm", "[", 
          RowBox[{"lhsRule", "[", "expr", "]"}], "]"}], "]"}], "<>", 
        "\"\< & {} = \>\"", "<>", 
        RowBox[{"texIntegralsGath", "[", 
         RowBox[{"Total", "/@", "gath"}], "]"}]}]}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"texRuleWithFrac", "[", "expr_", "]"}], ":=", 
     RowBox[{"Block", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"gath", "=", 
         RowBox[{"gatherIntegrals", "[", 
          RowBox[{"Expand", "@", 
           RowBox[{"rhsRule", "[", "expr", "]"}]}], "]"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"ToString", "[", 
         RowBox[{"TeXForm", "[", 
          RowBox[{"lhsRule", "[", "expr", "]"}], "]"}], "]"}], "<>", 
        "\"\< & {} = \>\"", "<>", 
        RowBox[{"texIntegralsWithFracGath", "[", 
         RowBox[{"Total", "/@", "gath"}], "]"}]}]}], "]"}]}], ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"texRuleByCoeff", "[", "expr_", "]"}], ":=", 
     RowBox[{"Block", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"gath", "=", 
         RowBox[{"gatherIntegrals", "[", 
          RowBox[{
           RowBox[{"Expand", "@", 
            RowBox[{"rhsRule", "[", "expr", "]"}]}], ",", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"indices", "[", "#", "]"}], ",", 
              RowBox[{"denominator", "[", "#", "]"}]}], "}"}], "&"}]}], 
          "]"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"ToString", "[", 
         RowBox[{"TeXForm", "[", 
          RowBox[{"lhsRule", "[", "expr", "]"}], "]"}], "]"}], "<>", 
        "\"\< & {} = \>\"", "<>", 
        RowBox[{"texIntegralsGath", "[", 
         RowBox[{
          RowBox[{"Total", "/@", "gath"}], ",", 
          RowBox[{"denominator", "/@", 
           RowBox[{"gath", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "1"}], "]"}], "]"}]}]}], "]"}]}]}], "]"}]}], 
    ";"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"texRuleByCR", "[", "expr_", "]"}], ":=", 
     RowBox[{"Block", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"gath", "=", 
         RowBox[{"Reverse", "@", 
          RowBox[{"gatherIntegrals", "[", 
           RowBox[{
            RowBox[{"Expand", "@", 
             RowBox[{"rhsRule", "[", "expr", "]"}]}], ",", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"indices", "[", "#", "]"}], ",", 
               RowBox[{"denominator", "[", "#", "]"}], ",", 
               RowBox[{
                RowBox[{"args", "[", "#", "]"}], "//", "Length"}], ",", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"Union", "@@", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"args", "[", "#", "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "1"}], "]"}], "]"}], ")"}]}], ")"}], "//",
                 "Length"}]}], "}"}], "&"}]}], "]"}]}]}], "}"}], ",", 
       RowBox[{
        RowBox[{"ToString", "[", 
         RowBox[{"TeXForm", "[", 
          RowBox[{"lhsRule", "[", "expr", "]"}], "]"}], "]"}], "<>", 
        "\"\< & {} = \>\"", "<>", 
        RowBox[{"texIntegralsGath", "[", 
         RowBox[{
          RowBox[{"Total", "/@", "gath"}], ",", 
          RowBox[{"denominator", "/@", 
           RowBox[{"gath", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "1"}], "]"}], "]"}]}]}], "]"}]}]}], "]"}]}], 
    ";"}]}]}]], "Input",
 CellChangeTimes->{{3.6976442543813295`*^9, 3.697644254404357*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Load", " ", "precomputed", " ", "results", " ", "to", " ", "check", " ", 
    "later"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Get", "[", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
     "\"\<wt5_dan_precomputed.m\>\""}], "]"}], ";"}]}]], "Input",
 CellChangeTimes->{{3.697599051790345*^9, 3.697599063237075*^9}, {
  3.6975994686062803`*^9, 3.6975994702639437`*^9}, {3.697602550513105*^9, 
  3.6976025651452227`*^9}, {3.697602753883231*^9, 3.6976027625747285`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"--", 
   RowBox[{"--", "--"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.697525923879716*^9, 3.6975259257636223`*^9}, {
  3.6975994958065605`*^9, 3.6975994965253487`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"wt5VarsToABC", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"a", "[", "i_", "]"}], "\[RuleDelayed]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g"}], 
        "}"}], "[", 
       RowBox[{"[", 
        RowBox[{"i", "+", "1"}], "]"}], "]"}]}], ",", " ", 
     RowBox[{"x", "\[Rule]", "Inf"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"canonicalCR", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"cri", "[", 
      RowBox[{"{", 
       RowBox[{"a_", ",", "b_", ",", "c_", ",", "d_"}], "}"}], "]"}], 
     "\[RuleDelayed]", 
     RowBox[{"cri", "[", 
      RowBox[{"crOrbit", "[", 
       RowBox[{"{", 
        RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}], "]"}], "]"}]}], 
    "}"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.6975258965009623`*^9, 3.697525916828238*^9}, {
  3.697526197772664*^9, 3.6975262352827177`*^9}, {3.6975276207863693`*^9, 
  3.6975276217531137`*^9}, {3.6975566747688217`*^9, 3.6975566835903435`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"in5Dan", " ", "=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"Asymb", "[", 
     RowBox[{"5", ",", "1", ",", "2"}], "]"}], "/.", "wt5VarsToABC"}], "//", 
   "TeXForm"}]}]], "Input",
 CellChangeTimes->{{3.697525953475912*^9, 3.697525970522691*^9}, 
   3.697526038593132*^9, {3.697527624825776*^9, 3.697527624953837*^9}, {
   3.697534964626761*^9, 3.697534977585638*^9}}],

Cell["H(a \\mid b, c, d, e, f \\dblslash \\infty \\mid g)", "Output",
 CellChangeTimes->{{3.697525950078225*^9, 3.697525980503378*^9}, 
   3.6975260392841663`*^9, 3.69752703329508*^9, 3.697527625484969*^9, 
   3.6975322929099703`*^9, {3.697534961874489*^9, 3.6975349778372602`*^9}, 
   3.6975350638330793`*^9, 3.6975548163934045`*^9, 3.697556684684046*^9, 
   3.6975633436990175`*^9, {3.697599501326394*^9, 3.6975995146651907`*^9}, 
   3.6976025703779964`*^9, {3.6976124524613757`*^9, 3.6976124687994537`*^9}, 
   3.697616055513669*^9, 3.6976442564668264`*^9, 3.6976480463961773`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"in5Polylog", " ", "=", " ", 
   RowBox[{
    RowBox[{"iToCcr", "@", 
     RowBox[{"hToI", "@", 
      RowBox[{"hCrSimp", "[", 
       RowBox[{"Asymb", "[", 
        RowBox[{"5", ",", "1", ",", "2"}], "]"}], "]"}]}]}], "/.", 
    "wt5VarsToABC"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"%", "//", "TeXForm"}]}], "Input",
 CellChangeTimes->{{3.657352131949285*^9, 3.657352147617848*^9}, {
   3.657352549486443*^9, 3.6573526108128433`*^9}, {3.65735267326958*^9, 
   3.657352673349101*^9}, {3.657690322744503*^9, 3.6576903488893175`*^9}, {
   3.659091519477152*^9, 3.659091519565649*^9}, {3.6711879043747396`*^9, 
   3.671187923058796*^9}, {3.697525856502245*^9, 3.697525888949885*^9}, {
   3.6975259280282393`*^9, 3.697525932571065*^9}, {3.697525977194881*^9, 
   3.697525978178672*^9}, 3.697526040272935*^9, {3.69752761722637*^9, 
   3.697527627139942*^9}, {3.697534970370522*^9, 3.697534990721616*^9}}],

Cell["I_{1, 1, 1, 1, 1}(\\infty a g b c d e f)", "Output",
 CellChangeTimes->{
  3.697534992060092*^9, 3.697535063888892*^9, 3.6975548194031157`*^9, 
   3.6975566854041185`*^9, 3.6975633437302814`*^9, 3.697599515776038*^9, 
   3.697602570831111*^9, {3.697612452477*^9, 3.697612468830721*^9}, 
   3.6976160561869965`*^9, 3.6976442565038457`*^9, 3.6976480464292*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "apply", " ", "the", " ", "all", " ", "n", " ", "reduction", " ", "first"}],
   " ", "*)"}]], "Input",
 CellChangeTimes->{{3.6975269060094547`*^9, 3.697526912215732*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"out5AllN", " ", "=", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"iToCcr", "@", 
      RowBox[{"hToI", "@", 
       RowBox[{"hCrSimp", "@", 
        RowBox[{"Expand", "@", 
         RowBox[{"reduceAll", "[", "5", "]"}]}]}]}]}], "/.", "wt5VarsToABC"}],
     "//", "Expand"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.697525275693885*^9, 3.697525311397773*^9}, {
   3.69752539230795*^9, 3.697525393331551*^9}, {3.697525544511775*^9, 
   3.697525545311083*^9}, 3.6975255787951097`*^9, {3.697525622691525*^9, 
   3.6975256229473343`*^9}, {3.6975257002509193`*^9, 3.697525748995326*^9}, 
   3.697525938052705*^9, {3.697525982586339*^9, 3.697526042160902*^9}, {
   3.697526217307646*^9, 3.6975262184674187`*^9}, {3.697527609948696*^9, 
   3.697527615385573*^9}, {3.697556657612116*^9, 3.6975566634914985`*^9}, {
   3.6975567744312897`*^9, 3.6975567829856997`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"out5AllNLower", " ", "=", " ", 
   RowBox[{
    RowBox[{"Select", "[", 
     RowBox[{"out5AllN", ",", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"Position", "[", 
         RowBox[{"#", ",", " ", "a"}], "]"}], "\[NotEqual]", 
        RowBox[{"{", "}"}]}], "&"}]}], "]"}], "/.", "canonicalCR"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.6975261391398783`*^9, 3.6975261859800367`*^9}, {
  3.69752633152815*^9, 3.697526334071616*^9}, {3.697527640463204*^9, 
  3.697527647466877*^9}, {3.6975567935427074`*^9, 3.697556794091116*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"out5AllN", " ", "-", " ", 
    RowBox[{"(", 
     RowBox[{"out5AllNLower", " ", "-", " ", 
      RowBox[{"(", 
       RowBox[{"out5AllNLower", "/.", 
        RowBox[{"a", "\[Rule]", "g"}]}], ")"}]}], ")"}]}], "/.", 
   "canonicalCR"}], "//", "Expand"}]], "Input",
 CellChangeTimes->{{3.697526335455419*^9, 3.69752639615788*^9}, {
  3.697526920486521*^9, 3.697526931318369*^9}, {3.697527651505542*^9, 
  3.69752765370453*^9}, {3.697556760088269*^9, 3.697556798970463*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.697526390517892*^9, 3.697526396780108*^9}, 
   3.6975269320551662`*^9, 3.697527654303132*^9, 3.697532293200407*^9, 
   3.69753499832206*^9, 3.697535064128533*^9, 3.6975548238942876`*^9, 
   3.69755669665574*^9, {3.6975567646082478`*^9, 3.6975567995329275`*^9}, 
   3.6975633441833963`*^9, 3.697599525267686*^9, 3.6976025736761355`*^9, {
   3.697612452773879*^9, 3.6976124690182033`*^9}, 3.6976160586727724`*^9, 
   3.697644256745021*^9, 3.6976480466633673`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"wt5DanAllNPrecomputed", " ", "==", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"in5Polylog", " ", "-", " ", 
       RowBox[{"(", 
        RowBox[{"out5AllNLower", " ", "-", " ", 
         RowBox[{"(", 
          RowBox[{"out5AllNLower", "/.", 
           RowBox[{"a", "\[Rule]", "g"}]}], ")"}]}], ")"}]}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", "\[Rule]", "0"}], ",", 
        RowBox[{"g", "\[Rule]", "1"}]}], "}"}]}], "/.", "canonicalCR"}], "//",
     "Expand"}], ")"}]}]], "Input",
 CellChangeTimes->{{3.6975418299919577`*^9, 3.697542016701066*^9}, {
   3.69754206739629*^9, 3.6975420787709827`*^9}, {3.697556440706278*^9, 
   3.6975564421608105`*^9}, 3.6975568553198547`*^9, {3.697559767857934*^9, 
   3.697559770374942*^9}, {3.697602576286768*^9, 3.6976025900270505`*^9}, {
   3.6976124848842154`*^9, 3.6976124855254126`*^9}, {3.697616101916132*^9, 
   3.6976161159117737`*^9}}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{
  3.697602591215184*^9, {3.697612452789505*^9, 3.6976124690494556`*^9}, {
   3.6976160599086947`*^9, 3.6976161162242327`*^9}, 3.6976442567830315`*^9, 
   3.697648046694388*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"out5AllNLowerGathered", " ", "=", " ", 
   RowBox[{"gatherIntegrals", "[", "out5AllNLower", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.670915222347866*^9, 3.670915289663663*^9}, {
  3.670915332846138*^9, 3.67091535581328*^9}, {3.670916219945907*^9, 
  3.670916221082815*^9}, {3.670916333281445*^9, 3.670916344666979*^9}, {
  3.6709189674655952`*^9, 3.670919042204668*^9}, {3.6709258128572893`*^9, 
  3.670925813211691*^9}, {3.67118350918089*^9, 3.671183531116184*^9}, {
  3.671183581222713*^9, 3.6711835985946093`*^9}, {3.671185477981173*^9, 
  3.671185488930788*^9}, {3.6711866229772873`*^9, 3.671186625444181*^9}, {
  3.697526489797328*^9, 3.69752652016094*^9}, {3.697526563194475*^9, 
  3.6975266037261*^9}, {3.697526670126646*^9, 3.697526734427701*^9}, {
  3.697526796050971*^9, 3.697526882791471*^9}, {3.697527778452664*^9, 
  3.6975277802290154`*^9}, {3.6975311529386387`*^9, 3.697531158768909*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"countIntegrals", "[", "out5AllNLowerGathered", "]"}]], "Input",
 CellChangeTimes->{
  3.697526887879635*^9, {3.6975311604902887`*^9, 3.697531165857418*^9}}],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{"{", 
      RowBox[{"22", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "d", ",", "a", ",", "c", ",", "e", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "d", ",", "a", ",", "e", ",", "f", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "d", ",", "a", ",", "Inf", ",", "e", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "d", ",", "a", ",", "Inf", ",", "f", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "e", ",", "a", ",", "d", ",", "c", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "b", ",", "e", ",", "a", ",", "Inf", ",", "c", ",", "f"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "c", ",", "d", ",", "a", ",", "b", ",", "e", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "c", ",", "d", ",", "a", ",", "Inf", ",", "e", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["3", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "d", ",", "Inf", ",", "a", ",", "b", ",", "e", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "d", ",", "Inf", ",", "a", ",", "b", ",", "f", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "d", ",", "Inf", ",", "a", ",", "e", ",", "f", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "e", ",", "Inf", ",", "a", ",", "b", ",", "c", ",", "f"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "e", ",", "Inf", ",", "a", ",", "d", ",", "c", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "f", ",", "Inf", ",", "a", ",", "d", ",", "b", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "f", ",", "Inf", ",", "a", ",", "e", ",", "b", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "c", ",", "e", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "d", ",", "c", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "d", ",", "e", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "d", ",", "f", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "e", ",", "c", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "e", ",", "f", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["3", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "c", ",", "a", ",", "d", ",", "e", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}]}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"26", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "d", ",", "a", ",", "c", ",", "e", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "d", ",", "a", ",", "e", ",", "f", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "d", ",", "a", ",", "Inf", ",", "c", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "d", ",", "a", ",", "Inf", ",", "e", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "e", ",", "a", ",", "Inf", ",", "c", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "f", ",", "a", ",", "d", ",", "Inf", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "f", ",", "a", ",", "e", ",", "Inf", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "c", ",", "d", ",", "a", ",", "Inf", ",", "e", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "c", ",", "e", ",", "a", ",", "b", ",", "Inf", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "c", ",", "e", ",", "a", ",", "d", ",", "Inf", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "d", ",", "Inf", ",", "a", ",", "b", ",", "c", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "d", ",", "Inf", ",", "a", ",", "b", ",", "e", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "d", ",", "Inf", ",", "a", ",", "b", ",", "e", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "d", ",", "Inf", ",", "a", ",", "b", ",", "f", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "d", ",", "Inf", ",", "a", ",", "e", ",", "f", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "e", ",", "Inf", ",", "a", ",", "b", ",", "c", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "e", ",", "Inf", ",", "a", ",", "d", ",", "b", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "e", ",", "Inf", ",", "a", ",", "d", ",", "c", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "f", ",", "Inf", ",", "a", ",", "e", ",", "b", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "c", ",", "e", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "d", ",", "c", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "d", ",", "e", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "d", ",", "f", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "e", ",", "c", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "c", ",", "a", ",", "b", ",", "d", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "c", ",", "a", ",", "d", ",", "e", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}]}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"22", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "d", ",", "a", ",", "c", ",", "e", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "d", ",", "a", ",", "e", ",", "f", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "d", ",", "a", ",", "Inf", ",", "c", ",", "e"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "d", ",", "a", ",", "Inf", ",", "e", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "e", ",", "a", ",", "Inf", ",", "c", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "c", ",", "d", ",", "a", ",", "Inf", ",", "e", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "d", ",", "Inf", ",", "a", ",", "b", ",", "c", ",", "e"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "d", ",", "Inf", ",", "a", ",", "b", ",", "e", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "d", ",", "Inf", ",", "a", ",", "b", ",", "f", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "d", ",", "Inf", ",", "a", ",", "e", ",", "f", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "e", ",", "Inf", ",", "a", ",", "b", ",", "c", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "e", ",", "Inf", ",", "a", ",", "d", ",", "b", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "e", ",", "Inf", ",", "a", ",", "d", ",", "c", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "f", ",", "Inf", ",", "a", ",", "e", ",", "b", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "c", ",", "e", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "d", ",", "c", ",", "e"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "d", ",", "e", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "d", ",", "e", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "d", ",", "f", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "e", ",", "c", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "c", ",", "a", ",", "b", ",", "d", ",", "e"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "c", ",", "a", ",", "d", ",", "e", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}]}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"21", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "d", ",", "a", ",", "c", ",", "e", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "d", ",", "a", ",", "e", ",", "f", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "e", ",", "a", ",", "d", ",", "Inf", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "f", ",", "a", ",", "d", ",", "e", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "3", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "b", ",", "f", ",", "a", ",", "e", ",", "Inf", ",", "c"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "c", ",", "d", ",", "a", ",", "b", ",", "Inf", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "c", ",", "e", ",", "a", ",", "b", ",", "d", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "3", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "c", ",", "e", ",", "a", ",", "d", ",", "Inf", ",", "f"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "d", ",", "Inf", ",", "a", ",", "b", ",", "c", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "d", ",", "Inf", ",", "a", ",", "b", ",", "e", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "d", ",", "Inf", ",", "a", ",", "e", ",", "f", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "e", ",", "Inf", ",", "a", ",", "b", ",", "c", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "e", ",", "Inf", ",", "a", ",", "b", ",", "d", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "f", ",", "Inf", ",", "a", ",", "d", ",", "e", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "c", ",", "e", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "d", ",", "c", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "d", ",", "e", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "e", ",", "c", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "e", ",", "f", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "c", ",", "a", ",", "b", ",", "d", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "c", ",", "a", ",", "d", ",", "e", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}]}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"22", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "d", ",", "a", ",", "c", ",", "e", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "d", ",", "a", ",", "e", ",", "f", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "e", ",", "a", ",", "d", ",", "Inf", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "f", ",", "a", ",", "e", ",", "Inf", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "c", ",", "d", ",", "a", ",", "b", ",", "Inf", ",", "e"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "c", ",", "e", ",", "a", ",", "d", ",", "Inf", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "d", ",", "Inf", ",", "a", ",", "b", ",", "c", ",", "e"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "d", ",", "Inf", ",", "a", ",", "b", ",", "c", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "d", ",", "Inf", ",", "a", ",", "b", ",", "e", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "d", ",", "Inf", ",", "a", ",", "b", ",", "e", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "d", ",", "Inf", ",", "a", ",", "e", ",", "f", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "e", ",", "Inf", ",", "a", ",", "b", ",", "c", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "e", ",", "Inf", ",", "a", ",", "b", ",", "d", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "f", ",", "Inf", ",", "a", ",", "d", ",", "e", ",", "b"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "c", ",", "e", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "d", ",", "c", ",", "e"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "d", ",", "c", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "d", ",", "e", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "e", ",", "c", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "e", ",", "f", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "c", ",", "a", ",", "b", ",", "d", ",", "e"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "c", ",", "a", ",", "d", ",", "e", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}]}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"14", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "d", ",", "a", ",", "c", ",", "e", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "d", ",", "a", ",", "e", ",", "f", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "f", ",", "a", ",", "d", ",", "e", ",", "Inf"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "c", ",", "e", ",", "a", ",", "b", ",", "d", ",", "Inf"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "d", ",", "Inf", ",", "a", ",", "b", ",", "c", ",", "e"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "d", ",", "Inf", ",", "a", ",", "b", ",", "e", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "d", ",", "Inf", ",", "a", ",", "e", ",", "f", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "e", ",", "Inf", ",", "a", ",", "b", ",", "c", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "c", ",", "e", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "d", ",", "c", ",", "e"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "d", ",", "e", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "e", ",", "c", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "e", ",", "f", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "c", ",", "a", ",", "d", ",", "e", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}]}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"34", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          FractionBox["3", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "c", ",", "f"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["3", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "e", ",", "c"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "e", ",", "f"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "f", ",", "c"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "Inf", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "Inf", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "e", ",", "a", ",", "c", ",", "f"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "e", ",", "a", ",", "d", ",", "f"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["3", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "e", ",", "a", ",", "Inf", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "a", ",", "d", ",", "c"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["3", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "a", ",", "e", ",", "c"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["3", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "a", ",", "Inf", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "d", ",", "a", ",", "b", ",", "f"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "d", ",", "a", ",", "e", ",", "f"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["3", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "d", ",", "a", ",", "Inf", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "e", ",", "a", ",", "b", ",", "f"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["3", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "e", ",", "a", ",", "d", ",", "f"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["3", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "e", ",", "a", ",", "Inf", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["3", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "b", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"2", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "b", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["3", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "e", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "f", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "Inf", ",", "a", ",", "b", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"4", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"e", ",", "Inf", ",", "a", ",", "c", ",", "f"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"4", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"e", ",", "Inf", ",", "a", ",", "d", ",", "f"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "Inf", ",", "a", ",", "b", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "Inf", ",", "a", ",", "d", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["3", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "Inf", ",", "a", ",", "e", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "c", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"4", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"Inf", ",", "b", ",", "a", ",", "d", ",", "c"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"4", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"Inf", ",", "b", ",", "a", ",", "d", ",", "f"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "e", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"4", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"Inf", ",", "b", ",", "a", ",", "f", ",", "c"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"3", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "c", ",", "a", ",", "d", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}]}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"41", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "c", ",", "e"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"b", ",", "d", ",", "a", ",", "c", ",", "f"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"b", ",", "d", ",", "a", ",", "e", ",", "c"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "f", ",", "c"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "Inf", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "Inf", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "e", ",", "a", ",", "c", ",", "f"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "e", ",", "a", ",", "d", ",", "c"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "e", ",", "a", ",", "Inf", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "e", ",", "a", ",", "Inf", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "a", ",", "e", ",", "c"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"b", ",", "f", ",", "a", ",", "Inf", ",", "c"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "d", ",", "a", ",", "b", ",", "e"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "d", ",", "a", ",", "e", ",", "f"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"c", ",", "d", ",", "a", ",", "Inf", ",", "e"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "d", ",", "a", ",", "Inf", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "e", ",", "a", ",", "d", ",", "f"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"c", ",", "e", ",", "a", ",", "Inf", ",", "f"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "b", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["3", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "b", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["3", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "b", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "e", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "e", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "f", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "Inf", ",", "a", ",", "b", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "Inf", ",", "a", ",", "b", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"e", ",", "Inf", ",", "a", ",", "c", ",", "f"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "Inf", ",", "a", ",", "d", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "Inf", ",", "a", ",", "d", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "Inf", ",", "a", ",", "b", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "Inf", ",", "a", ",", "d", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"f", ",", "Inf", ",", "a", ",", "e", ",", "b"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "Inf", ",", "a", ",", "e", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "c", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "c", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"Inf", ",", "b", ",", "a", ",", "d", ",", "e"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"Inf", ",", "b", ",", "a", ",", "d", ",", "f"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "e", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"Inf", ",", "b", ",", "a", ",", "f", ",", "c"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          FractionBox["3", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "c", ",", "a", ",", "d", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["3", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "c", ",", "a", ",", "d", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}]}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"39", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "3"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"b", ",", "d", ",", "a", ",", "c", ",", "e"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "c", ",", "f"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "e", ",", "c"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "e", ",", "f"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "f", ",", "c"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "Inf", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "Inf", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "e", ",", "a", ",", "c", ",", "f"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "e", ",", "a", ",", "Inf", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "a", ",", "d", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "a", ",", "e", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "a", ",", "Inf", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "d", ",", "a", ",", "e", ",", "f"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "3"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"c", ",", "d", ",", "a", ",", "Inf", ",", "e"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "e", ",", "a", ",", "b", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "e", ",", "a", ",", "d", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "e", ",", "a", ",", "Inf", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "3"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"d", ",", "Inf", ",", "a", ",", "b", ",", "c"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          FractionBox["3", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "b", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "3"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"d", ",", "Inf", ",", "a", ",", "b", ",", "f"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "e", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "e", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "f", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "Inf", ",", "a", ",", "b", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "Inf", ",", "a", ",", "b", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "3"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"e", ",", "Inf", ",", "a", ",", "c", ",", "f"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "Inf", ",", "a", ",", "d", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "3"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"e", ",", "Inf", ",", "a", ",", "d", ",", "c"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "Inf", ",", "a", ",", "b", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "3"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"f", ",", "Inf", ",", "a", ",", "e", ",", "b"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "c", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "d", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "3"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"Inf", ",", "b", ",", "a", ",", "d", ",", "e"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "3"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"Inf", ",", "b", ",", "a", ",", "d", ",", "f"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["3", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "e", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "3"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"Inf", ",", "b", ",", "a", ",", "f", ",", "c"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "c", ",", "a", ",", "b", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"2", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "c", ",", "a", ",", "d", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "c", ",", "a", ",", "d", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}]}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"29", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          FractionBox["3", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "c", ",", "e"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "4"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"b", ",", "d", ",", "a", ",", "e", ",", "f"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "f", ",", "c"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "e", ",", "a", ",", "c", ",", "f"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "e", ",", "a", ",", "d", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "a", ",", "d", ",", "e"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["3", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "a", ",", "e", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "d", ",", "a", ",", "b", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "d", ",", "a", ",", "e", ",", "f"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "e", ",", "a", ",", "b", ",", "d"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["3", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "e", ",", "a", ",", "d", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["3", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "b", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["3", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "b", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["3", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "e", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "f", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["3", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "Inf", ",", "a", ",", "b", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"e", ",", "Inf", ",", "a", ",", "b", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "4"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"e", ",", "Inf", ",", "a", ",", "c", ",", "f"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "Inf", ",", "a", ",", "b", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "Inf", ",", "a", ",", "d", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["3", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "c", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "c", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["3", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "d", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "4"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"Inf", ",", "b", ",", "a", ",", "d", ",", "e"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["3", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "e", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "e", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "4"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"Inf", ",", "b", ",", "a", ",", "f", ",", "c"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "c", ",", "a", ",", "b", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["3", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "c", ",", "a", ",", "d", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}]}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"37", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "b", ",", "c", ",", "e"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["9", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "b", ",", "d", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["7", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "b", ",", "e", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "b", ",", "f", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["7", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "c", ",", "b", ",", "d"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"2", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "c", ",", "b", ",", "e"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "c", ",", "b", ",", "f"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "c", ",", "d", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "4"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "c", ",", "e", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "c", ",", "f", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"2", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "c", ",", "Inf", ",", "b"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "d", ",", "b", ",", "e"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "d", ",", "b", ",", "f"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"2", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "d", ",", "c", ",", "e"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["3", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "d", ",", "e", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "d", ",", "f", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "3"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "d", ",", "Inf", ",", "b"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "5"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "d", ",", "Inf", ",", "c"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "e", ",", "b", ",", "d"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"2", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "e", ",", "b", ",", "f"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "e", ",", "c", ",", "d"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"3", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "e", ",", "d", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "e", ",", "f", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"2", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "e", ",", "Inf", ",", "b"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["3", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "f", ",", "b", ",", "d"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "f", ",", "b", ",", "e"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "2"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "f", ",", "c", ",", "d"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "2"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "f", ",", "c", ",", "e"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "f", ",", "d", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", "5", "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"a", ",", "f", ",", "e", ",", "Inf"}], "}"}], "]"}], 
            "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"-", "3"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "f", ",", "Inf", ",", "b"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "Inf", ",", "b", ",", "d"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"2", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "Inf", ",", "b", ",", "e"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "3"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "Inf", ",", "b", ",", "f"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "Inf", ",", "c", ",", "d"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "3"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "Inf", ",", "c", ",", "e"}], "}"}], "]"}], 
             "}"}]}], "]"}]}]}], "}"}]}], "}"}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  ColumnForm[{{22, {Rational[-1, 2] $CellContext`IIi[{3, 1, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`c, $CellContext`e, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 1, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`e, $CellContext`f, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 1, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`e, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 1, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`f, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 1, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`e, $CellContext`a, \
$CellContext`d, $CellContext`c, $CellContext`f}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`b, $CellContext`e, $CellContext`a, \
$CellContext`Inf, $CellContext`c, $CellContext`f}]}], 
      Rational[1, 2] $CellContext`IIi[{3, 1, 1}, {
         $CellContext`cri[{$CellContext`c, $CellContext`d, $CellContext`a, \
$CellContext`b, $CellContext`e, $CellContext`f}]}], -$CellContext`IIi[{3, 1, 
        1}, {
         $CellContext`cri[{$CellContext`c, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`e, $CellContext`f}]}], 
      Rational[-3, 2] $CellContext`IIi[{3, 1, 1}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`e, $CellContext`f}]}], -$CellContext`IIi[{3, 1, 
        1}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`f, $CellContext`c}]}], 
      Rational[1, 2] $CellContext`IIi[{3, 1, 1}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`e, $CellContext`f, $CellContext`c}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 1, 1}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`d, $CellContext`c, $CellContext`f}]}], 
      Rational[1, 2] $CellContext`IIi[{3, 1, 1}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`d, $CellContext`b, $CellContext`c}]}], -$CellContext`IIi[{3, 1, 
        1}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`e, $CellContext`b, $CellContext`c}]}], 
      Rational[1, 2] $CellContext`IIi[{3, 1, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`c, $CellContext`e, $CellContext`f}]}], 
      Rational[1, 2] $CellContext`IIi[{3, 1, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`c, $CellContext`f}]}], -$CellContext`IIi[{3, 1, 
        1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`e, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 1, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`f, $CellContext`c}]}], 
      Rational[1, 2] $CellContext`IIi[{3, 1, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`e, $CellContext`c, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 1, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`e, $CellContext`f, $CellContext`c}]}], 
      Rational[-3, 2] $CellContext`IIi[{3, 1, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`c, $CellContext`a, \
$CellContext`d, $CellContext`e, $CellContext`f}]}]}}, {
    26, {Rational[-1, 2] $CellContext`IIi[{2, 2, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`c, $CellContext`e, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 2, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`e, $CellContext`f, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 2, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`c, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 2, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`e, $CellContext`c}]}], 
      Rational[1, 2] $CellContext`IIi[{2, 2, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`e, $CellContext`a, \
$CellContext`Inf, $CellContext`c, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 2, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`d, $CellContext`Inf, $CellContext`c}]}], 
      Rational[1, 2] $CellContext`IIi[{2, 2, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`e, $CellContext`Inf, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 2, 1}, {
         $CellContext`cri[{$CellContext`c, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`e, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 2, 1}, {
         $CellContext`cri[{$CellContext`c, $CellContext`e, $CellContext`a, \
$CellContext`b, $CellContext`Inf, $CellContext`f}]}], 
      Rational[1, 2] $CellContext`IIi[{2, 2, 1}, {
         $CellContext`cri[{$CellContext`c, $CellContext`e, $CellContext`a, \
$CellContext`d, $CellContext`Inf, $CellContext`f}]}], -$CellContext`IIi[{2, 2,
         1}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 2, 1}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`e, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 2, 1}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`e, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 2, 1}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`f, $CellContext`c}]}], 
      Rational[1, 2] $CellContext`IIi[{2, 2, 1}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`e, $CellContext`f, $CellContext`c}]}], 
      Rational[1, 2] $CellContext`IIi[{2, 2, 1}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c, $CellContext`f}]}], 
      Rational[1, 2] $CellContext`IIi[{2, 2, 1}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`d, $CellContext`b, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 2, 1}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`d, $CellContext`c, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 2, 1}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`e, $CellContext`b, $CellContext`c}]}], 
      Rational[1, 2] $CellContext`IIi[{2, 2, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`c, $CellContext`e, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 2, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`c, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 2, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`e, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 2, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`f, $CellContext`c}]}], 
      Rational[1, 2] $CellContext`IIi[{2, 2, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`e, $CellContext`c, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 2, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`c, $CellContext`a, \
$CellContext`b, $CellContext`d, $CellContext`f}]}], -$CellContext`IIi[{2, 2, 
        1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`c, $CellContext`a, \
$CellContext`d, $CellContext`e, $CellContext`f}]}]}}, {
    22, {Rational[-1, 2] $CellContext`IIi[{2, 1, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`c, $CellContext`e, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 1, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`e, $CellContext`f, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 1, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`c, $CellContext`e}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 1, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`e, $CellContext`f}]}], 
      Rational[1, 2] $CellContext`IIi[{2, 1, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`e, $CellContext`a, \
$CellContext`Inf, $CellContext`c, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 1, 2}, {
         $CellContext`cri[{$CellContext`c, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`e, $CellContext`f}]}], -$CellContext`IIi[{2, 1,
         2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c, $CellContext`e}]}], -$CellContext`IIi[{2, 1, 
        2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`e, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 1, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`f, $CellContext`c}]}], 
      Rational[1, 2] $CellContext`IIi[{2, 1, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`e, $CellContext`f, $CellContext`c}]}], 
      Rational[1, 2] $CellContext`IIi[{2, 1, 2}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c, $CellContext`f}]}], 
      Rational[1, 2] $CellContext`IIi[{2, 1, 2}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`d, $CellContext`b, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 1, 2}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`d, $CellContext`c, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 1, 2}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`e, $CellContext`b, $CellContext`c}]}], 
      Rational[1, 2] $CellContext`IIi[{2, 1, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`c, $CellContext`e, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 1, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`c, $CellContext`e}]}], 
      Rational[1, 2] $CellContext`IIi[{2, 1, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`e, $CellContext`c}]}], -$CellContext`IIi[{2, 1, 
        2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`e, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 1, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`f, $CellContext`c}]}], 
      Rational[1, 2] $CellContext`IIi[{2, 1, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`e, $CellContext`c, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 1, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`c, $CellContext`a, \
$CellContext`b, $CellContext`d, $CellContext`e}]}], -$CellContext`IIi[{2, 1, 
        2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`c, $CellContext`a, \
$CellContext`d, $CellContext`e, $CellContext`f}]}]}}, {
    21, {Rational[-1, 2] $CellContext`IIi[{1, 3, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`c, $CellContext`e, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{1, 3, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`e, $CellContext`f, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{1, 3, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`e, $CellContext`a, \
$CellContext`d, $CellContext`Inf, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{1, 3, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`d, $CellContext`e, $CellContext`c}]}], 
      $CellContext`IIi[{1, 3, 1}, {
        $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`e, $CellContext`Inf, $CellContext`c}]}], 
      Rational[1, 2] $CellContext`IIi[{1, 3, 1}, {
         $CellContext`cri[{$CellContext`c, $CellContext`d, $CellContext`a, \
$CellContext`b, $CellContext`Inf, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{1, 3, 1}, {
         $CellContext`cri[{$CellContext`c, $CellContext`e, $CellContext`a, \
$CellContext`b, $CellContext`d, $CellContext`f}]}], 
      $CellContext`IIi[{1, 3, 1}, {
        $CellContext`cri[{$CellContext`c, $CellContext`e, $CellContext`a, \
$CellContext`d, $CellContext`Inf, $CellContext`f}]}], -$CellContext`IIi[{1, 3,
         1}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c, $CellContext`f}]}], -$CellContext`IIi[{1, 3, 
        1}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`e, $CellContext`c}]}], 
      Rational[1, 2] $CellContext`IIi[{1, 3, 1}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`e, $CellContext`f, $CellContext`c}]}], 
      Rational[1, 2] $CellContext`IIi[{1, 3, 1}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c, $CellContext`f}]}], 
      Rational[1, 2] $CellContext`IIi[{1, 3, 1}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`d, $CellContext`f}]}], 
      Rational[1, 2] $CellContext`IIi[{1, 3, 1}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`d, $CellContext`e, $CellContext`c}]}], 
      Rational[1, 2] $CellContext`IIi[{1, 3, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`c, $CellContext`e, $CellContext`f}]}], -$CellContext`IIi[{1, 3, 
        1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`c, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{1, 3, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`e, $CellContext`c}]}], 
      Rational[1, 2] $CellContext`IIi[{1, 3, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`e, $CellContext`c, $CellContext`f}]}], 
      Rational[1, 2] $CellContext`IIi[{1, 3, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`e, $CellContext`f, $CellContext`c}]}], 
      Rational[1, 2] $CellContext`IIi[{1, 3, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`c, $CellContext`a, \
$CellContext`b, $CellContext`d, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{1, 3, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`c, $CellContext`a, \
$CellContext`d, $CellContext`e, $CellContext`f}]}]}}, {
    22, {Rational[-1, 2] $CellContext`IIi[{1, 2, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`c, $CellContext`e, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{1, 2, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`e, $CellContext`f, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{1, 2, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`e, $CellContext`a, \
$CellContext`d, $CellContext`Inf, $CellContext`c}]}], 
      Rational[1, 2] $CellContext`IIi[{1, 2, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`e, $CellContext`Inf, $CellContext`c}]}], 
      Rational[1, 2] $CellContext`IIi[{1, 2, 2}, {
         $CellContext`cri[{$CellContext`c, $CellContext`d, $CellContext`a, \
$CellContext`b, $CellContext`Inf, $CellContext`e}]}], 
      Rational[1, 2] $CellContext`IIi[{1, 2, 2}, {
         $CellContext`cri[{$CellContext`c, $CellContext`e, $CellContext`a, \
$CellContext`d, $CellContext`Inf, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{1, 2, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c, $CellContext`e}]}], 
      Rational[-1, 2] $CellContext`IIi[{1, 2, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{1, 2, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`e, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{1, 2, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`e, $CellContext`f}]}], 
      Rational[1, 2] $CellContext`IIi[{1, 2, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`e, $CellContext`f, $CellContext`c}]}], 
      Rational[1, 2] $CellContext`IIi[{1, 2, 2}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c, $CellContext`f}]}], 
      Rational[1, 2] $CellContext`IIi[{1, 2, 2}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`d, $CellContext`c}]}], 
      Rational[1, 2] $CellContext`IIi[{1, 2, 2}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`d, $CellContext`e, $CellContext`b}]}], 
      Rational[1, 2] $CellContext`IIi[{1, 2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`c, $CellContext`e, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{1, 2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`c, $CellContext`e}]}], 
      Rational[-1, 2] $CellContext`IIi[{1, 2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`c, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{1, 2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`e, $CellContext`c}]}], 
      Rational[1, 2] $CellContext`IIi[{1, 2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`e, $CellContext`c, $CellContext`f}]}], 
      Rational[1, 2] $CellContext`IIi[{1, 2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`e, $CellContext`f, $CellContext`c}]}], 
      Rational[1, 2] $CellContext`IIi[{1, 2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`c, $CellContext`a, \
$CellContext`b, $CellContext`d, $CellContext`e}]}], 
      Rational[-1, 2] $CellContext`IIi[{1, 2, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`c, $CellContext`a, \
$CellContext`d, $CellContext`e, $CellContext`f}]}]}}, {
    14, {Rational[-1, 2] $CellContext`IIi[{1, 1, 3}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`c, $CellContext`e, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{1, 1, 3}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`e, $CellContext`f, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{1, 1, 3}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`d, $CellContext`e, $CellContext`Inf}]}], 
      Rational[-1, 2] $CellContext`IIi[{1, 1, 3}, {
         $CellContext`cri[{$CellContext`c, $CellContext`e, $CellContext`a, \
$CellContext`b, $CellContext`d, $CellContext`Inf}]}], -$CellContext`IIi[{1, 1,
         3}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c, $CellContext`e}]}], -$CellContext`IIi[{1, 1, 
        3}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`e, $CellContext`f}]}], 
      Rational[1, 2] $CellContext`IIi[{1, 1, 3}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`e, $CellContext`f, $CellContext`c}]}], 
      Rational[1, 2] $CellContext`IIi[{1, 1, 3}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c, $CellContext`f}]}], 
      Rational[1, 2] $CellContext`IIi[{1, 1, 3}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`c, $CellContext`e, $CellContext`f}]}], -$CellContext`IIi[{1, 1, 
        3}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`c, $CellContext`e}]}], -$CellContext`IIi[{1, 1, 
        3}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`e, $CellContext`f}]}], 
      Rational[1, 2] $CellContext`IIi[{1, 1, 3}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`e, $CellContext`c, $CellContext`f}]}], 
      Rational[1, 2] $CellContext`IIi[{1, 1, 3}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`e, $CellContext`f, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{1, 1, 3}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`c, $CellContext`a, \
$CellContext`d, $CellContext`e, $CellContext`f}]}]}}, {
    34, {Rational[3, 2] $CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`c, $CellContext`f}]}], Rational[3, 2] $CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`e, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`e, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`f, $CellContext`c}]}], Rational[1, 2] $CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`c}]}], Rational[1, 2] $CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`e, $CellContext`a, \
$CellContext`c, $CellContext`f}]}], Rational[1, 2] $CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`e, $CellContext`a, \
$CellContext`d, $CellContext`f}]}], 
      Rational[-3, 2] $CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`e, $CellContext`a, \
$CellContext`Inf, $CellContext`f}]}], Rational[1, 2] $CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`d, $CellContext`c}]}], 
      Rational[-3, 2] $CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`e, $CellContext`c}]}], Rational[3, 2] $CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`Inf, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`c, $CellContext`d, $CellContext`a, \
$CellContext`b, $CellContext`f}]}], Rational[1, 2] $CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`c, $CellContext`d, $CellContext`a, \
$CellContext`e, $CellContext`f}]}], Rational[3, 2] $CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`c, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`f}]}], Rational[1, 2] $CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`c, $CellContext`e, $CellContext`a, \
$CellContext`b, $CellContext`f}]}], 
      Rational[-3, 2] $CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`c, $CellContext`e, $CellContext`a, \
$CellContext`d, $CellContext`f}]}], Rational[3, 2] $CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`c, $CellContext`e, $CellContext`a, \
$CellContext`Inf, $CellContext`f}]}], Rational[3, 2] $CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c}]}], 2 $CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`f}]}], 
      Rational[-3, 2] $CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`e, $CellContext`c}]}], Rational[1, 2] $CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`f, $CellContext`c}]}], (-2) $CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`f}]}], 
      $CellContext`IIi[{4, 1}, {
        $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`c, $CellContext`f}]}], 
      $CellContext`IIi[{4, 1}, {
        $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`d, $CellContext`f}]}], Rational[1, 2] $CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`d, $CellContext`c}]}], Rational[3, 2] $CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`e, $CellContext`c}]}], -$CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`c, $CellContext`f}]}], 
      $CellContext`IIi[{4, 1}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`c}]}], 
      $CellContext`IIi[{4, 1}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`f}]}], -$CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`e, $CellContext`f}]}], 
      $CellContext`IIi[{4, 1}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`f, $CellContext`c}]}], 3 $CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`c, $CellContext`a, \
$CellContext`d, $CellContext`f}]}]}}, {
    41, {Rational[1, 2] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`c, $CellContext`e}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`c, $CellContext`f}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`e, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`f, $CellContext`c}]}], Rational[1, 2] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`e}]}], Rational[1, 2] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`e, $CellContext`a, \
$CellContext`c, $CellContext`f}]}], Rational[1, 2] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`e, $CellContext`a, \
$CellContext`d, $CellContext`c}]}], -$CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`e, $CellContext`a, \
$CellContext`Inf, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`e, $CellContext`a, \
$CellContext`Inf, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`e, $CellContext`c}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`Inf, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`c, $CellContext`d, $CellContext`a, \
$CellContext`b, $CellContext`e}]}], Rational[1, 2] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`c, $CellContext`d, $CellContext`a, \
$CellContext`e, $CellContext`f}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`c, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`e}]}], Rational[1, 2] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`c, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`c, $CellContext`e, $CellContext`a, \
$CellContext`d, $CellContext`f}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`c, $CellContext`e, $CellContext`a, \
$CellContext`Inf, $CellContext`f}]}], Rational[1, 2] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c}]}], Rational[3, 2] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`e}]}], Rational[3, 2] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`f}]}], -$CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`e, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`e, $CellContext`f}]}], Rational[1, 2] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`f, $CellContext`c}]}], -$CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c}]}], -$CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`f}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`c, $CellContext`f}]}], Rational[1, 2] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`d, $CellContext`c}]}], Rational[1, 2] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`d, $CellContext`f}]}], Rational[1, 2] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`d, $CellContext`b}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`e, $CellContext`b}]}], Rational[1, 2] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`e, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`c, $CellContext`e}]}], 
      Rational[-1, 2] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`c, $CellContext`f}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`e}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`f}]}], -$CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`e, $CellContext`c}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`f, $CellContext`c}]}], Rational[3, 2] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`c, $CellContext`a, \
$CellContext`d, $CellContext`e}]}], Rational[3, 2] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`c, $CellContext`a, \
$CellContext`d, $CellContext`f}]}]}}, {39, {
      $CellContext`IIi[{2, 3}, {
        $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`c, $CellContext`e}]}], Rational[1, 2] $CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`c, $CellContext`f}]}], Rational[1, 2] $CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`e, $CellContext`c}]}], Rational[1, 2] $CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`e, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`f, $CellContext`c}]}], Rational[1, 2] $CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`c}]}], Rational[1, 2] $CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`e}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`b, $CellContext`e, $CellContext`a, \
$CellContext`c, $CellContext`f}]}], -$CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`b, $CellContext`e, $CellContext`a, \
$CellContext`Inf, $CellContext`c}]}], Rational[1, 2] $CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`d, $CellContext`Inf}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`e, $CellContext`Inf}]}], Rational[1, 2] $CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`Inf, $CellContext`c}]}], Rational[1, 2] $CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`c, $CellContext`d, $CellContext`a, \
$CellContext`e, $CellContext`f}]}], 
      $CellContext`IIi[{2, 3}, {
        $CellContext`cri[{$CellContext`c, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`e}]}], Rational[1, 2] $CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`c, $CellContext`e, $CellContext`a, \
$CellContext`b, $CellContext`Inf}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`c, $CellContext`e, $CellContext`a, \
$CellContext`d, $CellContext`Inf}]}], Rational[1, 2] $CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`c, $CellContext`e, $CellContext`a, \
$CellContext`Inf, $CellContext`f}]}], 
      $CellContext`IIi[{2, 3}, {
        $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c}]}], Rational[3, 2] $CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`e}]}], 
      $CellContext`IIi[{2, 3}, {
        $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`e, $CellContext`c}]}], -$CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`e, $CellContext`f}]}], Rational[1, 2] $CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`f, $CellContext`c}]}], -$CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`f}]}], 
      $CellContext`IIi[{2, 3}, {
        $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`c, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`d, $CellContext`b}]}], 
      $CellContext`IIi[{2, 3}, {
        $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`d, $CellContext`c}]}], Rational[1, 2] $CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c}]}], 
      $CellContext`IIi[{2, 3}, {
        $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`e, $CellContext`b}]}], -$CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`c, $CellContext`e}]}], Rational[1, 2] $CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`c}]}], 
      $CellContext`IIi[{2, 3}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`e}]}], 
      $CellContext`IIi[{2, 3}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`f}]}], 
      Rational[-3, 2] $CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`e, $CellContext`c}]}], 
      $CellContext`IIi[{2, 3}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`f, $CellContext`c}]}], Rational[1, 2] $CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`c, $CellContext`a, \
$CellContext`b, $CellContext`d}]}], 2 $CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`c, $CellContext`a, \
$CellContext`d, $CellContext`e}]}], Rational[1, 2] $CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`c, $CellContext`a, \
$CellContext`d, $CellContext`f}]}]}}, {
    29, {Rational[3, 2] $CellContext`IIi[{1, 4}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`c, $CellContext`e}]}], 
      $CellContext`IIi[{1, 4}, {
        $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`e, $CellContext`f}]}], 
      Rational[-1, 2] $CellContext`IIi[{1, 4}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`f, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{1, 4}, {
         $CellContext`cri[{$CellContext`b, $CellContext`e, $CellContext`a, \
$CellContext`c, $CellContext`f}]}], Rational[1, 2] $CellContext`IIi[{1, 4}, {
         $CellContext`cri[{$CellContext`b, $CellContext`e, $CellContext`a, \
$CellContext`d, $CellContext`Inf}]}], Rational[1, 2] $CellContext`IIi[{1, 4}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`d, $CellContext`e}]}], 
      Rational[-3, 2] $CellContext`IIi[{1, 4}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`e, $CellContext`Inf}]}], 
      Rational[-1, 2] $CellContext`IIi[{1, 4}, {
         $CellContext`cri[{$CellContext`c, $CellContext`d, $CellContext`a, \
$CellContext`b, $CellContext`Inf}]}], Rational[1, 2] $CellContext`IIi[{1, 4}, {
         $CellContext`cri[{$CellContext`c, $CellContext`d, $CellContext`a, \
$CellContext`e, $CellContext`f}]}], Rational[1, 2] $CellContext`IIi[{1, 4}, {
         $CellContext`cri[{$CellContext`c, $CellContext`e, $CellContext`a, \
$CellContext`b, $CellContext`d}]}], 
      Rational[-3, 2] $CellContext`IIi[{1, 4}, {
         $CellContext`cri[{$CellContext`c, $CellContext`e, $CellContext`a, \
$CellContext`d, $CellContext`Inf}]}], Rational[3, 2] $CellContext`IIi[{1, 4}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c}]}], Rational[3, 2] $CellContext`IIi[{1, 4}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`e}]}], 
      Rational[-3, 2] $CellContext`IIi[{1, 4}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`e, $CellContext`f}]}], Rational[1, 2] $CellContext`IIi[{1, 4}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`f, $CellContext`c}]}], 
      Rational[-3, 2] $CellContext`IIi[{1, 4}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{1, 4}, {
         $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`d}]}], 
      $CellContext`IIi[{1, 4}, {
        $CellContext`cri[{$CellContext`e, $CellContext`Inf, $CellContext`a, \
$CellContext`c, $CellContext`f}]}], Rational[1, 2] $CellContext`IIi[{1, 4}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{1, 4}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`d, $CellContext`e}]}], 
      Rational[-3, 2] $CellContext`IIi[{1, 4}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`c, $CellContext`e}]}], Rational[1, 2] $CellContext`IIi[{1, 4}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`c, $CellContext`f}]}], Rational[3, 2] $CellContext`IIi[{1, 4}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`c}]}], 
      $CellContext`IIi[{1, 4}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`e}]}], 
      Rational[-3, 2] $CellContext`IIi[{1, 4}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`e, $CellContext`c}]}], -$CellContext`IIi[{1, 4}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`e, $CellContext`f}]}], 
      $CellContext`IIi[{1, 4}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`f, $CellContext`c}]}], 
      Rational[-1, 2] $CellContext`IIi[{1, 4}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`c, $CellContext`a, \
$CellContext`b, $CellContext`d}]}], Rational[3, 2] $CellContext`IIi[{1, 4}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`c, $CellContext`a, \
$CellContext`d, $CellContext`e}]}]}}, {
    37, {Rational[1, 2] $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`b, $CellContext`c, \
$CellContext`d}]}], Rational[-1, 2] $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`b, $CellContext`c, \
$CellContext`e}]}], Rational[-9, 2] $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`b, $CellContext`d, \
$CellContext`Inf}]}], Rational[7, 2] $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`b, $CellContext`e, \
$CellContext`Inf}]}], (-2) $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`b, $CellContext`f, \
$CellContext`Inf}]}], Rational[-7, 2] $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`c, $CellContext`b, \
$CellContext`d}]}], 2 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`c, $CellContext`b, \
$CellContext`e}]}], Rational[-1, 2] $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`c, $CellContext`b, \
$CellContext`f}]}], Rational[1, 2] $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`c, $CellContext`d, \
$CellContext`Inf}]}], (-4) $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`c, $CellContext`e, \
$CellContext`Inf}]}], Rational[1, 2] $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`c, $CellContext`f, \
$CellContext`Inf}]}], 2 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`c, $CellContext`Inf, \
$CellContext`b}]}], Rational[-1, 2] $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`d, $CellContext`b, \
$CellContext`e}]}], Rational[-1, 2] $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`d, $CellContext`b, \
$CellContext`f}]}], 2 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`d, $CellContext`c, \
$CellContext`e}]}], Rational[-3, 2] $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`d, $CellContext`e, \
$CellContext`Inf}]}], Rational[1, 2] $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`d, $CellContext`f, \
$CellContext`Inf}]}], (-3) $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`d, $CellContext`Inf, \
$CellContext`b}]}], (-5) $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`d, $CellContext`Inf, \
$CellContext`c}]}], -$CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`e, $CellContext`b, \
$CellContext`d}]}], 2 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`e, $CellContext`b, \
$CellContext`f}]}], (-2) $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`e, $CellContext`c, \
$CellContext`d}]}], 3 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`e, $CellContext`d, \
$CellContext`Inf}]}], (-2) $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`e, $CellContext`f, \
$CellContext`Inf}]}], 2 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`e, $CellContext`Inf, \
$CellContext`b}]}], Rational[3, 2] $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`f, $CellContext`b, \
$CellContext`d}]}], Rational[-1, 2] $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`f, $CellContext`b, \
$CellContext`e}]}], Rational[1, 2] $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`f, $CellContext`c, \
$CellContext`d}]}], Rational[-1, 2] $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`f, $CellContext`c, \
$CellContext`e}]}], (-2) $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`f, $CellContext`d, \
$CellContext`Inf}]}], 
      $CellContext`IIi[{5}, {
        $CellContext`cri[{$CellContext`a, $CellContext`f, $CellContext`e, \
$CellContext`Inf}]}], (-3) $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`f, $CellContext`Inf, \
$CellContext`b}]}], -$CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`Inf, $CellContext`b, \
$CellContext`d}]}], 2 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`Inf, $CellContext`b, \
$CellContext`e}]}], (-3) $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`Inf, $CellContext`b, \
$CellContext`f}]}], (-2) $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`Inf, $CellContext`c, \
$CellContext`d}]}], (-3) $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`Inf, $CellContext`c, \
$CellContext`e}]}]}}}],
  Editable->False]], "Print",
 CellChangeTimes->{3.6976124691744757`*^9, 3.697616063741351*^9, 
  3.6976161175381856`*^9, 3.697644256951157*^9, 3.697648046830484*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"texCountIntegrals", "[", "out5AllNLowerGathered", "]"}]], "Input",
 CellChangeTimes->{{3.697531169131065*^9, 3.697531176585211*^9}, {
  3.697538854472363*^9, 3.697538855200598*^9}}],

Cell[BoxData["\<\"Integral & Number in expression \\\\\\\\ \\n$ I_{3, 1, 1} $ \
& 22 \\\\\\\\ \\n$ I_{2, 2, 1} $ & 26 \\\\\\\\ \\n$ I_{2, 1, 2} $ & 22 \\\\\\\
\\ \\n$ I_{1, 3, 1} $ & 21 \\\\\\\\ \\n$ I_{1, 2, 2} $ & 22 \\\\\\\\ \\n$ \
I_{1, 1, 3} $ & 14 \\\\\\\\ \\n$ I_{4, 1} $ & 34 \\\\\\\\ \\n$ I_{3, 2} $ & \
41 \\\\\\\\ \\n$ I_{2, 3} $ & 39 \\\\\\\\ \\n$ I_{1, 4} $ & 29 \\\\\\\\ \\n$ \
I_{5} $ & 37 \\\\\\\\ \\nTotal & 307\"\>"], "Output",
 CellChangeTimes->{
  3.6975268918505983`*^9, 3.697526936476169*^9, 3.697527662164844*^9, 
   3.697527783374353*^9, 3.697531176921974*^9, 3.6975317746006823`*^9, 
   3.69753230698015*^9, 3.697533993800804*^9, 3.6975341028944283`*^9, 
   3.697535069937953*^9, 3.6975380754407454`*^9, {3.697538855591337*^9, 
   3.697538882491431*^9}, 3.6975406058393993`*^9, 3.697541463567626*^9, 
   3.697554830823242*^9, 3.6975568057103405`*^9, 3.6975633444490232`*^9, 
   3.697599525423956*^9, 3.6976025969946327`*^9, {3.697612453023903*^9, 
   3.6976124692213306`*^9}, 3.697616065774077*^9, 3.697616117897561*^9, 
   3.697644256986182*^9, 3.697648046885523*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"texIntegrals", "[", 
  RowBox[{
   RowBox[{"2", "*", "out5AllNLower"}], "//", "Expand"}], "]"}]], "Input",
 CellChangeTimes->{
  3.697526887879635*^9, {3.6975311604902887`*^9, 3.697531165857418*^9}, {
   3.697538138813191*^9, 3.697538216883462*^9}, 3.697538270739386*^9, {
   3.697538337360173*^9, 3.697538337711383*^9}, {3.69753857632196*^9, 
   3.697538576849647*^9}, {3.69753892282316*^9, 3.697538980876439*^9}, {
   3.697539012467823*^9, 3.6975390132822638`*^9}, {3.6975395697486267`*^9, 
   3.6975395816937637`*^9}, {3.69753964480942*^9, 3.697539645025524*^9}, {
   3.6975399013220043`*^9, 3.697539904290333*^9}, {3.697540001060424*^9, 
   3.6975400078139353`*^9}}],

Cell[BoxData["\<\"I_{3, 1, 1}( -[b d a c e f] \\n - [b d a e f c] \\n - [b d \
a \\\\infty e f] \\n - [b d a \\\\infty f c] \\n - [b e a d c f] \\n + 2 [b e \
a \\\\infty c f] \\n + [c d a b e f] \\n - 2 [c d a \\\\infty e f] \\n - 3 [d \
\\\\infty a b e f] \\n - 2 [d \\\\infty a b f c] \\n + [d \\\\infty a e f c] \
\\n + 2 [e \\\\infty a b c f] \\n - [e \\\\infty a d c f] \\n + [f \\\\infty \
a d b c] \\n - 2 [f \\\\infty a e b c] \\n + [\\\\infty b a c e f] \\n + \
[\\\\infty b a d c f] \\n - 2 [\\\\infty b a d e f] \\n - [\\\\infty b a d f \
c] \\n + [\\\\infty b a e c f] \\n - [\\\\infty b a e f c] \\n - 3 [\\\\infty \
c a d e f] ) + {} \\\\\\\\ \\n & {} + I_{2, 2, 1}( -[b d a c e f] \\n - [b d \
a e f c] \\n - [b d a \\\\infty c f] \\n - [b d a \\\\infty e c] \\n + [b e a \
\\\\infty c f] \\n - [b f a d \\\\infty c] \\n + [b f a e \\\\infty c] \\n - \
[c d a \\\\infty e f] \\n - [c e a b \\\\infty f] \\n + [c e a d \\\\infty f] \
\\n - 2 [d \\\\infty a b c f] \\n - [d \\\\infty a b e c] \\n - [d \\\\infty \
a b e f] \\n - [d \\\\infty a b f c] \\n + [d \\\\infty a e f c] \\n + [e \
\\\\infty a b c f] \\n + [e \\\\infty a d b f] \\n - [e \\\\infty a d c f] \
\\n - [f \\\\infty a e b c] \\n + [\\\\infty b a c e f] \\n - [\\\\infty b a \
d c f] \\n - [\\\\infty b a d e c] \\n - [\\\\infty b a d f c] \\n + \
[\\\\infty b a e c f] \\n - [\\\\infty c a b d f] \\n - 2 [\\\\infty c a d e \
f] ) + {} \\\\\\\\ \\n & {} + I_{2, 1, 2}( -[b d a c e f] \\n - [b d a e f c] \
\\n - [b d a \\\\infty c e] \\n - [b d a \\\\infty e f] \\n + [b e a \
\\\\infty c f] \\n - [c d a \\\\infty e f] \\n - 2 [d \\\\infty a b c e] \\n \
- 2 [d \\\\infty a b e f] \\n - [d \\\\infty a b f c] \\n + [d \\\\infty a e \
f c] \\n + [e \\\\infty a b c f] \\n + [e \\\\infty a d b c] \\n - [e \
\\\\infty a d c f] \\n - [f \\\\infty a e b c] \\n + [\\\\infty b a c e f] \
\\n - [\\\\infty b a d c e] \\n + [\\\\infty b a d e c] \\n - 2 [\\\\infty b \
a d e f] \\n - [\\\\infty b a d f c] \\n + [\\\\infty b a e c f] \\n - \
[\\\\infty c a b d e] \\n - 2 [\\\\infty c a d e f] ) + {} \\\\\\\\ \\n & {} \
+ I_{1, 3, 1}( -[b d a c e f] \\n - [b d a e f c] \\n - [b e a d \\\\infty f] \
\\n - [b f a d e c] \\n + 2 [b f a e \\\\infty c] \\n + [c d a b \\\\infty f] \
\\n - [c e a b d f] \\n + 2 [c e a d \\\\infty f] \\n - 2 [d \\\\infty a b c \
f] \\n - 2 [d \\\\infty a b e c] \\n + [d \\\\infty a e f c] \\n + [e \
\\\\infty a b c f] \\n + [e \\\\infty a b d f] \\n + [f \\\\infty a d e c] \
\\n + [\\\\infty b a c e f] \\n - 2 [\\\\infty b a d c f] \\n - [\\\\infty b \
a d e c] \\n + [\\\\infty b a e c f] \\n + [\\\\infty b a e f c] \\n + \
[\\\\infty c a b d f] \\n - [\\\\infty c a d e f] ) + {} \\\\\\\\ \\n & {} + \
I_{1, 2, 2}( -[b d a c e f] \\n - [b d a e f c] \\n - [b e a d \\\\infty c] \
\\n + [b f a e \\\\infty c] \\n + [c d a b \\\\infty e] \\n + [c e a d \
\\\\infty f] \\n - [d \\\\infty a b c e] \\n - [d \\\\infty a b c f] \\n - [d \
\\\\infty a b e c] \\n - [d \\\\infty a b e f] \\n + [d \\\\infty a e f c] \
\\n + [e \\\\infty a b c f] \\n + [e \\\\infty a b d c] \\n + [f \\\\infty a \
d e b] \\n + [\\\\infty b a c e f] \\n - [\\\\infty b a d c e] \\n - \
[\\\\infty b a d c f] \\n - [\\\\infty b a d e c] \\n + [\\\\infty b a e c f] \
\\n + [\\\\infty b a e f c] \\n + [\\\\infty c a b d e] \\n - [\\\\infty c a \
d e f] ) + {} \\\\\\\\ \\n & {} + I_{1, 1, 3}( -[b d a c e f] \\n - [b d a e \
f c] \\n - [b f a d e \\\\infty] \\n - [c e a b d \\\\infty] \\n - 2 [d \
\\\\infty a b c e] \\n - 2 [d \\\\infty a b e f] \\n + [d \\\\infty a e f c] \
\\n + [e \\\\infty a b c f] \\n + [\\\\infty b a c e f] \\n - 2 [\\\\infty b \
a d c e] \\n - 2 [\\\\infty b a d e f] \\n + [\\\\infty b a e c f] \\n + \
[\\\\infty b a e f c] \\n - [\\\\infty c a d e f] ) + {} \\\\\\\\ \\n & {} + \
I_{4, 1}( 3 [b d a c f] \\n + 3 [b d a e c] \\n - [b d a e f] \\n - [b d a f \
c] \\n + [b d a \\\\infty c] \\n + [b d a \\\\infty f] \\n - [b e a c f] \\n \
+ [b e a d f] \\n - 3 [b e a \\\\infty f] \\n + [b f a d c] \\n - 3 [b f a e \
c] \\n + 3 [b f a \\\\infty c] \\n - [c d a b f] \\n + [c d a e f] \\n + 3 [c \
d a \\\\infty f] \\n + [c e a b f] \\n - 3 [c e a d f] \\n + 3 [c e a \
\\\\infty f] \\n + 3 [d \\\\infty a b c] \\n + 4 [d \\\\infty a b f] \\n - 3 \
[d \\\\infty a e c] \\n + [d \\\\infty a f c] \\n - 4 [e \\\\infty a b f] \\n \
+ 2 [e \\\\infty a c f] \\n + 2 [e \\\\infty a d f] \\n + [f \\\\infty a b c] \
\\n - [f \\\\infty a d c] \\n + 3 [f \\\\infty a e c] \\n - 2 [\\\\infty b a \
c f] \\n + 2 [\\\\infty b a d c] \\n + 2 [\\\\infty b a d f] \\n - 2 \
[\\\\infty b a e f] \\n + 2 [\\\\infty b a f c] \\n + 6 [\\\\infty c a d f] ) \
+ {} \\\\\\\\ \\n & {} + I_{3, 2}( [b d a c e] \\n + 2 [b d a c f] \\n + 2 [b \
d a e c] \\n - [b d a f c] \\n + [b d a \\\\infty e] \\n + [b d a \\\\infty \
f] \\n - [b e a c f] \\n + [b e a d c] \\n - 2 [b e a \\\\infty c] \\n - [b e \
a \\\\infty f] \\n - [b f a e c] \\n + 2 [b f a \\\\infty c] \\n - [c d a b \
e] \\n + [c d a e f] \\n + 2 [c d a \\\\infty e] \\n + [c d a \\\\infty f] \
\\n - [c e a d f] \\n + 2 [c e a \\\\infty f] \\n + [d \\\\infty a b c] \\n + \
3 [d \\\\infty a b e] \\n + 3 [d \\\\infty a b f] \\n - 2 [d \\\\infty a e c] \
\\n - [d \\\\infty a e f] \\n + [d \\\\infty a f c] \\n - 2 [e \\\\infty a b \
c] \\n - 2 [e \\\\infty a b f] \\n + 2 [e \\\\infty a c f] \\n + [e \\\\infty \
a d c] \\n + [e \\\\infty a d f] \\n + [f \\\\infty a b c] \\n - [f \\\\infty \
a d b] \\n + 2 [f \\\\infty a e b] \\n + [f \\\\infty a e c] \\n - [\\\\infty \
b a c e] \\n - [\\\\infty b a c f] \\n + 2 [\\\\infty b a d e] \\n + 2 \
[\\\\infty b a d f] \\n - 2 [\\\\infty b a e c] \\n + 2 [\\\\infty b a f c] \
\\n + 3 [\\\\infty c a d e] \\n + 3 [\\\\infty c a d f] ) + {} \\\\\\\\ \\n & \
{} + I_{2, 3}( 2 [b d a c e] \\n + [b d a c f] \\n + [b d a e c] \\n + [b d a \
e f] \\n - [b d a f c] \\n + [b d a \\\\infty c] \\n + [b d a \\\\infty e] \
\\n - [b e a c f] \\n - 2 [b e a \\\\infty c] \\n + [b f a d \\\\infty] \\n - \
[b f a e \\\\infty] \\n + [b f a \\\\infty c] \\n + [c d a e f] \\n + 2 [c d \
a \\\\infty e] \\n + [c e a b \\\\infty] \\n - [c e a d \\\\infty] \\n + [c e \
a \\\\infty f] \\n + 2 [d \\\\infty a b c] \\n + 3 [d \\\\infty a b e] \\n + \
2 [d \\\\infty a b f] \\n - [d \\\\infty a e c] \\n - 2 [d \\\\infty a e f] \
\\n + [d \\\\infty a f c] \\n - 2 [e \\\\infty a b c] \\n - [e \\\\infty a b \
f] \\n + 2 [e \\\\infty a c f] \\n - [e \\\\infty a d b] \\n + 2 [e \\\\infty \
a d c] \\n + [f \\\\infty a b c] \\n + 2 [f \\\\infty a e b] \\n - 2 \
[\\\\infty b a c e] \\n + [\\\\infty b a d c] \\n + 2 [\\\\infty b a d e] \\n \
+ 2 [\\\\infty b a d f] \\n - 3 [\\\\infty b a e c] \\n + 2 [\\\\infty b a f \
c] \\n + [\\\\infty c a b d] \\n + 4 [\\\\infty c a d e] \\n + [\\\\infty c a \
d f] ) + {} \\\\\\\\ \\n & {} + I_{1, 4}( 3 [b d a c e] \\n + 2 [b d a e f] \
\\n - [b d a f c] \\n - [b e a c f] \\n + [b e a d \\\\infty] \\n + [b f a d \
e] \\n - 3 [b f a e \\\\infty] \\n - [c d a b \\\\infty] \\n + [c d a e f] \
\\n + [c e a b d] \\n - 3 [c e a d \\\\infty] \\n + 3 [d \\\\infty a b c] \\n \
+ 3 [d \\\\infty a b e] \\n - 3 [d \\\\infty a e f] \\n + [d \\\\infty a f c] \
\\n - 3 [e \\\\infty a b c] \\n - [e \\\\infty a b d] \\n + 2 [e \\\\infty a \
c f] \\n + [f \\\\infty a b c] \\n - [f \\\\infty a d e] \\n - 3 [\\\\infty b \
a c e] \\n + [\\\\infty b a c f] \\n + 3 [\\\\infty b a d c] \\n + 2 \
[\\\\infty b a d e] \\n - 3 [\\\\infty b a e c] \\n - 2 [\\\\infty b a e f] \
\\n + 2 [\\\\infty b a f c] \\n - [\\\\infty c a b d] \\n + 3 [\\\\infty c a \
d e] ) + {} \\\\\\\\ \\n & {} + I_{5}( [a b c d] \\n - [a b c e] \\n - 9 [a b \
d \\\\infty] \\n + 7 [a b e \\\\infty] \\n - 4 [a b f \\\\infty] \\n - 7 [a c \
b d] \\n + 4 [a c b e] \\n - [a c b f] \\n + [a c d \\\\infty] \\n - 8 [a c e \
\\\\infty] \\n + [a c f \\\\infty] \\n + 4 [a c \\\\infty b] \\n - [a d b e] \
\\n - [a d b f] \\n + 4 [a d c e] \\n - 3 [a d e \\\\infty] \\n + [a d f \
\\\\infty] \\n - 6 [a d \\\\infty b] \\n - 10 [a d \\\\infty c] \\n - 2 [a e \
b d] \\n + 4 [a e b f] \\n - 4 [a e c d] \\n + 6 [a e d \\\\infty] \\n - 4 [a \
e f \\\\infty] \\n + 4 [a e \\\\infty b] \\n + 3 [a f b d] \\n - [a f b e] \
\\n + [a f c d] \\n - [a f c e] \\n - 4 [a f d \\\\infty] \\n + 2 [a f e \
\\\\infty] \\n - 6 [a f \\\\infty b] \\n - 2 [a \\\\infty b d] \\n + 4 [a \
\\\\infty b e] \\n - 6 [a \\\\infty b f] \\n - 4 [a \\\\infty c d] \\n - 6 [a \
\\\\infty c e] )\"\>"], "Output",
 CellChangeTimes->{
  3.697539909007635*^9, {3.6975399960830297`*^9, 3.6975400105367126`*^9}, 
   3.6975406099586906`*^9, 3.697541388142503*^9, 3.697554839001501*^9, 
   3.6975568136229243`*^9, 3.697563346450122*^9, 3.69759952720568*^9, {
   3.6976026001834145`*^9, 3.697602611469016*^9}, {3.697612453117652*^9, 
   3.697612471362584*^9}, 3.697616120196397*^9, 3.697644258954562*^9, 
   3.6976480487658415`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"texIntegralsWithFrac", "[", "out5AllNLower", "]"}]], "Input",
 CellChangeTimes->{
  3.697526887879635*^9, {3.6975311604902887`*^9, 3.697531165857418*^9}, {
   3.697538138813191*^9, 3.697538216883462*^9}, 3.697538270739386*^9, {
   3.697538337360173*^9, 3.697538337711383*^9}, {3.69753857632196*^9, 
   3.697538576849647*^9}, {3.69753892282316*^9, 3.697538980876439*^9}, {
   3.697539012467823*^9, 3.6975390132822638`*^9}, {3.6975395697486267`*^9, 
   3.6975395816937637`*^9}, {3.69753964480942*^9, 3.697539645025524*^9}, {
   3.697539870083351*^9, 3.697539883226457*^9}}],

Cell[BoxData["\<\"I_{3, 1, 1}( -\\\\frac{1}{2} [b d a c e f] \\n - \
\\\\frac{1}{2} [b d a e f c] \\n - \\\\frac{1}{2} [b d a \\\\infty e f] \\n - \
\\\\frac{1}{2} [b d a \\\\infty f c] \\n - \\\\frac{1}{2} [b e a d c f] \\n + \
[b e a \\\\infty c f] \\n + \\\\frac{1}{2} [c d a b e f] \\n - [c d a \
\\\\infty e f] \\n - \\\\frac{3}{2} [d \\\\infty a b e f] \\n - [d \\\\infty \
a b f c] \\n + \\\\frac{1}{2} [d \\\\infty a e f c] \\n + [e \\\\infty a b c \
f] \\n - \\\\frac{1}{2} [e \\\\infty a d c f] \\n + \\\\frac{1}{2} [f \
\\\\infty a d b c] \\n - [f \\\\infty a e b c] \\n + \\\\frac{1}{2} \
[\\\\infty b a c e f] \\n + \\\\frac{1}{2} [\\\\infty b a d c f] \\n - \
[\\\\infty b a d e f] \\n - \\\\frac{1}{2} [\\\\infty b a d f c] \\n + \
\\\\frac{1}{2} [\\\\infty b a e c f] \\n - \\\\frac{1}{2} [\\\\infty b a e f \
c] \\n - \\\\frac{3}{2} [\\\\infty c a d e f] ) + {} \\\\\\\\ \\n & {} + \
I_{2, 2, 1}( -\\\\frac{1}{2} [b d a c e f] \\n - \\\\frac{1}{2} [b d a e f c] \
\\n - \\\\frac{1}{2} [b d a \\\\infty c f] \\n - \\\\frac{1}{2} [b d a \
\\\\infty e c] \\n + \\\\frac{1}{2} [b e a \\\\infty c f] \\n - \
\\\\frac{1}{2} [b f a d \\\\infty c] \\n + \\\\frac{1}{2} [b f a e \\\\infty \
c] \\n - \\\\frac{1}{2} [c d a \\\\infty e f] \\n - \\\\frac{1}{2} [c e a b \
\\\\infty f] \\n + \\\\frac{1}{2} [c e a d \\\\infty f] \\n - [d \\\\infty a \
b c f] \\n - \\\\frac{1}{2} [d \\\\infty a b e c] \\n - \\\\frac{1}{2} [d \
\\\\infty a b e f] \\n - \\\\frac{1}{2} [d \\\\infty a b f c] \\n + \
\\\\frac{1}{2} [d \\\\infty a e f c] \\n + \\\\frac{1}{2} [e \\\\infty a b c \
f] \\n + \\\\frac{1}{2} [e \\\\infty a d b f] \\n - \\\\frac{1}{2} [e \
\\\\infty a d c f] \\n - \\\\frac{1}{2} [f \\\\infty a e b c] \\n + \
\\\\frac{1}{2} [\\\\infty b a c e f] \\n - \\\\frac{1}{2} [\\\\infty b a d c \
f] \\n - \\\\frac{1}{2} [\\\\infty b a d e c] \\n - \\\\frac{1}{2} [\\\\infty \
b a d f c] \\n + \\\\frac{1}{2} [\\\\infty b a e c f] \\n - \\\\frac{1}{2} \
[\\\\infty c a b d f] \\n - [\\\\infty c a d e f] ) + {} \\\\\\\\ \\n & {} + \
I_{2, 1, 2}( -\\\\frac{1}{2} [b d a c e f] \\n - \\\\frac{1}{2} [b d a e f c] \
\\n - \\\\frac{1}{2} [b d a \\\\infty c e] \\n - \\\\frac{1}{2} [b d a \
\\\\infty e f] \\n + \\\\frac{1}{2} [b e a \\\\infty c f] \\n - \
\\\\frac{1}{2} [c d a \\\\infty e f] \\n - [d \\\\infty a b c e] \\n - [d \
\\\\infty a b e f] \\n - \\\\frac{1}{2} [d \\\\infty a b f c] \\n + \
\\\\frac{1}{2} [d \\\\infty a e f c] \\n + \\\\frac{1}{2} [e \\\\infty a b c \
f] \\n + \\\\frac{1}{2} [e \\\\infty a d b c] \\n - \\\\frac{1}{2} [e \
\\\\infty a d c f] \\n - \\\\frac{1}{2} [f \\\\infty a e b c] \\n + \
\\\\frac{1}{2} [\\\\infty b a c e f] \\n - \\\\frac{1}{2} [\\\\infty b a d c \
e] \\n + \\\\frac{1}{2} [\\\\infty b a d e c] \\n - [\\\\infty b a d e f] \\n \
- \\\\frac{1}{2} [\\\\infty b a d f c] \\n + \\\\frac{1}{2} [\\\\infty b a e \
c f] \\n - \\\\frac{1}{2} [\\\\infty c a b d e] \\n - [\\\\infty c a d e f] ) \
+ {} \\\\\\\\ \\n & {} + I_{1, 3, 1}( -\\\\frac{1}{2} [b d a c e f] \\n - \
\\\\frac{1}{2} [b d a e f c] \\n - \\\\frac{1}{2} [b e a d \\\\infty f] \\n - \
\\\\frac{1}{2} [b f a d e c] \\n + [b f a e \\\\infty c] \\n + \\\\frac{1}{2} \
[c d a b \\\\infty f] \\n - \\\\frac{1}{2} [c e a b d f] \\n + [c e a d \
\\\\infty f] \\n - [d \\\\infty a b c f] \\n - [d \\\\infty a b e c] \\n + \\\
\\frac{1}{2} [d \\\\infty a e f c] \\n + \\\\frac{1}{2} [e \\\\infty a b c f] \
\\n + \\\\frac{1}{2} [e \\\\infty a b d f] \\n + \\\\frac{1}{2} [f \\\\infty \
a d e c] \\n + \\\\frac{1}{2} [\\\\infty b a c e f] \\n - [\\\\infty b a d c \
f] \\n - \\\\frac{1}{2} [\\\\infty b a d e c] \\n + \\\\frac{1}{2} [\\\\infty \
b a e c f] \\n + \\\\frac{1}{2} [\\\\infty b a e f c] \\n + \\\\frac{1}{2} \
[\\\\infty c a b d f] \\n - \\\\frac{1}{2} [\\\\infty c a d e f] ) + {} \
\\\\\\\\ \\n & {} + I_{1, 2, 2}( -\\\\frac{1}{2} [b d a c e f] \\n - \
\\\\frac{1}{2} [b d a e f c] \\n - \\\\frac{1}{2} [b e a d \\\\infty c] \\n + \
\\\\frac{1}{2} [b f a e \\\\infty c] \\n + \\\\frac{1}{2} [c d a b \\\\infty \
e] \\n + \\\\frac{1}{2} [c e a d \\\\infty f] \\n - \\\\frac{1}{2} [d \
\\\\infty a b c e] \\n - \\\\frac{1}{2} [d \\\\infty a b c f] \\n - \
\\\\frac{1}{2} [d \\\\infty a b e c] \\n - \\\\frac{1}{2} [d \\\\infty a b e \
f] \\n + \\\\frac{1}{2} [d \\\\infty a e f c] \\n + \\\\frac{1}{2} [e \
\\\\infty a b c f] \\n + \\\\frac{1}{2} [e \\\\infty a b d c] \\n + \
\\\\frac{1}{2} [f \\\\infty a d e b] \\n + \\\\frac{1}{2} [\\\\infty b a c e \
f] \\n - \\\\frac{1}{2} [\\\\infty b a d c e] \\n - \\\\frac{1}{2} [\\\\infty \
b a d c f] \\n - \\\\frac{1}{2} [\\\\infty b a d e c] \\n + \\\\frac{1}{2} \
[\\\\infty b a e c f] \\n + \\\\frac{1}{2} [\\\\infty b a e f c] \\n + \
\\\\frac{1}{2} [\\\\infty c a b d e] \\n - \\\\frac{1}{2} [\\\\infty c a d e \
f] ) + {} \\\\\\\\ \\n & {} + I_{1, 1, 3}( -\\\\frac{1}{2} [b d a c e f] \\n \
- \\\\frac{1}{2} [b d a e f c] \\n - \\\\frac{1}{2} [b f a d e \\\\infty] \\n \
- \\\\frac{1}{2} [c e a b d \\\\infty] \\n - [d \\\\infty a b c e] \\n - [d \
\\\\infty a b e f] \\n + \\\\frac{1}{2} [d \\\\infty a e f c] \\n + \
\\\\frac{1}{2} [e \\\\infty a b c f] \\n + \\\\frac{1}{2} [\\\\infty b a c e \
f] \\n - [\\\\infty b a d c e] \\n - [\\\\infty b a d e f] \\n + \
\\\\frac{1}{2} [\\\\infty b a e c f] \\n + \\\\frac{1}{2} [\\\\infty b a e f \
c] \\n - \\\\frac{1}{2} [\\\\infty c a d e f] ) + {} \\\\\\\\ \\n & {} + \
I_{4, 1}( \\\\frac{3}{2} [b d a c f] \\n + \\\\frac{3}{2} [b d a e c] \\n - \
\\\\frac{1}{2} [b d a e f] \\n - \\\\frac{1}{2} [b d a f c] \\n + \
\\\\frac{1}{2} [b d a \\\\infty c] \\n + \\\\frac{1}{2} [b d a \\\\infty f] \
\\n - \\\\frac{1}{2} [b e a c f] \\n + \\\\frac{1}{2} [b e a d f] \\n - \
\\\\frac{3}{2} [b e a \\\\infty f] \\n + \\\\frac{1}{2} [b f a d c] \\n - \
\\\\frac{3}{2} [b f a e c] \\n + \\\\frac{3}{2} [b f a \\\\infty c] \\n - \
\\\\frac{1}{2} [c d a b f] \\n + \\\\frac{1}{2} [c d a e f] \\n + \
\\\\frac{3}{2} [c d a \\\\infty f] \\n + \\\\frac{1}{2} [c e a b f] \\n - \
\\\\frac{3}{2} [c e a d f] \\n + \\\\frac{3}{2} [c e a \\\\infty f] \\n + \
\\\\frac{3}{2} [d \\\\infty a b c] \\n + 2 [d \\\\infty a b f] \\n - \
\\\\frac{3}{2} [d \\\\infty a e c] \\n + \\\\frac{1}{2} [d \\\\infty a f c] \
\\n - 2 [e \\\\infty a b f] \\n + [e \\\\infty a c f] \\n + [e \\\\infty a d \
f] \\n + \\\\frac{1}{2} [f \\\\infty a b c] \\n - \\\\frac{1}{2} [f \\\\infty \
a d c] \\n + \\\\frac{3}{2} [f \\\\infty a e c] \\n - [\\\\infty b a c f] \\n \
+ [\\\\infty b a d c] \\n + [\\\\infty b a d f] \\n - [\\\\infty b a e f] \\n \
+ [\\\\infty b a f c] \\n + 3 [\\\\infty c a d f] ) + {} \\\\\\\\ \\n & {} + \
I_{3, 2}( \\\\frac{1}{2} [b d a c e] \\n + [b d a c f] \\n + [b d a e c] \\n \
- \\\\frac{1}{2} [b d a f c] \\n + \\\\frac{1}{2} [b d a \\\\infty e] \\n + \
\\\\frac{1}{2} [b d a \\\\infty f] \\n - \\\\frac{1}{2} [b e a c f] \\n + \
\\\\frac{1}{2} [b e a d c] \\n - [b e a \\\\infty c] \\n - \\\\frac{1}{2} [b \
e a \\\\infty f] \\n - \\\\frac{1}{2} [b f a e c] \\n + [b f a \\\\infty c] \
\\n - \\\\frac{1}{2} [c d a b e] \\n + \\\\frac{1}{2} [c d a e f] \\n + [c d \
a \\\\infty e] \\n + \\\\frac{1}{2} [c d a \\\\infty f] \\n - \\\\frac{1}{2} \
[c e a d f] \\n + [c e a \\\\infty f] \\n + \\\\frac{1}{2} [d \\\\infty a b \
c] \\n + \\\\frac{3}{2} [d \\\\infty a b e] \\n + \\\\frac{3}{2} [d \\\\infty \
a b f] \\n - [d \\\\infty a e c] \\n - \\\\frac{1}{2} [d \\\\infty a e f] \\n \
+ \\\\frac{1}{2} [d \\\\infty a f c] \\n - [e \\\\infty a b c] \\n - [e \
\\\\infty a b f] \\n + [e \\\\infty a c f] \\n + \\\\frac{1}{2} [e \\\\infty \
a d c] \\n + \\\\frac{1}{2} [e \\\\infty a d f] \\n + \\\\frac{1}{2} [f \
\\\\infty a b c] \\n - \\\\frac{1}{2} [f \\\\infty a d b] \\n + [f \\\\infty \
a e b] \\n + \\\\frac{1}{2} [f \\\\infty a e c] \\n - \\\\frac{1}{2} \
[\\\\infty b a c e] \\n - \\\\frac{1}{2} [\\\\infty b a c f] \\n + [\\\\infty \
b a d e] \\n + [\\\\infty b a d f] \\n - [\\\\infty b a e c] \\n + [\\\\infty \
b a f c] \\n + \\\\frac{3}{2} [\\\\infty c a d e] \\n + \\\\frac{3}{2} \
[\\\\infty c a d f] ) + {} \\\\\\\\ \\n & {} + I_{2, 3}( [b d a c e] \\n + \\\
\\frac{1}{2} [b d a c f] \\n + \\\\frac{1}{2} [b d a e c] \\n + \
\\\\frac{1}{2} [b d a e f] \\n - \\\\frac{1}{2} [b d a f c] \\n + \
\\\\frac{1}{2} [b d a \\\\infty c] \\n + \\\\frac{1}{2} [b d a \\\\infty e] \
\\n - \\\\frac{1}{2} [b e a c f] \\n - [b e a \\\\infty c] \\n + \
\\\\frac{1}{2} [b f a d \\\\infty] \\n - \\\\frac{1}{2} [b f a e \\\\infty] \
\\n + \\\\frac{1}{2} [b f a \\\\infty c] \\n + \\\\frac{1}{2} [c d a e f] \\n \
+ [c d a \\\\infty e] \\n + \\\\frac{1}{2} [c e a b \\\\infty] \\n - \
\\\\frac{1}{2} [c e a d \\\\infty] \\n + \\\\frac{1}{2} [c e a \\\\infty f] \
\\n + [d \\\\infty a b c] \\n + \\\\frac{3}{2} [d \\\\infty a b e] \\n + [d \
\\\\infty a b f] \\n - \\\\frac{1}{2} [d \\\\infty a e c] \\n - [d \\\\infty \
a e f] \\n + \\\\frac{1}{2} [d \\\\infty a f c] \\n - [e \\\\infty a b c] \\n \
- \\\\frac{1}{2} [e \\\\infty a b f] \\n + [e \\\\infty a c f] \\n - \
\\\\frac{1}{2} [e \\\\infty a d b] \\n + [e \\\\infty a d c] \\n + \
\\\\frac{1}{2} [f \\\\infty a b c] \\n + [f \\\\infty a e b] \\n - [\\\\infty \
b a c e] \\n + \\\\frac{1}{2} [\\\\infty b a d c] \\n + [\\\\infty b a d e] \
\\n + [\\\\infty b a d f] \\n - \\\\frac{3}{2} [\\\\infty b a e c] \\n + \
[\\\\infty b a f c] \\n + \\\\frac{1}{2} [\\\\infty c a b d] \\n + 2 \
[\\\\infty c a d e] \\n + \\\\frac{1}{2} [\\\\infty c a d f] ) + {} \\\\\\\\ \
\\n & {} + I_{1, 4}( \\\\frac{3}{2} [b d a c e] \\n + [b d a e f] \\n - \
\\\\frac{1}{2} [b d a f c] \\n - \\\\frac{1}{2} [b e a c f] \\n + \
\\\\frac{1}{2} [b e a d \\\\infty] \\n + \\\\frac{1}{2} [b f a d e] \\n - \
\\\\frac{3}{2} [b f a e \\\\infty] \\n - \\\\frac{1}{2} [c d a b \\\\infty] \
\\n + \\\\frac{1}{2} [c d a e f] \\n + \\\\frac{1}{2} [c e a b d] \\n - \
\\\\frac{3}{2} [c e a d \\\\infty] \\n + \\\\frac{3}{2} [d \\\\infty a b c] \
\\n + \\\\frac{3}{2} [d \\\\infty a b e] \\n - \\\\frac{3}{2} [d \\\\infty a \
e f] \\n + \\\\frac{1}{2} [d \\\\infty a f c] \\n - \\\\frac{3}{2} [e \
\\\\infty a b c] \\n - \\\\frac{1}{2} [e \\\\infty a b d] \\n + [e \\\\infty \
a c f] \\n + \\\\frac{1}{2} [f \\\\infty a b c] \\n - \\\\frac{1}{2} [f \
\\\\infty a d e] \\n - \\\\frac{3}{2} [\\\\infty b a c e] \\n + \
\\\\frac{1}{2} [\\\\infty b a c f] \\n + \\\\frac{3}{2} [\\\\infty b a d c] \
\\n + [\\\\infty b a d e] \\n - \\\\frac{3}{2} [\\\\infty b a e c] \\n - \
[\\\\infty b a e f] \\n + [\\\\infty b a f c] \\n - \\\\frac{1}{2} [\\\\infty \
c a b d] \\n + \\\\frac{3}{2} [\\\\infty c a d e] ) + {} \\\\\\\\ \\n & {} + \
I_{5}( \\\\frac{1}{2} [a b c d] \\n - \\\\frac{1}{2} [a b c e] \\n - \
\\\\frac{9}{2} [a b d \\\\infty] \\n + \\\\frac{7}{2} [a b e \\\\infty] \\n - \
2 [a b f \\\\infty] \\n - \\\\frac{7}{2} [a c b d] \\n + 2 [a c b e] \\n - \\\
\\frac{1}{2} [a c b f] \\n + \\\\frac{1}{2} [a c d \\\\infty] \\n - 4 [a c e \
\\\\infty] \\n + \\\\frac{1}{2} [a c f \\\\infty] \\n + 2 [a c \\\\infty b] \
\\n - \\\\frac{1}{2} [a d b e] \\n - \\\\frac{1}{2} [a d b f] \\n + 2 [a d c \
e] \\n - \\\\frac{3}{2} [a d e \\\\infty] \\n + \\\\frac{1}{2} [a d f \
\\\\infty] \\n - 3 [a d \\\\infty b] \\n - 5 [a d \\\\infty c] \\n - [a e b \
d] \\n + 2 [a e b f] \\n - 2 [a e c d] \\n + 3 [a e d \\\\infty] \\n - 2 [a e \
f \\\\infty] \\n + 2 [a e \\\\infty b] \\n + \\\\frac{3}{2} [a f b d] \\n - \
\\\\frac{1}{2} [a f b e] \\n + \\\\frac{1}{2} [a f c d] \\n - \\\\frac{1}{2} \
[a f c e] \\n - 2 [a f d \\\\infty] \\n + [a f e \\\\infty] \\n - 3 [a f \
\\\\infty b] \\n - [a \\\\infty b d] \\n + 2 [a \\\\infty b e] \\n - 3 [a \
\\\\infty b f] \\n - 2 [a \\\\infty c d] \\n - 3 [a \\\\infty c e] )\"\>"], \
"Output",
 CellChangeTimes->{{3.6975398726424913`*^9, 3.6975398853072853`*^9}, 
   3.6975399928269367`*^9, 3.697540624148397*^9, 3.6975406648043623`*^9, 
   3.6975414095746593`*^9, 3.697554845615701*^9, 3.6975568220214376`*^9, 
   3.69756334840396*^9, 3.6975995291280956`*^9, 3.6976026135634146`*^9, {
   3.6976124532582617`*^9, 3.697612473629527*^9}, 3.6976161221188755`*^9, 
   3.697644261093094*^9, 3.6976480508473177`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"texIntegralsByCoeff", "[", "out5AllNLower", "]"}]], "Input",
 CellChangeTimes->{
  3.697526887879635*^9, {3.6975311604902887`*^9, 3.697531165857418*^9}, {
   3.697538138813191*^9, 3.697538216883462*^9}, 3.697538270739386*^9, {
   3.697538337360173*^9, 3.697538337711383*^9}, {3.69753857632196*^9, 
   3.697538576849647*^9}, {3.69753892282316*^9, 3.697538980876439*^9}, {
   3.697539012467823*^9, 3.6975390132822638`*^9}, {3.6975395697486267`*^9, 
   3.6975395816937637`*^9}, {3.69753964480942*^9, 3.697539645025524*^9}}],

Cell[BoxData["\<\"I_{3, 1, 1}( [b e a \\\\infty c f] \\n - [c d a \\\\infty e \
f] \\n - [d \\\\infty a b f c] \\n + [e \\\\infty a b c f] \\n - [f \\\\infty \
a e b c] \\n - [\\\\infty b a d e f] ) + {} \\\\\\\\ \\n & {} + \
\\\\frac{1}{2} I_{3, 1, 1}( -[b d a c e f] \\n - [b d a e f c] \\n - [b d a \
\\\\infty e f] \\n - [b d a \\\\infty f c] \\n - [b e a d c f] \\n + [c d a b \
e f] \\n - 3 [d \\\\infty a b e f] \\n + [d \\\\infty a e f c] \\n - [e \
\\\\infty a d c f] \\n + [f \\\\infty a d b c] \\n + [\\\\infty b a c e f] \
\\n + [\\\\infty b a d c f] \\n - [\\\\infty b a d f c] \\n + [\\\\infty b a \
e c f] \\n - [\\\\infty b a e f c] \\n - 3 [\\\\infty c a d e f] ) + {} \
\\\\\\\\ \\n & {} + I_{2, 2, 1}( -[d \\\\infty a b c f] \\n - [\\\\infty c a \
d e f] ) + {} \\\\\\\\ \\n & {} + \\\\frac{1}{2} I_{2, 2, 1}( -[b d a c e f] \
\\n - [b d a e f c] \\n - [b d a \\\\infty c f] \\n - [b d a \\\\infty e c] \
\\n + [b e a \\\\infty c f] \\n - [b f a d \\\\infty c] \\n + [b f a e \
\\\\infty c] \\n - [c d a \\\\infty e f] \\n - [c e a b \\\\infty f] \\n + [c \
e a d \\\\infty f] \\n - [d \\\\infty a b e c] \\n - [d \\\\infty a b e f] \
\\n - [d \\\\infty a b f c] \\n + [d \\\\infty a e f c] \\n + [e \\\\infty a \
b c f] \\n + [e \\\\infty a d b f] \\n - [e \\\\infty a d c f] \\n - [f \
\\\\infty a e b c] \\n + [\\\\infty b a c e f] \\n - [\\\\infty b a d c f] \
\\n - [\\\\infty b a d e c] \\n - [\\\\infty b a d f c] \\n + [\\\\infty b a \
e c f] \\n - [\\\\infty c a b d f] ) + {} \\\\\\\\ \\n & {} + I_{2, 1, 2}( \
-[d \\\\infty a b c e] \\n - [d \\\\infty a b e f] \\n - [\\\\infty b a d e \
f] \\n - [\\\\infty c a d e f] ) + {} \\\\\\\\ \\n & {} + \\\\frac{1}{2} \
I_{2, 1, 2}( -[b d a c e f] \\n - [b d a e f c] \\n - [b d a \\\\infty c e] \
\\n - [b d a \\\\infty e f] \\n + [b e a \\\\infty c f] \\n - [c d a \
\\\\infty e f] \\n - [d \\\\infty a b f c] \\n + [d \\\\infty a e f c] \\n + \
[e \\\\infty a b c f] \\n + [e \\\\infty a d b c] \\n - [e \\\\infty a d c f] \
\\n - [f \\\\infty a e b c] \\n + [\\\\infty b a c e f] \\n - [\\\\infty b a \
d c e] \\n + [\\\\infty b a d e c] \\n - [\\\\infty b a d f c] \\n + \
[\\\\infty b a e c f] \\n - [\\\\infty c a b d e] ) + {} \\\\\\\\ \\n & {} + \
I_{1, 3, 1}( [b f a e \\\\infty c] \\n + [c e a d \\\\infty f] \\n - [d \
\\\\infty a b c f] \\n - [d \\\\infty a b e c] \\n - [\\\\infty b a d c f] ) \
+ {} \\\\\\\\ \\n & {} + \\\\frac{1}{2} I_{1, 3, 1}( -[b d a c e f] \\n - [b \
d a e f c] \\n - [b e a d \\\\infty f] \\n - [b f a d e c] \\n + [c d a b \
\\\\infty f] \\n - [c e a b d f] \\n + [d \\\\infty a e f c] \\n + [e \
\\\\infty a b c f] \\n + [e \\\\infty a b d f] \\n + [f \\\\infty a d e c] \
\\n + [\\\\infty b a c e f] \\n - [\\\\infty b a d e c] \\n + [\\\\infty b a \
e c f] \\n + [\\\\infty b a e f c] \\n + [\\\\infty c a b d f] \\n - \
[\\\\infty c a d e f] ) + {} \\\\\\\\ \\n & {} + \\\\frac{1}{2} I_{1, 2, 2}( \
-[b d a c e f] \\n - [b d a e f c] \\n - [b e a d \\\\infty c] \\n + [b f a e \
\\\\infty c] \\n + [c d a b \\\\infty e] \\n + [c e a d \\\\infty f] \\n - [d \
\\\\infty a b c e] \\n - [d \\\\infty a b c f] \\n - [d \\\\infty a b e c] \
\\n - [d \\\\infty a b e f] \\n + [d \\\\infty a e f c] \\n + [e \\\\infty a \
b c f] \\n + [e \\\\infty a b d c] \\n + [f \\\\infty a d e b] \\n + \
[\\\\infty b a c e f] \\n - [\\\\infty b a d c e] \\n - [\\\\infty b a d c f] \
\\n - [\\\\infty b a d e c] \\n + [\\\\infty b a e c f] \\n + [\\\\infty b a \
e f c] \\n + [\\\\infty c a b d e] \\n - [\\\\infty c a d e f] ) + {} \
\\\\\\\\ \\n & {} + I_{1, 1, 3}( -[d \\\\infty a b c e] \\n - [d \\\\infty a \
b e f] \\n - [\\\\infty b a d c e] \\n - [\\\\infty b a d e f] ) + {} \
\\\\\\\\ \\n & {} + \\\\frac{1}{2} I_{1, 1, 3}( -[b d a c e f] \\n - [b d a e \
f c] \\n - [b f a d e \\\\infty] \\n - [c e a b d \\\\infty] \\n + [d \
\\\\infty a e f c] \\n + [e \\\\infty a b c f] \\n + [\\\\infty b a c e f] \
\\n + [\\\\infty b a e c f] \\n + [\\\\infty b a e f c] \\n - [\\\\infty c a \
d e f] ) + {} \\\\\\\\ \\n & {} + I_{4, 1}( 2 [d \\\\infty a b f] \\n - 2 [e \
\\\\infty a b f] \\n + [e \\\\infty a c f] \\n + [e \\\\infty a d f] \\n - \
[\\\\infty b a c f] \\n + [\\\\infty b a d c] \\n + [\\\\infty b a d f] \\n - \
[\\\\infty b a e f] \\n + [\\\\infty b a f c] \\n + 3 [\\\\infty c a d f] ) + \
{} \\\\\\\\ \\n & {} + \\\\frac{1}{2} I_{4, 1}( 3 [b d a c f] \\n + 3 [b d a \
e c] \\n - [b d a e f] \\n - [b d a f c] \\n + [b d a \\\\infty c] \\n + [b d \
a \\\\infty f] \\n - [b e a c f] \\n + [b e a d f] \\n - 3 [b e a \\\\infty \
f] \\n + [b f a d c] \\n - 3 [b f a e c] \\n + 3 [b f a \\\\infty c] \\n - [c \
d a b f] \\n + [c d a e f] \\n + 3 [c d a \\\\infty f] \\n + [c e a b f] \\n \
- 3 [c e a d f] \\n + 3 [c e a \\\\infty f] \\n + 3 [d \\\\infty a b c] \\n - \
3 [d \\\\infty a e c] \\n + [d \\\\infty a f c] \\n + [f \\\\infty a b c] \\n \
- [f \\\\infty a d c] \\n + 3 [f \\\\infty a e c] ) + {} \\\\\\\\ \\n & {} + \
I_{3, 2}( [b d a c f] \\n + [b d a e c] \\n - [b e a \\\\infty c] \\n + [b f \
a \\\\infty c] \\n + [c d a \\\\infty e] \\n + [c e a \\\\infty f] \\n - [d \
\\\\infty a e c] \\n - [e \\\\infty a b c] \\n - [e \\\\infty a b f] \\n + [e \
\\\\infty a c f] \\n + [f \\\\infty a e b] \\n + [\\\\infty b a d e] \\n + \
[\\\\infty b a d f] \\n - [\\\\infty b a e c] \\n + [\\\\infty b a f c] ) + \
{} \\\\\\\\ \\n & {} + \\\\frac{1}{2} I_{3, 2}( [b d a c e] \\n - [b d a f c] \
\\n + [b d a \\\\infty e] \\n + [b d a \\\\infty f] \\n - [b e a c f] \\n + \
[b e a d c] \\n - [b e a \\\\infty f] \\n - [b f a e c] \\n - [c d a b e] \\n \
+ [c d a e f] \\n + [c d a \\\\infty f] \\n - [c e a d f] \\n + [d \\\\infty \
a b c] \\n + 3 [d \\\\infty a b e] \\n + 3 [d \\\\infty a b f] \\n - [d \
\\\\infty a e f] \\n + [d \\\\infty a f c] \\n + [e \\\\infty a d c] \\n + [e \
\\\\infty a d f] \\n + [f \\\\infty a b c] \\n - [f \\\\infty a d b] \\n + [f \
\\\\infty a e c] \\n - [\\\\infty b a c e] \\n - [\\\\infty b a c f] \\n + 3 \
[\\\\infty c a d e] \\n + 3 [\\\\infty c a d f] ) + {} \\\\\\\\ \\n & {} + \\\
\\frac{1}{2} I_{2, 3}( [b d a c f] \\n + [b d a e c] \\n + [b d a e f] \\n - \
[b d a f c] \\n + [b d a \\\\infty c] \\n + [b d a \\\\infty e] \\n - [b e a \
c f] \\n + [b f a d \\\\infty] \\n - [b f a e \\\\infty] \\n + [b f a \
\\\\infty c] \\n + [c d a e f] \\n + [c e a b \\\\infty] \\n - [c e a d \
\\\\infty] \\n + [c e a \\\\infty f] \\n + 3 [d \\\\infty a b e] \\n - [d \
\\\\infty a e c] \\n + [d \\\\infty a f c] \\n - [e \\\\infty a b f] \\n - [e \
\\\\infty a d b] \\n + [f \\\\infty a b c] \\n + [\\\\infty b a d c] \\n - 3 \
[\\\\infty b a e c] \\n + [\\\\infty c a b d] \\n + [\\\\infty c a d f] ) + \
{} \\\\\\\\ \\n & {} + I_{2, 3}( [b d a c e] \\n - [b e a \\\\infty c] \\n + \
[c d a \\\\infty e] \\n + [d \\\\infty a b c] \\n + [d \\\\infty a b f] \\n - \
[d \\\\infty a e f] \\n - [e \\\\infty a b c] \\n + [e \\\\infty a c f] \\n + \
[e \\\\infty a d c] \\n + [f \\\\infty a e b] \\n - [\\\\infty b a c e] \\n + \
[\\\\infty b a d e] \\n + [\\\\infty b a d f] \\n + [\\\\infty b a f c] \\n + \
2 [\\\\infty c a d e] ) + {} \\\\\\\\ \\n & {} + I_{1, 4}( [b d a e f] \\n + \
[e \\\\infty a c f] \\n + [\\\\infty b a d e] \\n - [\\\\infty b a e f] \\n + \
[\\\\infty b a f c] ) + {} \\\\\\\\ \\n & {} + \\\\frac{1}{2} I_{1, 4}( 3 [b \
d a c e] \\n - [b d a f c] \\n - [b e a c f] \\n + [b e a d \\\\infty] \\n + \
[b f a d e] \\n - 3 [b f a e \\\\infty] \\n - [c d a b \\\\infty] \\n + [c d \
a e f] \\n + [c e a b d] \\n - 3 [c e a d \\\\infty] \\n + 3 [d \\\\infty a b \
c] \\n + 3 [d \\\\infty a b e] \\n - 3 [d \\\\infty a e f] \\n + [d \\\\infty \
a f c] \\n - 3 [e \\\\infty a b c] \\n - [e \\\\infty a b d] \\n + [f \
\\\\infty a b c] \\n - [f \\\\infty a d e] \\n - 3 [\\\\infty b a c e] \\n + \
[\\\\infty b a c f] \\n + 3 [\\\\infty b a d c] \\n - 3 [\\\\infty b a e c] \
\\n - [\\\\infty c a b d] \\n + 3 [\\\\infty c a d e] ) + {} \\\\\\\\ \\n & \
{} + I_{5}( -2 [a b f \\\\infty] \\n + 2 [a c b e] \\n - 4 [a c e \\\\infty] \
\\n + 2 [a c \\\\infty b] \\n + 2 [a d c e] \\n - 3 [a d \\\\infty b] \\n - 5 \
[a d \\\\infty c] \\n - [a e b d] \\n + 2 [a e b f] \\n - 2 [a e c d] \\n + 3 \
[a e d \\\\infty] \\n - 2 [a e f \\\\infty] \\n + 2 [a e \\\\infty b] \\n - 2 \
[a f d \\\\infty] \\n + [a f e \\\\infty] \\n - 3 [a f \\\\infty b] \\n - [a \
\\\\infty b d] \\n + 2 [a \\\\infty b e] \\n - 3 [a \\\\infty b f] \\n - 2 [a \
\\\\infty c d] \\n - 3 [a \\\\infty c e] ) + {} \\\\\\\\ \\n & {} + \
\\\\frac{1}{2} I_{5}( [a b c d] \\n - [a b c e] \\n - 9 [a b d \\\\infty] \\n \
+ 7 [a b e \\\\infty] \\n - 7 [a c b d] \\n - [a c b f] \\n + [a c d \
\\\\infty] \\n + [a c f \\\\infty] \\n - [a d b e] \\n - [a d b f] \\n - 3 [a \
d e \\\\infty] \\n + [a d f \\\\infty] \\n + 3 [a f b d] \\n - [a f b e] \\n \
+ [a f c d] \\n - [a f c e] )\"\>"], "Output",
 CellChangeTimes->{
  3.697539020727252*^9, 3.697539646926193*^9, 3.697539695026929*^9, 
   3.6975398611906967`*^9, 3.697540025989278*^9, 3.6975406776242237`*^9, 
   3.6975414190902348`*^9, 3.697554851651846*^9, 3.697556828245373*^9, 
   3.6975633501701403`*^9, 3.6975995308324213`*^9, 3.697602615455371*^9, {
   3.69761245338384*^9, 3.6976124755832896`*^9}, 3.697616123869398*^9, 
   3.6976442631915617`*^9, 3.697648052767691*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "now", " ", "apply", " ", "the", " ", "odd", " ", "n", " ", "reduction"}], 
  " ", "*)"}]], "Input",
 CellChangeTimes->{{3.6975269389308*^9, 3.6975269429893723`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"out5OddN", " ", "=", " ", 
   RowBox[{
    RowBox[{"iToCcr", "@", 
     RowBox[{"hToI", "@", 
      RowBox[{"hCrSimp", "@", 
       RowBox[{"Expand", "@", 
        RowBox[{"reduceOdd", "[", "5", "]"}]}]}]}]}], "/.", 
    "wt5VarsToABC"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.697525275693885*^9, 3.697525311397773*^9}, {
   3.69752539230795*^9, 3.697525393331551*^9}, {3.697525544511775*^9, 
   3.697525545311083*^9}, 3.6975255787951097`*^9, {3.697525622691525*^9, 
   3.6975256229473343`*^9}, {3.6975257002509193`*^9, 3.697525748995326*^9}, 
   3.697525938052705*^9, {3.697525982586339*^9, 3.69752604351982*^9}, {
   3.697526219963241*^9, 3.697526222019184*^9}, {3.697527665985228*^9, 
   3.697527666944165*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"out5OddNLower", " ", "=", " ", 
   RowBox[{
    RowBox[{"Select", "[", 
     RowBox[{"out5OddN", ",", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"Position", "[", 
         RowBox[{"#", ",", " ", "a"}], "]"}], "\[NotEqual]", 
        RowBox[{"{", "}"}]}], "&"}]}], "]"}], "/.", "canonicalCR"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.6975261391398783`*^9, 3.6975261859800367`*^9}, {
   3.697526249125107*^9, 3.697526250466311*^9}, {3.697526309865019*^9, 
   3.697526310792336*^9}, {3.697527670455904*^9, 3.697527670928276*^9}, 
   3.6975568226308184`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"out5OddN", " ", "-", 
    RowBox[{"(", 
     RowBox[{"out5OddNLower", " ", "-", " ", 
      RowBox[{"(", 
       RowBox[{"out5OddNLower", "/.", 
        RowBox[{"a", "\[Rule]", "g"}]}], ")"}]}], ")"}]}], "/.", 
   "canonicalCR"}], "//", "Expand"}]], "Input",
 CellChangeTimes->{{3.6975264039387827`*^9, 3.6975264069864473`*^9}, {
   3.697527673904818*^9, 3.697527675735983*^9}, 3.697556830090645*^9, {
   3.697616123150642*^9, 3.6976161322839203`*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.697526407599947*^9, 3.6975269448462477`*^9, 3.697527676410205*^9, 
   3.6975277854547443`*^9, 3.697532463958506*^9, 3.697535074979974*^9, 
   3.6975406896967688`*^9, 3.697554851917474*^9, {3.6975568286360016`*^9, 
   3.697556830982767*^9}, 3.697563350279499*^9, 3.6975995309105635`*^9, 
   3.6976026155803585`*^9, {3.6976124534932127`*^9, 3.697612475677026*^9}, {
   3.697616124307659*^9, 3.697616132549549*^9}, 3.6976442634157324`*^9, 
   3.697648052973832*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "[", "out5OddNLower", "]"}]], "Input",
 CellChangeTimes->{{3.697526048280281*^9, 3.6975260511518707`*^9}, {
  3.697526298648799*^9, 3.6975262990671797`*^9}, {3.697556534764338*^9, 
  3.6975565453841853`*^9}}],

Cell[BoxData["113"], "Output",
 CellChangeTimes->{
  3.697526051854006*^9, 3.697526243500636*^9, {3.697526304127879*^9, 
   3.697526311582303*^9}, 3.6975269517362213`*^9, 3.697527693108122*^9, 
   3.697527785654913*^9, 3.6975324659756107`*^9, 3.6975350758602247`*^9, 
   3.697540689703474*^9, 3.697554851948724*^9, {3.6975565360768476`*^9, 
   3.6975565458998356`*^9}, 3.6975568319202757`*^9, 3.697563350295124*^9, 
   3.6975995309261847`*^9, 3.6976026156116085`*^9, {3.697612453508837*^9, 
   3.697612475677026*^9}, {3.6976161251045427`*^9, 3.6976161331120553`*^9}, 
   3.6976442634527583`*^9, 3.697648053004854*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"wt5DanOddNPrecomputed", "  ", "==", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"in5Polylog", " ", "-", " ", 
       RowBox[{"(", 
        RowBox[{"out5OddNLower", " ", "-", " ", 
         RowBox[{"(", 
          RowBox[{"out5OddNLower", "/.", 
           RowBox[{"a", "\[Rule]", "g"}]}], ")"}]}], ")"}]}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", "\[Rule]", "0"}], ",", 
        RowBox[{"g", "\[Rule]", "1"}]}], "}"}]}], "/.", "canonicalCR"}], "//",
     "Expand"}], ")"}]}]], "Input",
 CellChangeTimes->{{3.6975421131424513`*^9, 3.697542116530246*^9}, 
   3.697556840086152*^9, {3.697559774879486*^9, 3.697559775115117*^9}, {
   3.6976026166116376`*^9, 3.697602630449067*^9}, {3.697612488823577*^9, 
   3.6976124891516857`*^9}}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{{3.6976026256779466`*^9, 3.697602630761551*^9}, {
   3.697612453508837*^9, 3.697612475692663*^9}, {3.697616125824938*^9, 
   3.6976161335824194`*^9}, 3.6976442634887714`*^9, 3.6976480530368767`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"out5OddNLowerGathered", " ", "=", " ", 
   RowBox[{"gatherIntegrals", "[", "out5OddNLower", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.670915222347866*^9, 3.670915289663663*^9}, {
  3.670915332846138*^9, 3.67091535581328*^9}, {3.670916219945907*^9, 
  3.670916221082815*^9}, {3.670916333281445*^9, 3.670916344666979*^9}, {
  3.6709189674655952`*^9, 3.670919042204668*^9}, {3.6709258128572893`*^9, 
  3.670925813211691*^9}, {3.67118350918089*^9, 3.671183531116184*^9}, {
  3.671183581222713*^9, 3.6711835985946093`*^9}, {3.671185477981173*^9, 
  3.671185488930788*^9}, {3.6711866229772873`*^9, 3.671186625444181*^9}, {
  3.697526489797328*^9, 3.69752652016094*^9}, {3.697526563194475*^9, 
  3.6975266037261*^9}, {3.697526670126646*^9, 3.697526734427701*^9}, {
  3.697526796050971*^9, 3.697526882791471*^9}, {3.697527708694839*^9, 
  3.697527715102789*^9}, {3.6975277540701838`*^9, 3.6975277717739773`*^9}, {
  3.697531057846198*^9, 3.697531071804587*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"countIntegrals", "[", "out5OddNLowerGathered", "]"}], 
  ";"}]], "Input",
 CellChangeTimes->{
  3.697526887879635*^9, {3.697526977513122*^9, 3.69752700992336*^9}, 
   3.6975311271401253`*^9, {3.697531186249144*^9, 3.697531197064547*^9}}],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{"{", 
      RowBox[{"6", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "d", ",", "a", ",", "c", ",", "e", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"2", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "d", ",", "a", ",", "Inf", ",", "e", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "d", ",", "Inf", ",", "a", ",", "b", ",", "e", ",", "f"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "d", ",", "Inf", ",", "a", ",", "c", ",", "e", ",", "f"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "Inf", ",", "b", ",", "a", ",", "c", ",", "e", ",", "f"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "Inf", ",", "b", ",", "a", ",", "d", ",", "e", ",", "f"}], 
              "}"}], "]"}], "}"}]}], "]"}]}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"7", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "b", ",", "d", ",", "a", ",", "Inf", ",", "e", ",", "f"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "d", ",", "Inf", ",", "a", ",", "b", ",", "e", ",", "f"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "d", ",", "Inf", ",", "a", ",", "c", ",", "b", ",", "f"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "f", ",", "Inf", ",", "a", ",", "c", ",", "e", ",", "b"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "f", ",", "Inf", ",", "a", ",", "d", ",", "e", ",", "b"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "Inf", ",", "b", ",", "a", ",", "c", ",", "d", ",", "f"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "2", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "Inf", ",", "b", ",", "a", ",", "c", ",", "e", ",", "f"}], 
              "}"}], "]"}], "}"}]}], "]"}]}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"7", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "1", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "b", ",", "d", ",", "a", ",", "Inf", ",", "e", ",", "f"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "f", ",", "a", ",", "c", ",", "e", ",", "Inf"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "1", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "b", ",", "f", ",", "a", ",", "d", ",", "e", ",", "Inf"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "1", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "d", ",", "Inf", ",", "a", ",", "b", ",", "e", ",", "f"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "1", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "d", ",", "Inf", ",", "a", ",", "c", ",", "b", ",", "e"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "1", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "Inf", ",", "b", ",", "a", ",", "c", ",", "d", ",", "e"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "1", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "Inf", ",", "b", ",", "a", ",", "d", ",", "e", ",", "f"}], 
              "}"}], "]"}], "}"}]}], "]"}]}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"6", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "d", ",", "a", ",", "c", ",", "Inf", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "3", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "d", ",", "Inf", ",", "a", ",", "b", ",", "e", ",", "f"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "3", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "f", ",", "Inf", ",", "a", ",", "c", ",", "d", ",", "b"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "f", ",", "Inf", ",", "a", ",", "d", ",", "e", ",", "b"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "3", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "Inf", ",", "b", ",", "a", ",", "c", ",", "d", ",", "f"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "3", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "d", ",", "e", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}]}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"5", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "d", ",", "a", ",", "c", ",", "Inf", ",", "e"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "f", ",", "a", ",", "c", ",", "d", ",", "Inf"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "b", ",", "f", ",", "a", ",", "d", ",", "e", ",", "Inf"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "d", ",", "Inf", ",", "a", ",", "b", ",", "e", ",", "f"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "2", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "f", ",", "Inf", ",", "a", ",", "d", ",", "e", ",", "b"}], 
               "}"}], "]"}], "}"}]}], "]"}]}]}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"6", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "f", ",", "a", ",", "c", ",", "d", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"2", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "f", ",", "a", ",", "d", ",", "e", ",", "Inf"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "1", ",", "3"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "d", ",", "Inf", ",", "a", ",", "b", ",", "e", ",", "f"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "1", ",", "3"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "f", ",", "Inf", ",", "a", ",", "c", ",", "d", ",", "e"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "1", ",", "3"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "Inf", ",", "b", ",", "a", ",", "c", ",", "d", ",", "e"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "1", ",", "3"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "Inf", ",", "b", ",", "a", ",", "d", ",", "e", ",", "f"}], 
              "}"}], "]"}], "}"}]}], "]"}]}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"11", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"4", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"b", ",", "d", ",", "a", ",", "c", ",", "f"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "e", ",", "f"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "3"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "Inf", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "3"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "b", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "c", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"4", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"d", ",", "Inf", ",", "a", ",", "e", ",", "f"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "Inf", ",", "a", ",", "c", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"3", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "Inf", ",", "a", ",", "d", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "3"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "Inf", ",", "a", ",", "e", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "c", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"4", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "e", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}]}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"17", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"b", ",", "d", ",", "a", ",", "c", ",", "e"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "e", ",", "f"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "Inf", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "Inf", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"b", ",", "f", ",", "a", ",", "c", ",", "Inf"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "a", ",", "d", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"b", ",", "f", ",", "a", ",", "e", ",", "Inf"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "b", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "b", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "c", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"d", ",", "Inf", ",", "a", ",", "e", ",", "f"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"f", ",", "Inf", ",", "a", ",", "d", ",", "b"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "Inf", ",", "a", ",", "e", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "c", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "d", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "d", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "e", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}]}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"17", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "e", ",", "f"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "Inf", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "3"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"b", ",", "f", ",", "a", ",", "c", ",", "e"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "a", ",", "d", ",", "e"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "a", ",", "d", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"2", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "a", ",", "e", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "b", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "b", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "c", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "3"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"d", ",", "Inf", ",", "a", ",", "e", ",", "f"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "Inf", ",", "a", ",", "c", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"2", ",", "3"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"f", ",", "Inf", ",", "a", ",", "d", ",", "e"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "Inf", ",", "a", ",", "e", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "c", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "c", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "d", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"2", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "d", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}]}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"11", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "4"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"b", ",", "d", ",", "a", ",", "c", ",", "Inf"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "e", ",", "f"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "4"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"b", ",", "f", ",", "a", ",", "c", ",", "d"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"-", "3"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "a", ",", "d", ",", "e"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"3", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "a", ",", "e", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "3"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "b", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "4"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"d", ",", "Inf", ",", "a", ",", "e", ",", "f"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "Inf", ",", "a", ",", "c", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"3", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "Inf", ",", "a", ",", "d", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "4"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "c", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "4"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"Inf", ",", "b", ",", "a", ",", "e", ",", "f"}], "}"}], 
             "]"}], "}"}]}], "]"}]}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"20", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"6", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "b", ",", "d", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", "5", "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"a", ",", "b", ",", "f", ",", "Inf"}], "}"}], "]"}], 
            "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "c", ",", "b", ",", "d"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "c", ",", "b", ",", "f"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", "5", "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"a", ",", "c", ",", "d", ",", "Inf"}], "}"}], "]"}], 
            "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", "5", "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"a", ",", "c", ",", "f", ",", "Inf"}], "}"}], "]"}], 
            "}"}]}], "]"}], ",", 
         RowBox[{"2", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "c", ",", "Inf", ",", "b"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"4", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "d", ",", "b", ",", "f"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "4"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "d", ",", "f", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"2", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "d", ",", "Inf", ",", "b"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"4", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "e", ",", "b", ",", "d"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "6"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "e", ",", "b", ",", "f"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "4"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "e", ",", "d", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"6", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "e", ",", "f", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"2", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "e", ",", "Inf", ",", "b"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "f", ",", "b", ",", "d"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", "5", "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"a", ",", "f", ",", "d", ",", "Inf"}], "}"}], "]"}], 
            "}"}]}], "]"}], ",", 
         RowBox[{"2", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "f", ",", "Inf", ",", "b"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"4", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "Inf", ",", "b", ",", "d"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"4", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "Inf", ",", "b", ",", "f"}], "}"}], "]"}], 
             "}"}]}], "]"}]}]}], "}"}]}], "}"}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  ColumnForm[{{6, {-$CellContext`IIi[{3, 1, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`c, $CellContext`e, $CellContext`f}]}], 
      2 $CellContext`IIi[{3, 1, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`e, $CellContext`f}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`e, $CellContext`f}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`c, $CellContext`e, $CellContext`f}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`c, $CellContext`e, $CellContext`f}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`e, $CellContext`f}]}]}}, {7, {
      $CellContext`IIi[{2, 2, 1}, {
        $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`e, $CellContext`f}]}], 
      $CellContext`IIi[{2, 2, 1}, {
        $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`e, $CellContext`f}]}], 
      $CellContext`IIi[{2, 2, 1}, {
        $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`c, $CellContext`b, $CellContext`f}]}], 
      $CellContext`IIi[{2, 2, 1}, {
        $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`c, $CellContext`e, $CellContext`b}]}], -$CellContext`IIi[{2, 2, 
        1}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`d, $CellContext`e, $CellContext`b}]}], 
      $CellContext`IIi[{2, 2, 1}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`c, $CellContext`d, $CellContext`f}]}], 
      $CellContext`IIi[{2, 2, 1}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`c, $CellContext`e, $CellContext`f}]}]}}, {7, {
      $CellContext`IIi[{2, 1, 2}, {
        $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`e, $CellContext`f}]}], -$CellContext`IIi[{2, 1,
         2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`c, $CellContext`e, $CellContext`Inf}]}], 
      $CellContext`IIi[{2, 1, 2}, {
        $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`d, $CellContext`e, $CellContext`Inf}]}], 
      $CellContext`IIi[{2, 1, 2}, {
        $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`e, $CellContext`f}]}], 
      $CellContext`IIi[{2, 1, 2}, {
        $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`c, $CellContext`b, $CellContext`e}]}], 
      $CellContext`IIi[{2, 1, 2}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`c, $CellContext`d, $CellContext`e}]}], 
      $CellContext`IIi[{2, 1, 2}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`e, $CellContext`f}]}]}}, {
    6, {-$CellContext`IIi[{1, 3, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`c, $CellContext`Inf, $CellContext`f}]}], 
      $CellContext`IIi[{1, 3, 1}, {
        $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`e, $CellContext`f}]}], 
      $CellContext`IIi[{1, 3, 1}, {
        $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`c, $CellContext`d, $CellContext`b}]}], (-2) $CellContext`IIi[{1, 
        3, 1}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`d, $CellContext`e, $CellContext`b}]}], 
      $CellContext`IIi[{1, 3, 1}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`c, $CellContext`d, $CellContext`f}]}], -$CellContext`IIi[{1, 3, 
        1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`e, $CellContext`f}]}]}}, {
    5, {-$CellContext`IIi[{1, 2, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`c, $CellContext`Inf, $CellContext`e}]}], -$CellContext`IIi[{1, 2,
         2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`c, $CellContext`d, $CellContext`Inf}]}], 
      $CellContext`IIi[{1, 2, 2}, {
        $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`d, $CellContext`e, $CellContext`Inf}]}], 
      $CellContext`IIi[{1, 2, 2}, {
        $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`e, $CellContext`f}]}], -$CellContext`IIi[{1, 2, 
        2}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`d, $CellContext`e, $CellContext`b}]}]}}, {
    6, {-$CellContext`IIi[{1, 1, 3}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`c, $CellContext`d, $CellContext`e}]}], 
      2 $CellContext`IIi[{1, 1, 3}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`d, $CellContext`e, $CellContext`Inf}]}], 
      $CellContext`IIi[{1, 1, 3}, {
        $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`e, $CellContext`f}]}], 
      $CellContext`IIi[{1, 1, 3}, {
        $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`c, $CellContext`d, $CellContext`e}]}], 
      $CellContext`IIi[{1, 1, 3}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`c, $CellContext`d, $CellContext`e}]}], 
      $CellContext`IIi[{1, 1, 3}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`e, $CellContext`f}]}]}}, {11, {
      $CellContext`IIi[{4, 1}, {
        $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`c, $CellContext`f}]}], -$CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`e, $CellContext`f}]}], (-3) $CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`f}]}], (-3) $CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`f}]}], -$CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`c, $CellContext`f}]}], 
      $CellContext`IIi[{4, 1}, {
        $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`e, $CellContext`f}]}], -$CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`c, $CellContext`b}]}], 3 $CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`d, $CellContext`b}]}], (-3) $CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`e, $CellContext`b}]}], (-2) $CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`c, $CellContext`f}]}], (-2) $CellContext`IIi[{4, 1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`e, $CellContext`f}]}]}}, {17, {
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`c, $CellContext`e}]}], -$CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`e, $CellContext`f}]}], (-2) $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`e}]}], -$CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`f}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`c, $CellContext`Inf}]}], (-2) $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`d, $CellContext`Inf}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`e, $CellContext`Inf}]}], -$CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`e}]}], (-2) $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`f}]}], -$CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`c, $CellContext`e}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`e, $CellContext`f}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`d, $CellContext`b}]}], (-2) $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`e, $CellContext`b}]}], -$CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`c, $CellContext`e}]}], -$CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`e}]}], -$CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`f}]}], -$CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`e, $CellContext`f}]}]}}, {17, {-$CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`e, $CellContext`f}]}], (-2) $CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`e}]}], 
      $CellContext`IIi[{2, 3}, {
        $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`c, $CellContext`e}]}], -$CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`d, $CellContext`e}]}], (-2) $CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`d, $CellContext`Inf}]}], 2 $CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`e, $CellContext`Inf}]}], (-2) $CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`e}]}], -$CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`f}]}], -$CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`c, $CellContext`b}]}], 
      $CellContext`IIi[{2, 3}, {
        $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`e, $CellContext`f}]}], -$CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`c, $CellContext`e}]}], 
      $CellContext`IIi[{2, 3}, {
        $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`d, $CellContext`e}]}], -$CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`e, $CellContext`b}]}], -$CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`c, $CellContext`d}]}], -$CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`c, $CellContext`e}]}], -$CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`e}]}], -$CellContext`IIi[{2, 3}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`f}]}]}}, {11, {
      $CellContext`IIi[{1, 4}, {
        $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`c, $CellContext`Inf}]}], -$CellContext`IIi[{1, 4}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`e, $CellContext`f}]}], 
      $CellContext`IIi[{1, 4}, {
        $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`c, $CellContext`d}]}], (-3) $CellContext`IIi[{1, 4}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`d, $CellContext`e}]}], 3 $CellContext`IIi[{1, 4}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`e, $CellContext`Inf}]}], (-3) $CellContext`IIi[{1, 4}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`e}]}], 
      $CellContext`IIi[{1, 4}, {
        $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`e, $CellContext`f}]}], -$CellContext`IIi[{1, 4}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`c, $CellContext`d}]}], 3 $CellContext`IIi[{1, 4}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`d, $CellContext`e}]}], -$CellContext`IIi[{1, 4}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`c, $CellContext`d}]}], 
      $CellContext`IIi[{1, 4}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`e, $CellContext`f}]}]}}, {20, {6 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`b, $CellContext`d, \
$CellContext`Inf}]}], 
      $CellContext`IIi[{5}, {
        $CellContext`cri[{$CellContext`a, $CellContext`b, $CellContext`f, \
$CellContext`Inf}]}], -$CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`c, $CellContext`b, \
$CellContext`d}]}], -$CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`c, $CellContext`b, \
$CellContext`f}]}], 
      $CellContext`IIi[{5}, {
        $CellContext`cri[{$CellContext`a, $CellContext`c, $CellContext`d, \
$CellContext`Inf}]}], 
      $CellContext`IIi[{5}, {
        $CellContext`cri[{$CellContext`a, $CellContext`c, $CellContext`f, \
$CellContext`Inf}]}], 2 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`c, $CellContext`Inf, \
$CellContext`b}]}], 4 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`d, $CellContext`b, \
$CellContext`f}]}], (-4) $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`d, $CellContext`f, \
$CellContext`Inf}]}], 2 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`d, $CellContext`Inf, \
$CellContext`b}]}], 4 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`e, $CellContext`b, \
$CellContext`d}]}], (-6) $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`e, $CellContext`b, \
$CellContext`f}]}], (-4) $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`e, $CellContext`d, \
$CellContext`Inf}]}], 6 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`e, $CellContext`f, \
$CellContext`Inf}]}], 2 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`e, $CellContext`Inf, \
$CellContext`b}]}], -$CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`f, $CellContext`b, \
$CellContext`d}]}], 
      $CellContext`IIi[{5}, {
        $CellContext`cri[{$CellContext`a, $CellContext`f, $CellContext`d, \
$CellContext`Inf}]}], 2 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`f, $CellContext`Inf, \
$CellContext`b}]}], 4 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`Inf, $CellContext`b, \
$CellContext`d}]}], 4 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`Inf, $CellContext`b, \
$CellContext`f}]}]}}}],
  Editable->False]], "Print",
 CellChangeTimes->{3.697612475739526*^9, 3.6976161355674796`*^9, 
  3.6976442636028643`*^9, 3.697648053119935*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"texCountIntegrals", "[", "out5OddNLowerGathered", "]"}]], "Input",
 CellChangeTimes->{{3.69753120376591*^9, 3.697531213888858*^9}}],

Cell[BoxData["\<\"Integral & Number in expression \\\\\\\\ \\n$ I_{3, 1, 1} $ \
& 6 \\\\\\\\ \\n$ I_{2, 2, 1} $ & 7 \\\\\\\\ \\n$ I_{2, 1, 2} $ & 7 \\\\\\\\ \
\\n$ I_{1, 3, 1} $ & 6 \\\\\\\\ \\n$ I_{1, 2, 2} $ & 5 \\\\\\\\ \\n$ I_{1, 1, \
3} $ & 6 \\\\\\\\ \\n$ I_{4, 1} $ & 11 \\\\\\\\ \\n$ I_{3, 2} $ & 17 \\\\\\\\ \
\\n$ I_{2, 3} $ & 17 \\\\\\\\ \\n$ I_{1, 4} $ & 11 \\\\\\\\ \\n$ I_{5} $ & 20 \
\\\\\\\\ \\nTotal & 113\"\>"], "Output",
 CellChangeTimes->{
  3.697531214131105*^9, 3.6975340220278587`*^9, 3.697535111166356*^9, 
   3.697540690117272*^9, 3.697541496818494*^9, 3.69755485218449*^9, 
   3.6975569039916673`*^9, 3.697563350388893*^9, 3.697599531004315*^9, 
   3.697602634106586*^9, {3.6976124535869646`*^9, 3.697612475739526*^9}, 
   3.6976161365220404`*^9, 3.697644263641893*^9, 3.6976480531549597`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"texIntegrals", "[", "out5OddNLower", "]"}]], "Input",
 CellChangeTimes->{{3.69753150858425*^9, 3.697531521678891*^9}, 
   3.6975400492795*^9}],

Cell[BoxData["\<\"I_{3, 1, 1}( -[b d a c e f] \\n + 2 [b d a \\\\infty e f] \
\\n + [d \\\\infty a b e f] \\n + [d \\\\infty a c e f] \\n + [\\\\infty b a \
c e f] \\n + [\\\\infty b a d e f] ) + {} \\\\\\\\ \\n & {} + I_{2, 2, 1}( [b \
d a \\\\infty e f] \\n + [d \\\\infty a b e f] \\n + [d \\\\infty a c b f] \
\\n + [f \\\\infty a c e b] \\n - [f \\\\infty a d e b] \\n + [\\\\infty b a \
c d f] \\n + [\\\\infty b a c e f] ) + {} \\\\\\\\ \\n & {} + I_{2, 1, 2}( [b \
d a \\\\infty e f] \\n - [b f a c e \\\\infty] \\n + [b f a d e \\\\infty] \
\\n + [d \\\\infty a b e f] \\n + [d \\\\infty a c b e] \\n + [\\\\infty b a \
c d e] \\n + [\\\\infty b a d e f] ) + {} \\\\\\\\ \\n & {} + I_{1, 3, 1}( \
-[b d a c \\\\infty f] \\n + [d \\\\infty a b e f] \\n + [f \\\\infty a c d \
b] \\n - 2 [f \\\\infty a d e b] \\n + [\\\\infty b a c d f] \\n - [\\\\infty \
b a d e f] ) + {} \\\\\\\\ \\n & {} + I_{1, 2, 2}( -[b d a c \\\\infty e] \\n \
- [b f a c d \\\\infty] \\n + [b f a d e \\\\infty] \\n + [d \\\\infty a b e \
f] \\n - [f \\\\infty a d e b] ) + {} \\\\\\\\ \\n & {} + I_{1, 1, 3}( -[b f \
a c d e] \\n + 2 [b f a d e \\\\infty] \\n + [d \\\\infty a b e f] \\n + [f \
\\\\infty a c d e] \\n + [\\\\infty b a c d e] \\n + [\\\\infty b a d e f] ) \
+ {} \\\\\\\\ \\n & {} + I_{4, 1}( [b d a c f] \\n - [b d a e f] \\n - 3 [b d \
a \\\\infty f] \\n - 3 [d \\\\infty a b f] \\n - [d \\\\infty a c f] \\n + [d \
\\\\infty a e f] \\n - [f \\\\infty a c b] \\n + 3 [f \\\\infty a d b] \\n - \
3 [f \\\\infty a e b] \\n - 2 [\\\\infty b a c f] \\n - 2 [\\\\infty b a e f] \
) + {} \\\\\\\\ \\n & {} + I_{3, 2}( [b d a c e] \\n - [b d a e f] \\n - 2 [b \
d a \\\\infty e] \\n - [b d a \\\\infty f] \\n + [b f a c \\\\infty] \\n - 2 \
[b f a d \\\\infty] \\n + [b f a e \\\\infty] \\n - [d \\\\infty a b e] \\n - \
2 [d \\\\infty a b f] \\n - [d \\\\infty a c e] \\n + [d \\\\infty a e f] \\n \
+ [f \\\\infty a d b] \\n - 2 [f \\\\infty a e b] \\n - [\\\\infty b a c e] \
\\n - [\\\\infty b a d e] \\n - [\\\\infty b a d f] \\n - [\\\\infty b a e f] \
) + {} \\\\\\\\ \\n & {} + I_{2, 3}( -[b d a e f] \\n - 2 [b d a \\\\infty e] \
\\n + [b f a c e] \\n - [b f a d e] \\n - 2 [b f a d \\\\infty] \\n + 2 [b f \
a e \\\\infty] \\n - 2 [d \\\\infty a b e] \\n - [d \\\\infty a b f] \\n - [d \
\\\\infty a c b] \\n + [d \\\\infty a e f] \\n - [f \\\\infty a c e] \\n + [f \
\\\\infty a d e] \\n - [f \\\\infty a e b] \\n - [\\\\infty b a c d] \\n - \
[\\\\infty b a c e] \\n - [\\\\infty b a d e] \\n - [\\\\infty b a d f] ) + \
{} \\\\\\\\ \\n & {} + I_{1, 4}( [b d a c \\\\infty] \\n - [b d a e f] \\n + \
[b f a c d] \\n - 3 [b f a d e] \\n + 3 [b f a e \\\\infty] \\n - 3 [d \
\\\\infty a b e] \\n + [d \\\\infty a e f] \\n - [f \\\\infty a c d] \\n + 3 \
[f \\\\infty a d e] \\n - [\\\\infty b a c d] \\n + [\\\\infty b a e f] ) + \
{} \\\\\\\\ \\n & {} + I_{5}( 6 [a b d \\\\infty] \\n + [a b f \\\\infty] \\n \
- [a c b d] \\n - [a c b f] \\n + [a c d \\\\infty] \\n + [a c f \\\\infty] \
\\n + 2 [a c \\\\infty b] \\n + 4 [a d b f] \\n - 4 [a d f \\\\infty] \\n + 2 \
[a d \\\\infty b] \\n + 4 [a e b d] \\n - 6 [a e b f] \\n - 4 [a e d \
\\\\infty] \\n + 6 [a e f \\\\infty] \\n + 2 [a e \\\\infty b] \\n - [a f b \
d] \\n + [a f d \\\\infty] \\n + 2 [a f \\\\infty b] \\n + 4 [a \\\\infty b \
d] \\n + 4 [a \\\\infty b f] )\"\>"], "Output",
 CellChangeTimes->{{3.6975315227873297`*^9, 3.6975315464446373`*^9}, 
   3.697534024340219*^9, 3.697535113320058*^9, 3.697540050365181*^9, 
   3.6975406909137497`*^9, 3.697541497958569*^9, 3.6975548544826546`*^9, 
   3.697556907980155*^9, 3.697563351092588*^9, 3.697599534538522*^9, 
   3.6976026359041204`*^9, {3.697612453631729*^9, 3.6976124764588804`*^9}, 
   3.6976161380070267`*^9, 3.697644264330385*^9, 3.697648053826426*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{
   "Now", " ", "we", " ", "use", " ", "some", " ", "identities", " ", "to", 
    " ", "write", " ", "everything", " ", "in", " ", "terms", " ", "of", " ", 
    "I311"}], ",", " ", 
   RowBox[{"I32", " ", "and", " ", "I5"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.697529025044095*^9, 3.6975290390957727`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Get", "[", 
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
    "\"\<wt5_rules_to_i311_i32_i5.m\>\""}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.6975995688855553`*^9, 3.697599593032262*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"texRuleByCoeff", "[", "rule41to32", "]"}]], "Input",
 CellChangeTimes->{{3.697533168654767*^9, 3.6975332150532827`*^9}, {
  3.697533285979505*^9, 3.697533290459104*^9}, {3.697533721440003*^9, 
  3.697533744270117*^9}, {3.697535132649744*^9, 3.69753513367642*^9}, {
  3.697540292159876*^9, 3.697540294414844*^9}}],

Cell[BoxData["\<\"I_{4, 1}(a b c d e) & {} = \\\\frac{1}{3} I_{3, 2}( -[a b c \
d e] \\n - [a b c e d] )\"\>"], "Output",
 CellChangeTimes->{{3.697533171635413*^9, 3.697533215363018*^9}, {
   3.697533300515257*^9, 3.697533307945298*^9}, {3.6975333406152573`*^9, 
   3.6975333880920277`*^9}, 3.697533427442638*^9, 3.697533648447213*^9, {
   3.6975337266290493`*^9, 3.6975337445875263`*^9}, 3.69753435852728*^9, {
   3.697535123186822*^9, 3.6975351340025187`*^9}, 3.6975400947845793`*^9, {
   3.697540294889286*^9, 3.697540307098394*^9}, 3.697540705065556*^9, 
   3.697540739068193*^9, 3.697541515017982*^9, 3.6975415557781773`*^9, 
   3.6975548585650387`*^9, 3.6975569186779046`*^9, 3.6975633512331977`*^9, 
   3.6975995953930454`*^9, 3.697602638295951*^9, {3.697612453668228*^9, 
   3.6976124765214005`*^9}, 3.6976161399615936`*^9, 3.697644264519513*^9, 
   3.697648054003561*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"texRuleByCoeff", "[", "rule14to32", "]"}]], "Input",
 CellChangeTimes->{{3.697533787212222*^9, 3.697533798356614*^9}, {
   3.697535135779728*^9, 3.697535136468616*^9}, 3.697540313788288*^9}],

Cell[BoxData["\<\"I_{1, 4}(a b c d e) & {} = \\\\frac{1}{3} I_{3, 2}( -[a b d \
c e] \\n - [a b d e c] ) + {} \\\\\\\\ \\n & {} + I_{5}( -4 [a b c e] \\n - \
[a b d e] )\"\>"], "Output",
 CellChangeTimes->{{3.6975337897078733`*^9, 3.6975337986814423`*^9}, 
   3.69753435948752*^9, 3.697535136773245*^9, 3.697540314495534*^9, 
   3.6975407406765003`*^9, 3.697541515108055*^9, 3.697541555866744*^9, 
   3.6975548609194374`*^9, 3.697556918834156*^9, 3.6975633512644477`*^9, 
   3.6975995960039005`*^9, 3.6976026388272247`*^9, {3.697612453715104*^9, 
   3.697612476552635*^9}, 3.697616140633462*^9, 3.697644264558542*^9, 
   3.697648054042588*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"texRule", "[", "rule23to32", "]"}]], "Input",
 CellChangeTimes->{{3.6975338102513113`*^9, 3.697533813219574*^9}}],

Cell[BoxData["\<\"I_{2, 3}(a b c d e) & {} = I_{3, 2}( -[b a d c e] ) + {} \\\
\\\\\\ \\n & {} + I_{5}( [a b c d] )\"\>"], "Output",
 CellChangeTimes->{
  3.697533813492608*^9, 3.6975343609547977`*^9, 3.697535138708061*^9, 
   3.697540321731565*^9, 3.697540741624073*^9, 3.6975415151696863`*^9, 
   3.6975415559373913`*^9, 3.697554861546013*^9, 3.697556918959159*^9, 
   3.697563351295698*^9, 3.6975995967226553`*^9, 3.6976026409072394`*^9, {
   3.697612453730729*^9, 3.6976124765838814`*^9}, 3.6976161411661606`*^9, 
   3.6976442645955563`*^9, 3.697648054076615*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"texRule", "[", "rule221to311", "]"}]], "Input",
 CellChangeTimes->{{3.697533823211285*^9, 3.69753382483512*^9}}],

Cell[BoxData["\<\"I_{2, 2, 1}(a b c d e f) & {} = I_{3, 1, 1}( -[a b c d e f] \
\\n - [a b c d f e] \\n - [a b c f d e] \\n - [a b c f e d] )\"\>"], "Output",\

 CellChangeTimes->{
  3.6975338392808228`*^9, 3.697534361684524*^9, 3.697535141771187*^9, 
   3.697540325217535*^9, 3.697540742565435*^9, 3.69754151523946*^9, 
   3.6975415560231133`*^9, 3.697554862046017*^9, 3.697556919068534*^9, 
   3.697563351326949*^9, 3.697599597269539*^9, 3.6976026415166397`*^9, {
   3.697612453730729*^9, 3.697612476630776*^9}, 3.6976161416974*^9, 
   3.6976442646425886`*^9, 3.697648054119629*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"texRule", "[", "rule131to311", "]"}]], "Input",
 CellChangeTimes->{{3.697533840474712*^9, 3.6975338427389193`*^9}}],

Cell[BoxData["\<\"I_{1, 3, 1}(a b c d e f) & {} = I_{3, 1, 1}( [a b c f e d] \
)\"\>"], "Output",
 CellChangeTimes->{
  3.697533843146543*^9, 3.6975340347590933`*^9, 3.697534115664836*^9, 
   3.6975341460376253`*^9, 3.6975343622436533`*^9, 3.697535142130534*^9, 
   3.697540326753566*^9, 3.697540405898048*^9, 3.697540743472879*^9, 
   3.697541515310505*^9, 3.697541556102086*^9, 3.6975548626410723`*^9, 
   3.6975569191310153`*^9, 3.697563351358198*^9, 3.6975995979428396`*^9, 
   3.6976026421260023`*^9, {3.6976124537463646`*^9, 3.6976124766620083`*^9}, 
   3.6976161422286587`*^9, 3.697644264681628*^9, 3.6976480541516542`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"texRuleByCoeff", "[", "rule113to311", "]"}]], "Input",
 CellChangeTimes->{{3.697540753029357*^9, 3.697540756097432*^9}}],

Cell[BoxData["\<\"I_{1, 1, 3}(a b c d e f) & {} = I_{3, 1, 1}( [a b d c f e] \
) + {} \\\\\\\\ \\n & {} + \\\\frac{1}{3} I_{3, 2}( [a b c e f] \\n + [a b e \
c f] \\n + [a b e d f] \\n + [a b e f c] \\n - [b a e f c] \\n - [b a e f d] \
\\n + [b a f e c] ) + {} \\\\\\\\ \\n & {} + I_{5}( 2 [a b d f] ) + {} \\\\\\\
\\ \\n & {} + \\\\frac{1}{3} I_{5}( -4 [a b d e] \\n - 4 [a b e c] \\n + 7 [a \
b e f] \\n + 16 [a b f c] )\"\>"], "Output",
 CellChangeTimes->{
  3.6975407565404863`*^9, 3.697541515438047*^9, 3.697541556235914*^9, 
   3.697554863516081*^9, 3.6975569194122667`*^9, 3.6975633514363422`*^9, 
   3.697599598505344*^9, 3.69760264275179*^9, {3.69761245376198*^9, 
   3.6976124767557793`*^9}, 3.6976161428239093`*^9, 3.697644264770699*^9, {
   3.697648026807434*^9, 3.697648054241726*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"texRule", "[", "rule122to311", "]"}]], "Input",
 CellChangeTimes->{{3.6975344249457407`*^9, 3.697534426233705*^9}, {
  3.697535154356792*^9, 3.6975351625083237`*^9}}],

Cell[BoxData["\<\"I_{1, 2, 2}(a b c d e f) & {} = I_{3, 1, 1}( -[a b c f e d] \
\\n - [a b d c e f] \\n - [a b d c f e] \\n - [a b d e c f] ) + {} \\\\\\\\ \
\\n & {} + I_{3, 2}( -2 [a b c e f] \\n + [a b c f e] \\n - 2 [a b e c f] \\n \
- [a b e f d] \\n - [a b f e d] ) + {} \\\\\\\\ \\n & {} + I_{5}( -12 [a b c \
f] \\n - 6 [a b d e] \\n - 6 [a b d f] \\n - 6 [a b e f] )\"\>"], "Output",
 CellChangeTimes->{
  3.6975344266493998`*^9, {3.697535155183242*^9, 3.697535163043181*^9}, 
   3.6975408583304167`*^9, 3.697541515620864*^9, 3.6975415563610477`*^9, 
   3.6975548645331774`*^9, 3.6975569197091627`*^9, 3.6975633515144672`*^9, 
   3.697599599334879*^9, 3.6976026433611727`*^9, {3.697612453777605*^9, 
   3.6976124768495283`*^9}, 3.6976161434176817`*^9, 3.697644264867767*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"texRule", "[", "rule212to311", "]"}]], "Input",
 CellChangeTimes->{{3.697534427386078*^9, 3.697534433665922*^9}}],

Cell[BoxData["\<\"I_{2, 1, 2}(a b c d e f) & {} = I_{3, 1, 1}( [a b c d f e] \
\\n + [a b c f d e] \\n + [a b c f e d] \\n + [a b d c e f] \\n + [a b d e c \
f] \\n + [a b e d c f] ) + {} \\\\\\\\ \\n & {} + I_{3, 2}( [a b c d f] \\n + \
2 [a b c e f] \\n - [a b c f d] \\n - [a b c f e] \\n + [a b d c f] \\n + [a \
b d e f] \\n + 2 [a b e c f] \\n + [a b e d f] \\n - [a b e f c] ) + {} \
\\\\\\\\ \\n & {} + I_{5}( 12 [a b c f] \\n + 6 [a b d f] \\n + 12 [a b e f] \
)\"\>"], "Output",
 CellChangeTimes->{
  3.697534434718194*^9, 3.697535163980986*^9, 3.69754086000718*^9, 
   3.6975415158110733`*^9, 3.6975415564965343`*^9, 3.697554865423788*^9, 
   3.6975569201323395`*^9, 3.6975633516238427`*^9, 3.697599600381767*^9, 
   3.6976026440180807`*^9, {3.697612453793231*^9, 3.697612476958901*^9}, 
   3.6976161441067095`*^9, 3.6976442649918485`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{
   "Apply", " ", "these", " ", "rules", " ", "to", " ", "write", " ", 
    "I11111", " ", "as", " ", "I311"}], ",", " ", 
   RowBox[{"I32", " ", "and", " ", "I5"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.697529241868978*^9, 3.697529243537937*^9}, {
  3.697556125326988*^9, 3.697556139527169*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"out5OddNLoweras311and32and5", " ", "=", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"out5OddNLower", "/.", 
      RowBox[{"{", 
       RowBox[{
       "rule221to311", ",", "rule212to311", ",", "rule122to311", ",", 
        "rule113to311", ",", "rule131to311", ",", "rule41to32", ",", 
        "rule14to32", ",", "rule23to32"}], "}"}]}], "/.", "canonicalCR"}], "//",
     "Expand"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.671372160128628*^9, 3.671372174663937*^9}, {
   3.6713723371125727`*^9, 3.6713724219982147`*^9}, {3.671372465261487*^9, 
   3.6713724679748373`*^9}, {3.6713726009752693`*^9, 3.671372625813992*^9}, {
   3.6975351977871447`*^9, 3.697535232842347*^9}, 3.697541072905052*^9, {
   3.697542343220536*^9, 3.697542364706523*^9}, {3.6975565765419846`*^9, 
   3.6975566149451275`*^9}, {3.6975569264195986`*^9, 3.697556928717916*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"out5OddNLoweras311and32and5gathered", " ", "=", " ", 
   RowBox[{"gatherIntegrals", "[", "out5OddNLoweras311and32and5", "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.697541078808*^9, 3.697541102903522*^9}, {
  3.697542349764102*^9, 3.697542362019065*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "[", "out5OddNLoweras311and32and5", "]"}]], "Input",
 CellChangeTimes->{{3.697542270714327*^9, 3.697542278373323*^9}, {
  3.697542353489497*^9, 3.697542355754746*^9}}],

Cell[BoxData["242"], "Output",
 CellChangeTimes->{{3.697542274962091*^9, 3.6975422790174093`*^9}, 
   3.697542366093031*^9, 3.697554868114072*^9, 3.6975565877881737`*^9, 
   3.697556934150905*^9, 3.6975633516707015`*^9, 3.697599604495513*^9, 
   3.6976026475818653`*^9, {3.697612453840123*^9, 3.6976124770057735`*^9}, 
   3.697616146529151*^9, 3.6976442651399527`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"wt5DanOddNas311and32and5Precomputed", "  ", "==", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"in5Polylog", " ", "-", " ", 
       RowBox[{"(", 
        RowBox[{"out5OddNLoweras311and32and5", " ", "-", " ", 
         RowBox[{"(", 
          RowBox[{"out5OddNLoweras311and32and5", "/.", 
           RowBox[{"a", "\[Rule]", "g"}]}], ")"}]}], ")"}]}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", "\[Rule]", "0"}], ",", 
        RowBox[{"g", "\[Rule]", "1"}]}], "}"}]}], "/.", "canonicalCR"}], "//",
     "Expand"}], ")"}]}]], "Input",
 CellChangeTimes->{{3.69754229151503*^9, 3.6975423349585238`*^9}, {
   3.697542368989965*^9, 3.6975423825362864`*^9}, 3.697556938421156*^9, {
   3.697559779352412*^9, 3.697559780619249*^9}, {3.6976026488013225`*^9, 
   3.6976026601650906`*^9}, {3.6976027001466837`*^9, 3.697602714340189*^9}, {
   3.697612490667964*^9, 3.6976124910117364`*^9}}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{
  3.697602714996428*^9, {3.6976124538713555`*^9, 3.6976124770214005`*^9}, 
   3.6976161473276033`*^9, 3.697644265176979*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"countIntegrals", "[", "out5OddNLoweras311and32and5gathered", 
  "]"}]], "Input",
 CellChangeTimes->{{3.697541104968307*^9, 3.697541115863147*^9}}],

Cell[BoxData[
 InterpretationBox[GridBox[{
    {
     RowBox[{"{", 
      RowBox[{"69", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "d", ",", "a", ",", "c", ",", "e", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "b", ",", "d", ",", "a", ",", "e", ",", "Inf", ",", "c"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "d", ",", "a", ",", "f", ",", "Inf", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "b", ",", "d", ",", "a", ",", "Inf", ",", "e", ",", "f"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "b", ",", "d", ",", "c", ",", "a", ",", "e", ",", "Inf"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "b", ",", "d", ",", "c", ",", "a", ",", "Inf", ",", "e"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "b", ",", "d", ",", "c", ",", "Inf", ",", "a", ",", "e"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "b", ",", "d", ",", "e", ",", "Inf", ",", "a", ",", "f"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "b", ",", "d", ",", "Inf", ",", "a", ",", "e", ",", "f"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "b", ",", "d", ",", "Inf", ",", "e", ",", "a", ",", "f"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "f", ",", "a", ",", "c", ",", "Inf", ",", "e"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "b", ",", "f", ",", "a", ",", "d", ",", "Inf", ",", "e"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "f", ",", "a", ",", "Inf", ",", "c", ",", "e"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "b", ",", "f", ",", "a", ",", "Inf", ",", "d", ",", "c"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "b", ",", "f", ",", "a", ",", "Inf", ",", "d", ",", "e"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "f", ",", "a", ",", "Inf", ",", "e", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "b", ",", "f", ",", "c", ",", "a", ",", "d", ",", "Inf"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "f", ",", "c", ",", "a", ",", "e", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "f", ",", "c", ",", "a", ",", "e", ",", "Inf"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "b", ",", "f", ",", "c", ",", "a", ",", "Inf", ",", "d"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "b", ",", "f", ",", "c", ",", "d", ",", "a", ",", "Inf"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "f", ",", "c", ",", "e", ",", "a", ",", "Inf"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "b", ",", "f", ",", "d", ",", "a", ",", "Inf", ",", "e"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "b", ",", "f", ",", "e", ",", "c", ",", "a", ",", "Inf"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "b", ",", "f", ",", "e", ",", "d", ",", "a", ",", "Inf"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "d", ",", "Inf", ",", "a", ",", "c", ",", "b", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "d", ",", "Inf", ",", "a", ",", "c", ",", "e", ",", "b"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "d", ",", "Inf", ",", "a", ",", "c", ",", "e", ",", "f"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "d", ",", "Inf", ",", "a", ",", "c", ",", "f", ",", "b"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "d", ",", "Inf", ",", "a", ",", "e", ",", "b", ",", "c"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "d", ",", "Inf", ",", "a", ",", "e", ",", "c", ",", "b"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "d", ",", "Inf", ",", "a", ",", "f", ",", "b", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "d", ",", "Inf", ",", "a", ",", "f", ",", "c", ",", "b"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "d", ",", "Inf", ",", "b", ",", "c", ",", "a", ",", "e"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "d", ",", "Inf", ",", "c", ",", "a", ",", "b", ",", "e"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "d", ",", "Inf", ",", "c", ",", "b", ",", "a", ",", "e"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "d", ",", "Inf", ",", "e", ",", "b", ",", "a", ",", "f"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "f", ",", "Inf", ",", "a", ",", "b", ",", "c", ",", "e"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "f", ",", "Inf", ",", "a", ",", "b", ",", "d", ",", "c"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "f", ",", "Inf", ",", "a", ",", "b", ",", "d", ",", "e"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "f", ",", "Inf", ",", "a", ",", "b", ",", "e", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "f", ",", "Inf", ",", "a", ",", "c", ",", "b", ",", "e"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "f", ",", "Inf", ",", "a", ",", "c", ",", "e", ",", "b"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "f", ",", "Inf", ",", "a", ",", "d", ",", "b", ",", "e"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "f", ",", "Inf", ",", "a", ",", "d", ",", "e", ",", "b"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "f", ",", "Inf", ",", "c", ",", "a", ",", "e", ",", "d"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "f", ",", "Inf", ",", "d", ",", "a", ",", "b", ",", "e"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "f", ",", "Inf", ",", "d", ",", "a", ",", "e", ",", "b"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "f", ",", "Inf", ",", "d", ",", "e", ",", "a", ",", "b"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "c", ",", "d", ",", "f"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "Inf", ",", "b", ",", "a", ",", "c", ",", "e", ",", "d"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "c", ",", "f", ",", "d"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "c", ",", "f", ",", "e"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "Inf", ",", "b", ",", "a", ",", "d", ",", "e", ",", "f"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "Inf", ",", "b", ",", "a", ",", "d", ",", "f", ",", "e"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "Inf", ",", "b", ",", "a", ",", "e", ",", "c", ",", "d"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "Inf", ",", "b", ",", "a", ",", "e", ",", "d", ",", "c"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "f", ",", "c", ",", "d"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "f", ",", "c", ",", "e"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "Inf", ",", "b", ",", "a", ",", "f", ",", "d", ",", "e"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{
               "Inf", ",", "b", ",", "a", ",", "f", ",", "e", ",", "c"}], 
               "}"}], "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "Inf", ",", "b", ",", "c", ",", "a", ",", "d", ",", "e"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "Inf", ",", "b", ",", "c", ",", "a", ",", "e", ",", "d"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "Inf", ",", "b", ",", "c", ",", "d", ",", "a", ",", "e"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "Inf", ",", "b", ",", "d", ",", "a", ",", "e", ",", "f"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "Inf", ",", "b", ",", "d", ",", "a", ",", "f", ",", "e"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "Inf", ",", "b", ",", "d", ",", "c", ",", "a", ",", "e"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "Inf", ",", "b", ",", "d", ",", "e", ",", "a", ",", "f"}], 
              "}"}], "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "1", ",", "1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{
              "Inf", ",", "b", ",", "e", ",", "d", ",", "a", ",", "f"}], 
              "}"}], "]"}], "}"}]}], "]"}]}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"125", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"b", ",", "d", ",", "a", ",", "c", ",", "e"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "c", ",", "f"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["4", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "e", ",", "f"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "e", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "f", ",", "c"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["2", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "a", ",", "f", ",", "e"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"b", ",", "d", ",", "a", ",", "Inf", ",", "f"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "c", ",", "a", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "c", ",", "Inf", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["7", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "e", ",", "a", ",", "f"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["2", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "e", ",", "f", ",", "a"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"b", ",", "d", ",", "e", ",", "Inf", ",", "c"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"b", ",", "d", ",", "e", ",", "Inf", ",", "f"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"2", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "Inf", ",", "a", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"b", ",", "d", ",", "Inf", ",", "a", ",", "f"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"b", ",", "d", ",", "Inf", ",", "e", ",", "c"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"b", ",", "d", ",", "Inf", ",", "e", ",", "f"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "a", ",", "d", ",", "e"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"b", ",", "f", ",", "a", ",", "d", ",", "Inf"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "a", ",", "e", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"b", ",", "f", ",", "a", ",", "Inf", ",", "c"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "a", ",", "Inf", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"b", ",", "f", ",", "a", ",", "Inf", ",", "e"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "c", ",", "a", ",", "d"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "c", ",", "a", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "c", ",", "d", ",", "a"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "c", ",", "e", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["2", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "d", ",", "a", ",", "e"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"3", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "d", ",", "a", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "d", ",", "c", ",", "e"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["2", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "d", ",", "e", ",", "a"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"b", ",", "f", ",", "d", ",", "e", ",", "Inf"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"b", ",", "f", ",", "d", ",", "Inf", ",", "c"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["7", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "e", ",", "a", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "e", ",", "c", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["5", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "e", ",", "d", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "e", ",", "Inf", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "e", ",", "Inf", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"b", ",", "f", ",", "Inf", ",", "d", ",", "c"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "Inf", ",", "e", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"b", ",", "Inf", ",", "c", ",", "a", ",", "d"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"b", ",", "Inf", ",", "c", ",", "a", ",", "e"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"b", ",", "Inf", ",", "d", ",", "a", ",", "e"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"b", ",", "Inf", ",", "d", ",", "a", ",", "f"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "Inf", ",", "d", ",", "e", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "Inf", ",", "d", ",", "e", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "Inf", ",", "e", ",", "d", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "Inf", ",", "e", ",", "f", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "Inf", ",", "e", ",", "f", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "Inf", ",", "f", ",", "e", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"d", ",", "b", ",", "e", ",", "a", ",", "f"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"2", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "b", ",", "Inf", ",", "a", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"d", ",", "Inf", ",", "a", ",", "b", ",", "e"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          FractionBox["1", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "c", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "e", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "e", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"d", ",", "Inf", ",", "a", ",", "e", ",", "f"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          FractionBox["1", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "f", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "a", ",", "f", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"3", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "b", ",", "a", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"d", ",", "Inf", ",", "b", ",", "a", ",", "f"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"d", ",", "Inf", ",", "b", ",", "c", ",", "e"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"d", ",", "Inf", ",", "b", ",", "e", ",", "f"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"d", ",", "Inf", ",", "c", ",", "a", ",", "e"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"d", ",", "Inf", ",", "c", ",", "b", ",", "e"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          FractionBox["4", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "e", ",", "b", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "e", ",", "f", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "e", ",", "f", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "f", ",", "e", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "b", ",", "c", ",", "a", ",", "e"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"f", ",", "b", ",", "d", ",", "a", ",", "e"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"2", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "b", ",", "d", ",", "a", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "b", ",", "d", ",", "e", ",", "a"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "b", ",", "d", ",", "e", ",", "c"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "b", ",", "e", ",", "a", ",", "Inf"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "b", ",", "e", ",", "d", ",", "a"}], "}"}], 
              "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["2", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "b", ",", "e", ",", "Inf", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["2", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "b", ",", "e", ",", "Inf", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["2", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "b", ",", "Inf", ",", "e", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "Inf", ",", "a", ",", "b", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "Inf", ",", "a", ",", "b", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "Inf", ",", "a", ",", "c", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "Inf", ",", "a", ",", "d", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"f", ",", "Inf", ",", "a", ",", "e", ",", "b"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"f", ",", "Inf", ",", "b", ",", "e", ",", "d"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          FractionBox["1", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "Inf", ",", "c", ",", "a", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "Inf", ",", "c", ",", "d", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["2", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "Inf", ",", "d", ",", "a", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "Inf", ",", "d", ",", "c", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["2", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "Inf", ",", "d", ",", "e", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"2", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"f", ",", "Inf", ",", "e", ",", "a", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"f", ",", "Inf", ",", "e", ",", "b", ",", "d"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          FractionBox["2", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "c", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["4", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "d", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "e", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "e", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"2", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "e", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["2", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "f", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "f", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "a", ",", "f", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "c", ",", "a", ",", "d"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"Inf", ",", "b", ",", "c", ",", "a", ",", "e"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          FractionBox["1", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "c", ",", "d", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"Inf", ",", "b", ",", "c", ",", "d", ",", "e"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          FractionBox["7", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "d", ",", "a", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"Inf", ",", "b", ",", "d", ",", "a", ",", "f"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          FractionBox["4", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "d", ",", "c", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["2", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "d", ",", "e", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"Inf", ",", "b", ",", "d", ",", "e", ",", "f"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"2", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "e", ",", "a", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["4", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "e", ",", "d", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "b", ",", "e", ",", "f", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"2", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "d", ",", "b", ",", "a", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"Inf", ",", "d", ",", "b", ",", "a", ",", "f"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"Inf", ",", "d", ",", "c", ",", "a", ",", "b"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "d", ",", "e", ",", "a", ",", "f"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "d", ",", "e", ",", "f", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "d", ",", "e", ",", "f", ",", "b"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["1", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "d", ",", "f", ",", "e", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"Inf", ",", "f", ",", "c", ",", "a", ",", "e"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "f", ",", "d", ",", "a", ",", "e"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "f", ",", "d", ",", "e", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "f", ",", "d", ",", "e", ",", "c"}], "}"}],
               "]"}], "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"3", ",", "2"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"Inf", ",", "f", ",", "e", ",", "a", ",", "b"}], "}"}], 
             "]"}], "}"}]}], "]"}], ",", 
         RowBox[{
          FractionBox["1", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"3", ",", "2"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"Inf", ",", "f", ",", "e", ",", "d", ",", "a"}], "}"}],
               "]"}], "}"}]}], "]"}]}]}], "}"}]}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"48", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"3", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "b", ",", "d", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"13", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "b", ",", "f", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"-", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "c", ",", "b", ",", "d"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "3"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "d", ",", "b", ",", "f"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["4", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "d", ",", "b", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["4", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "d", ",", "f", ",", "b"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"IIi", "[", 
          RowBox[{
           RowBox[{"{", "5", "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"cri", "[", 
             RowBox[{"{", 
              RowBox[{"a", ",", "d", ",", "f", ",", "Inf"}], "}"}], "]"}], 
            "}"}]}], "]"}], ",", 
         RowBox[{"4", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "d", ",", "Inf", ",", "b"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["4", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "d", ",", "Inf", ",", "f"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"15", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "e", ",", "b", ",", "d"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"8", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "e", ",", "b", ",", "f"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"4", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "e", ",", "b", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"21", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "e", ",", "d", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "8"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "e", ",", "f", ",", "b"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "7"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "e", ",", "f", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"14", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "e", ",", "Inf", ",", "b"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["4", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "e", ",", "Inf", ",", "d"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["16", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "e", ",", "Inf", ",", "f"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"15", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "f", ",", "b", ",", "d"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["16", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "f", ",", "b", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "3"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "f", ",", "d", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"10", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "f", ",", "Inf", ",", "b"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["16", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "f", ",", "Inf", ",", "d"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "Inf", ",", "b", ",", "d"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "8"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "Inf", ",", "b", ",", "f"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["32", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"a", ",", "Inf", ",", "f", ",", "b"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"6", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "c", ",", "e"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"5", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "c", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"13", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "e", ",", "f"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"6", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "Inf", ",", "e"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"12", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "d", ",", "Inf", ",", "f"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["23", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "e", ",", "d", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"6", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "e", ",", "Inf", ",", "f"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["19", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "c", ",", "d"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "c", ",", "e"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", "8"}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "d", ",", "e"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"12", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "d", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["13", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "f", ",", "e", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "Inf", ",", "d", ",", "c"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"8", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "Inf", ",", "e", ",", "c"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"13", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "Inf", ",", "e", ",", "d"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"8", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "Inf", ",", "f", ",", "d"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["40", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"b", ",", "Inf", ",", "f", ",", "e"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "3"]}], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "d", ",", "f", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"6", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "e", ",", "d", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{"2", " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"c", ",", "e", ",", "f", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["16", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "e", ",", "f", ",", "Inf"}], "}"}], "]"}], 
             "}"}]}], "]"}]}], ",", 
         RowBox[{
          FractionBox["22", "3"], " ", 
          RowBox[{"IIi", "[", 
           RowBox[{
            RowBox[{"{", "5", "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"cri", "[", 
              RowBox[{"{", 
               RowBox[{"d", ",", "Inf", ",", "e", ",", "f"}], "}"}], "]"}], 
             "}"}]}], "]"}]}]}], "}"}]}], "}"}]}
   },
   BaselinePosition->{Baseline, {1, 1}},
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}}],
  ColumnForm[{{69, {-$CellContext`IIi[{3, 1, 1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`c, $CellContext`e, $CellContext`f}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`e, $CellContext`Inf, $CellContext`c}]}], -$CellContext`IIi[{3, 1,
         1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`f, $CellContext`Inf, $CellContext`c}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`e, $CellContext`f}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`c, \
$CellContext`a, $CellContext`e, $CellContext`Inf}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`c, \
$CellContext`a, $CellContext`Inf, $CellContext`e}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`c, \
$CellContext`Inf, $CellContext`a, $CellContext`e}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`e, \
$CellContext`Inf, $CellContext`a, $CellContext`f}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`Inf, \
$CellContext`a, $CellContext`e, $CellContext`f}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`Inf, \
$CellContext`e, $CellContext`a, $CellContext`f}]}], -$CellContext`IIi[{3, 1, 
        1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`c, $CellContext`Inf, $CellContext`e}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`d, $CellContext`Inf, $CellContext`e}]}], -$CellContext`IIi[{3, 1,
         1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`Inf, $CellContext`c, $CellContext`e}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`Inf, $CellContext`d, $CellContext`c}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`Inf, $CellContext`d, $CellContext`e}]}], -$CellContext`IIi[{3, 1,
         1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`Inf, $CellContext`e, $CellContext`c}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`c, \
$CellContext`a, $CellContext`d, $CellContext`Inf}]}], -$CellContext`IIi[{3, 1,
         1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`c, \
$CellContext`a, $CellContext`e, $CellContext`d}]}], -$CellContext`IIi[{3, 1, 
        1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`c, \
$CellContext`a, $CellContext`e, $CellContext`Inf}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`c, \
$CellContext`a, $CellContext`Inf, $CellContext`d}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`c, \
$CellContext`d, $CellContext`a, $CellContext`Inf}]}], -$CellContext`IIi[{3, 1,
         1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`c, \
$CellContext`e, $CellContext`a, $CellContext`Inf}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`d, \
$CellContext`a, $CellContext`Inf, $CellContext`e}]}], -$CellContext`IIi[{3, 1,
         1}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`e, \
$CellContext`c, $CellContext`a, $CellContext`Inf}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`e, \
$CellContext`d, $CellContext`a, $CellContext`Inf}]}], -$CellContext`IIi[{3, 1,
         1}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`c, $CellContext`b, $CellContext`f}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`c, $CellContext`e, $CellContext`b}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`c, $CellContext`e, $CellContext`f}]}], -$CellContext`IIi[{3, 1, 
        1}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`c, $CellContext`f, $CellContext`b}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`e, $CellContext`b, $CellContext`c}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`e, $CellContext`c, $CellContext`b}]}], -$CellContext`IIi[{3, 1, 
        1}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`f, $CellContext`b, $CellContext`c}]}], -$CellContext`IIi[{3, 1, 
        1}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`f, $CellContext`c, $CellContext`b}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`b, \
$CellContext`c, $CellContext`a, $CellContext`e}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`c, \
$CellContext`a, $CellContext`b, $CellContext`e}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`c, \
$CellContext`b, $CellContext`a, $CellContext`e}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`e, \
$CellContext`b, $CellContext`a, $CellContext`f}]}], -$CellContext`IIi[{3, 1, 
        1}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c, $CellContext`e}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`d, $CellContext`c}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`d, $CellContext`e}]}], -$CellContext`IIi[{3, 1, 
        1}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`e, $CellContext`c}]}], -$CellContext`IIi[{3, 1, 
        1}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`c, $CellContext`b, $CellContext`e}]}], -$CellContext`IIi[{3, 1, 
        1}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`c, $CellContext`e, $CellContext`b}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`d, $CellContext`b, $CellContext`e}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`d, $CellContext`e, $CellContext`b}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`c, \
$CellContext`a, $CellContext`e, $CellContext`d}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`d, \
$CellContext`a, $CellContext`b, $CellContext`e}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`d, \
$CellContext`a, $CellContext`e, $CellContext`b}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`d, \
$CellContext`e, $CellContext`a, $CellContext`b}]}], -$CellContext`IIi[{3, 1, 
        1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`c, $CellContext`d, $CellContext`f}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`c, $CellContext`e, $CellContext`d}]}], -$CellContext`IIi[{3, 1, 
        1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`c, $CellContext`f, $CellContext`d}]}], -$CellContext`IIi[{3, 1, 
        1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`c, $CellContext`f, $CellContext`e}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`e, $CellContext`f}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`f, $CellContext`e}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`e, $CellContext`c, $CellContext`d}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`e, $CellContext`d, $CellContext`c}]}], -$CellContext`IIi[{3, 1, 
        1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`f, $CellContext`c, $CellContext`d}]}], -$CellContext`IIi[{3, 1, 
        1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`f, $CellContext`c, $CellContext`e}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`f, $CellContext`d, $CellContext`e}]}], -$CellContext`IIi[{3, 1, 
        1}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`f, $CellContext`e, $CellContext`c}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`c, \
$CellContext`a, $CellContext`d, $CellContext`e}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`c, \
$CellContext`a, $CellContext`e, $CellContext`d}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`c, \
$CellContext`d, $CellContext`a, $CellContext`e}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`d, \
$CellContext`a, $CellContext`e, $CellContext`f}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`d, \
$CellContext`a, $CellContext`f, $CellContext`e}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`d, \
$CellContext`c, $CellContext`a, $CellContext`e}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`d, \
$CellContext`e, $CellContext`a, $CellContext`f}]}], 
      $CellContext`IIi[{3, 1, 1}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`e, \
$CellContext`d, $CellContext`a, $CellContext`f}]}]}}, {125, {
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`c, $CellContext`e}]}], 
      Rational[-1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`c, $CellContext`f}]}], Rational[4, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`e, $CellContext`f}]}], -$CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`e, $CellContext`Inf}]}], 
      Rational[-1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`f, $CellContext`c}]}], 
      Rational[-2, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`f, $CellContext`e}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`a, \
$CellContext`Inf, $CellContext`f}]}], 
      Rational[-1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`c, \
$CellContext`a, $CellContext`Inf}]}], 
      Rational[-1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`c, \
$CellContext`Inf, $CellContext`a}]}], Rational[7, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`e, \
$CellContext`a, $CellContext`f}]}], 
      Rational[-2, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`e, \
$CellContext`f, $CellContext`a}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`e, \
$CellContext`Inf, $CellContext`c}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`e, \
$CellContext`Inf, $CellContext`f}]}], 2 $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`Inf, \
$CellContext`a, $CellContext`e}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`Inf, \
$CellContext`a, $CellContext`f}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`Inf, \
$CellContext`e, $CellContext`c}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`Inf, \
$CellContext`e, $CellContext`f}]}], 
      Rational[-1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`d, $CellContext`e}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`d, $CellContext`Inf}]}], 
      Rational[-1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`e, $CellContext`Inf}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`Inf, $CellContext`c}]}], (-2) $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`Inf, $CellContext`d}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`a, \
$CellContext`Inf, $CellContext`e}]}], 
      Rational[-1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`c, \
$CellContext`a, $CellContext`d}]}], -$CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`c, \
$CellContext`a, $CellContext`Inf}]}], 
      Rational[-1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`c, \
$CellContext`d, $CellContext`a}]}], -$CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`c, \
$CellContext`e, $CellContext`Inf}]}], Rational[2, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`d, \
$CellContext`a, $CellContext`e}]}], 3 $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`d, \
$CellContext`a, $CellContext`Inf}]}], 
      Rational[-1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`d, \
$CellContext`c, $CellContext`e}]}], Rational[2, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`d, \
$CellContext`e, $CellContext`a}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`d, \
$CellContext`e, $CellContext`Inf}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`d, \
$CellContext`Inf, $CellContext`c}]}], 
      Rational[-7, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`e, \
$CellContext`a, $CellContext`Inf}]}], -$CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`e, \
$CellContext`c, $CellContext`Inf}]}], Rational[5, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`e, \
$CellContext`d, $CellContext`Inf}]}], 
      Rational[-1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`e, \
$CellContext`Inf, $CellContext`a}]}], -$CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`e, \
$CellContext`Inf, $CellContext`d}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`Inf, \
$CellContext`d, $CellContext`c}]}], -$CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`Inf, \
$CellContext`e, $CellContext`d}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`b, $CellContext`Inf, $CellContext`c, \
$CellContext`a, $CellContext`d}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`b, $CellContext`Inf, $CellContext`c, \
$CellContext`a, $CellContext`e}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`b, $CellContext`Inf, $CellContext`d, \
$CellContext`a, $CellContext`e}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`b, $CellContext`Inf, $CellContext`d, \
$CellContext`a, $CellContext`f}]}], 
      Rational[-1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`Inf, $CellContext`d, \
$CellContext`e, $CellContext`a}]}], 
      Rational[-1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`Inf, $CellContext`d, \
$CellContext`e, $CellContext`c}]}], Rational[1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`Inf, $CellContext`e, \
$CellContext`d, $CellContext`a}]}], 
      Rational[-1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`Inf, $CellContext`e, \
$CellContext`f, $CellContext`a}]}], 
      Rational[-1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`Inf, $CellContext`e, \
$CellContext`f, $CellContext`d}]}], Rational[1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`b, $CellContext`Inf, $CellContext`f, \
$CellContext`e, $CellContext`a}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`d, $CellContext`b, $CellContext`e, \
$CellContext`a, $CellContext`f}]}], 2 $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`b, $CellContext`Inf, \
$CellContext`a, $CellContext`e}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`e}]}], Rational[1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`c, $CellContext`f}]}], -$CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`e, $CellContext`b}]}], -$CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`e, $CellContext`c}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`e, $CellContext`f}]}], Rational[1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`f, $CellContext`c}]}], 
      Rational[-1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`a, \
$CellContext`f, $CellContext`e}]}], 3 $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`b, \
$CellContext`a, $CellContext`e}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`b, \
$CellContext`a, $CellContext`f}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`b, \
$CellContext`c, $CellContext`e}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`b, \
$CellContext`e, $CellContext`f}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`c, \
$CellContext`a, $CellContext`e}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`c, \
$CellContext`b, $CellContext`e}]}], Rational[4, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`e, \
$CellContext`b, $CellContext`f}]}], -$CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`e, \
$CellContext`f, $CellContext`a}]}], -$CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`e, \
$CellContext`f, $CellContext`b}]}], -$CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`f, \
$CellContext`e, $CellContext`b}]}], -$CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`f, $CellContext`b, $CellContext`c, \
$CellContext`a, $CellContext`e}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`f, $CellContext`b, $CellContext`d, \
$CellContext`a, $CellContext`e}]}], 2 $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`f, $CellContext`b, $CellContext`d, \
$CellContext`a, $CellContext`Inf}]}], Rational[1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`f, $CellContext`b, $CellContext`d, \
$CellContext`e, $CellContext`a}]}], Rational[1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`f, $CellContext`b, $CellContext`d, \
$CellContext`e, $CellContext`c}]}], (-2) $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`f, $CellContext`b, $CellContext`e, \
$CellContext`a, $CellContext`Inf}]}], 
      Rational[-1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`f, $CellContext`b, $CellContext`e, \
$CellContext`d, $CellContext`a}]}], 
      Rational[-2, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`f, $CellContext`b, $CellContext`e, \
$CellContext`Inf, $CellContext`a}]}], 
      Rational[-2, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`f, $CellContext`b, $CellContext`e, \
$CellContext`Inf, $CellContext`d}]}], Rational[2, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`f, $CellContext`b, $CellContext`Inf, \
$CellContext`e, $CellContext`a}]}], Rational[1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`c}]}], -$CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`b, $CellContext`d}]}], Rational[1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`c, $CellContext`b}]}], Rational[1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`d, $CellContext`e}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`a, \
$CellContext`e, $CellContext`b}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`b, \
$CellContext`e, $CellContext`d}]}], Rational[1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`c, \
$CellContext`a, $CellContext`d}]}], Rational[1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`c, \
$CellContext`d, $CellContext`a}]}], 
      Rational[-2, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`d, \
$CellContext`a, $CellContext`e}]}], Rational[1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`d, \
$CellContext`c, $CellContext`e}]}], 
      Rational[-2, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`d, \
$CellContext`e, $CellContext`a}]}], 2 $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`e, \
$CellContext`a, $CellContext`b}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`f, $CellContext`Inf, $CellContext`e, \
$CellContext`b, $CellContext`d}]}], Rational[2, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`c, $CellContext`f}]}], Rational[4, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`d, $CellContext`e}]}], -$CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`e, $CellContext`c}]}], -$CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`e, $CellContext`d}]}], 2 $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`e, $CellContext`f}]}], Rational[2, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`f, $CellContext`c}]}], -$CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`f, $CellContext`d}]}], 
      Rational[-1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`a, \
$CellContext`f, $CellContext`e}]}], Rational[1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`c, \
$CellContext`a, $CellContext`d}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`c, \
$CellContext`a, $CellContext`e}]}], Rational[1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`c, \
$CellContext`d, $CellContext`a}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`c, \
$CellContext`d, $CellContext`e}]}], Rational[7, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`d, \
$CellContext`a, $CellContext`e}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`d, \
$CellContext`a, $CellContext`f}]}], Rational[4, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`d, \
$CellContext`c, $CellContext`e}]}], 
      Rational[-2, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`d, \
$CellContext`e, $CellContext`a}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`d, \
$CellContext`e, $CellContext`f}]}], 2 $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`e, \
$CellContext`a, $CellContext`f}]}], Rational[4, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`e, \
$CellContext`d, $CellContext`f}]}], -$CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`b, $CellContext`e, \
$CellContext`f, $CellContext`a}]}], 2 $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`d, $CellContext`b, \
$CellContext`a, $CellContext`e}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`d, $CellContext`b, \
$CellContext`a, $CellContext`f}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`d, $CellContext`c, \
$CellContext`a, $CellContext`b}]}], -$CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`d, $CellContext`e, \
$CellContext`a, $CellContext`f}]}], 
      Rational[-1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`d, $CellContext`e, \
$CellContext`f, $CellContext`a}]}], 
      Rational[-1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`d, $CellContext`e, \
$CellContext`f, $CellContext`b}]}], Rational[1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`d, $CellContext`f, \
$CellContext`e, $CellContext`a}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`f, $CellContext`c, \
$CellContext`a, $CellContext`e}]}], -$CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`f, $CellContext`d, \
$CellContext`a, $CellContext`e}]}], 
      Rational[-1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`f, $CellContext`d, \
$CellContext`e, $CellContext`a}]}], 
      Rational[-1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`f, $CellContext`d, \
$CellContext`e, $CellContext`c}]}], 
      $CellContext`IIi[{3, 2}, {
        $CellContext`cri[{$CellContext`Inf, $CellContext`f, $CellContext`e, \
$CellContext`a, $CellContext`b}]}], Rational[1, 3] $CellContext`IIi[{3, 2}, {
         $CellContext`cri[{$CellContext`Inf, $CellContext`f, $CellContext`e, \
$CellContext`d, $CellContext`a}]}]}}, {48, {3 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`b, $CellContext`d, \
$CellContext`Inf}]}], 13 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`b, $CellContext`f, \
$CellContext`Inf}]}], -$CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`c, $CellContext`b, \
$CellContext`d}]}], (-3) $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`d, $CellContext`b, \
$CellContext`f}]}], Rational[-4, 3] $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`d, $CellContext`b, \
$CellContext`Inf}]}], Rational[4, 3] $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`d, $CellContext`f, \
$CellContext`b}]}], 
      $CellContext`IIi[{5}, {
        $CellContext`cri[{$CellContext`a, $CellContext`d, $CellContext`f, \
$CellContext`Inf}]}], 4 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`d, $CellContext`Inf, \
$CellContext`b}]}], Rational[-4, 3] $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`d, $CellContext`Inf, \
$CellContext`f}]}], 15 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`e, $CellContext`b, \
$CellContext`d}]}], 8 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`e, $CellContext`b, \
$CellContext`f}]}], 4 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`e, $CellContext`b, \
$CellContext`Inf}]}], 21 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`e, $CellContext`d, \
$CellContext`Inf}]}], (-8) $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`e, $CellContext`f, \
$CellContext`b}]}], (-7) $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`e, $CellContext`f, \
$CellContext`Inf}]}], 14 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`e, $CellContext`Inf, \
$CellContext`b}]}], Rational[-4, 3] $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`e, $CellContext`Inf, \
$CellContext`d}]}], Rational[16, 3] $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`e, $CellContext`Inf, \
$CellContext`f}]}], 15 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`f, $CellContext`b, \
$CellContext`d}]}], Rational[16, 3] $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`f, $CellContext`b, \
$CellContext`Inf}]}], (-3) $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`f, $CellContext`d, \
$CellContext`Inf}]}], 10 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`f, $CellContext`Inf, \
$CellContext`b}]}], Rational[16, 3] $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`f, $CellContext`Inf, \
$CellContext`d}]}], (-2) $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`Inf, $CellContext`b, \
$CellContext`d}]}], (-8) $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`Inf, $CellContext`b, \
$CellContext`f}]}], Rational[32, 3] $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`a, $CellContext`Inf, $CellContext`f, \
$CellContext`b}]}], 6 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`c, \
$CellContext`e}]}], 5 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`c, \
$CellContext`Inf}]}], 13 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`e, \
$CellContext`f}]}], 6 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`Inf, \
$CellContext`e}]}], 12 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`b, $CellContext`d, $CellContext`Inf, \
$CellContext`f}]}], Rational[23, 3] $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`b, $CellContext`e, $CellContext`d, \
$CellContext`Inf}]}], 6 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`b, $CellContext`e, $CellContext`Inf, \
$CellContext`f}]}], Rational[19, 3] $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`c, \
$CellContext`d}]}], (-2) $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`c, \
$CellContext`e}]}], (-8) $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`d, \
$CellContext`e}]}], 12 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`d, \
$CellContext`Inf}]}], Rational[-13, 3] $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`b, $CellContext`f, $CellContext`e, \
$CellContext`Inf}]}], Rational[-1, 3] $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`b, $CellContext`Inf, $CellContext`d, \
$CellContext`c}]}], 8 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`b, $CellContext`Inf, $CellContext`e, \
$CellContext`c}]}], 13 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`b, $CellContext`Inf, $CellContext`e, \
$CellContext`d}]}], 8 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`b, $CellContext`Inf, $CellContext`f, \
$CellContext`d}]}], Rational[40, 3] $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`b, $CellContext`Inf, $CellContext`f, \
$CellContext`e}]}], Rational[-1, 3] $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`c, $CellContext`d, $CellContext`f, \
$CellContext`Inf}]}], 6 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`c, $CellContext`e, $CellContext`d, \
$CellContext`Inf}]}], 2 $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`c, $CellContext`e, $CellContext`f, \
$CellContext`Inf}]}], Rational[16, 3] $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`d, $CellContext`e, $CellContext`f, \
$CellContext`Inf}]}], Rational[22, 3] $CellContext`IIi[{5}, {
         $CellContext`cri[{$CellContext`d, $CellContext`Inf, $CellContext`e, \
$CellContext`f}]}]}}}],
  Editable->False]], "Print",
 CellChangeTimes->{3.6976124770995116`*^9, 3.697616148610265*^9, 
  3.6976442653120804`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"texCountIntegrals", "[", "out5OddNLoweras311and32and5gathered", 
  "]"}]], "Input",
 CellChangeTimes->{{3.697541176944091*^9, 3.697541183844907*^9}}],

Cell[BoxData["\<\"Integral & Number in expression \\\\\\\\ \\n$ I_{3, 1, 1} $ \
& 69 \\\\\\\\ \\n$ I_{3, 2} $ & 125 \\\\\\\\ \\n$ I_{5} $ & 48 \\\\\\\\ \
\\nTotal & 242\"\>"], "Output",
 CellChangeTimes->{
  3.697541184578389*^9, 3.6975415625748787`*^9, 3.6975423881706247`*^9, 
   3.697554872942132*^9, 3.697556942533373*^9, 3.6975633519519544`*^9, 
   3.697599612345704*^9, 3.697602717279029*^9, {3.6976124540588703`*^9, 
   3.697612477115136*^9}, 3.6976161496571493`*^9, 3.6976442653620977`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"texIntegralsByCoeff", "[", "out5OddNLoweras311and32and5", 
  "]"}]], "Input",
 CellChangeTimes->{{3.6975412338845387`*^9, 3.6975412460026407`*^9}, {
  3.697541316714067*^9, 3.697541324473263*^9}}],

Cell[BoxData["\<\"I_{3, 1, 1}( -[b d a c e f] \\n + [b d a e \\\\infty c] \\n \
- [b d a f \\\\infty c] \\n + [b d a \\\\infty e f] \\n + [b d c a e \
\\\\infty] \\n + [b d c a \\\\infty e] \\n + [b d c \\\\infty a e] \\n + [b d \
e \\\\infty a f] \\n + [b d \\\\infty a e f] \\n + [b d \\\\infty e a f] \\n \
- [b f a c \\\\infty e] \\n + [b f a d \\\\infty e] \\n - [b f a \\\\infty c \
e] \\n + [b f a \\\\infty d c] \\n + [b f a \\\\infty d e] \\n - [b f a \
\\\\infty e c] \\n + [b f c a d \\\\infty] \\n - [b f c a e d] \\n - [b f c a \
e \\\\infty] \\n + [b f c a \\\\infty d] \\n + [b f c d a \\\\infty] \\n - [b \
f c e a \\\\infty] \\n + [b f d a \\\\infty e] \\n - [b f e c a \\\\infty] \
\\n + [b f e d a \\\\infty] \\n - [d \\\\infty a c b f] \\n + [d \\\\infty a \
c e b] \\n + [d \\\\infty a c e f] \\n - [d \\\\infty a c f b] \\n + [d \
\\\\infty a e b c] \\n + [d \\\\infty a e c b] \\n - [d \\\\infty a f b c] \
\\n - [d \\\\infty a f c b] \\n + [d \\\\infty b c a e] \\n + [d \\\\infty c \
a b e] \\n + [d \\\\infty c b a e] \\n + [d \\\\infty e b a f] \\n - [f \
\\\\infty a b c e] \\n + [f \\\\infty a b d c] \\n + [f \\\\infty a b d e] \
\\n - [f \\\\infty a b e c] \\n - [f \\\\infty a c b e] \\n - [f \\\\infty a \
c e b] \\n + [f \\\\infty a d b e] \\n + [f \\\\infty a d e b] \\n + [f \
\\\\infty c a e d] \\n + [f \\\\infty d a b e] \\n + [f \\\\infty d a e b] \
\\n + [f \\\\infty d e a b] \\n - [\\\\infty b a c d f] \\n + [\\\\infty b a \
c e d] \\n - [\\\\infty b a c f d] \\n - [\\\\infty b a c f e] \\n + \
[\\\\infty b a d e f] \\n + [\\\\infty b a d f e] \\n + [\\\\infty b a e c d] \
\\n + [\\\\infty b a e d c] \\n - [\\\\infty b a f c d] \\n - [\\\\infty b a \
f c e] \\n + [\\\\infty b a f d e] \\n - [\\\\infty b a f e c] \\n + \
[\\\\infty b c a d e] \\n + [\\\\infty b c a e d] \\n + [\\\\infty b c d a e] \
\\n + [\\\\infty b d a e f] \\n + [\\\\infty b d a f e] \\n + [\\\\infty b d \
c a e] \\n + [\\\\infty b d e a f] \\n + [\\\\infty b e d a f] ) + {} \
\\\\\\\\ \\n & {} + \\\\frac{1}{3} I_{3, 2}( -[b d a c f] \\n + 4 [b d a e f] \
\\n - [b d a f c] \\n - 2 [b d a f e] \\n - [b d c a \\\\infty] \\n - [b d c \
\\\\infty a] \\n + 7 [b d e a f] \\n - 2 [b d e f a] \\n - [b f a d e] \\n - \
[b f a e \\\\infty] \\n - [b f c a d] \\n - [b f c d a] \\n + 2 [b f d a e] \
\\n - [b f d c e] \\n + 2 [b f d e a] \\n - 7 [b f e a \\\\infty] \\n + 5 [b \
f e d \\\\infty] \\n - [b f e \\\\infty a] \\n - [b \\\\infty d e a] \\n - [b \
\\\\infty d e c] \\n + [b \\\\infty e d a] \\n - [b \\\\infty e f a] \\n - [b \
\\\\infty e f d] \\n + [b \\\\infty f e a] \\n + [d \\\\infty a c f] \\n + [d \
\\\\infty a f c] \\n - [d \\\\infty a f e] \\n + 4 [d \\\\infty e b f] \\n + \
[f b d e a] \\n + [f b d e c] \\n - [f b e d a] \\n - 2 [f b e \\\\infty a] \
\\n - 2 [f b e \\\\infty d] \\n + 2 [f b \\\\infty e a] \\n + [f \\\\infty a \
b c] \\n + [f \\\\infty a c b] \\n + [f \\\\infty a d e] \\n + [f \\\\infty c \
a d] \\n + [f \\\\infty c d a] \\n - 2 [f \\\\infty d a e] \\n + [f \\\\infty \
d c e] \\n - 2 [f \\\\infty d e a] \\n + 2 [\\\\infty b a c f] \\n + 4 \
[\\\\infty b a d e] \\n + 2 [\\\\infty b a f c] \\n - [\\\\infty b a f e] \\n \
+ [\\\\infty b c a d] \\n + [\\\\infty b c d a] \\n + 7 [\\\\infty b d a e] \
\\n + 4 [\\\\infty b d c e] \\n - 2 [\\\\infty b d e a] \\n + 4 [\\\\infty b \
e d f] \\n - [\\\\infty d e f a] \\n - [\\\\infty d e f b] \\n + [\\\\infty d \
f e a] \\n - [\\\\infty f d e a] \\n - [\\\\infty f d e c] \\n + [\\\\infty f \
e d a] ) + {} \\\\\\\\ \\n & {} + I_{3, 2}( [b d a c e] \\n - [b d a e \
\\\\infty] \\n + [b d a \\\\infty f] \\n + [b d e \\\\infty c] \\n + [b d e \
\\\\infty f] \\n + 2 [b d \\\\infty a e] \\n + [b d \\\\infty a f] \\n + [b d \
\\\\infty e c] \\n + [b d \\\\infty e f] \\n + [b f a d \\\\infty] \\n + [b f \
a \\\\infty c] \\n - 2 [b f a \\\\infty d] \\n + [b f a \\\\infty e] \\n - [b \
f c a \\\\infty] \\n - [b f c e \\\\infty] \\n + 3 [b f d a \\\\infty] \\n + \
[b f d e \\\\infty] \\n + [b f d \\\\infty c] \\n - [b f e c \\\\infty] \\n - \
[b f e \\\\infty d] \\n + [b f \\\\infty d c] \\n - [b f \\\\infty e d] \\n + \
[b \\\\infty c a d] \\n + [b \\\\infty c a e] \\n + [b \\\\infty d a e] \\n + \
[b \\\\infty d a f] \\n + [d b e a f] \\n + 2 [d b \\\\infty a e] \\n + [d \\\
\\infty a b e] \\n - [d \\\\infty a e b] \\n - [d \\\\infty a e c] \\n + [d \
\\\\infty a e f] \\n + 3 [d \\\\infty b a e] \\n + [d \\\\infty b a f] \\n + \
[d \\\\infty b c e] \\n + [d \\\\infty b e f] \\n + [d \\\\infty c a e] \\n + \
[d \\\\infty c b e] \\n - [d \\\\infty e f a] \\n - [d \\\\infty e f b] \\n - \
[d \\\\infty f e b] \\n - [f b c a e] \\n + [f b d a e] \\n + 2 [f b d a \
\\\\infty] \\n - 2 [f b e a \\\\infty] \\n - [f \\\\infty a b d] \\n + [f \
\\\\infty a e b] \\n + [f \\\\infty b e d] \\n + 2 [f \\\\infty e a b] \\n + \
[f \\\\infty e b d] \\n - [\\\\infty b a e c] \\n - [\\\\infty b a e d] \\n + \
2 [\\\\infty b a e f] \\n - [\\\\infty b a f d] \\n + [\\\\infty b c a e] \\n \
+ [\\\\infty b c d e] \\n + [\\\\infty b d a f] \\n + [\\\\infty b d e f] \\n \
+ 2 [\\\\infty b e a f] \\n - [\\\\infty b e f a] \\n + 2 [\\\\infty d b a e] \
\\n + [\\\\infty d b a f] \\n + [\\\\infty d c a b] \\n - [\\\\infty d e a f] \
\\n + [\\\\infty f c a e] \\n - [\\\\infty f d a e] \\n + [\\\\infty f e a b] \
) + {} \\\\\\\\ \\n & {} + \\\\frac{1}{3} I_{5}( -4 [a d b \\\\infty] \\n + 4 \
[a d f b] \\n - 4 [a d \\\\infty f] \\n - 4 [a e \\\\infty d] \\n + 16 [a e \
\\\\infty f] \\n + 16 [a f b \\\\infty] \\n + 16 [a f \\\\infty d] \\n + 32 \
[a \\\\infty f b] \\n + 23 [b e d \\\\infty] \\n + 19 [b f c d] \\n - 13 [b f \
e \\\\infty] \\n - [b \\\\infty d c] \\n + 40 [b \\\\infty f e] \\n - [c d f \
\\\\infty] \\n + 16 [d e f \\\\infty] \\n + 22 [d \\\\infty e f] ) + {} \
\\\\\\\\ \\n & {} + I_{5}( 3 [a b d \\\\infty] \\n + 13 [a b f \\\\infty] \\n \
- [a c b d] \\n - 3 [a d b f] \\n + [a d f \\\\infty] \\n + 4 [a d \\\\infty \
b] \\n + 15 [a e b d] \\n + 8 [a e b f] \\n + 4 [a e b \\\\infty] \\n + 21 [a \
e d \\\\infty] \\n - 8 [a e f b] \\n - 7 [a e f \\\\infty] \\n + 14 [a e \
\\\\infty b] \\n + 15 [a f b d] \\n - 3 [a f d \\\\infty] \\n + 10 [a f \
\\\\infty b] \\n - 2 [a \\\\infty b d] \\n - 8 [a \\\\infty b f] \\n + 6 [b d \
c e] \\n + 5 [b d c \\\\infty] \\n + 13 [b d e f] \\n + 6 [b d \\\\infty e] \
\\n + 12 [b d \\\\infty f] \\n + 6 [b e \\\\infty f] \\n - 2 [b f c e] \\n - \
8 [b f d e] \\n + 12 [b f d \\\\infty] \\n + 8 [b \\\\infty e c] \\n + 13 [b \
\\\\infty e d] \\n + 8 [b \\\\infty f d] \\n + 6 [c e d \\\\infty] \\n + 2 [c \
e f \\\\infty] )\"\>"], "Output",
 CellChangeTimes->{
  3.697541248314834*^9, 3.697541326371251*^9, 3.697541565501934*^9, 
   3.697554878556632*^9, 3.697556957000516*^9, 3.697563353327479*^9, 
   3.69759961475397*^9, 3.697602719732797*^9, {3.697612454137001*^9, 
   3.6976124786782722`*^9}, 3.6976161519248233`*^9, 3.697644266908204*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{
   "Now", " ", "convert", " ", "I311", " ", "to", " ", "I32", " ", "modulo", 
    " ", "del"}], ",", " ", 
   RowBox[{
   "to", " ", "reduce", " ", "I11111", " ", "to", " ", "I32", " ", "only"}]}],
   " ", "*)"}]], "Input",
 CellChangeTimes->{{3.671633831870961*^9, 3.671633833937984*^9}, {
  3.6975558235063705`*^9, 3.6975558372226505`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"texRuleByCR", "[", "rule311to32", "]"}]], "Input",
 CellChangeTimes->{{3.697542544462171*^9, 3.6975425527749968`*^9}, {
   3.69755546005392*^9, 3.6975554612741623`*^9}, 3.697556022710973*^9}],

Cell[BoxData["\<\"I_{3, 1, 1}(a b c d e f) & {} = \\\\frac{1}{3} I_{3, 2}( [a \
b c d e] \\n + [a b c d f] \\n + [a b c e d] \\n + [a b c f d] \\n - [a c b d \
f] \\n - [a c b f d] \\n - [a d b e f] \\n - [a d b f e] \\n + [b a f c e] \
\\n + [b a f e c] \\n - [b f a c e] \\n - [b f a e c] ) + {} \\\\\\\\ \\n & \
{} + \\\\frac{1}{3} I_{3, 2}( [a b c d, a b f e] \\n - [a b e f, a b d c] \\n \
- [a b e f, a d b c] \\n + [a c b d, a e c f] \\n - [a c b d, b c e f] \\n - \
[a c b d, b e c f] \\n - [a c d f, a d b e] \\n - [a c d f, a e b d] \\n + [a \
c d f, a e b f] \\n - [a c e f, a d b c] \\n + [a c e f, a d b e] \\n + [a c \
e f, a e b d] \\n - [a d b c, a b e f] \\n - [a d b c, a c e f] \\n - [a d b \
e, a c d f] \\n + [a d b e, a c e f] \\n - [a e b d, a c d f] \\n + [a e b d, \
a c e f] \\n + [a e b f, a c d f] \\n + [a e c f, a c b d] \\n + [a f b e, b \
c d f] \\n + [b c d f, a f b e] \\n - [b c e f, a c b d] \\n - [b e c f, a c \
b d] ) + {} \\\\\\\\ \\n & {} + \\\\frac{1}{3} I_{3, 2}( [a b c e, a c b d] \
\\n + [a b c e, a d b c] \\n + [a b c f, a d c b] \\n - [a b d f, a e b f] \
\\n - [a b e f, a d e b] \\n - [a b e f, a e d b] \\n + [a c b d, a b c e] \
\\n + [a d b c, a b c e] \\n - [a d b c, a b f c] \\n + [a d b e, a b f e] \
\\n - [a d b f, a e b d] \\n + [a e b d, a b f e] \\n - [a e b d, a d b f] \
\\n - [a e b f, a b d f] )\"\>"], "Output",
 CellChangeTimes->{
  3.6976027259548078`*^9, {3.697612454215124*^9, 3.6976124790851784`*^9}, 
   3.6976161525498295`*^9, 3.69764426738653*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
  "Now", " ", "apply", " ", "this", " ", "rule", " ", "to", " ", "write", " ",
    "I11111", " ", "as", " ", "I32", " ", "mod", " ", "del"}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.671633831870961*^9, 3.671633833937984*^9}, {
  3.697556151523426*^9, 3.6975561590933833`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"out5OddNLoweras32del", " ", "=", " ", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"out5OddNLoweras311and32and5", "/.", "rule311to32"}], "/.", 
      RowBox[{
       RowBox[{"IIi", "[", 
        RowBox[{
         RowBox[{"{", "5", "}"}], ",", "_List"}], "]"}], "\[RuleDelayed]", 
       "0"}]}], "/.", "canonicalCR"}], "//", "Expand"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6975561624714565`*^9, 3.697556179764132*^9}, {
   3.697556244894848*^9, 3.697556256357874*^9}, {3.697556353115967*^9, 
   3.697556395891412*^9}, {3.69755697945467*^9, 3.6975569806437426`*^9}, 
   3.697560293861398*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"out5OddNLoweras32del", "//", "Length"}]], "Input",
 CellChangeTimes->{{3.69755618373592*^9, 3.6975561870356665`*^9}}],

Cell[BoxData["2457"], "Output",
 CellChangeTimes->{
  3.697556187208768*^9, 3.697556259360857*^9, {3.6975563682872634`*^9, 
   3.697556398081483*^9}, 3.6975569831324587`*^9, 3.69756029514394*^9, 
   3.697563353890486*^9, 3.6975996705439982`*^9, 3.69760272867428*^9, {
   3.697612454324504*^9, 3.6976124791789274`*^9}, 3.6976161548801093`*^9, 
   3.6976442675426607`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"wt5DanOddNas32delPrecomputed", " ", "==", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"in5Polylog", " ", "-", " ", 
       RowBox[{"(", 
        RowBox[{"out5OddNLoweras32del", " ", "-", " ", 
         RowBox[{"(", 
          RowBox[{"out5OddNLoweras32del", "/.", 
           RowBox[{"a", "\[Rule]", "g"}]}], ")"}]}], ")"}]}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"a", "\[Rule]", "0"}], ",", 
        RowBox[{"g", "\[Rule]", "1"}]}], "}"}]}], "/.", "canonicalCR"}], "//",
     "Expand"}], ")"}]}]], "Input",
 CellChangeTimes->{{3.69756021288015*^9, 3.697560236836722*^9}, {
  3.697602734817774*^9, 3.697602740007778*^9}, {3.697602796055416*^9, 
  3.6976027961960616`*^9}, {3.6976028536462665`*^9, 3.697602865182523*^9}, {
  3.697612492278098*^9, 3.697612492653104*^9}}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{
  3.6976028656206703`*^9, {3.697612454449506*^9, 3.6976124793195767`*^9}, 
   3.697616156209708*^9, 3.6976442676757517`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"out5OddNLoweras32delGathered", " ", "=", " ", 
   RowBox[{
    RowBox[{"gatherIntegrals", "[", 
     RowBox[{"out5OddNLoweras32del", ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"args", "[", "#", "]"}], "//", "Length"}], ",", " ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"Union", "@@", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"args", "[", "#", "]"}], "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "1"}], "]"}], "]"}], ")"}]}], ")"}], "//", 
          "Length"}], ",", " ", 
         RowBox[{"Count", "[", 
          RowBox[{
           RowBox[{"Join", "@@", 
            RowBox[{
             RowBox[{"ccrToCr", "[", 
              RowBox[{"args", "[", "#", "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ",", "Inf"}], 
          "]"}]}], "}"}], "&"}]}], "]"}], "//", 
    RowBox[{
     RowBox[{"SortBy", "[", 
      RowBox[{"#", ",", " ", 
       RowBox[{
        RowBox[{"Switch", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"args", "[", 
              RowBox[{"#", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], "//", "Length"}], ",", 
            "  ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"Union", "@@", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"args", "[", 
                  RowBox[{"#", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "]"}], "[", 
                 RowBox[{"[", 
                  RowBox[{"All", ",", "1"}], "]"}], "]"}], ")"}]}], ")"}], "//",
              "Length"}], ",", " ", 
            RowBox[{"Count", "[", 
             RowBox[{
              RowBox[{"Join", "@@", 
               RowBox[{
                RowBox[{"ccrToCr", "[", 
                 RowBox[{"args", "[", 
                  RowBox[{"#", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "]"}], "]"}], "[", 
                RowBox[{"[", 
                 RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ",", "Inf"}], 
             "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"1", ",", "5", ",", "0"}], "}"}], ",", "1", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"1", ",", "5", ",", "1"}], "}"}], ",", "2", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"1", ",", "5", ",", "2"}], "}"}], ",", "3", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"2", ",", "5", ",", "0"}], "}"}], ",", "4", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"2", ",", "5", ",", "1"}], "}"}], ",", "5", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"2", ",", "5", ",", "2"}], "}"}], ",", "6", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"2", ",", "6", ",", "0"}], "}"}], ",", "7", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"2", ",", "6", ",", "1"}], "}"}], ",", "8", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"2", ",", "6", ",", "2"}], "}"}], ",", "9"}], "]"}], 
        "&"}]}], "]"}], "&"}]}]}], ";"}]], "Input",
 CellChangeTimes->{{3.69755707753829*^9, 3.697557119408141*^9}, {
  3.697557162667533*^9, 3.6975571641145363`*^9}, {3.6975572282615376`*^9, 
  3.697557312730861*^9}, {3.6975573830729556`*^9, 3.6975574058298225`*^9}, {
  3.697557507436061*^9, 3.697557530082731*^9}, {3.697557701825432*^9, 
  3.697557702925208*^9}, {3.6975579492008915`*^9, 3.697557965091366*^9}, {
  3.697558349847371*^9, 3.6975583516002903`*^9}, {3.6975587807734003`*^9, 
  3.697558826332943*^9}, {3.6975588670693245`*^9, 3.697558960894367*^9}, {
  3.6976028444862843`*^9, 3.697602845173792*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"texCountIntegrals", "[", 
  RowBox[{"out5OddNLoweras32delGathered", ",", " ", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"Switch", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"args", "[", "#", "]"}], "//", "Length"}], ",", "  ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"Union", "@@", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"args", "[", "#", "]"}], "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "1"}], "]"}], "]"}], ")"}]}], ")"}], "//", 
          "Length"}], ",", " ", 
         RowBox[{"Count", "[", 
          RowBox[{
           RowBox[{"Join", "@@", 
            RowBox[{
             RowBox[{"ccrToCr", "[", 
              RowBox[{"args", "[", "#", "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ",", "Inf"}], 
          "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"2", ",", "6", ",", "2"}], "}"}], ",", 
       "\"\<6-variable & 2\>\"", ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"2", ",", "6", ",", "1"}], "}"}], ",", 
       "\"\<6-variable & 1\>\"", ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"2", ",", "6", ",", "0"}], "}"}], ",", 
       "\"\<6-variable & 0\>\"", ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"2", ",", "5", ",", "2"}], "}"}], ",", 
       "\"\<5-variable & 2\>\"", ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"2", ",", "5", ",", "1"}], "}"}], ",", 
       "\"\<5-variable & 1\>\"", ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"2", ",", "5", ",", "0"}], "}"}], ",", 
       "\"\<5-variable & 0\>\"", ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"1", ",", "5", ",", "2"}], "}"}], ",", "\"\<Coupled & 2\>\"", 
       ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"1", ",", "5", ",", "1"}], "}"}], ",", "\"\<Coupled & 1\>\"", 
       ",", "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"1", ",", "5", ",", "0"}], "}"}], ",", 
       "\"\<Coupled & 0\>\""}], "]"}], "}"}], "&"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.697558342277566*^9, 3.6975583725102434`*^9}, {
  3.697558407839547*^9, 3.697558419662536*^9}, {3.697558572560914*^9, 
  3.697558733853961*^9}}],

Cell[BoxData["\<\"Type & Number in expression \\\\\\\\ \\nCoupled & 0 $ & 68 \
\\\\\\\\ \\nCoupled & 1 $ & 88 \\\\\\\\ \\nCoupled & 2 $ & 276 \\\\\\\\ \
\\n5-variable & 0 $ & 78 \\\\\\\\ \\n5-variable & 1 $ & 155 \\\\\\\\ \
\\n5-variable & 2 $ & 578 \\\\\\\\ \\n6-variable & 0 $ & 48 \\\\\\\\ \
\\n6-variable & 1 $ & 686 \\\\\\\\ \\n6-variable & 2 $ & 480 \\\\\\\\ \
\\nTotal & 2457\"\>"], "Output",
 CellChangeTimes->{
  3.6975583757957544`*^9, {3.69755871786907*^9, 3.6975587347914047`*^9}, 
   3.697558830696514*^9, 3.697558915045251*^9, 3.697558961864275*^9, 
   3.6975633541873646`*^9, 3.69759967495368*^9, 3.6976028703610573`*^9, 
   3.6976124794133053`*^9, 3.6976161586017017`*^9, 3.6976442677998233`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"out5OddNLoweras32delGatheredCoeff", " ", "=", " ", 
   RowBox[{
    RowBox[{"gatherIntegrals", "[", 
     RowBox[{"out5OddNLoweras32del", ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"denominator", "[", "#", "]"}], ",", " ", 
         RowBox[{
          RowBox[{"args", "[", "#", "]"}], "//", "Length"}], ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"Union", "@@", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"args", "[", "#", "]"}], "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "1"}], "]"}], "]"}], ")"}]}], ")"}], "//", 
          "Length"}], ",", " ", 
         RowBox[{"Count", "[", 
          RowBox[{
           RowBox[{"Join", "@@", 
            RowBox[{
             RowBox[{"ccrToCr", "[", 
              RowBox[{"args", "[", "#", "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ",", "Inf"}], 
          "]"}]}], "}"}], "&"}]}], "]"}], "//", 
    RowBox[{
     RowBox[{"SortBy", "[", 
      RowBox[{"#", ",", " ", 
       RowBox[{
        RowBox[{"Switch", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"args", "[", 
              RowBox[{"#", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}], "//", "Length"}], ",", 
            "  ", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"Union", "@@", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"args", "[", 
                  RowBox[{"#", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "]"}], "[", 
                 RowBox[{"[", 
                  RowBox[{"All", ",", "1"}], "]"}], "]"}], ")"}]}], ")"}], "//",
              "Length"}], ",", " ", 
            RowBox[{"Count", "[", 
             RowBox[{
              RowBox[{"Join", "@@", 
               RowBox[{
                RowBox[{"ccrToCr", "[", 
                 RowBox[{"args", "[", 
                  RowBox[{"#", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "]"}], "]"}], "[", 
                RowBox[{"[", 
                 RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ",", "Inf"}], 
             "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"1", ",", "5", ",", "0"}], "}"}], ",", "1", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"1", ",", "5", ",", "1"}], "}"}], ",", "2", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"1", ",", "5", ",", "2"}], "}"}], ",", "3", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"2", ",", "5", ",", "0"}], "}"}], ",", "4", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"2", ",", "5", ",", "1"}], "}"}], ",", "5", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"2", ",", "5", ",", "2"}], "}"}], ",", "6", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"2", ",", "6", ",", "0"}], "}"}], ",", "7", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"2", ",", "6", ",", "1"}], "}"}], ",", "8", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"2", ",", "6", ",", "2"}], "}"}], ",", "9"}], "]"}], 
        "&"}]}], "]"}], "&"}]}]}], ";"}]], "Input",
 CellChangeTimes->{{3.69755707753829*^9, 3.697557119408141*^9}, {
  3.697557162667533*^9, 3.6975571641145363`*^9}, {3.6975572282615376`*^9, 
  3.697557312730861*^9}, {3.6975573830729556`*^9, 3.6975574058298225`*^9}, {
  3.697557507436061*^9, 3.697557530082731*^9}, {3.697557701825432*^9, 
  3.697557702925208*^9}, {3.6975579492008915`*^9, 3.697557965091366*^9}, {
  3.697558349847371*^9, 3.6975583516002903`*^9}, {3.6975587807734003`*^9, 
  3.697558826332943*^9}, {3.6975588670693245`*^9, 3.697558960894367*^9}, {
  3.6975594500610595`*^9, 3.697559460929784*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"texWt5As32del", " ", "=", " ", 
   RowBox[{"ToString", "[", 
    RowBox[{"texIntegralsGath", "[", 
     RowBox[{
      RowBox[{"Total", "/@", "out5OddNLoweras32delGatheredCoeff"}], ",", " ", 
      
      RowBox[{"denominator", "/@", 
       RowBox[{"out5OddNLoweras32delGatheredCoeff", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", "1"}], "]"}], "]"}]}]}], "]"}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.6975590770383024`*^9, 3.697559085608014*^9}, {
  3.6975592564329786`*^9, 3.6975592577164984`*^9}, {3.6975593759646406`*^9, 
  3.697559382563693*^9}, {3.697559473097017*^9, 3.697559473659514*^9}, {
  3.697559527459485*^9, 3.6975595404945416`*^9}, {3.697559745633615*^9, 
  3.697559755346603*^9}, {3.6975597892658176`*^9, 3.6975598241752853`*^9}, {
  3.6975599395065084`*^9, 3.6975599462779317`*^9}, {3.697560129908328*^9, 
  3.6975601426303124`*^9}, {3.6975605142502265`*^9, 3.6975605778176365`*^9}, {
  3.6975629800562363`*^9, 3.697562980587517*^9}, {3.697612380601693*^9, 
  3.6976124459119186`*^9}, {3.6976125210123715`*^9, 3.697612521121769*^9}, {
  3.6976125811435375`*^9, 3.6976125873026037`*^9}}],

Cell[CellGroupData[{

Cell[BoxData["texWt5As32del"], "Input",
 CellChangeTimes->{{3.6976154614184074`*^9, 3.6976154930250874`*^9}}],

Cell[BoxData["\<\"I_{3, 2}( [b d a c e] \\n - [b d a c f] \\n - [b d a f c] \
\\n - [b f c a e] \\n - [b f c e a] \\n + [b f d a e] \\n + [b f d e a] \\n + \
[d b e a f] \\n + [f b d a e] ) + {} \\\\\\\\ \\n & {} + \\\\frac{1}{3} I_{3, \
2}( -[b a d c e] \\n + 2 [b a d c f] \\n - [b a d e c] \\n - [b a d e f] \\n \
+ 2 [b a d f c] \\n - [b a d f e] \\n + [b a f c e] \\n + [b a f e c] \\n - \
[b c d a e] \\n - [b c d e a] \\n + [b c d e f] \\n + [b c d f e] \\n + 4 [b \
d a e f] \\n - 2 [b d a f e] \\n + 2 [b d c a e] \\n + 2 [b d c e a] \\n + 7 \
[b d e a f] \\n - 2 [b d e f a] \\n - [b d f a e] \\n - [b d f e a] \\n - [b \
e d a f] \\n - [b e d f a] \\n - [b f a c e] \\n - [b f a e c] \\n + [b f a e \
d] \\n + [b f c a d] \\n + [b f c d a] \\n - [b f d c e] \\n - [b f e a c] \
\\n + [b f e a d] \\n - [b f e c a] \\n + [b f e d a] \\n + [d b e a c] \\n + \
[d b e c a] \\n + [d b f a e] \\n + [d b f e a] \\n - [d e b a c] \\n - [d e \
b c a] \\n - [d f b a e] \\n - [d f b e a] \\n + [f b c a d] \\n - 4 [f b c a \
e] \\n + [f b c d a] \\n - [f b c e a] \\n - [f b d c e] \\n + [f b d e a] \
\\n - [f b e a c] \\n + [f b e a d] \\n - [f b e c a] \\n - [f c b a d] \\n + \
[f c b a e] \\n - [f c b d a] \\n + [f c b e a] \\n + [f d b c e] \\n + [f d \
b e c] \\n + [f e b a c] \\n - [f e b a d] \\n + [f e b c a] \\n - [f e b d \
a] ) + {} \\\\\\\\ \\n & {} + I_{3, 2}( [b d a \\\\infty f] \\n + [b d e \
\\\\infty c] \\n + 2 [b f a d \\\\infty] \\n - [b f a \\\\infty d] \\n + [b f \
d e \\\\infty] \\n + 2 [b f e d \\\\infty] \\n + 2 [f b d a \\\\infty] \\n - \
2 [f b e a \\\\infty] ) + {} \\\\\\\\ \\n & {} + \\\\frac{1}{3} I_{3, 2}( -2 \
[b a d e \\\\infty] \\n - [b a d f \\\\infty] \\n - 2 [b a d \\\\infty e] \\n \
- [b a d \\\\infty f] \\n - 2 [b a f d \\\\infty] \\n - 2 [b a f \\\\infty d] \
\\n - [b c d a \\\\infty] \\n - [b c d e \\\\infty] \\n - [b c d \\\\infty a] \
\\n - [b c d \\\\infty e] \\n + [b c f a \\\\infty] \\n - [b c f d \\\\infty] \
\\n + 2 [b c f e \\\\infty] \\n + [b c f \\\\infty a] \\n - [b c f \\\\infty \
d] \\n + 2 [b c f \\\\infty e] \\n - [b d a e \\\\infty] \\n + 2 [b d a \
\\\\infty e] \\n + 2 [b d c a \\\\infty] \\n + [b d c e \\\\infty] \\n + 2 [b \
d c \\\\infty a] \\n + [b d c \\\\infty e] \\n + [b d e a \\\\infty] \\n + [b \
d e f \\\\infty] \\n + [b d e \\\\infty a] \\n + 4 [b d e \\\\infty f] \\n - \
2 [b d f a \\\\infty] \\n - [b d f e \\\\infty] \\n - 2 [b d f \\\\infty a] \
\\n - [b d f \\\\infty e] \\n - [b e d c \\\\infty] \\n - [b e d f \\\\infty] \
\\n - [b e d \\\\infty c] \\n - [b e d \\\\infty f] \\n + [b e f a \\\\infty] \
\\n + [b e f c \\\\infty] \\n - [b e f d \\\\infty] \\n + [b e f \\\\infty a] \
\\n + [b e f \\\\infty c] \\n - [b e f \\\\infty d] \\n - 2 [b f a c \
\\\\infty] \\n - 2 [b f a e \\\\infty] \\n + [b f a \\\\infty c] \\n + 2 [b f \
a \\\\infty e] \\n - 2 [b f c a \\\\infty] \\n + [b f c d \\\\infty] \\n - 4 \
[b f c e \\\\infty] \\n + [b f c \\\\infty a] \\n + [b f c \\\\infty d] \\n - \
[b f c \\\\infty e] \\n + 10 [b f d a \\\\infty] \\n + [b f d c \\\\infty] \
\\n + [b f d \\\\infty a] \\n + 4 [b f d \\\\infty c] \\n - 7 [b f e a \
\\\\infty] \\n - 4 [b f e c \\\\infty] \\n - [b f e \\\\infty a] \\n - [b f e \
\\\\infty c] \\n - 2 [b f e \\\\infty d] \\n + [d b e c \\\\infty] \\n + [d b \
e \\\\infty c] \\n + [d b f a \\\\infty] \\n + [d b f e \\\\infty] \\n + [d b \
f \\\\infty a] \\n + [d b f \\\\infty e] \\n - [d e b c \\\\infty] \\n - [d e \
b \\\\infty c] \\n - [d f b a \\\\infty] \\n - [d f b e \\\\infty] \\n - [d f \
b \\\\infty a] \\n - [d f b \\\\infty e] \\n + [f b d c \\\\infty] \\n + [f b \
d \\\\infty c] \\n + [f b e d \\\\infty] \\n - 2 [f b e \\\\infty a] \\n - [f \
b e \\\\infty d] \\n - [f d b c \\\\infty] \\n - [f d b \\\\infty c] \\n - [f \
e b d \\\\infty] \\n - [f e b \\\\infty d] ) + {} \\\\\\\\ \\n & {} + I_{3, \
2}( [b f \\\\infty d c] \\n + [b \\\\infty d a e] \\n - [b \\\\infty d f a] \
\\n + [b \\\\infty e d a] \\n + [b \\\\infty f e a] \\n + [d \\\\infty a e f] \
\\n + 3 [d \\\\infty b a e] \\n + [d \\\\infty b a f] \\n + [d \\\\infty b c \
e] \\n + [d \\\\infty b e f] \\n - [d \\\\infty e f a] \\n - [d \\\\infty f e \
b] \\n - [f d \\\\infty b e] \\n - [f d \\\\infty e b] \\n + [f \\\\infty a d \
e] \\n + [f \\\\infty b e d] \\n + 2 [f \\\\infty e a b] \\n + [f \\\\infty e \
b d] \\n + 3 [\\\\infty b d a e] \\n + 2 [\\\\infty b d a f] \\n + [\\\\infty \
b d f a] \\n + 2 [\\\\infty b e a f] \\n - [\\\\infty b e f a] \\n - \
[\\\\infty d b e f] \\n - [\\\\infty d b f a] \\n - [\\\\infty d b f e] \\n + \
[\\\\infty d c a b] \\n - [\\\\infty d e a f] \\n + [\\\\infty d f e a] \\n - \
[\\\\infty f d e a] \\n + [\\\\infty f e a b] ) + {} \\\\\\\\ \\n & {} + \
\\\\frac{1}{3} I_{3, 2}( -[b c \\\\infty a d] \\n + [b c \\\\infty a e] \\n - \
[b c \\\\infty d a] \\n + [b c \\\\infty e a] \\n + 7 [b d \\\\infty a e] \\n \
+ 5 [b d \\\\infty a f] \\n - [b d \\\\infty c e] \\n + [b d \\\\infty e a] \
\\n + 2 [b d \\\\infty e c] \\n + 4 [b d \\\\infty e f] \\n + 2 [b d \
\\\\infty f a] \\n + [b d \\\\infty f e] \\n - 2 [b e \\\\infty a d] \\n - [b \
e \\\\infty c d] \\n - 2 [b e \\\\infty d a] \\n - [b e \\\\infty d c] \\n - \
[b e \\\\infty d f] \\n - [b e \\\\infty f d] \\n - 2 [b f \\\\infty a e] \\n \
- [b f \\\\infty d e] \\n - 2 [b f \\\\infty e a] \\n - 4 [b f \\\\infty e d] \
\\n + 4 [b \\\\infty c a d] \\n + 2 [b \\\\infty c a e] \\n + [b \\\\infty c \
d a] \\n - [b \\\\infty c e a] \\n + [b \\\\infty d c e] \\n - [b \\\\infty d \
e a] \\n - 2 [b \\\\infty d e f] \\n - 2 [b \\\\infty d f e] \\n + 2 [b \
\\\\infty e a d] \\n + [b \\\\infty e c d] \\n + [b \\\\infty e d c] \\n + [b \
\\\\infty e d f] \\n - [b \\\\infty e f a] \\n + 2 [b \\\\infty f a e] \\n - \
[b \\\\infty f c d] \\n + 2 [b \\\\infty f c e] \\n - [b \\\\infty f d c] \\n \
+ 2 [b \\\\infty f e c] \\n - 2 [d a \\\\infty b e] \\n + [d a \\\\infty b f] \
\\n - [d a \\\\infty c e] \\n + [d a \\\\infty c f] \\n - 2 [d a \\\\infty e \
b] \\n - [d a \\\\infty e c] \\n + [d a \\\\infty f b] \\n + [d a \\\\infty f \
c] \\n + 5 [d b \\\\infty a e] \\n - [d b \\\\infty a f] \\n - [d b \\\\infty \
e a] \\n - [d b \\\\infty f a] \\n - 2 [d c \\\\infty a e] \\n - 2 [d c \
\\\\infty b e] \\n + 2 [d c \\\\infty b f] \\n - 2 [d c \\\\infty e a] \\n - \
2 [d c \\\\infty e b] \\n - [d c \\\\infty e f] \\n + 2 [d c \\\\infty f b] \
\\n - [d c \\\\infty f e] \\n - 2 [d e \\\\infty b c] \\n - [d e \\\\infty b \
f] \\n - 2 [d e \\\\infty c b] \\n - [d e \\\\infty f b] \\n + 2 [d f \
\\\\infty b c] \\n + 2 [d f \\\\infty c b] \\n - [d \\\\infty a b c] \\n + 5 \
[d \\\\infty a b e] \\n - 2 [d \\\\infty a b f] \\n - [d \\\\infty a c b] \\n \
+ 4 [d \\\\infty a c e] \\n - 2 [d \\\\infty a c f] \\n - [d \\\\infty a e b] \
\\n + [d \\\\infty a e c] \\n - 2 [d \\\\infty a f b] \\n - 2 [d \\\\infty a \
f c] \\n - [d \\\\infty a f e] \\n + [d \\\\infty b a c] \\n + [d \\\\infty b \
c a] \\n + 2 [d \\\\infty c a b] \\n + 4 [d \\\\infty c a e] \\n + 2 [d \
\\\\infty c b a] \\n + 4 [d \\\\infty c b e] \\n + [d \\\\infty c e a] \\n + \
[d \\\\infty c e b] \\n + [d \\\\infty e a b] \\n + [d \\\\infty e b a] \\n + \
5 [d \\\\infty e b f] \\n - 2 [d \\\\infty e f b] \\n + [f a \\\\infty b c] \
\\n - [f a \\\\infty b d] \\n - 2 [f a \\\\infty b e] \\n + [f a \\\\infty c \
b] \\n + [f a \\\\infty c e] \\n - [f a \\\\infty d b] \\n - 2 [f a \\\\infty \
d e] \\n - 2 [f a \\\\infty e b] \\n + [f a \\\\infty e c] \\n - 2 [f a \
\\\\infty e d] \\n + [f b \\\\infty c e] \\n - [f b \\\\infty d e] \\n + 2 [f \
b \\\\infty e a] \\n + [f b \\\\infty e c] \\n - [f b \\\\infty e d] \\n - [f \
c \\\\infty a d] \\n + 2 [f c \\\\infty b e] \\n - [f c \\\\infty d a] \\n + \
2 [f c \\\\infty e b] \\n - [f d \\\\infty a b] \\n - [f d \\\\infty a e] \\n \
- [f d \\\\infty b a] \\n - [f d \\\\infty e a] \\n - [f e \\\\infty a b] \\n \
- [f e \\\\infty b a] \\n - 2 [f \\\\infty a b c] \\n + [f \\\\infty a b d] \
\\n - [f \\\\infty a b e] \\n - 2 [f \\\\infty a c b] \\n - 2 [f \\\\infty a \
c e] \\n + 4 [f \\\\infty a d b] \\n + 2 [f \\\\infty a e b] \\n - 2 [f \
\\\\infty a e c] \\n + 2 [f \\\\infty a e d] \\n - [f \\\\infty b c d] \\n + \
[f \\\\infty b c e] \\n - [f \\\\infty b d c] \\n + [f \\\\infty b e c] \\n + \
2 [f \\\\infty c a d] \\n + [f \\\\infty c a e] \\n + 2 [f \\\\infty c d a] \
\\n + [f \\\\infty c e a] \\n + 2 [f \\\\infty d a b] \\n + [f \\\\infty d a \
e] \\n + 2 [f \\\\infty d b a] \\n + [f \\\\infty d b e] \\n + [f \\\\infty d \
c e] \\n + [f \\\\infty d e a] \\n + [f \\\\infty d e b] \\n + 2 [\\\\infty a \
b c f] \\n - 4 [\\\\infty a b d e] \\n - 4 [\\\\infty a b e d] \\n - 2 \
[\\\\infty a b e f] \\n + 2 [\\\\infty a b f c] \\n - 2 [\\\\infty a b f e] \
\\n - [\\\\infty b a c d] \\n + 2 [\\\\infty b a c e] \\n - 4 [\\\\infty b a \
c f] \\n - [\\\\infty b a d c] \\n + 8 [\\\\infty b a d e] \\n + 2 [\\\\infty \
b a d f] \\n - [\\\\infty b a e c] \\n + [\\\\infty b a e d] \\n + 5 \
[\\\\infty b a e f] \\n - 4 [\\\\infty b a f c] \\n - [\\\\infty b a f d] \\n \
- 2 [\\\\infty b a f e] \\n + 4 [\\\\infty b c a d] \\n + 5 [\\\\infty b c a \
e] \\n + 4 [\\\\infty b c d a] \\n + 4 [\\\\infty b c d e] \\n + 2 [\\\\infty \
b c e a] \\n + [\\\\infty b c e d] \\n + [\\\\infty b d a c] \\n + [\\\\infty \
b d c a] \\n + 5 [\\\\infty b d c e] \\n + [\\\\infty b d e c] \\n + 4 \
[\\\\infty b d e f] \\n + [\\\\infty b d f e] \\n + [\\\\infty b e a d] \\n + \
[\\\\infty b e d a] \\n + 5 [\\\\infty b e d f] \\n + [\\\\infty b e f d] \\n \
- [\\\\infty b f a d] \\n - [\\\\infty b f d a] \\n - [\\\\infty b f d e] \\n \
- [\\\\infty b f e d] \\n - [\\\\infty c b a d] \\n - 2 [\\\\infty c b a e] \
\\n - [\\\\infty c b d a] \\n - 2 [\\\\infty c b d e] \\n + 2 [\\\\infty c b \
d f] \\n - 2 [\\\\infty c b e a] \\n - 2 [\\\\infty c b e d] \\n + [\\\\infty \
c b e f] \\n + 2 [\\\\infty c b f d] \\n + [\\\\infty c b f e] \\n - \
[\\\\infty c f a d] \\n + [\\\\infty c f a e] \\n - [\\\\infty c f d a] \\n + \
[\\\\infty c f e a] \\n + 5 [\\\\infty d b a e] \\n - [\\\\infty d b c e] \\n \
- [\\\\infty d b e a] \\n - [\\\\infty d b e c] \\n + [\\\\infty d e a b] \\n \
+ [\\\\infty d e a c] \\n + [\\\\infty d e b a] \\n + [\\\\infty d e b c] \\n \
+ [\\\\infty d e c a] \\n + [\\\\infty d e c b] \\n - [\\\\infty d e f a] \\n \
- [\\\\infty d e f b] \\n - [\\\\infty d f a b] \\n + 2 [\\\\infty d f a e] \
\\n - [\\\\infty d f b a] \\n - [\\\\infty d f c e] \\n - [\\\\infty d f e c] \
\\n - [\\\\infty e b a f] \\n - 2 [\\\\infty e b c d] \\n - 2 [\\\\infty e b \
d c] \\n - [\\\\infty e b d f] \\n - [\\\\infty e b f a] \\n - [\\\\infty e b \
f d] \\n - [\\\\infty e d a b] \\n - [\\\\infty e d a c] \\n - [\\\\infty e d \
b a] \\n - [\\\\infty e d b c] \\n - [\\\\infty e d c a] \\n - [\\\\infty e d \
c b] \\n + [\\\\infty e f a c] \\n - [\\\\infty e f a d] \\n - [\\\\infty e f \
b d] \\n + [\\\\infty e f c a] \\n - [\\\\infty e f d a] \\n - [\\\\infty e f \
d b] \\n + [\\\\infty f b a d] \\n + [\\\\infty f b c d] \\n + 2 [\\\\infty f \
b c e] \\n + [\\\\infty f b d a] \\n + [\\\\infty f b d c] \\n + 2 [\\\\infty \
f b e c] \\n + [\\\\infty f c a d] \\n + 2 [\\\\infty f c a e] \\n + \
[\\\\infty f c d a] \\n - [\\\\infty f c e a] \\n + [\\\\infty f d a b] \\n - \
5 [\\\\infty f d a e] \\n + [\\\\infty f d b a] \\n + [\\\\infty f d c e] \\n \
- [\\\\infty f e a c] \\n + [\\\\infty f e a d] \\n + [\\\\infty f e b d] \\n \
- [\\\\infty f e c a] \\n + 2 [\\\\infty f e d a] \\n + [\\\\infty f e d b] ) \
+ {} \\\\\\\\ \\n & {} + \\\\frac{1}{3} I_{3, 2}( -[a b c d, a e b d] \\n + \
[a b c d, b d c e] \\n - [a b c d, b d e c] \\n + [a b c f, b f c d] \\n - 2 \
[a b c f, b f c e] \\n + [a b d f, a f e b] \\n - [a b d f, b f e d] \\n + [a \
b e d, a f d b] \\n + [a b e d, b d f e] \\n - [a b e d, b e d f] \\n - [a b \
e f, b f d e] \\n - [a b f d, a d e b] \\n - [a b f d, b d e f] \\n + [a c b \
d, a d b e] \\n - [a c b d, a d b f] \\n + [a c f b, b c f d] \\n - [a c f b, \
b c f e] \\n + [a c f b, b d f c] \\n - [a c f b, b e f c] \\n + [a d b f, b \
e f d] \\n - [a d c b, a e b d] \\n + [a d c b, a f d b] \\n + [a d c b, b d \
c e] \\n - [a d e b, a b f d] \\n - [a d e b, a c d b] \\n + [a d e b, a f d \
b] \\n + [a d e b, b d f e] \\n + [a d f b, a c d b] \\n - [a e b d, a b c d] \
\\n - [a e b d, a d c b] \\n - [a e b f, a f b c] \\n + [a e b f, a f b d] \
\\n - [a e f b, b c f e] \\n + [a e f b, b d f e] \\n - [a e f b, b e f c] \
\\n + [a e f b, b e f d] \\n - [a f b d, a b d e] \\n - [a f b d, a d b c] \
\\n - [a f b d, a d b e] \\n - [a f b d, b e d f] \\n + [a f c b, a e f b] \
\\n + [a f c b, b f c d] \\n - 2 [a f c b, b f c e] \\n - [a f d b, a e f b] \
\\n + [a f e b, a b d f] \\n - [a f e b, b f d e] \\n - [b c d e, b d f e] \
\\n + [b c d f, b e d c] \\n + [b c f d, a c f b] \\n - [b c f e, a c f b] \
\\n - [b c f e, a e f b] \\n + [b d c e, a b c d] \\n + [b d c e, a b d c] \
\\n + [b d c e, a d c b] \\n + [b d c f, b e d f] \\n - [b d e f, a b d e] \
\\n - [b d e f, a b f d] \\n - [b d e f, a d b e] \\n + [b d e f, b c e d] \
\\n + [b d e f, b e c d] \\n + [b d f c, a c f b] \\n + [b d f e, a e f b] \
\\n + [b e d c, b c d f] \\n - [b e d c, b d f e] \\n - [b e d f, a b e d] \
\\n - [b e d f, a f b d] \\n + [b e d f, b d c f] \\n - [b e f c, a c f b] \
\\n - [b e f c, a e f b] \\n + [b e f d, a d b f] \\n + [b e f d, a e f b] \
\\n + [b f c d, a b c f] \\n + [b f c d, a f c b] \\n - 2 [b f c e, a b c f] \
\\n - 2 [b f c e, a f c b] \\n + [b f d e, a b f d] \\n + [b f e d, a b f e] \
\\n + [b f e d, a f b e] ) + {} \\\\\\\\ \\n & {} + \\\\frac{1}{3} I_{3, 2}( \
[a b c d, b d c \\\\infty] \\n - [a b c d, b d \\\\infty c] \\n - [a b c f, a \
\\\\infty b f] \\n - [a b c f, a \\\\infty f b] \\n + [a b c f, b c f \
\\\\infty] \\n + [a b c f, b f c \\\\infty] \\n - [a b d f, a f \\\\infty b] \
\\n + [a b d f, a \\\\infty b f] \\n + 2 [a b d f, a \\\\infty f b] \\n - 2 \
[a b d f, b d f \\\\infty] \\n + [a b d f, b f d \\\\infty] \\n + [a b d f, b \
f \\\\infty d] \\n - [a b e d, a d \\\\infty b] \\n + [a b e d, a \\\\infty b \
d] \\n - [a b e f, a f \\\\infty b] \\n - [a b e f, a \\\\infty f b] \\n + [a \
b e f, b e f \\\\infty] \\n - [a b e f, b f \\\\infty e] \\n - [a b f d, a \\\
\\infty b d] \\n - [a b f d, b d \\\\infty f] \\n - [a b \\\\infty d, a d e \
b] \\n + [a b \\\\infty d, a e b d] \\n + [a b \\\\infty d, a e d b] \\n + [a \
b \\\\infty d, a f d b] \\n - [a b \\\\infty f, a c b f] \\n + 2 [a b \
\\\\infty f, a d b f] \\n - [a b \\\\infty f, a e b f] \\n - [a b \\\\infty \
f, a f d b] \\n + [a b \\\\infty f, a f e b] \\n - [a c b f, a b \\\\infty f] \
\\n - [a c b f, a f \\\\infty b] \\n + [a c d b, b c d \\\\infty] \\n + [a c \
d b, b \\\\infty d c] \\n + 2 [a d b f, a b \\\\infty f] \\n + 2 [a d b f, a \
f \\\\infty b] \\n - [a d b f, b \\\\infty f d] \\n + [a d c b, b d c \
\\\\infty] \\n - [a d e b, a b \\\\infty d] \\n + [a d e b, a \\\\infty b d] \
\\n + [a d e b, b d \\\\infty e] \\n - [a d f b, a \\\\infty b d] \\n - [a d \
\\\\infty b, a b e d] \\n + [a d \\\\infty b, a e b d] \\n + [a d \\\\infty \
b, a e d b] \\n - [a e b d, a b d \\\\infty] \\n + [a e b d, a b \\\\infty d] \
\\n - [a e b d, a d b \\\\infty] \\n + [a e b d, a d \\\\infty b] \\n - [a e \
b d, b \\\\infty d e] \\n - [a e b f, a b \\\\infty f] \\n - [a e b f, a f \\\
\\infty b] \\n - [a e b f, b \\\\infty f e] \\n + [a e d b, b e d \\\\infty] \
\\n + [a e d b, b \\\\infty d e] \\n - [a f b d, a b d \\\\infty] \\n - [a f \
c b, a \\\\infty b f] \\n - [a f c b, a \\\\infty f b] \\n + [a f c b, b f c \
\\\\infty] \\n - [a f d b, a b \\\\infty f] \\n + [a f d b, a \\\\infty b f] \
\\n + 2 [a f d b, a \\\\infty f b] \\n + [a f d b, b f d \\\\infty] \\n + [a \
f d b, b f \\\\infty d] \\n + [a f e b, a b \\\\infty f] \\n - [a f e b, a \\\
\\infty f b] \\n - [a f e b, b f \\\\infty e] \\n - [a f \\\\infty b, a b d \
f] \\n - [a f \\\\infty b, a b e f] \\n - [a f \\\\infty b, a c b f] \\n + 2 \
[a f \\\\infty b, a d b f] \\n - [a f \\\\infty b, a e b f] \\n + [a \
\\\\infty b d, a b e d] \\n - [a \\\\infty b d, a b f d] \\n + [a \\\\infty b \
d, a d e b] \\n - [a \\\\infty b d, a d f b] \\n - [a \\\\infty b f, a b c f] \
\\n + [a \\\\infty b f, a b d f] \\n + [a \\\\infty b f, a b f c] \\n - 2 [a \
\\\\infty b f, a b f d] \\n + [a \\\\infty b f, a b f e] \\n + [a \\\\infty b \
f, a f b c] \\n - 2 [a \\\\infty b f, a f b d] \\n + [a \\\\infty b f, a f b \
e] \\n - [a \\\\infty b f, a f c b] \\n + [a \\\\infty b f, a f d b] \\n + [b \
c d \\\\infty, a c d b] \\n + 2 [b c f e, b f \\\\infty e] \\n + [b c f e, b \
\\\\infty f c] \\n + [b c f \\\\infty, a b c f] \\n - [b c f \\\\infty, b f e \
c] \\n + [b d c e, b \\\\infty c d] \\n + [b d c \\\\infty, a b c d] \\n + [b \
d c \\\\infty, a b d c] \\n + [b d c \\\\infty, a d c b] \\n - [b d e c, b \\\
\\infty d c] \\n - [b d e f, b e \\\\infty d] \\n - [b d e \\\\infty, a b d \
e] \\n - [b d e \\\\infty, a d b e] \\n - 2 [b d f c, b f \\\\infty c] \\n + \
[b d f c, b \\\\infty d c] \\n - 2 [b d f e, b f \\\\infty e] \\n - [b d f e, \
b \\\\infty f d] \\n - 2 [b d f \\\\infty, a b d f] \\n + [b d f \\\\infty, b \
f c d] \\n + [b d f \\\\infty, b f e d] \\n - [b d \\\\infty e, a b e d] \\n \
- [b d \\\\infty f, a b f d] \\n - [b d \\\\infty f, b e d f] \\n - [b e d c, \
b \\\\infty d e] \\n - [b e d f, b d \\\\infty f] \\n + [b e d \\\\infty, a e \
d b] \\n + [b e d \\\\infty, b d f e] \\n + 2 [b e f c, b f \\\\infty c] \\n \
+ [b e f \\\\infty, a b e f] \\n - [b e f \\\\infty, b f c e] \\n + [b f c e, \
b c \\\\infty f] \\n + [b f c e, b \\\\infty c f] \\n + [b f c e, b \\\\infty \
f e] \\n + [b f c \\\\infty, a b c f] \\n + [b f c \\\\infty, a f c b] \\n + \
[b f c \\\\infty, b d c f] \\n - [b f c \\\\infty, b e c f] \\n - [b f d c, b \
d \\\\infty f] \\n - [b f d e, b d \\\\infty f] \\n - [b f d e, b \\\\infty d \
f] \\n - [b f d e, b \\\\infty f e] \\n + [b f d \\\\infty, a b d f] \\n - [b \
f d \\\\infty, a b f d] \\n - [b f d \\\\infty, a f b d] \\n + [b f d \
\\\\infty, a f d b] \\n + [b f e c, b e \\\\infty f] \\n + [b f e c, b \
\\\\infty e f] \\n + [b f e \\\\infty, a b f e] \\n + [b f e \\\\infty, a f b \
e] \\n - [b f e \\\\infty, b c e f] \\n + [b f e \\\\infty, b d e f] \\n - [b \
f \\\\infty c, b d f c] \\n + [b f \\\\infty c, b e f c] \\n + [b f \\\\infty \
e, b c f e] \\n - [b f \\\\infty e, b d f e] \\n + [b \\\\infty d c, a c d b] \
\\n - 2 [b \\\\infty d c, b d e c] \\n + [b \\\\infty d c, b d f c] \\n - [b \
\\\\infty d e, a e b d] \\n + [b \\\\infty d e, a e d b] \\n - [b \\\\infty d \
e, b e d c] \\n + [b \\\\infty d f, b f d c] \\n + [b \\\\infty f c, b c f e] \
\\n - [b \\\\infty f c, b f e c] \\n - [b \\\\infty f d, a d b f] \\n - [b \\\
\\infty f d, b d f e] \\n + [b \\\\infty f d, b f c d] \\n + [b \\\\infty f \
d, b f e d] \\n - [b \\\\infty f e, a e b f] \\n - [b \\\\infty f e, b f d e] \
) + {} \\\\\\\\ \\n & {} + \\\\frac{1}{3} I_{3, 2}( -[a b c \\\\infty, a d \\\
\\infty b] \\n + 2 [a b c \\\\infty, a e b \\\\infty] \\n + [a b c \\\\infty, \
a e \\\\infty b] \\n + [a b c \\\\infty, a f b \\\\infty] \\n - 2 [a b c \
\\\\infty, a f \\\\infty b] \\n + [a b c \\\\infty, b \\\\infty d c] \\n + [a \
b c \\\\infty, b \\\\infty e c] \\n - [a b d \\\\infty, a d c \\\\infty] \\n \
+ [a b d \\\\infty, a d e \\\\infty] \\n - [a b d \\\\infty, a d f \\\\infty] \
\\n + [a b d \\\\infty, a e \\\\infty b] \\n + [a b d \\\\infty, a f \
\\\\infty b] \\n - [a b d \\\\infty, a \\\\infty c d] \\n + [a b d \\\\infty, \
a \\\\infty d e] \\n - [a b d \\\\infty, a \\\\infty d f] \\n - [a b d \
\\\\infty, a \\\\infty e b] \\n + [a b d \\\\infty, a \\\\infty e d] \\n - [a \
b d \\\\infty, a \\\\infty f d] \\n + [a b d \\\\infty, b \\\\infty d e] \\n \
+ [a b d \\\\infty, b \\\\infty e d] \\n + [a b d \\\\infty, b \\\\infty f d] \
\\n - [a b e \\\\infty, a c b \\\\infty] \\n + [a b e \\\\infty, a c \
\\\\infty b] \\n - [a b e \\\\infty, a d b \\\\infty] \\n + [a b e \\\\infty, \
a d \\\\infty b] \\n + [a b e \\\\infty, a f b \\\\infty] \\n - [a b e \
\\\\infty, a \\\\infty d b] \\n - [a b e \\\\infty, a \\\\infty f b] \\n + [a \
b e \\\\infty, b \\\\infty e d] \\n + [a b e \\\\infty, b \\\\infty e f] \\n \
+ [a b f \\\\infty, a c b \\\\infty] \\n - 2 [a b f \\\\infty, a c \\\\infty \
b] \\n + [a b f \\\\infty, a d b \\\\infty] \\n + [a b f \\\\infty, a d \
\\\\infty b] \\n - [a b f \\\\infty, a e \\\\infty b] \\n - [a b f \\\\infty, \
a f c \\\\infty] \\n + [a b f \\\\infty, a f d \\\\infty] \\n - [a b f \
\\\\infty, a f \\\\infty e] \\n - [a b f \\\\infty, a \\\\infty c f] \\n + [a \
b f \\\\infty, a \\\\infty d f] \\n - [a b f \\\\infty, a \\\\infty e b] \\n \
- [a b f \\\\infty, a \\\\infty f c] \\n + [a b f \\\\infty, a \\\\infty f d] \
\\n - [a b f \\\\infty, a \\\\infty f e] \\n - [a b f \\\\infty, b \\\\infty \
e f] \\n + [a b f \\\\infty, b \\\\infty f e] \\n + [a b \\\\infty d, b d c \
\\\\infty] \\n + [a b \\\\infty d, b d e \\\\infty] \\n - [a b \\\\infty d, b \
d f \\\\infty] \\n + [a b \\\\infty d, b d \\\\infty e] \\n + [a b \\\\infty \
d, b \\\\infty c d] \\n - [a b \\\\infty d, b \\\\infty d e] \\n - [a b \
\\\\infty d, b \\\\infty d f] \\n + [a b \\\\infty f, b f c \\\\infty] \\n - \
[a b \\\\infty f, b f d \\\\infty] \\n + 2 [a b \\\\infty f, b f e \\\\infty] \
\\n + [a c b \\\\infty, b c \\\\infty d] \\n + [a c b \\\\infty, b d \
\\\\infty c] \\n + [a c d \\\\infty, a d e \\\\infty] \\n - [a c d \\\\infty, \
a d f \\\\infty] \\n + [a c d \\\\infty, a \\\\infty d e] \\n - [a c d \
\\\\infty, a \\\\infty d f] \\n + [a c d \\\\infty, a \\\\infty e d] \\n - [a \
c d \\\\infty, a \\\\infty f d] \\n - [a c f \\\\infty, a f b \\\\infty] \\n \
- [a c f \\\\infty, a \\\\infty b f] \\n + [a c \\\\infty b, a b e \\\\infty] \
\\n - 2 [a c \\\\infty b, a b f \\\\infty] \\n + [a c \\\\infty b, a b \
\\\\infty e] \\n - [a c \\\\infty b, a b \\\\infty f] \\n + [a c \\\\infty b, \
a \\\\infty e b] \\n - 2 [a c \\\\infty b, a \\\\infty f b] \\n + [a c \
\\\\infty d, b d c \\\\infty] \\n + [a c \\\\infty d, b \\\\infty c d] \\n + \
[a d b \\\\infty, a e \\\\infty d] \\n + [a d b \\\\infty, a f \\\\infty d] \
\\n + [a d b \\\\infty, b c \\\\infty d] \\n - [a d b \\\\infty, b d e \
\\\\infty] \\n - [a d b \\\\infty, b d f \\\\infty] \\n + [a d b \\\\infty, b \
d \\\\infty c] \\n + [a d b \\\\infty, b d \\\\infty e] \\n + 2 [a d b \
\\\\infty, b e \\\\infty d] \\n - [a d c \\\\infty, a b d \\\\infty] \\n + 2 \
[a d c \\\\infty, a e d \\\\infty] \\n + [a d c \\\\infty, a e \\\\infty d] \
\\n - [a d c \\\\infty, a f d \\\\infty] \\n + [a d c \\\\infty, b c \
\\\\infty d] \\n - [a d c \\\\infty, c d e \\\\infty] \\n - [a d c \\\\infty, \
c e \\\\infty d] \\n + [a d e \\\\infty, a b d \\\\infty] \\n + [a d e \
\\\\infty, a c d \\\\infty] \\n - [a d e \\\\infty, a \\\\infty b d] \\n - [a \
d e \\\\infty, b e d \\\\infty] \\n - [a d e \\\\infty, c e d \\\\infty] \\n \
- [a d f \\\\infty, a b d \\\\infty] \\n - [a d f \\\\infty, a c d \\\\infty] \
\\n + 2 [a d f \\\\infty, a f b \\\\infty] \\n + 2 [a d f \\\\infty, a \
\\\\infty b f] \\n - [a d f \\\\infty, b f d \\\\infty] \\n - [a d f \
\\\\infty, d \\\\infty e f] \\n - [a d \\\\infty b, a b c \\\\infty] \\n + [a \
d \\\\infty b, a b e \\\\infty] \\n + [a d \\\\infty b, a b f \\\\infty] \\n \
+ [a d \\\\infty b, a b \\\\infty e] \\n - [a d \\\\infty b, a b \\\\infty f] \
\\n - [a d \\\\infty b, a \\\\infty c b] \\n + [a d \\\\infty b, a \\\\infty \
e b] \\n + [a d \\\\infty b, a \\\\infty f b] \\n + [a d \\\\infty b, b d e \
\\\\infty] \\n + [a d \\\\infty f, d f e \\\\infty] \\n + [a d \\\\infty f, d \
\\\\infty e f] \\n + [a e b \\\\infty, b d \\\\infty e] \\n + [a e b \
\\\\infty, b e \\\\infty d] \\n + 2 [a e d \\\\infty, a d c \\\\infty] \\n - \
[a e d \\\\infty, a d \\\\infty b] \\n - [a e d \\\\infty, a d \\\\infty c] \
\\n + 2 [a e d \\\\infty, a \\\\infty c d] \\n - [a e d \\\\infty, a \
\\\\infty d b] \\n - [a e d \\\\infty, a \\\\infty d c] \\n - [a e d \
\\\\infty, b d e \\\\infty] \\n - [a e f \\\\infty, a f b \\\\infty] \\n - [a \
e f \\\\infty, a f c \\\\infty] \\n + [a e f \\\\infty, a f d \\\\infty] \\n \
- [a e f \\\\infty, a \\\\infty b f] \\n - [a e f \\\\infty, a \\\\infty c f] \
\\n + [a e f \\\\infty, a \\\\infty d f] \\n - [a e f \\\\infty, a \\\\infty \
f c] \\n + [a e f \\\\infty, a \\\\infty f d] \\n - [a e f \\\\infty, b f e \
\\\\infty] \\n + [a e \\\\infty b, a b c \\\\infty] \\n + [a e \\\\infty b, a \
b d \\\\infty] \\n - [a e \\\\infty b, a b f \\\\infty] \\n - 2 [a e \
\\\\infty b, a b \\\\infty c] \\n - [a e \\\\infty b, a \\\\infty b c] \\n - \
[a e \\\\infty b, a \\\\infty b d] \\n + [a e \\\\infty b, a \\\\infty c b] \
\\n + [a e \\\\infty b, a \\\\infty d b] \\n - [a e \\\\infty b, a \\\\infty \
f b] \\n - [a e \\\\infty b, b e \\\\infty d] \\n - [a e \\\\infty b, b e \
\\\\infty f] \\n + [a e \\\\infty d, b d e \\\\infty] \\n + [a e \\\\infty d, \
b \\\\infty e d] \\n - [a f b \\\\infty, a c f \\\\infty] \\n + 2 [a f b \
\\\\infty, a d f \\\\infty] \\n - [a f b \\\\infty, a e f \\\\infty] \\n - [a \
f b \\\\infty, a \\\\infty e f] \\n - [a f c \\\\infty, a b f \\\\infty] \\n \
- [a f c \\\\infty, a e f \\\\infty] \\n - [a f c \\\\infty, c d \\\\infty f] \
\\n + [a f c \\\\infty, c e f \\\\infty] \\n + [a f d \\\\infty, a b f \
\\\\infty] \\n - [a f d \\\\infty, a d c \\\\infty] \\n - [a f d \\\\infty, a \
d \\\\infty b] \\n + [a f d \\\\infty, a e f \\\\infty] \\n - [a f d \
\\\\infty, a \\\\infty c d] \\n - [a f d \\\\infty, a \\\\infty d b] \\n - [a \
f d \\\\infty, a \\\\infty e f] \\n - [a f d \\\\infty, b d f \\\\infty] \\n \
+ [a f d \\\\infty, b d \\\\infty f] \\n + [a f d \\\\infty, d e f \\\\infty] \
\\n - [a f d \\\\infty, d e \\\\infty f] \\n + [a f e \\\\infty, a b \
\\\\infty f] \\n - [a f e \\\\infty, a \\\\infty b f] \\n + [a f e \\\\infty, \
b e f \\\\infty] \\n - [a f e \\\\infty, b \\\\infty e f] \\n + [a f e \
\\\\infty, d e f \\\\infty] \\n - 2 [a f \\\\infty b, a b c \\\\infty] \\n + \
[a f \\\\infty b, a b d \\\\infty] \\n - [a f \\\\infty b, a b \\\\infty c] \
\\n - [a f \\\\infty b, a b \\\\infty e] \\n - [a f \\\\infty b, a \\\\infty \
b d] \\n - [a f \\\\infty b, a \\\\infty b e] \\n - 2 [a f \\\\infty b, a \
\\\\infty c b] \\n + [a f \\\\infty b, a \\\\infty d b] \\n + [a f \\\\infty \
b, b f d \\\\infty] \\n + [a f \\\\infty b, b f e \\\\infty] \\n - [a f \
\\\\infty b, b f \\\\infty e] \\n - [a \\\\infty b d, a d e \\\\infty] \\n + \
[a \\\\infty b d, a e \\\\infty d] \\n + [a \\\\infty b d, a f \\\\infty d] \
\\n - [a \\\\infty b d, b e d \\\\infty] \\n + [a \\\\infty b d, b e \
\\\\infty d] \\n - [a \\\\infty b f, a c f \\\\infty] \\n + 2 [a \\\\infty b \
f, a d f \\\\infty] \\n - [a \\\\infty b f, a e f \\\\infty] \\n - [a \
\\\\infty b f, a f e \\\\infty] \\n - [a \\\\infty b f, b d f \\\\infty] \\n \
+ [a \\\\infty b f, b e f \\\\infty] \\n + [a \\\\infty b f, b e \\\\infty f] \
\\n - [a \\\\infty c b, a d \\\\infty b] \\n + [a \\\\infty c b, a e b \
\\\\infty] \\n + [a \\\\infty c b, a e \\\\infty b] \\n - 2 [a \\\\infty c b, \
a f \\\\infty b] \\n - [a \\\\infty c b, b e \\\\infty c] \\n - [a \\\\infty \
c b, b \\\\infty c d] \\n - [a \\\\infty c b, b \\\\infty c e] \\n + [a \
\\\\infty c b, b \\\\infty d c] \\n + [a \\\\infty c b, b \\\\infty e c] \\n \
- [a \\\\infty c d, a b d \\\\infty] \\n + 2 [a \\\\infty c d, a e d \
\\\\infty] \\n + [a \\\\infty c d, a e \\\\infty d] \\n - [a \\\\infty c d, a \
f d \\\\infty] \\n + [a \\\\infty c d, b c \\\\infty d] \\n - [a \\\\infty c \
f, a b f \\\\infty] \\n + [a \\\\infty c f, a b \\\\infty f] \\n - [a \
\\\\infty c f, a e f \\\\infty] \\n + [a \\\\infty c f, a e \\\\infty f] \\n \
+ [a \\\\infty c f, c e f \\\\infty] \\n - [a \\\\infty d b, a b e \\\\infty] \
\\n + [a \\\\infty d b, a e b \\\\infty] \\n + [a \\\\infty d b, a e \
\\\\infty b] \\n + [a \\\\infty d b, a f b \\\\infty] \\n + [a \\\\infty d b, \
a f \\\\infty b] \\n + [a \\\\infty d b, b e d \\\\infty] \\n - [a \\\\infty \
d b, b e \\\\infty d] \\n - [a \\\\infty d b, b f \\\\infty d] \\n + [a \
\\\\infty d b, b \\\\infty d e] \\n - [a \\\\infty d b, b \\\\infty d f] \\n \
+ [a \\\\infty d b, b \\\\infty e d] \\n + [a \\\\infty d b, b \\\\infty f d] \
\\n + [a \\\\infty d f, a b f \\\\infty] \\n - [a \\\\infty d f, a b \
\\\\infty f] \\n + [a \\\\infty d f, a e f \\\\infty] \\n - [a \\\\infty d f, \
a e \\\\infty f] \\n + [a \\\\infty d f, b d \\\\infty f] \\n + [a \\\\infty \
d f, d e f \\\\infty] \\n - [a \\\\infty e b, a b d \\\\infty] \\n - [a \
\\\\infty e b, a b f \\\\infty] \\n + [a \\\\infty e b, a c \\\\infty b] \\n \
+ [a \\\\infty e b, a d \\\\infty b] \\n + [a \\\\infty e b, a f b \\\\infty] \
\\n - [a \\\\infty e b, b f \\\\infty e] \\n - [a \\\\infty e b, b \\\\infty \
e c] \\n + [a \\\\infty e b, b \\\\infty e f] \\n + [a \\\\infty e d, a b d \
\\\\infty] \\n - [a \\\\infty e d, a b \\\\infty d] \\n + [a \\\\infty e d, a \
c d \\\\infty] \\n - [a \\\\infty e d, a c \\\\infty d] \\n + [a \\\\infty e \
f, a b \\\\infty f] \\n - [a \\\\infty e f, a f b \\\\infty] \\n - [a \
\\\\infty e f, a f d \\\\infty] \\n + [a \\\\infty e f, b e f \\\\infty] \\n \
+ [a \\\\infty e f, d e f \\\\infty] \\n - [a \\\\infty f b, a b e \\\\infty] \
\\n - 2 [a \\\\infty f b, a c \\\\infty b] \\n + [a \\\\infty f b, a d \
\\\\infty b] \\n - [a \\\\infty f b, a e \\\\infty b] \\n - [a \\\\infty f b, \
b \\\\infty f d] \\n - [a \\\\infty f d, a b d \\\\infty] \\n + [a \\\\infty \
f d, a b \\\\infty d] \\n - [a \\\\infty f d, a c d \\\\infty] \\n + [a \
\\\\infty f d, a c \\\\infty d] \\n - [b c d \\\\infty, b d \\\\infty e] \\n \
+ [b c d \\\\infty, b d \\\\infty f] \\n - [b c d \\\\infty, b \\\\infty d e] \
\\n + [b c d \\\\infty, b \\\\infty d f] \\n - [b c f \\\\infty, b f e \
\\\\infty] \\n + [b c f \\\\infty, b \\\\infty f e] \\n - [b c f \\\\infty, c \
\\\\infty d f] \\n + [b c f \\\\infty, c \\\\infty e f] \\n + [b c \\\\infty \
d, a c b \\\\infty] \\n + [b c \\\\infty d, a d b \\\\infty] \\n + [b c \
\\\\infty d, a d c \\\\infty] \\n + [b c \\\\infty d, a \\\\infty c d] \\n + \
[b c \\\\infty d, b f \\\\infty c] \\n - 2 [b c \\\\infty d, b \\\\infty c e] \
\\n - [b c \\\\infty d, b \\\\infty d f] \\n - [b c \\\\infty d, b \\\\infty \
e d] \\n + [b c \\\\infty d, b \\\\infty f d] \\n - [b c \\\\infty d, c d \
\\\\infty e] \\n + [b c \\\\infty d, c d \\\\infty f] \\n - [b c \\\\infty d, \
c \\\\infty d e] \\n + [b c \\\\infty d, c \\\\infty d f] \\n - [b c \
\\\\infty e, b d \\\\infty c] \\n - [b c \\\\infty e, b e \\\\infty d] \\n + \
[b c \\\\infty e, b \\\\infty c d] \\n + [b c \\\\infty e, b \\\\infty c f] \
\\n + [b c \\\\infty e, b \\\\infty e d] \\n + [b c \\\\infty f, b d \
\\\\infty c] \\n + [b c \\\\infty f, b e \\\\infty c] \\n + [b c \\\\infty f, \
b f \\\\infty e] \\n - [b c \\\\infty f, b \\\\infty c d] \\n - [b c \
\\\\infty f, b \\\\infty c e] \\n + [b c \\\\infty f, b \\\\infty e f] \\n - \
[b c \\\\infty f, b \\\\infty f d] \\n - [b c \\\\infty f, b \\\\infty f e] \
\\n + [b d c \\\\infty, a b \\\\infty d] \\n + [b d c \\\\infty, a c \
\\\\infty d] \\n - [b d c \\\\infty, b f \\\\infty d] \\n + [b d c \\\\infty, \
c d f \\\\infty] \\n - 2 [b d c \\\\infty, c e \\\\infty d] \\n + [b d c \
\\\\infty, c f \\\\infty d] \\n - [b d e \\\\infty, a d b \\\\infty] \\n - [b \
d e \\\\infty, a e d \\\\infty] \\n + [b d e \\\\infty, a e \\\\infty d] \\n \
+ [b d e \\\\infty, b c \\\\infty d] \\n - [b d e \\\\infty, c \\\\infty e d] \
\\n - [b d e \\\\infty, d \\\\infty f e] \\n - [b d f \\\\infty, a d b \
\\\\infty] \\n - [b d f \\\\infty, a \\\\infty b f] \\n - [b d f \\\\infty, b \
c \\\\infty d] \\n + [b d f \\\\infty, b f e \\\\infty] \\n - [b d f \
\\\\infty, b \\\\infty f c] \\n - [b d f \\\\infty, b \\\\infty f e] \\n + [b \
d f \\\\infty, c f d \\\\infty] \\n + [b d f \\\\infty, c \\\\infty f d] \\n \
+ [b d \\\\infty c, a c b \\\\infty] \\n + [b d \\\\infty c, a d b \\\\infty] \
\\n - [b d \\\\infty c, b c \\\\infty e] \\n + [b d \\\\infty c, b c \
\\\\infty f] \\n - [b d \\\\infty c, b e \\\\infty d] \\n + [b d \\\\infty c, \
b f \\\\infty d] \\n - 2 [b d \\\\infty c, b \\\\infty d e] \\n - [b d \
\\\\infty c, b \\\\infty e d] \\n + [b d \\\\infty c, b \\\\infty f d] \\n - \
[b d \\\\infty e, a b d \\\\infty] \\n + [b d \\\\infty e, a b \\\\infty d] \
\\n + [b d \\\\infty e, a e b \\\\infty] \\n - [b d \\\\infty e, b e \
\\\\infty c] \\n - [b d \\\\infty e, b f \\\\infty d] \\n - [b d \\\\infty e, \
b \\\\infty d f] \\n + [b d \\\\infty e, b \\\\infty e f] \\n + [b d \
\\\\infty f, a b d \\\\infty] \\n + [b d \\\\infty f, a f d \\\\infty] \\n + \
[b d \\\\infty f, a f \\\\infty d] \\n + [b d \\\\infty f, a \\\\infty d f] \
\\n + [b d \\\\infty f, b f \\\\infty c] \\n + [b d \\\\infty f, b \\\\infty \
d c] \\n + [b d \\\\infty f, b \\\\infty d e] \\n - [b d \\\\infty f, b \
\\\\infty e f] \\n + [b d \\\\infty f, b \\\\infty f e] \\n + [b d \\\\infty \
f, d \\\\infty f e] \\n - [b e d \\\\infty, a d e \\\\infty] \\n - [b e d \
\\\\infty, a d \\\\infty b] \\n - [b e d \\\\infty, a \\\\infty b d] \\n + [b \
e d \\\\infty, b d c \\\\infty] \\n - [b e d \\\\infty, b d f \\\\infty] \\n \
+ [b e d \\\\infty, b \\\\infty d c] \\n - [b e d \\\\infty, b \\\\infty d f] \
\\n - [b e f \\\\infty, a f \\\\infty b] \\n + [b e f \\\\infty, a \\\\infty \
b f] \\n - [b e f \\\\infty, a \\\\infty f b] \\n + [b e f \\\\infty, b f \
\\\\infty c] \\n - [b e f \\\\infty, b f \\\\infty d] \\n + 2 [b e f \
\\\\infty, b \\\\infty f c] \\n - [b e f \\\\infty, b \\\\infty f d] \\n + [b \
e f \\\\infty, c f e \\\\infty] \\n - [b e f \\\\infty, d f e \\\\infty] \\n \
- [b e \\\\infty c, a \\\\infty c b] \\n + [b e \\\\infty c, b c \\\\infty f] \
\\n - [b e \\\\infty c, b d \\\\infty e] \\n + [b e \\\\infty c, b \\\\infty \
c d] \\n + [b e \\\\infty c, b \\\\infty e d] \\n + [b e \\\\infty c, b \
\\\\infty e f] \\n + [b e \\\\infty d, a d b \\\\infty] \\n + [b e \\\\infty \
d, a e b \\\\infty] \\n - [b e \\\\infty d, a e \\\\infty b] \\n - [b e \
\\\\infty d, a \\\\infty d b] \\n - [b e \\\\infty d, b c \\\\infty e] \\n - \
[b e \\\\infty d, b d \\\\infty f] \\n - [b e \\\\infty d, b \\\\infty c d] \
\\n + [b e \\\\infty d, b \\\\infty d c] \\n - [b e \\\\infty d, b \\\\infty \
e f] \\n - [b e \\\\infty d, c d \\\\infty e] \\n - [b e \\\\infty d, c \
\\\\infty d e] \\n - [b e \\\\infty f, a e \\\\infty b] \\n - [b e \\\\infty \
f, a f b \\\\infty] \\n - [b e \\\\infty f, a f \\\\infty e] \\n - [b e \
\\\\infty f, a \\\\infty f e] \\n + [b e \\\\infty f, b f \\\\infty c] \\n - \
[b e \\\\infty f, b f \\\\infty d] \\n - [b e \\\\infty f, b \\\\infty e d] \
\\n + [b e \\\\infty f, c f \\\\infty e] \\n + [b e \\\\infty f, c \\\\infty \
f e] \\n - [b e \\\\infty f, d f \\\\infty e] \\n - [b e \\\\infty f, d \
\\\\infty f e] \\n + [b f c \\\\infty, a b \\\\infty f] \\n - [b f c \
\\\\infty, b e \\\\infty f] \\n - [b f c \\\\infty, b \\\\infty d f] \\n + [b \
f c \\\\infty, b \\\\infty e f] \\n - [b f c \\\\infty, c e \\\\infty f] \\n \
+ [b f c \\\\infty, c f e \\\\infty] \\n - 2 [b f d \\\\infty, a b \\\\infty \
f] \\n - [b f d \\\\infty, a d f \\\\infty] \\n - [b f d \\\\infty, b d c \
\\\\infty] \\n + [b f d \\\\infty, b d \\\\infty c] \\n + [b f d \\\\infty, b \
e \\\\infty f] \\n + [b f d \\\\infty, b \\\\infty d c] \\n + [b f d \
\\\\infty, c d f \\\\infty] \\n + [b f d \\\\infty, d e \\\\infty f] \\n - [b \
f d \\\\infty, d f e \\\\infty] \\n + [b f e \\\\infty, a b \\\\infty f] \\n \
- [b f e \\\\infty, a e f \\\\infty] \\n + [b f e \\\\infty, b \\\\infty c f] \
\\n - [b f e \\\\infty, b \\\\infty d f] \\n - [b f e \\\\infty, d e f \
\\\\infty] \\n + [b f \\\\infty c, b c \\\\infty d] \\n + [b f \\\\infty c, b \
d \\\\infty f] \\n + [b f \\\\infty c, b e \\\\infty f] \\n - [b f \\\\infty \
c, b \\\\infty c d] \\n - [b f \\\\infty c, b \\\\infty c e] \\n - [b f \
\\\\infty c, b \\\\infty f d] \\n - [b f \\\\infty c, b \\\\infty f e] \\n - \
[b f \\\\infty d, a b f \\\\infty] \\n - [b f \\\\infty d, a f b \\\\infty] \
\\n - [b f \\\\infty d, a \\\\infty d b] \\n - [b f \\\\infty d, b d \
\\\\infty e] \\n - [b f \\\\infty d, b e \\\\infty f] \\n + [b f \\\\infty d, \
b \\\\infty c d] \\n + [b f \\\\infty d, b \\\\infty d e] \\n + [b f \
\\\\infty d, b \\\\infty f c] \\n + [b f \\\\infty d, b \\\\infty f e] \\n + \
[b f \\\\infty d, c d \\\\infty f] \\n + [b f \\\\infty d, c \\\\infty d f] \
\\n - [b f \\\\infty e, a b f \\\\infty] \\n - [b f \\\\infty e, a f b \
\\\\infty] \\n - [b f \\\\infty e, a f \\\\infty b] \\n - [b f \\\\infty e, a \
\\\\infty e b] \\n + 2 [b f \\\\infty e, b c \\\\infty f] \\n - [b f \
\\\\infty e, b d \\\\infty f] \\n + [b f \\\\infty e, b \\\\infty c f] \\n - \
[b f \\\\infty e, b \\\\infty d f] \\n - [b f \\\\infty e, b \\\\infty e c] \
\\n - [b f \\\\infty e, b \\\\infty f d] \\n + [b \\\\infty c d, a b \
\\\\infty d] \\n + [b \\\\infty c d, a c \\\\infty d] \\n - [b \\\\infty c d, \
b d e \\\\infty] \\n - [b \\\\infty c d, b e d \\\\infty] \\n - 2 [b \
\\\\infty c d, b e \\\\infty d] \\n - [b \\\\infty c d, c \\\\infty e d] \\n \
+ [b \\\\infty c d, c \\\\infty f d] \\n - [b \\\\infty c e, b c \\\\infty d] \
\\n + [b \\\\infty c e, b e f \\\\infty] \\n + [b \\\\infty c e, b f e \
\\\\infty] \\n + [b \\\\infty c f, b c \\\\infty e] \\n - [b \\\\infty c f, b \
e \\\\infty f] \\n + [b \\\\infty c f, b f e \\\\infty] \\n - [b \\\\infty c \
f, c e \\\\infty f] \\n + [b \\\\infty c f, c \\\\infty e f] \\n + [b \
\\\\infty d c, a b c \\\\infty] \\n + [b \\\\infty d c, a \\\\infty b c] \\n \
+ [b \\\\infty d c, a \\\\infty c b] \\n - [b \\\\infty d c, b c e \\\\infty] \
\\n + [b \\\\infty d c, b c f \\\\infty] \\n - [b \\\\infty d c, b d \
\\\\infty e] \\n + [b \\\\infty d c, b d \\\\infty f] \\n - [b \\\\infty d c, \
b e c \\\\infty] \\n + [b \\\\infty d c, b f c \\\\infty] \\n - [b \\\\infty \
d e, a b \\\\infty d] \\n - [b \\\\infty d e, a b \\\\infty e] \\n - [b \
\\\\infty d e, a \\\\infty b e] \\n + [b \\\\infty d e, a \\\\infty d b] \\n \
- [b \\\\infty d e, b c e \\\\infty] \\n + [b \\\\infty d e, b d c \\\\infty] \
\\n - [b \\\\infty d e, b d \\\\infty c] \\n - [b \\\\infty d e, b e c \
\\\\infty] \\n - [b \\\\infty d f, a b \\\\infty d] \\n + [b \\\\infty d f, b \
c f \\\\infty] \\n - [b \\\\infty d f, b d c \\\\infty] \\n + [b \\\\infty d \
f, b d \\\\infty c] \\n - [b \\\\infty d f, b e d \\\\infty] \\n + [b \
\\\\infty d f, b e \\\\infty f] \\n - [b \\\\infty d f, b f e \\\\infty] \\n \
+ [b \\\\infty d f, c d f \\\\infty] \\n + [b \\\\infty d f, d e \\\\infty f] \
\\n - [b \\\\infty d f, d \\\\infty e f] \\n + [b \\\\infty e c, a b c \
\\\\infty] \\n + [b \\\\infty e c, a \\\\infty b c] \\n + [b \\\\infty e c, a \
\\\\infty c b] \\n - [b \\\\infty e c, a \\\\infty e b] \\n + [b \\\\infty e \
c, b c d \\\\infty] \\n + [b \\\\infty e c, b c f \\\\infty] \\n + [b \
\\\\infty e c, b e \\\\infty f] \\n + [b \\\\infty e c, b f c \\\\infty] \\n \
+ [b \\\\infty e d, a b d \\\\infty] \\n - [b \\\\infty e d, a b \\\\infty d] \
\\n + [b \\\\infty e d, a e \\\\infty d] \\n + [b \\\\infty e d, a \\\\infty \
d b] \\n - [b \\\\infty e d, a \\\\infty e b] \\n + [b \\\\infty e d, b d c \
\\\\infty] \\n - [b \\\\infty e d, b d f \\\\infty] \\n - [b \\\\infty e d, b \
e \\\\infty f] \\n - [b \\\\infty e d, b f d \\\\infty] \\n - [b \\\\infty e \
d, c d e \\\\infty] \\n - [b \\\\infty e f, a b f \\\\infty] \\n - [b \
\\\\infty e f, a b \\\\infty f] \\n - [b \\\\infty e f, a f e \\\\infty] \\n \
- [b \\\\infty e f, a \\\\infty b f] \\n + [b \\\\infty e f, b c f \\\\infty] \
\\n + [b \\\\infty e f, b c \\\\infty f] \\n - [b \\\\infty e f, b d f \
\\\\infty] \\n - [b \\\\infty e f, b d \\\\infty f] \\n + [b \\\\infty e f, b \
e \\\\infty c] \\n - [b \\\\infty e f, b e \\\\infty d] \\n + 2 [b \\\\infty \
e f, b f c \\\\infty] \\n - [b \\\\infty e f, b f d \\\\infty] \\n - [b \
\\\\infty e f, c e f \\\\infty] \\n - [b \\\\infty f c, b d f \\\\infty] \\n \
+ [b \\\\infty f c, b e f \\\\infty] \\n - [b \\\\infty f c, b f e \\\\infty] \
\\n + [b \\\\infty f c, b f \\\\infty d] \\n + [b \\\\infty f d, a b d \
\\\\infty] \\n + [b \\\\infty f d, a \\\\infty b d] \\n + [b \\\\infty f d, a \
\\\\infty d b] \\n - [b \\\\infty f d, a \\\\infty f b] \\n + [b \\\\infty f \
d, b c d \\\\infty] \\n + [b \\\\infty f d, b d c \\\\infty] \\n + [b \
\\\\infty f d, b d e \\\\infty] \\n + [b \\\\infty f d, b f e \\\\infty] \\n \
- [b \\\\infty f d, b f \\\\infty e] \\n + [b \\\\infty f d, c d f \\\\infty] \
\\n - [b \\\\infty f e, a b \\\\infty e] \\n - [b \\\\infty f e, a \\\\infty \
b e] \\n - [b \\\\infty f e, a \\\\infty f b] \\n + [b \\\\infty f e, b c f \
\\\\infty] \\n - [b \\\\infty f e, b d e \\\\infty] \\n - [b \\\\infty f e, b \
d f \\\\infty] \\n - [c d e \\\\infty, a d c \\\\infty] \\n + [c d e \
\\\\infty, b c d \\\\infty] \\n + [c d e \\\\infty, b e d \\\\infty] \\n - [c \
d e \\\\infty, b \\\\infty e d] \\n + [c d e \\\\infty, d \\\\infty f e] \\n \
+ [c d f \\\\infty, a f \\\\infty c] \\n - [c d f \\\\infty, b c d \\\\infty] \
\\n + [c d f \\\\infty, b d c \\\\infty] \\n - [c d f \\\\infty, b f d \
\\\\infty] \\n + [c d f \\\\infty, b \\\\infty f d] \\n - [c d f \\\\infty, c \
\\\\infty e d] \\n - [c d \\\\infty f, b f \\\\infty d] \\n - [c d \\\\infty \
f, b \\\\infty f d] \\n - [c e d \\\\infty, a d e \\\\infty] \\n + [c e d \
\\\\infty, a d \\\\infty c] \\n + [c e d \\\\infty, b d \\\\infty c] \\n + [c \
e f \\\\infty, a f c \\\\infty] \\n + [c e f \\\\infty, a \\\\infty c f] \\n \
+ [c e f \\\\infty, b f e \\\\infty] \\n + [c e f \\\\infty, b f \\\\infty c] \
\\n + [c e f \\\\infty, b \\\\infty f c] \\n - [c e \\\\infty d, b d c \
\\\\infty] \\n + [c e \\\\infty f, b f \\\\infty e] \\n + [c e \\\\infty f, b \
\\\\infty f e] \\n + [c f d \\\\infty, b d f \\\\infty] \\n - [c f d \
\\\\infty, d e \\\\infty f] \\n + [c f e \\\\infty, b f c \\\\infty] \\n + [c \
f \\\\infty d, b d c \\\\infty] \\n - [c \\\\infty d f, b c f \\\\infty] \\n \
+ [c \\\\infty e d, b c d \\\\infty] \\n - [c \\\\infty e d, b d e \\\\infty] \
\\n + [c \\\\infty e d, b e d \\\\infty] \\n - [c \\\\infty e d, b \\\\infty \
c d] \\n - [c \\\\infty e d, c d f \\\\infty] \\n + [c \\\\infty e d, d \
\\\\infty f e] \\n + [c \\\\infty e f, b c f \\\\infty] \\n - [c \\\\infty e \
f, b e f \\\\infty] \\n + [c \\\\infty e f, b \\\\infty c f] \\n - [c \
\\\\infty f d, b c d \\\\infty] \\n + [c \\\\infty f d, b d f \\\\infty] \\n \
- [c \\\\infty f d, b f d \\\\infty] \\n + [c \\\\infty f d, b \\\\infty c d] \
\\n + [d e f \\\\infty, a f d \\\\infty] \\n + [d e f \\\\infty, a f \
\\\\infty d] \\n + [d e f \\\\infty, a \\\\infty d f] \\n - [d e f \\\\infty, \
b f e \\\\infty] \\n - [d e f \\\\infty, b f \\\\infty d] \\n - [d e f \
\\\\infty, b \\\\infty f d] \\n - [d e \\\\infty f, a f \\\\infty e] \\n - [d \
e \\\\infty f, a \\\\infty f e] \\n - [d e \\\\infty f, c f d \\\\infty] \\n \
+ [d f e \\\\infty, a d \\\\infty f] \\n - [d f e \\\\infty, b f d \\\\infty] \
\\n - [d \\\\infty e f, a d f \\\\infty] \\n + [d \\\\infty e f, a d \
\\\\infty f] \\n - [d \\\\infty e f, b d f \\\\infty] \\n + [d \\\\infty e f, \
b d \\\\infty e] \\n + [d \\\\infty e f, b e f \\\\infty] \\n - [d \\\\infty \
e f, b \\\\infty d f] \\n - [d \\\\infty e f, c d \\\\infty e] \\n - [d \
\\\\infty e f, c \\\\infty d e] ) + {} \\\\\\\\ \\n & {} + \\\\frac{1}{3} \
I_{3, 2}( [a b c d, a d f e] \\n - [a b c d, a f b e] \\n + [a b c d, a f d \
e] \\n + [a b c f, b c e d] \\n + [a b c f, b f e d] \\n + [a b e f, a d b c] \
\\n - [a b e f, b c e d] \\n + [a b f c, b c d e] \\n + [a b f c, b e d c] \
\\n - [a b f c, b e d f] \\n + [a b f e, a d c b] \\n - [a b f e, b c d e] \
\\n - [a b f e, b e d c] \\n - [a c b d, b d f e] \\n - [a c f b, b f d e] \
\\n + [a d b c, a b e f] \\n + [a d b c, a f e b] \\n - [a d b c, b e f d] \
\\n + [a d c b, a b f e] \\n + [a d c b, b d e f] \\n - [a d f c, b d f e] \
\\n - [a d f c, b f d e] \\n + [a d f e, a b c d] \\n - [a f b e, a b c d] \
\\n - [a f c b, b e c d] \\n + [a f c b, c d f e] \\n + [a f c b, c f d e] \
\\n + [a f d e, a b c d] \\n + [a f e b, a d b c] \\n - [a f e b, b c e d] \
\\n + [b c d e, a b f c] \\n - [b c d e, a b f e] \\n + [b c e d, a b c f] \
\\n - [b c e d, a b e f] \\n - [b c e d, a f e b] \\n + [b d e f, a c d b] \
\\n + [b d e f, a d c b] \\n - [b d f e, a d f c] \\n - [b e c d, a f c b] \
\\n + [b e d c, a b f c] \\n - [b e d c, a b f e] \\n - [b e d f, a b f c] \
\\n - [b e f d, a d b c] \\n - [b f d e, a d f c] \\n + [b f e d, a b c f] \
\\n + [b f e d, a c b f] \\n + [c d f e, a f c b] \\n + [c f d e, a f c b] ) \
+ {} \\\\\\\\ \\n & {} + \\\\frac{1}{3} I_{3, 2}( -[a b c d, a f \\\\infty b] \
\\n - [a b c d, a \\\\infty e b] \\n - [a b c d, b c e \\\\infty] \\n - [a b \
c d, b c \\\\infty e] \\n - [a b c d, b d e \\\\infty] \\n + [a b c d, b d f \
\\\\infty] \\n - [a b c d, b d \\\\infty e] \\n + [a b c d, b \\\\infty f d] \
\\n + [a b c e, a f \\\\infty b] \\n + [a b c e, a \\\\infty f b] \\n + [a b \
c e, b d \\\\infty c] \\n - [a b c e, b e d \\\\infty] \\n - [a b c e, b e f \
\\\\infty] \\n + [a b c e, b \\\\infty d c] \\n - [a b c e, b \\\\infty d e] \
\\n - [a b c e, b \\\\infty f e] \\n - [a b c f, a e b \\\\infty] \\n + [a b \
c f, a e f \\\\infty] \\n + [a b c f, a f e \\\\infty] \\n - [a b c f, a \
\\\\infty b e] \\n - [a b c f, b c d \\\\infty] \\n + [a b c f, b c e \
\\\\infty] \\n - [a b c f, b c \\\\infty d] \\n + [a b c f, b e c \\\\infty] \
\\n - [a b c f, b e \\\\infty c] \\n + [a b c f, b f e \\\\infty] \\n - [a b \
c f, b f \\\\infty d] \\n - [a b c f, b \\\\infty d c] \\n + [a b c f, b \
\\\\infty d f] \\n - [a b c \\\\infty, a d e b] \\n + [a b c \\\\infty, a d f \
b] \\n - [a b c \\\\infty, b c d e] \\n - [a b c \\\\infty, b c e d] \\n - [a \
b c \\\\infty, b d c e] \\n + [a b c \\\\infty, b d f c] \\n - [a b c \
\\\\infty, b e c d] \\n - [a b c \\\\infty, b e f c] \\n + [a b d c, a d e \\\
\\infty] \\n - [a b d c, a d f \\\\infty] \\n - [a b d c, a \\\\infty e b] \
\\n + [a b d c, a \\\\infty f b] \\n + [a b d c, b e \\\\infty d] \\n - [a b \
d c, b f \\\\infty d] \\n + [a b d e, a d c \\\\infty] \\n - [a b d e, a \
\\\\infty c b] \\n + [a b d e, b c \\\\infty d] \\n - [a b d f, a d c \
\\\\infty] \\n + [a b d f, a e b \\\\infty] \\n - [a b d f, a e f \\\\infty] \
\\n - [a b d f, a f e \\\\infty] \\n + [a b d f, a \\\\infty b e] \\n + [a b \
d f, a \\\\infty c b] \\n - [a b d f, b c \\\\infty d] \\n - [a b d f, b d \\\
\\infty e] \\n - [a b d f, b e d \\\\infty] \\n - [a b d f, b f \\\\infty e] \
\\n - [a b d \\\\infty, b d e f] \\n - [a b d \\\\infty, b d f e] \\n - [a b \
d \\\\infty, b e d f] \\n - [a b d \\\\infty, b f d e] \\n + [a b e c, a f \\\
\\infty b] \\n + [a b e c, a \\\\infty f b] \\n + [a b e c, b c d \\\\infty] \
\\n - [a b e c, b d \\\\infty c] \\n - [a b e c, b f \\\\infty e] \\n - [a b \
e c, b \\\\infty f e] \\n + [a b e d, a c b \\\\infty] \\n - [a b e d, a c d \
\\\\infty] \\n - [a b e d, a d c \\\\infty] \\n - [a b e d, a f \\\\infty b] \
\\n - [a b e d, a \\\\infty b c] \\n - [a b e d, a \\\\infty f b] \\n + [a b \
e d, b c e \\\\infty] \\n - [a b e d, b c \\\\infty d] \\n + [a b e d, b c \\\
\\infty e] \\n + [a b e d, b f \\\\infty e] \\n + [a b e d, b \\\\infty f e] \
\\n + [a b e f, a \\\\infty c b] \\n - [a b e f, a \\\\infty d b] \\n - [a b \
e f, b c \\\\infty e] \\n + [a b e f, b d \\\\infty e] \\n + [a b e \
\\\\infty, a f c b] \\n - [a b e \\\\infty, a f d b] \\n + [a b e \\\\infty, \
b c d e] \\n - [a b e \\\\infty, b c f e] \\n + [a b e \\\\infty, b d c e] \
\\n + [a b e \\\\infty, b d f e] \\n - [a b f c, b d \\\\infty f] \\n - [a b \
f d, a c b \\\\infty] \\n + [a b f d, a c d \\\\infty] \\n + [a b f d, a d c \
\\\\infty] \\n + [a b f d, a \\\\infty c b] \\n - [a b f d, b e \\\\infty d] \
\\n + 2 [a b f d, b e \\\\infty f] \\n + 2 [a b f d, b \\\\infty e f] \\n - \
[a b f d, d \\\\infty e f] \\n - [a b f e, a d \\\\infty b] \\n - [a b f e, a \
f c \\\\infty] \\n + [a b f e, a f d \\\\infty] \\n - [a b f e, a \\\\infty d \
b] \\n - [a b f e, b d \\\\infty e] \\n + 2 [a b f e, b e d \\\\infty] \\n + \
[a b f e, b \\\\infty d e] \\n + [a b f \\\\infty, b d e f] \\n + 2 [a b f \\\
\\infty, b e d f] \\n + [a b \\\\infty c, b c f d] \\n - [a b \\\\infty c, b \
c f e] \\n - [a b \\\\infty d, a d f e] \\n + 2 [a b \\\\infty d, a f b e] \
\\n - [a b \\\\infty d, a f d e] \\n - [a b \\\\infty d, b d e f] \\n - [a b \
\\\\infty e, b e f c] \\n + [a b \\\\infty e, b e f d] \\n + [a b \\\\infty \
f, a c b d] \\n - [a b \\\\infty f, a c b e] \\n - [a b \\\\infty f, a c f d] \
\\n + [a b \\\\infty f, a c f e] \\n - [a b \\\\infty f, a d b c] \\n - [a b \
\\\\infty f, a e b c] \\n + [a b \\\\infty f, a e f c] \\n - [a b \\\\infty \
f, a e f d] \\n - [a b \\\\infty f, a f c d] \\n + [a b \\\\infty f, a f c e] \
\\n + [a b \\\\infty f, a f e c] \\n - [a b \\\\infty f, a f e d] \\n + [a c \
b d, a b \\\\infty f] \\n - [a c b d, a \\\\infty e b] \\n - [a c b e, a b \\\
\\infty f] \\n + [a c b e, a \\\\infty f b] \\n - [a c b f, b f e \\\\infty] \
\\n + [a c b \\\\infty, a b e d] \\n - [a c b \\\\infty, a b f d] \\n + [a c \
d b, a d e \\\\infty] \\n - [a c d b, a d f \\\\infty] \\n + [a c d b, b d e \
\\\\infty] \\n + [a c d b, b d \\\\infty e] \\n - [a c d \\\\infty, a b e d] \
\\n + [a c d \\\\infty, a b f d] \\n + [a c f b, b f d \\\\infty] \\n + [a c \
f b, b f \\\\infty d] \\n - [a c f b, b f \\\\infty e] \\n - [a c f d, a b \\\
\\infty f] \\n + [a c f d, a f b \\\\infty] \\n + [a c f e, a b \\\\infty f] \
\\n - [a c f e, a f b \\\\infty] \\n - [a d b c, a b \\\\infty f] \\n - [a d \
b c, a f \\\\infty b] \\n - [a d b c, a \\\\infty e b] \\n - [a d b c, a \
\\\\infty e d] \\n + [a d b c, a \\\\infty f b] \\n + [a d b c, a \\\\infty f \
d] \\n + [a d b c, b e \\\\infty d] \\n + [a d b c, b \\\\infty e d] \\n - [a \
d b e, a \\\\infty c b] \\n - [a d b e, a \\\\infty c d] \\n + [a d b e, b \\\
\\infty c d] \\n + [a d b f, a \\\\infty c b] \\n + [a d b f, a \\\\infty c \
d] \\n + [a d b f, b f e \\\\infty] \\n - [a d b f, b \\\\infty c d] \\n + [a \
d b \\\\infty, a f d e] \\n - [a d b \\\\infty, b f d e] \\n - [a d c b, a \\\
\\infty e d] \\n + [a d c b, a \\\\infty f d] \\n + [a d c b, b d e \
\\\\infty] \\n - [a d c b, b d f \\\\infty] \\n + [a d c b, b e c \\\\infty] \
\\n + [a d c b, b \\\\infty c e] \\n + [a d c b, b \\\\infty e d] \\n - [a d \
c b, b \\\\infty f d] \\n - [a d c b, c d e \\\\infty] \\n - [a d c b, c d \\\
\\infty e] \\n - [a d c b, c e d \\\\infty] \\n - [a d c b, c \\\\infty d e] \
\\n + [a d c e, b c d \\\\infty] \\n + [a d c e, b d c \\\\infty] \\n - [a d \
c e, b d e \\\\infty] \\n - [a d c e, b \\\\infty e d] \\n - [a d c f, b c d \
\\\\infty] \\n - [a d c f, b d c \\\\infty] \\n + [a d c f, b d f \\\\infty] \
\\n + [a d c f, b \\\\infty f d] \\n + [a d c \\\\infty, a b d e] \\n - [a d \
c \\\\infty, a b d f] \\n - [a d c \\\\infty, a b e d] \\n + [a d c \
\\\\infty, a b f d] \\n + [a d c \\\\infty, a e d b] \\n - [a d c \\\\infty, \
a f d b] \\n + [a d c \\\\infty, a f d e] \\n - [a d c \\\\infty, b d e c] \
\\n - [a d c \\\\infty, b e d c] \\n - [a d e b, a b c \\\\infty] \\n - [a d \
e b, a \\\\infty b c] \\n + [a d e b, b c e \\\\infty] \\n + [a d e b, b d c \
\\\\infty] \\n - [a d e b, b d \\\\infty c] \\n + [a d e b, c d e \\\\infty] \
\\n - [a d e c, b c d \\\\infty] \\n + [a d e c, b \\\\infty c d] \\n + [a d \
e \\\\infty, a b d c] \\n + [a d e \\\\infty, a c d b] \\n + [a d e \
\\\\infty, b d e c] \\n + [a d e \\\\infty, b e d c] \\n + [a d f b, a b c \\\
\\infty] \\n + [a d f b, a \\\\infty c d] \\n - [a d f b, b d c \\\\infty] \
\\n + [a d f b, b d \\\\infty c] \\n + [a d f b, b f e \\\\infty] \\n - [a d \
f b, b \\\\infty c d] \\n + [a d f b, d e \\\\infty f] \\n + [a d f b, d \
\\\\infty e f] \\n - [a d f c, a f e \\\\infty] \\n - [a d f c, a \\\\infty e \
f] \\n + [a d f c, b d c \\\\infty] \\n + [a d f c, b \\\\infty c d] \\n - [a \
d f c, c d e \\\\infty] \\n - [a d f c, c \\\\infty e d] \\n + [a d f c, d e \
\\\\infty f] \\n + [a d f c, d \\\\infty e f] \\n - [a d f e, a b \\\\infty \
d] \\n - [a d f e, a \\\\infty c d] \\n - [a d f e, b e d \\\\infty] \\n + [a \
d f e, b \\\\infty e d] \\n + [a d f e, c d e \\\\infty] \\n + [a d f e, c \\\
\\infty e d] \\n - [a d f \\\\infty, a b d c] \\n - [a d f \\\\infty, a c d \
b] \\n + 2 [a d f \\\\infty, b f d e] \\n - [a d \\\\infty b, a b f e] \\n + \
[a d \\\\infty b, a f b e] \\n - [a d \\\\infty b, b d e f] \\n - [a e b c, a \
b \\\\infty f] \\n + [a e b c, a \\\\infty f b] \\n - [a e b c, b d \\\\infty \
c] \\n + [a e b c, b d \\\\infty e] \\n - [a e b c, b \\\\infty d c] \\n + [a \
e b c, b \\\\infty d e] \\n - [a e b d, a f \\\\infty b] \\n - [a e b d, a \\\
\\infty f b] \\n - [a e b d, b c \\\\infty d] \\n + [a e b d, b d c \
\\\\infty] \\n - [a e b d, b d \\\\infty c] \\n + [a e b d, b f \\\\infty e] \
\\n - [a e b d, b \\\\infty d c] \\n + [a e b d, b \\\\infty f e] \\n + [a e \
b f, a \\\\infty c b] \\n - [a e b f, a \\\\infty d b] \\n - [a e b \
\\\\infty, a b c f] \\n + [a e b \\\\infty, a b d f] \\n + [a e d b, a d c \\\
\\infty] \\n + [a e d b, a \\\\infty c d] \\n - [a e d b, b \\\\infty c d] \
\\n - [a e d c, b c d \\\\infty] \\n - [a e d c, b d c \\\\infty] \\n + [a e \
d c, b d e \\\\infty] \\n + [a e d c, b e d \\\\infty] \\n - [a e f b, a f c \
\\\\infty] \\n + [a e f b, a f d \\\\infty] \\n + [a e f c, a b \\\\infty f] \
\\n - [a e f c, a f b \\\\infty] \\n - [a e f d, a b \\\\infty f] \\n - [a e \
f d, a \\\\infty b f] \\n + [a e f d, b e f \\\\infty] \\n + [a e f d, b f e \
\\\\infty] \\n + [a e f \\\\infty, a b c f] \\n - [a e f \\\\infty, a b d f] \
\\n - [a f b c, b \\\\infty e f] \\n + [a f b c, c f e \\\\infty] \\n + [a f \
b c, c \\\\infty e f] \\n + [a f b d, a \\\\infty c b] \\n - [a f b d, b d c \
\\\\infty] \\n - [a f b d, b d e \\\\infty] \\n - [a f b d, b d \\\\infty e] \
\\n - [a f b d, b e d \\\\infty] \\n - [a f b d, b e \\\\infty d] \\n + [a f \
b d, b e \\\\infty f] \\n - [a f b d, b \\\\infty d e] \\n + [a f b d, b \
\\\\infty e f] \\n - [a f b d, d \\\\infty e f] \\n + 2 [a f b e, a b \
\\\\infty d] \\n + [a f b e, a d \\\\infty b] \\n + [a f b e, a \\\\infty c \
f] \\n - [a f b e, a \\\\infty d b] \\n - [a f b e, a \\\\infty d f] \\n - [a \
f b e, b d \\\\infty e] \\n - [a f b e, b \\\\infty d e] \\n - [a f b e, c f \
e \\\\infty] \\n - [a f b e, c \\\\infty e f] \\n + [a f b e, d f e \
\\\\infty] \\n + [a f b e, d \\\\infty e f] \\n + [a f b \\\\infty, a c f d] \
\\n - [a f b \\\\infty, a c f e] \\n - [a f b \\\\infty, a e f c] \\n + 2 [a \
f b \\\\infty, b e d f] \\n + [a f b \\\\infty, b e f d] \\n + [a f c b, a b \
e \\\\infty] \\n - [a f c b, a \\\\infty b e] \\n + [a f c b, b d c \
\\\\infty] \\n - [a f c b, b f d \\\\infty] \\n + [a f c b, b f e \\\\infty] \
\\n + [a f c b, b f \\\\infty e] \\n + [a f c b, b \\\\infty c d] \\n - [a f \
c b, b \\\\infty d f] \\n + [a f c b, b \\\\infty e f] \\n - [a f c b, c d f \
\\\\infty] \\n - [a f c b, c f d \\\\infty] \\n - [a f c b, c f \\\\infty d] \
\\n + [a f c b, c f \\\\infty e] \\n + [a f c b, c \\\\infty d f] \\n - [a f \
c b, c \\\\infty e f] \\n - [a f c b, c \\\\infty f d] \\n + [a f c b, c \
\\\\infty f e] \\n - [a f c d, a b \\\\infty f] \\n - [a f c d, a \\\\infty b \
f] \\n + [a f c d, b f d \\\\infty] \\n + [a f c d, b \\\\infty d f] \\n + [a \
f c e, a b \\\\infty f] \\n + [a f c e, a \\\\infty b f] \\n - [a f c e, b f \
e \\\\infty] \\n - [a f c e, b \\\\infty e f] \\n - [a f c \\\\infty, a b f \
e] \\n - [a f c \\\\infty, a e f b] \\n + [a f c \\\\infty, b c f d] \\n - [a \
f c \\\\infty, b c f e] \\n - [a f c \\\\infty, c f d e] \\n - [a f d b, a b \
e \\\\infty] \\n - [a f d b, a d c \\\\infty] \\n + [a f d b, a \\\\infty b \
e] \\n - [a f d b, b e d \\\\infty] \\n - [a f d b, b f \\\\infty e] \\n + [a \
f d b, b \\\\infty d e] \\n - [a f d b, d e f \\\\infty] \\n - [a f d b, d f \
e \\\\infty] \\n - [a f d e, a b \\\\infty d] \\n + [a f d e, a d b \
\\\\infty] \\n + [a f d e, a d c \\\\infty] \\n + [a f d e, a \\\\infty b d] \
\\n - [a f d e, b d e \\\\infty] \\n - [a f d e, b e d \\\\infty] \\n + [a f \
d \\\\infty, a b f e] \\n + [a f d \\\\infty, a e f b] \\n - [a f d \
\\\\infty, b e d f] \\n - [a f d \\\\infty, b e f d] \\n + [a f d \\\\infty, \
b f d e] \\n + [a f e b, a \\\\infty c f] \\n - [a f e b, a \\\\infty d f] \
\\n - [a f e b, c f e \\\\infty] \\n + [a f e b, d f e \\\\infty] \\n + [a f \
e c, a b \\\\infty f] \\n + [a f e c, a \\\\infty b f] \\n - [a f e c, b e f \
\\\\infty] \\n - [a f e c, b f e \\\\infty] \\n - [a f e d, a b \\\\infty f] \
\\n - [a f e d, a \\\\infty b f] \\n + [a f e d, b e f \\\\infty] \\n + [a f \
e d, b f e \\\\infty] \\n + [a f e \\\\infty, a b c f] \\n - [a f e \
\\\\infty, a b d f] \\n - [a f e \\\\infty, a d f c] \\n - [a f e \\\\infty, \
b e f c] \\n + [a f e \\\\infty, b e f d] \\n + [a f e \\\\infty, c f d e] \
\\n - [a f \\\\infty b, a b c d] \\n + [a f \\\\infty b, a b c e] \\n + [a f \
\\\\infty b, a b e c] \\n - [a f \\\\infty b, a b e d] \\n - [a f \\\\infty \
b, a d b c] \\n - [a f \\\\infty b, a e b d] \\n + [a f \\\\infty b, b f c e] \
\\n - [a f \\\\infty b, b f d c] \\n - [a f \\\\infty b, b f d e] \\n + [a f \
\\\\infty b, b f e c] \\n - [a f \\\\infty c, b c f d] \\n + [a f \\\\infty \
c, b c f e] \\n + [a f \\\\infty e, b e f c] \\n - [a f \\\\infty e, b e f d] \
\\n - [a \\\\infty b c, a b e d] \\n - [a \\\\infty b c, a d e b] \\n - [a \\\
\\infty b c, b d f c] \\n + [a \\\\infty b c, b e f c] \\n + [a \\\\infty b \
d, a f d e] \\n + [a \\\\infty b d, b d f e] \\n - [a \\\\infty b d, b f d e] \
\\n - [a \\\\infty b e, a b c f] \\n + [a \\\\infty b e, a b d f] \\n - [a \\\
\\infty b e, a f c b] \\n + [a \\\\infty b e, a f d b] \\n + [a \\\\infty b \
e, b c f e] \\n - [a \\\\infty b e, b d f e] \\n - [a \\\\infty b f, a e f d] \
\\n - [a \\\\infty b f, a f c d] \\n + [a \\\\infty b f, a f c e] \\n + [a \\\
\\infty b f, a f e c] \\n - [a \\\\infty b f, a f e d] \\n + [a \\\\infty b \
f, b c f e] \\n - [a \\\\infty b f, b d f c] \\n - [a \\\\infty b f, b d f e] \
\\n + [a \\\\infty b f, b e f c] \\n + [a \\\\infty b f, b e f d] \\n + [a \\\
\\infty b f, b f c d] \\n - [a \\\\infty b f, b f d c] \\n - [a \\\\infty b \
f, b f d e] \\n + [a \\\\infty b f, b f e d] \\n - [a \\\\infty c b, a b d e] \
\\n + [a \\\\infty c b, a b d f] \\n + [a \\\\infty c b, a b e f] \\n + [a \\\
\\infty c b, a b f d] \\n - [a \\\\infty c b, a d b e] \\n + [a \\\\infty c \
b, a d b f] \\n + [a \\\\infty c b, a e b f] \\n + [a \\\\infty c b, a f b d] \
\\n - [a \\\\infty c d, a d b e] \\n + [a \\\\infty c d, a d b f] \\n + [a \\\
\\infty c d, a d f b] \\n - [a \\\\infty c d, a d f e] \\n + [a \\\\infty c \
d, a e d b] \\n + [a \\\\infty c f, a f b e] \\n + [a \\\\infty c f, a f e b] \
\\n + [a \\\\infty c f, c d f e] \\n - [a \\\\infty d b, a b e f] \\n - [a \\\
\\infty d b, a b f e] \\n - [a \\\\infty d b, a e b f] \\n - [a \\\\infty d \
b, a f b e] \\n + [a \\\\infty d b, b d f e] \\n - [a \\\\infty d f, a f b e] \
\\n - [a \\\\infty d f, a f e b] \\n + [a \\\\infty d f, b d e f] \\n + [a \\\
\\infty d f, b f e d] \\n - [a \\\\infty e b, a b c d] \\n - [a \\\\infty e \
b, a b d c] \\n - [a \\\\infty e b, a c b d] \\n - [a \\\\infty e b, a d b c] \
\\n - [a \\\\infty e d, a d b c] \\n - [a \\\\infty e d, a d c b] \\n - [a \\\
\\infty e f, a d f c] \\n + [a \\\\infty e f, c f d e] \\n + [a \\\\infty f \
b, a b c e] \\n + [a \\\\infty f b, a b d c] \\n + [a \\\\infty f b, a b e c] \
\\n - [a \\\\infty f b, a b e d] \\n + [a \\\\infty f b, a c b e] \\n + [a \\\
\\infty f b, a d b c] \\n + [a \\\\infty f b, a e b c] \\n - [a \\\\infty f \
b, a e b d] \\n - [a \\\\infty f c, b c f d] \\n + [a \\\\infty f c, b c f e] \
\\n + [a \\\\infty f d, a d b c] \\n + [a \\\\infty f d, a d c b] \\n + [a \\\
\\infty f e, b e f c] \\n - [a \\\\infty f e, b e f d] \\n - [b c d e, a b c \
\\\\infty] \\n + [b c d e, a b e \\\\infty] \\n - [b c d \\\\infty, a b c f] \
\\n + [b c d \\\\infty, a b e c] \\n + [b c d \\\\infty, a d c e] \\n - [b c \
d \\\\infty, a d c f] \\n - [b c d \\\\infty, a d e c] \\n - [b c d \
\\\\infty, a e d c] \\n - [b c e d, a b c \\\\infty] \\n - [b c e \\\\infty, \
a b c d] \\n + [b c e \\\\infty, a b c f] \\n + [b c e \\\\infty, a b e d] \
\\n + [b c e \\\\infty, a d e b] \\n + [b c f d, a b \\\\infty c] \\n + [b c \
f d, a f c \\\\infty] \\n - [b c f d, a f \\\\infty c] \\n - [b c f d, a \
\\\\infty f c] \\n - [b c f e, a b e \\\\infty] \\n - [b c f e, a b \\\\infty \
c] \\n - [b c f e, a f c \\\\infty] \\n + [b c f e, a f \\\\infty c] \\n + [b \
c f e, a \\\\infty b e] \\n + [b c f e, a \\\\infty b f] \\n + [b c f e, a \\\
\\infty f c] \\n - [b c \\\\infty d, a b c f] \\n + [b c \\\\infty d, a b d \
e] \\n - [b c \\\\infty d, a b d f] \\n - [b c \\\\infty d, a b e d] \\n - [b \
c \\\\infty d, a e b d] \\n - [b c \\\\infty e, a b c d] \\n + [b c \\\\infty \
e, a b e d] \\n - [b c \\\\infty e, a b e f] \\n - [b d c e, a b c \\\\infty] \
\\n + [b d c e, a b e \\\\infty] \\n + [b d c \\\\infty, a d c e] \\n - [b d \
c \\\\infty, a d c f] \\n + [b d c \\\\infty, a d e b] \\n - [b d c \
\\\\infty, a d f b] \\n + [b d c \\\\infty, a d f c] \\n + [b d c \\\\infty, \
a e d b] \\n - [b d c \\\\infty, a e d c] \\n + [b d c \\\\infty, a f c b] \
\\n - [b d e c, a d c \\\\infty] \\n + [b d e c, a d e \\\\infty] \\n - [b d \
e f, a b d \\\\infty] \\n + [b d e f, a b f \\\\infty] \\n - [b d e f, a b \\\
\\infty d] \\n - [b d e f, a d \\\\infty b] \\n - [b d e f, a \\\\infty b d] \
\\n - [b d e f, a \\\\infty d b] \\n + [b d e f, a \\\\infty d f] \\n - [b d \
e \\\\infty, a b c d] \\n - [b d e \\\\infty, a c b d] \\n + [b d e \
\\\\infty, a d c b] \\n - [b d e \\\\infty, a d c e] \\n + [b d e \\\\infty, \
a e d c] \\n + [b d e \\\\infty, a f d b] \\n - [b d e \\\\infty, a f d e] \
\\n + [b d f c, a b c \\\\infty] \\n - [b d f c, a \\\\infty b c] \\n - [b d \
f c, a \\\\infty b f] \\n - [b d f e, a b d \\\\infty] \\n + [b d f e, a b e \
\\\\infty] \\n - [b d f e, a \\\\infty b e] \\n - [b d f e, a \\\\infty b f] \
\\n + [b d f \\\\infty, a b c d] \\n - [b d f \\\\infty, a d c b] \\n + [b d \
f \\\\infty, a d c f] \\n + [b d \\\\infty c, a b c e] \\n - [b d \\\\infty \
c, a b e c] \\n - [b d \\\\infty c, a d e b] \\n + [b d \\\\infty c, a d f b] \
\\n - [b d \\\\infty c, a e b c] \\n - [b d \\\\infty c, a e d b] \\n + [b d \
\\\\infty c, a f d b] \\n - [b d \\\\infty e, a b c d] \\n - [b d \\\\infty \
e, a b d f] \\n + [b d \\\\infty e, a b e f] \\n - [b d \\\\infty e, a b f e] \
\\n - [b d \\\\infty e, a c b d] \\n + [b d \\\\infty e, a e b c] \\n - [b d \
\\\\infty e, a f b e] \\n + [b d \\\\infty e, a f d b] \\n - [b d \\\\infty \
f, a b f c] \\n - [b e c d, a b c \\\\infty] \\n + [b e c \\\\infty, a b c f] \
\\n + [b e c \\\\infty, a d c b] \\n - [b e d c, a d c \\\\infty] \\n + [b e \
d c, a d e \\\\infty] \\n - [b e d f, a b d \\\\infty] \\n + 2 [b e d f, a b \
f \\\\infty] \\n + 2 [b e d f, a f b \\\\infty] \\n - [b e d f, a f d \
\\\\infty] \\n - [b e d \\\\infty, a b c e] \\n - [b e d \\\\infty, a b d f] \
\\n + 2 [b e d \\\\infty, a b f e] \\n - [b e d \\\\infty, a d f e] \\n + [b \
e d \\\\infty, a e d c] \\n - [b e d \\\\infty, a f b d] \\n - [b e d \
\\\\infty, a f d b] \\n - [b e d \\\\infty, a f d e] \\n - [b e f c, a b c \\\
\\infty] \\n - [b e f c, a b \\\\infty e] \\n - [b e f c, a f e \\\\infty] \
\\n + [b e f c, a f \\\\infty e] \\n + [b e f c, a \\\\infty b c] \\n + [b e \
f c, a \\\\infty b f] \\n + [b e f c, a \\\\infty f e] \\n + [b e f d, a b \\\
\\infty e] \\n + [b e f d, a f b \\\\infty] \\n - [b e f d, a f d \\\\infty] \
\\n + [b e f d, a f e \\\\infty] \\n - [b e f d, a f \\\\infty e] \\n + [b e \
f d, a \\\\infty b f] \\n - [b e f d, a \\\\infty f e] \\n - [b e f \
\\\\infty, a b c e] \\n + [b e f \\\\infty, a e f d] \\n - [b e f \\\\infty, \
a f e c] \\n + [b e f \\\\infty, a f e d] \\n - [b e \\\\infty c, a b c f] \
\\n + [b e \\\\infty d, a b d c] \\n - [b e \\\\infty d, a b f d] \\n + [b e \
\\\\infty d, a d b c] \\n - [b e \\\\infty d, a f b d] \\n + 2 [b e \\\\infty \
f, a b f d] \\n + [b e \\\\infty f, a f b d] \\n + [b f c d, a \\\\infty f b] \
\\n + [b f c e, a f \\\\infty b] \\n - [b f d c, a f \\\\infty b] \\n - [b f \
d c, a \\\\infty f b] \\n - [b f d e, a b d \\\\infty] \\n - [b f d e, a d b \
\\\\infty] \\n + 2 [b f d e, a d f \\\\infty] \\n + [b f d e, a f d \
\\\\infty] \\n - [b f d e, a f \\\\infty b] \\n - [b f d e, a \\\\infty b d] \
\\n - [b f d e, a \\\\infty f b] \\n - [b f d \\\\infty, a c b f] \\n - [b f \
d \\\\infty, a f c b] \\n + [b f d \\\\infty, a f c d] \\n + [b f e c, a f \\\
\\infty b] \\n + [b f e d, a \\\\infty d f] \\n + [b f e d, a \\\\infty f b] \
\\n + [b f e \\\\infty, a b c f] \\n + [b f e \\\\infty, a c b f] \\n + [b f \
e \\\\infty, a e f d] \\n + [b f e \\\\infty, a f c b] \\n - [b f e \
\\\\infty, a f c e] \\n - [b f e \\\\infty, a f e c] \\n + [b f e \\\\infty, \
a f e d] \\n - [b f \\\\infty d, a b c f] \\n - [b f \\\\infty d, a b d c] \
\\n - [b f \\\\infty d, a c b f] \\n - [b f \\\\infty e, a b d f] \\n - [b f \
\\\\infty e, a b e c] \\n + [b f \\\\infty e, a b e d] \\n + [b f \\\\infty \
e, a c f b] \\n - [b f \\\\infty e, a d b f] \\n - [b f \\\\infty e, a d f b] \
\\n + [b f \\\\infty e, a e b d] \\n + [b f \\\\infty e, a f c b] \\n - [b f \
\\\\infty e, a f d b] \\n + [b \\\\infty c d, a d b e] \\n - [b \\\\infty c \
d, a d b f] \\n + [b \\\\infty c d, a d e c] \\n - [b \\\\infty c d, a d f b] \
\\n + [b \\\\infty c d, a d f c] \\n - [b \\\\infty c d, a e d b] \\n + [b \\\
\\infty c d, a f c b] \\n + [b \\\\infty c e, a d c b] \\n + [b \\\\infty d \
c, a b c e] \\n - [b \\\\infty d c, a b c f] \\n - [b \\\\infty d c, a e b c] \
\\n - [b \\\\infty d c, a e b d] \\n - [b \\\\infty d e, a b c e] \\n + [b \\\
\\infty d e, a b f e] \\n + [b \\\\infty d e, a e b c] \\n - [b \\\\infty d \
e, a f b d] \\n - [b \\\\infty d e, a f b e] \\n + [b \\\\infty d e, a f d b] \
\\n + [b \\\\infty d f, a b c f] \\n - [b \\\\infty d f, a f c b] \\n + [b \\\
\\infty d f, a f c d] \\n + [b \\\\infty e d, a d b c] \\n + [b \\\\infty e \
d, a d c b] \\n - [b \\\\infty e d, a d c e] \\n + [b \\\\infty e d, a d f e] \
\\n + 2 [b \\\\infty e f, a b f d] \\n - [b \\\\infty e f, a f b c] \\n + [b \
\\\\infty e f, a f b d] \\n + [b \\\\infty e f, a f c b] \\n - [b \\\\infty e \
f, a f c e] \\n + [b \\\\infty f d, a b c d] \\n - [b \\\\infty f d, a d c b] \
\\n + [b \\\\infty f d, a d c f] \\n - [b \\\\infty f e, a b c e] \\n - [b \\\
\\infty f e, a b e c] \\n + [b \\\\infty f e, a b e d] \\n + [b \\\\infty f \
e, a e b d] \\n - [c d e \\\\infty, a d c b] \\n + [c d e \\\\infty, a d e b] \
\\n - [c d e \\\\infty, a d f c] \\n + [c d e \\\\infty, a d f e] \\n + [c d \
f e, a \\\\infty c f] \\n - [c d f \\\\infty, a f c b] \\n - [c d \\\\infty \
e, a d c b] \\n - [c e d \\\\infty, a d c b] \\n - [c f d e, a f c \\\\infty] \
\\n + [c f d e, a f e \\\\infty] \\n + [c f d e, a \\\\infty e f] \\n - [c f \
d \\\\infty, a f c b] \\n + [c f e \\\\infty, a f b c] \\n - [c f e \
\\\\infty, a f b e] \\n - [c f e \\\\infty, a f e b] \\n - [c f \\\\infty d, \
a f c b] \\n + [c f \\\\infty e, a f c b] \\n - [c \\\\infty d e, a d c b] \
\\n + [c \\\\infty d f, a f c b] \\n - [c \\\\infty e d, a d f c] \\n + [c \\\
\\infty e d, a d f e] \\n + [c \\\\infty e f, a f b c] \\n - [c \\\\infty e \
f, a f b e] \\n - [c \\\\infty e f, a f c b] \\n - [c \\\\infty f d, a f c b] \
\\n + [c \\\\infty f e, a f c b] \\n - [d e f \\\\infty, a f d b] \\n + [d e \
\\\\infty f, a d f b] \\n + [d e \\\\infty f, a d f c] \\n + [d f e \
\\\\infty, a f b e] \\n - [d f e \\\\infty, a f d b] \\n + [d f e \\\\infty, \
a f e b] \\n - [d \\\\infty e f, a b f d] \\n + [d \\\\infty e f, a d f b] \
\\n + [d \\\\infty e f, a d f c] \\n - [d \\\\infty e f, a f b d] \\n + [d \\\
\\infty e f, a f b e] ) + {} \\\\\\\\ \\n & {} + \\\\frac{1}{3} I_{3, 2}( [a \
b c \\\\infty, a e \\\\infty d] \\n - [a b c \\\\infty, a \\\\infty d e] \\n \
+ [a b c \\\\infty, a \\\\infty d f] \\n + [a b c \\\\infty, a \\\\infty e f] \
\\n + [a b c \\\\infty, a \\\\infty f d] \\n - [a b c \\\\infty, b d f \
\\\\infty] \\n + [a b c \\\\infty, b e d \\\\infty] \\n + [a b c \\\\infty, b \
e f \\\\infty] \\n - [a b c \\\\infty, b f d \\\\infty] \\n + [a b c \
\\\\infty, b \\\\infty e f] \\n + [a b c \\\\infty, b \\\\infty f e] \\n + [a \
b c \\\\infty, c d \\\\infty e] \\n + [a b d \\\\infty, a f \\\\infty e] \\n \
- [a b d \\\\infty, a \\\\infty e f] \\n - [a b d \\\\infty, a \\\\infty f e] \
\\n - [a b d \\\\infty, b \\\\infty e f] \\n - [a b d \\\\infty, b \\\\infty \
f e] \\n + [a b d \\\\infty, d e \\\\infty f] \\n - [a b e \\\\infty, a d \
\\\\infty c] \\n - [a b e \\\\infty, a \\\\infty c d] \\n - [a b e \\\\infty, \
a \\\\infty d c] \\n - [a b e \\\\infty, b \\\\infty c d] \\n - [a b e \
\\\\infty, b \\\\infty d c] \\n + [a b e \\\\infty, c \\\\infty d e] \\n - [a \
b f \\\\infty, a e \\\\infty d] \\n + [a b f \\\\infty, a \\\\infty c e] \\n \
+ [a b f \\\\infty, a \\\\infty d c] \\n + [a b f \\\\infty, a \\\\infty e c] \
\\n - [a b f \\\\infty, a \\\\infty e d] \\n - [a b f \\\\infty, b e d \
\\\\infty] \\n + [a b f \\\\infty, b \\\\infty c e] \\n + [a b f \\\\infty, b \
\\\\infty d c] \\n + [a b f \\\\infty, b \\\\infty e c] \\n - [a b f \
\\\\infty, b \\\\infty e d] \\n + [a b f \\\\infty, c d f \\\\infty] \\n - [a \
b f \\\\infty, c e f \\\\infty] \\n - [a b f \\\\infty, c e \\\\infty f] \\n \
- [a b \\\\infty c, a d e \\\\infty] \\n + [a b \\\\infty c, a d f \\\\infty] \
\\n - [a b \\\\infty d, b e \\\\infty f] \\n + [a b \\\\infty d, b f e \
\\\\infty] \\n - [a b \\\\infty d, b \\\\infty e f] \\n - [a b \\\\infty d, d \
f e \\\\infty] \\n - [a b \\\\infty e, a d c \\\\infty] \\n + [a b \\\\infty \
e, a f c \\\\infty] \\n - [a b \\\\infty e, a f d \\\\infty] \\n + [a b \
\\\\infty f, a d c \\\\infty] \\n + [a b \\\\infty f, b c d \\\\infty] \\n - \
[a b \\\\infty f, b c e \\\\infty] \\n + [a b \\\\infty f, b c \\\\infty d] \
\\n + [a b \\\\infty f, b d \\\\infty e] \\n - [a b \\\\infty f, b e c \
\\\\infty] \\n + [a b \\\\infty f, b e d \\\\infty] \\n + [a c b \\\\infty, b \
\\\\infty d e] \\n + [a c b \\\\infty, b \\\\infty e d] \\n + [a c d \
\\\\infty, b e d \\\\infty] \\n - [a c d \\\\infty, b f d \\\\infty] \\n - [a \
c d \\\\infty, b f \\\\infty d] \\n + [a c d \\\\infty, d \\\\infty f e] \\n \
- [a c f \\\\infty, b e f \\\\infty] \\n - [a c f \\\\infty, b e \\\\infty f] \
\\n - [a c \\\\infty b, a d e \\\\infty] \\n + [a c \\\\infty b, a d f \
\\\\infty] \\n - [a c \\\\infty b, b \\\\infty d f] \\n + [a c \\\\infty b, b \
\\\\infty e d] \\n - [a c \\\\infty b, b \\\\infty f d] \\n - [a c \\\\infty \
b, b \\\\infty f e] \\n - [a c \\\\infty d, a f b \\\\infty] \\n + [a c \
\\\\infty d, a \\\\infty e b] \\n + [a c \\\\infty d, b e \\\\infty d] \\n + \
[a c \\\\infty e, a f b \\\\infty] \\n - [a c \\\\infty e, a \\\\infty f b] \
\\n + [a c \\\\infty f, d e f \\\\infty] \\n + [a d b \\\\infty, b \\\\infty \
e f] \\n + [a d b \\\\infty, b \\\\infty f e] \\n - [a d c \\\\infty, a b \
\\\\infty e] \\n + [a d c \\\\infty, a b \\\\infty f] \\n + [a d c \\\\infty, \
a f \\\\infty b] \\n - [a d c \\\\infty, a f \\\\infty e] \\n - [a d c \
\\\\infty, a \\\\infty b e] \\n + [a d c \\\\infty, a \\\\infty b f] \\n + [a \
d c \\\\infty, a \\\\infty f b] \\n - [a d c \\\\infty, a \\\\infty f e] \\n \
- [a d c \\\\infty, b e d \\\\infty] \\n - [a d e \\\\infty, a b \\\\infty c] \
\\n - [a d e \\\\infty, a c \\\\infty b] \\n - [a d e \\\\infty, a \\\\infty \
b c] \\n - [a d e \\\\infty, a \\\\infty c b] \\n + [a d f \\\\infty, a b \
\\\\infty c] \\n + [a d f \\\\infty, a c \\\\infty b] \\n + [a d f \\\\infty, \
a \\\\infty b c] \\n + [a d f \\\\infty, a \\\\infty c b] \\n + [a d f \
\\\\infty, b e f \\\\infty] \\n + [a d f \\\\infty, b e \\\\infty f] \\n - [a \
d f \\\\infty, b \\\\infty d e] \\n + [a d \\\\infty b, b \\\\infty e f] \\n \
+ [a d \\\\infty b, b \\\\infty f e] \\n - [a d \\\\infty b, d e \\\\infty f] \
\\n - [a d \\\\infty b, d \\\\infty e f] \\n - [a d \\\\infty c, a b e \
\\\\infty] \\n - [a d \\\\infty c, a \\\\infty f b] \\n + [a d \\\\infty c, b \
d \\\\infty e] \\n + [a d \\\\infty c, d f e \\\\infty] \\n + [a d \\\\infty \
e, a \\\\infty c b] \\n - [a d \\\\infty f, a \\\\infty c b] \\n + [a d \
\\\\infty f, b e f \\\\infty] \\n + [a d \\\\infty f, b e \\\\infty f] \\n - \
[a e d \\\\infty, b d c \\\\infty] \\n - [a e d \\\\infty, b \\\\infty c d] \
\\n + [a e \\\\infty b, a f c \\\\infty] \\n - [a e \\\\infty b, a f d \
\\\\infty] \\n - [a e \\\\infty b, b c \\\\infty d] \\n - [a e \\\\infty b, b \
d c \\\\infty] \\n - [a e \\\\infty b, b d \\\\infty c] \\n + [a e \\\\infty \
c, a f b \\\\infty] \\n - [a e \\\\infty c, a \\\\infty f b] \\n - [a e \
\\\\infty c, b c \\\\infty d] \\n + [a e \\\\infty c, b e \\\\infty d] \\n - \
[a e \\\\infty c, b \\\\infty c d] \\n + [a e \\\\infty c, b \\\\infty e d] \
\\n + [a e \\\\infty d, a b c \\\\infty] \\n - [a e \\\\infty d, a b f \
\\\\infty] \\n - [a e \\\\infty d, a f b \\\\infty] \\n + [a e \\\\infty d, a \
\\\\infty c b] \\n - [a e \\\\infty d, b d \\\\infty c] \\n + [a e \\\\infty \
d, b e \\\\infty f] \\n + [a e \\\\infty d, b \\\\infty e f] \\n - [a e \
\\\\infty f, a \\\\infty c b] \\n + [a e \\\\infty f, a \\\\infty d b] \\n - \
[a f b \\\\infty, a c \\\\infty d] \\n + [a f b \\\\infty, a c \\\\infty e] \
\\n + [a f b \\\\infty, a e \\\\infty c] \\n - [a f b \\\\infty, a e \
\\\\infty d] \\n - [a f b \\\\infty, a \\\\infty c d] \\n + [a f b \\\\infty, \
a \\\\infty c e] \\n + [a f b \\\\infty, a \\\\infty e c] \\n - [a f b \
\\\\infty, a \\\\infty e d] \\n - [a f b \\\\infty, b e d \\\\infty] \\n + [a \
f c \\\\infty, a b \\\\infty e] \\n + [a f c \\\\infty, a e \\\\infty b] \\n \
+ [a f c \\\\infty, a \\\\infty b e] \\n + [a f c \\\\infty, a \\\\infty e b] \
\\n - [a f c \\\\infty, d e \\\\infty f] \\n - [a f d \\\\infty, a b \
\\\\infty e] \\n - [a f d \\\\infty, a e \\\\infty b] \\n - [a f d \\\\infty, \
a \\\\infty b e] \\n - [a f d \\\\infty, a \\\\infty e b] \\n - [a f d \
\\\\infty, b c d \\\\infty] \\n - [a f d \\\\infty, b c \\\\infty d] \\n - [a \
f d \\\\infty, b d e \\\\infty] \\n - [a f d \\\\infty, b e d \\\\infty] \\n \
- [a f d \\\\infty, b e f \\\\infty] \\n - [a f d \\\\infty, b e \\\\infty f] \
\\n - [a f d \\\\infty, b \\\\infty d e] \\n + [a f \\\\infty b, a d c \
\\\\infty] \\n + [a f \\\\infty b, b c \\\\infty d] \\n - [a f \\\\infty b, b \
e \\\\infty d] \\n - [a f \\\\infty b, b \\\\infty c d] \\n - [a f \\\\infty \
b, b \\\\infty c e] \\n - [a f \\\\infty b, b \\\\infty e c] \\n - [a f \
\\\\infty b, b \\\\infty e d] \\n + [a f \\\\infty b, c f \\\\infty d] \\n - \
[a f \\\\infty b, c f \\\\infty e] \\n - [a f \\\\infty b, c \\\\infty f e] \
\\n + [a f \\\\infty b, d \\\\infty f e] \\n - [a f \\\\infty d, a \\\\infty \
c b] \\n - [a f \\\\infty d, b d \\\\infty e] \\n + [a f \\\\infty d, b f \
\\\\infty e] \\n + [a f \\\\infty e, a b d \\\\infty] \\n - [a f \\\\infty e, \
a d c \\\\infty] \\n + 2 [a f \\\\infty e, a \\\\infty d b] \\n - [a f \
\\\\infty e, b e \\\\infty d] \\n - [a f \\\\infty e, b \\\\infty e d] \\n - \
[a \\\\infty b c, a d e \\\\infty] \\n + [a \\\\infty b c, a d f \\\\infty] \
\\n + [a \\\\infty b c, b d e \\\\infty] \\n + [a \\\\infty b c, b e d \
\\\\infty] \\n - [a \\\\infty b c, b e f \\\\infty] \\n - [a \\\\infty b c, b \
f e \\\\infty] \\n + [a \\\\infty b d, b f e \\\\infty] \\n - [a \\\\infty b \
d, d f e \\\\infty] \\n - [a \\\\infty b e, a d c \\\\infty] \\n + [a \
\\\\infty b e, a f c \\\\infty] \\n - [a \\\\infty b e, a f d \\\\infty] \\n \
+ [a \\\\infty b e, b d c \\\\infty] \\n + [a \\\\infty b f, a d c \\\\infty] \
\\n - [a \\\\infty b f, b d c \\\\infty] \\n + [a \\\\infty b f, b e d \
\\\\infty] \\n - [a \\\\infty b f, c d \\\\infty f] \\n + [a \\\\infty b f, c \
e f \\\\infty] \\n + [a \\\\infty b f, c e \\\\infty f] \\n - [a \\\\infty b \
f, d e f \\\\infty] \\n - [a \\\\infty c b, a d e \\\\infty] \\n + [a \
\\\\infty c b, a d f \\\\infty] \\n + [a \\\\infty c b, a d \\\\infty e] \\n \
- [a \\\\infty c b, a d \\\\infty f] \\n + [a \\\\infty c b, a e \\\\infty d] \
\\n - [a \\\\infty c b, a e \\\\infty f] \\n - [a \\\\infty c b, a f \
\\\\infty d] \\n - [a \\\\infty c b, b \\\\infty d e] \\n - [a \\\\infty c b, \
b \\\\infty e d] \\n - [a \\\\infty c b, c e \\\\infty d] \\n + [a \\\\infty \
c b, c f d \\\\infty] \\n - [a \\\\infty c b, c f e \\\\infty] \\n - [a \
\\\\infty c b, c \\\\infty d e] \\n - [a \\\\infty c b, c \\\\infty e d] \\n \
- [a \\\\infty c d, a b e \\\\infty] \\n - [a \\\\infty c d, a f b \\\\infty] \
\\n + [a \\\\infty c d, b d \\\\infty e] \\n - [a \\\\infty c d, b e \
\\\\infty c] \\n + [a \\\\infty c d, b f d \\\\infty] \\n + [a \\\\infty c d, \
b f \\\\infty d] \\n - [a \\\\infty c d, b \\\\infty e c] \\n - [a \\\\infty \
c d, d \\\\infty e f] \\n + [a \\\\infty c e, a b f \\\\infty] \\n + [a \
\\\\infty c e, a f b \\\\infty] \\n + [a \\\\infty c e, b c \\\\infty d] \\n \
- [a \\\\infty c e, b d \\\\infty e] \\n - [a \\\\infty c e, b e \\\\infty d] \
\\n - [a \\\\infty c e, b e \\\\infty f] \\n - [a \\\\infty c e, b f \
\\\\infty e] \\n + [a \\\\infty c e, b \\\\infty c d] \\n - [a \\\\infty c f, \
b c \\\\infty e] \\n + [a \\\\infty c f, b e f \\\\infty] \\n + 2 [a \
\\\\infty c f, b e \\\\infty f] \\n + [a \\\\infty c f, b f \\\\infty e] \\n \
- [a \\\\infty c f, b \\\\infty c d] \\n - [a \\\\infty c f, c d \\\\infty e] \
\\n - [a \\\\infty c f, c \\\\infty d e] \\n + [a \\\\infty d b, a e \
\\\\infty f] \\n + 2 [a \\\\infty d b, a f \\\\infty e] \\n - [a \\\\infty d \
b, b \\\\infty e f] \\n - [a \\\\infty d b, b \\\\infty f e] \\n - [a \
\\\\infty d b, d f \\\\infty e] \\n - [a \\\\infty d b, d \\\\infty e f] \\n \
- [a \\\\infty d b, d \\\\infty f e] \\n - [a \\\\infty d c, a b e \\\\infty] \
\\n + [a \\\\infty d c, a b f \\\\infty] \\n + [a \\\\infty d c, b d \
\\\\infty e] \\n - [a \\\\infty d c, b d \\\\infty f] \\n + [a \\\\infty d c, \
b \\\\infty d e] \\n - [a \\\\infty d e, a b c \\\\infty] \\n + [a \\\\infty \
d e, b d \\\\infty c] \\n + [a \\\\infty d f, a b c \\\\infty] \\n - [a \
\\\\infty d f, b d e \\\\infty] \\n - [a \\\\infty d f, b d \\\\infty c] \\n \
- [a \\\\infty d f, b e d \\\\infty] \\n - [a \\\\infty d f, b e f \\\\infty] \
\\n - [a \\\\infty d f, b e \\\\infty d] \\n - [a \\\\infty d f, b e \
\\\\infty f] \\n - [a \\\\infty d f, b \\\\infty e d] \\n + [a \\\\infty e b, \
a c \\\\infty d] \\n + [a \\\\infty e b, a f c \\\\infty] \\n - [a \\\\infty \
e b, a f d \\\\infty] \\n - [a \\\\infty e b, b d c \\\\infty] \\n + [a \
\\\\infty e b, c e \\\\infty d] \\n + [a \\\\infty e b, c \\\\infty d e] \\n \
+ [a \\\\infty e b, c \\\\infty e d] \\n - [a \\\\infty e b, c \\\\infty e f] \
\\n + [a \\\\infty e b, d \\\\infty e f] \\n + [a \\\\infty e c, a b f \
\\\\infty] \\n + [a \\\\infty e c, a f b \\\\infty] \\n + [a \\\\infty e c, b \
d \\\\infty c] \\n - [a \\\\infty e c, b e \\\\infty f] \\n - [a \\\\infty e \
c, b \\\\infty c d] \\n - [a \\\\infty e c, b \\\\infty e f] \\n - [a \
\\\\infty e d, a b f \\\\infty] \\n - [a \\\\infty e d, a f b \\\\infty] \\n \
- [a \\\\infty e d, b c d \\\\infty] \\n + [a \\\\infty e d, b e \\\\infty c] \
\\n + [a \\\\infty e d, b e \\\\infty f] \\n + [a \\\\infty e d, b \\\\infty \
e c] \\n + [a \\\\infty e d, b \\\\infty e f] \\n + [a \\\\infty e f, a b c \
\\\\infty] \\n - [a \\\\infty e f, a b d \\\\infty] \\n - [a \\\\infty e f, b \
e \\\\infty c] \\n + [a \\\\infty e f, b e \\\\infty d] \\n - [a \\\\infty f \
b, a c \\\\infty e] \\n + [a \\\\infty f b, a d c \\\\infty] \\n - [a \
\\\\infty f b, a d \\\\infty c] \\n - [a \\\\infty f b, a e \\\\infty c] \\n \
+ [a \\\\infty f b, d f \\\\infty e] \\n + [a \\\\infty f b, d \\\\infty e f] \
\\n + [a \\\\infty f b, d \\\\infty f e] \\n + [a \\\\infty f c, b c \
\\\\infty d] \\n + [a \\\\infty f c, b d \\\\infty c] \\n - [a \\\\infty f c, \
b f \\\\infty d] \\n - [a \\\\infty f c, b \\\\infty f e] \\n + [a \\\\infty \
f c, d f \\\\infty e] \\n + [a \\\\infty f d, a b c \\\\infty] \\n + [a \
\\\\infty f d, b c d \\\\infty] \\n - [a \\\\infty f d, b d \\\\infty c] \\n \
- [a \\\\infty f d, b d \\\\infty e] \\n + 2 [a \\\\infty f d, b f \\\\infty \
e] \\n - [a \\\\infty f e, a b d \\\\infty] \\n - [a \\\\infty f e, a d c \
\\\\infty] \\n + 2 [a \\\\infty f e, b d \\\\infty e] \\n + [a \\\\infty f e, \
b e \\\\infty d] \\n - [a \\\\infty f e, b \\\\infty e d] \\n + [b c d \
\\\\infty, a b \\\\infty f] \\n + [b c d \\\\infty, a f \\\\infty d] \\n - [b \
c d \\\\infty, a \\\\infty e d] \\n + [b c d \\\\infty, a \\\\infty f d] \\n \
- [b c e \\\\infty, a b \\\\infty f] \\n + [b c \\\\infty d, a b \\\\infty f] \
\\n - [b c \\\\infty d, a e \\\\infty b] \\n - [b c \\\\infty d, a e \
\\\\infty c] \\n + [b c \\\\infty d, a f \\\\infty b] \\n + [b c \\\\infty d, \
a f \\\\infty d] \\n + [b c \\\\infty d, a \\\\infty c e] \\n + [b c \
\\\\infty d, a \\\\infty f c] \\n - [b c \\\\infty e, a \\\\infty c f] \\n - \
[b d c \\\\infty, a e d \\\\infty] \\n - [b d c \\\\infty, a e \\\\infty b] \
\\n + [b d c \\\\infty, a \\\\infty b e] \\n - [b d c \\\\infty, a \\\\infty \
b f] \\n - [b d c \\\\infty, a \\\\infty e b] \\n - [b d e \\\\infty, a f d \
\\\\infty] \\n + [b d e \\\\infty, a \\\\infty b c] \\n - [b d e \\\\infty, a \
\\\\infty d f] \\n - [b d f \\\\infty, a b c \\\\infty] \\n - [b d \\\\infty \
c, a e \\\\infty b] \\n - [b d \\\\infty c, a e \\\\infty d] \\n + [b d \
\\\\infty c, a \\\\infty d e] \\n - [b d \\\\infty c, a \\\\infty d f] \\n + \
[b d \\\\infty c, a \\\\infty e c] \\n + [b d \\\\infty c, a \\\\infty f c] \
\\n - [b d \\\\infty c, a \\\\infty f d] \\n + [b d \\\\infty e, a b \
\\\\infty f] \\n + [b d \\\\infty e, a d \\\\infty c] \\n - [b d \\\\infty e, \
a f \\\\infty d] \\n + [b d \\\\infty e, a \\\\infty c d] \\n - [b d \
\\\\infty e, a \\\\infty c e] \\n + [b d \\\\infty e, a \\\\infty d c] \\n - \
[b d \\\\infty e, a \\\\infty f d] \\n + 2 [b d \\\\infty e, a \\\\infty f e] \
\\n - [b d \\\\infty f, a \\\\infty d c] \\n - [b e c \\\\infty, a b \
\\\\infty f] \\n + [b e d \\\\infty, a b c \\\\infty] \\n - [b e d \\\\infty, \
a b f \\\\infty] \\n + [b e d \\\\infty, a b \\\\infty f] \\n - [b e d \
\\\\infty, a c d \\\\infty] \\n - [b e d \\\\infty, a d c \\\\infty] \\n - [b \
e d \\\\infty, a f b \\\\infty] \\n + [b e d \\\\infty, a \\\\infty b c] \\n \
+ [b e d \\\\infty, a \\\\infty b f] \\n - [b e d \\\\infty, a \\\\infty d f] \
\\n + [b e f \\\\infty, a b c \\\\infty] \\n + [b e f \\\\infty, a c \
\\\\infty f] \\n - [b e f \\\\infty, a d f \\\\infty] \\n - [b e f \\\\infty, \
a d \\\\infty f] \\n - [b e f \\\\infty, a f d \\\\infty] \\n - [b e f \
\\\\infty, a \\\\infty b c] \\n + [b e f \\\\infty, a \\\\infty c f] \\n - [b \
e f \\\\infty, a \\\\infty d f] \\n - [b e \\\\infty c, a \\\\infty c d] \\n \
+ [b e \\\\infty c, a \\\\infty e d] \\n - [b e \\\\infty c, a \\\\infty e f] \
\\n - [b e \\\\infty d, a c \\\\infty d] \\n + [b e \\\\infty d, a e \
\\\\infty c] \\n - [b e \\\\infty d, a f \\\\infty b] \\n + [b e \\\\infty d, \
a f \\\\infty d] \\n - [b e \\\\infty d, a f \\\\infty e] \\n - [b e \
\\\\infty d, a \\\\infty c e] \\n - [b e \\\\infty d, a \\\\infty d f] \\n + \
[b e \\\\infty d, a \\\\infty e f] \\n + [b e \\\\infty d, a \\\\infty f e] \
\\n - [b e \\\\infty f, a b \\\\infty d] \\n + [b e \\\\infty f, a c \
\\\\infty f] \\n - [b e \\\\infty f, a d f \\\\infty] \\n - [b e \\\\infty f, \
a d \\\\infty f] \\n + [b e \\\\infty f, a e \\\\infty d] \\n - [b e \
\\\\infty f, a f d \\\\infty] \\n - [b e \\\\infty f, a \\\\infty c e] \\n + \
2 [b e \\\\infty f, a \\\\infty c f] \\n - [b e \\\\infty f, a \\\\infty d f] \
\\n - [b e \\\\infty f, a \\\\infty e c] \\n + [b e \\\\infty f, a \\\\infty \
e d] \\n - [b f d \\\\infty, a b c \\\\infty] \\n + [b f d \\\\infty, a c \
\\\\infty d] \\n + [b f d \\\\infty, a \\\\infty c d] \\n + [b f e \\\\infty, \
a b \\\\infty d] \\n - [b f e \\\\infty, a \\\\infty b c] \\n + [b f e \
\\\\infty, a \\\\infty b d] \\n + [b f \\\\infty d, a c \\\\infty d] \\n + [b \
f \\\\infty d, a \\\\infty c d] \\n - [b f \\\\infty d, a \\\\infty f c] \\n \
+ [b f \\\\infty e, a f \\\\infty d] \\n - [b f \\\\infty e, a \\\\infty c e] \
\\n + [b f \\\\infty e, a \\\\infty c f] \\n + 2 [b f \\\\infty e, a \
\\\\infty f d] \\n - [b \\\\infty c d, a b e \\\\infty] \\n - [b \\\\infty c \
d, a e d \\\\infty] \\n - [b \\\\infty c d, a e \\\\infty c] \\n + [b \
\\\\infty c d, a \\\\infty c e] \\n - [b \\\\infty c d, a \\\\infty c f] \\n \
- [b \\\\infty c d, a \\\\infty e c] \\n + [b \\\\infty c e, a b f \\\\infty] \
\\n + [b \\\\infty c e, a f b \\\\infty] \\n - [b \\\\infty d c, a b e \
\\\\infty] \\n + [b \\\\infty d c, a b f \\\\infty] \\n + [b \\\\infty d c, a \
f b \\\\infty] \\n - [b \\\\infty d e, a c b \\\\infty] \\n - [b \\\\infty d \
e, a c \\\\infty b] \\n - [b \\\\infty d e, a d f \\\\infty] \\n + [b \
\\\\infty d e, a f b \\\\infty] \\n - [b \\\\infty d e, a f d \\\\infty] \\n \
- [b \\\\infty d e, a \\\\infty c b] \\n + [b \\\\infty d e, a \\\\infty d c] \
\\n + [b \\\\infty d f, a c b \\\\infty] \\n + [b \\\\infty e c, a b f \
\\\\infty] \\n + [b \\\\infty e c, a f b \\\\infty] \\n - [b \\\\infty e c, a \
\\\\infty c d] \\n + [b \\\\infty e c, a \\\\infty e d] \\n - [b \\\\infty e \
d, a b f \\\\infty] \\n - [b \\\\infty e d, a c \\\\infty b] \\n + [b \
\\\\infty e d, a e \\\\infty c] \\n - [b \\\\infty e d, a f \\\\infty e] \\n \
- [b \\\\infty e d, a \\\\infty c b] \\n - [b \\\\infty e d, a \\\\infty d f] \
\\n - [b \\\\infty e d, a \\\\infty f e] \\n + [b \\\\infty e f, a b c \
\\\\infty] \\n - [b \\\\infty e f, a b d \\\\infty] \\n - [b \\\\infty e f, a \
b \\\\infty d] \\n + [b \\\\infty e f, a c b \\\\infty] \\n - [b \\\\infty e \
f, a d b \\\\infty] \\n - [b \\\\infty e f, a d \\\\infty b] \\n + [b \
\\\\infty e f, a e \\\\infty d] \\n - [b \\\\infty e f, a \\\\infty d b] \\n \
- [b \\\\infty e f, a \\\\infty e c] \\n + [b \\\\infty e f, a \\\\infty e d] \
\\n + [b \\\\infty f d, a c b \\\\infty] \\n + [b \\\\infty f e, a b c \
\\\\infty] \\n - [b \\\\infty f e, a b d \\\\infty] \\n - [b \\\\infty f e, a \
d b \\\\infty] \\n - [b \\\\infty f e, a d \\\\infty b] \\n - [b \\\\infty f \
e, a \\\\infty d b] \\n - [b \\\\infty f e, a \\\\infty f c] \\n + [c d \
\\\\infty e, a b c \\\\infty] \\n - [c d \\\\infty e, a \\\\infty c f] \\n - \
[c d \\\\infty f, a b \\\\infty f] \\n - [c d \\\\infty f, a \\\\infty b f] \
\\n + [c e f \\\\infty, a b \\\\infty f] \\n + [c e f \\\\infty, a \\\\infty \
b f] \\n - [c e \\\\infty d, a \\\\infty c b] \\n + [c e \\\\infty d, a \
\\\\infty e b] \\n + [c e \\\\infty f, a b \\\\infty f] \\n + [c e \\\\infty \
f, a \\\\infty b f] \\n + [c f d \\\\infty, a \\\\infty c b] \\n - [c f e \
\\\\infty, a \\\\infty c b] \\n + [c f \\\\infty d, a f \\\\infty b] \\n - [c \
f \\\\infty e, a f \\\\infty b] \\n + [c \\\\infty d e, a b e \\\\infty] \\n \
- [c \\\\infty d e, a \\\\infty c b] \\n - [c \\\\infty d e, a \\\\infty c f] \
\\n + [c \\\\infty d e, a \\\\infty e b] \\n - [c \\\\infty e d, a \\\\infty \
c b] \\n + [c \\\\infty e d, a \\\\infty e b] \\n - [c \\\\infty e f, a \
\\\\infty e b] \\n - [c \\\\infty f e, a f \\\\infty b] \\n - [d e f \
\\\\infty, a \\\\infty b f] \\n + [d e \\\\infty f, a b d \\\\infty] \\n - [d \
e \\\\infty f, a c f \\\\infty] \\n - [d e \\\\infty f, a d \\\\infty b] \\n \
- [d e \\\\infty f, a f c \\\\infty] \\n - [d f e \\\\infty, a b \\\\infty d] \
\\n + [d f e \\\\infty, a d \\\\infty c] \\n - [d f e \\\\infty, a \\\\infty \
b d] \\n - [d f \\\\infty e, a \\\\infty d b] \\n + [d f \\\\infty e, a \
\\\\infty f b] \\n + [d f \\\\infty e, a \\\\infty f c] \\n - [d \\\\infty e \
f, a c \\\\infty d] \\n - [d \\\\infty e f, a d \\\\infty b] \\n - [d \
\\\\infty e f, a \\\\infty c d] \\n - [d \\\\infty e f, a \\\\infty d b] \\n \
+ [d \\\\infty e f, a \\\\infty e b] \\n + [d \\\\infty e f, a \\\\infty f b] \
\\n + [d \\\\infty f e, a f \\\\infty b] \\n - [d \\\\infty f e, a \\\\infty \
d b] \\n + [d \\\\infty f e, a \\\\infty f b] )\"\>"], "Output",
 CellChangeTimes->{{3.697615488555046*^9, 3.6976154935725517`*^9}, 
   3.697616189599332*^9, 3.69764429529029*^9}]
}, Open  ]]
},
WindowSize->{752, 778},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
ShowSelection->True,
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (September 21, 2016)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 175, 3, 30, "Input"],
Cell[735, 25, 232, 6, 30, "Input"],
Cell[970, 33, 17468, 472, 1716, "Input"],
Cell[18441, 507, 572, 13, 50, "Input"],
Cell[19016, 522, 222, 5, 30, "Input"],
Cell[19241, 529, 1107, 30, 50, "Input"],
Cell[CellGroupData[{
Cell[20373, 563, 392, 9, 30, "Input"],
Cell[20768, 574, 584, 7, 44, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21389, 586, 941, 18, 50, "Input"],
Cell[22333, 606, 364, 5, 44, "Output"]
}, Open  ]],
Cell[22712, 614, 218, 5, 30, "Input"],
Cell[22933, 621, 893, 18, 30, "Input"],
Cell[23829, 641, 575, 14, 30, "Input"],
Cell[CellGroupData[{
Cell[24429, 659, 518, 12, 30, "Input"],
Cell[24950, 673, 512, 7, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25499, 685, 962, 22, 69, "Input"],
Cell[26464, 709, 228, 4, 30, "Output"]
}, Open  ]],
Cell[26707, 716, 945, 14, 30, "Input"],
Cell[CellGroupData[{
Cell[27677, 734, 180, 3, 30, "Input"],
Cell[27860, 739, 175963, 4344, 269, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[203860, 5088, 205, 3, 30, "Input"],
Cell[204068, 5093, 1093, 15, 259, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[205198, 5113, 694, 12, 30, "Input"],
Cell[205895, 5127, 8870, 115, 5845, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[214802, 5247, 595, 9, 30, "Input"],
Cell[215400, 5258, 12064, 159, 5845, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[227501, 5422, 544, 8, 30, "Input"],
Cell[228048, 5432, 9260, 120, 5845, "Output"]
}, Open  ]],
Cell[237323, 5555, 214, 5, 30, "Input"],
Cell[237540, 5562, 752, 16, 30, "Input"],
Cell[238295, 5580, 604, 15, 30, "Input"],
Cell[CellGroupData[{
Cell[238924, 5599, 499, 12, 30, "Input"],
Cell[239426, 5613, 515, 8, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[239978, 5626, 241, 4, 30, "Input"],
Cell[240222, 5632, 617, 9, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[240876, 5646, 808, 20, 69, "Input"],
Cell[241687, 5668, 249, 3, 30, "Output"]
}, Open  ]],
Cell[241951, 5674, 994, 15, 30, "Input"],
Cell[CellGroupData[{
Cell[242970, 5693, 272, 6, 30, "Input"],
Cell[243245, 5701, 59124, 1467, 182, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[302406, 7173, 155, 2, 30, "Input"],
Cell[302564, 7177, 819, 11, 259, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[303420, 7193, 166, 3, 30, "Input"],
Cell[303589, 7198, 3782, 48, 2159, "Output"]
}, Open  ]],
Cell[307386, 7249, 374, 8, 50, "Input"],
Cell[307763, 7259, 246, 6, 30, "Input"],
Cell[CellGroupData[{
Cell[308034, 7269, 336, 5, 30, "Input"],
Cell[308373, 7276, 880, 12, 50, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[309290, 7293, 214, 3, 30, "Input"],
Cell[309507, 7298, 643, 9, 88, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[310187, 7312, 137, 2, 30, "Input"],
Cell[310327, 7316, 567, 8, 50, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[310931, 7329, 136, 2, 30, "Input"],
Cell[311070, 7333, 584, 9, 88, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[311691, 7347, 139, 2, 30, "Input"],
Cell[311833, 7351, 630, 9, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[312500, 7365, 144, 2, 30, "Input"],
Cell[312647, 7369, 799, 11, 259, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[313483, 7385, 190, 3, 30, "Input"],
Cell[313676, 7390, 783, 10, 259, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[314496, 7405, 137, 2, 30, "Input"],
Cell[314636, 7409, 850, 12, 354, "Output"]
}, Open  ]],
Cell[315501, 7424, 362, 8, 30, "Input"],
Cell[315866, 7434, 882, 17, 69, "Input"],
Cell[316751, 7453, 295, 6, 30, "Input"],
Cell[CellGroupData[{
Cell[317071, 7463, 200, 3, 30, "Input"],
Cell[317274, 7468, 368, 5, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[317679, 7478, 951, 21, 69, "Input"],
Cell[318633, 7501, 176, 3, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[318846, 7509, 170, 3, 30, "Input"],
Cell[319019, 7514, 127066, 3120, 70, "Print"]
}, Open  ]],
Cell[CellGroupData[{
Cell[446122, 10639, 173, 3, 30, "Input"],
Cell[446298, 10644, 498, 7, 107, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[446833, 10656, 220, 4, 30, "Input"],
Cell[447056, 10662, 6908, 89, 4610, "Output"]
}, Open  ]],
Cell[453979, 10754, 400, 10, 30, "Input"],
Cell[CellGroupData[{
Cell[454404, 10768, 215, 3, 30, "Input"],
Cell[454622, 10773, 1523, 20, 962, "Output"]
}, Open  ]],
Cell[456160, 10796, 330, 7, 30, "Input"],
Cell[456493, 10805, 640, 15, 50, "Input"],
Cell[CellGroupData[{
Cell[457158, 10824, 141, 2, 30, "Input"],
Cell[457302, 10828, 370, 6, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[457709, 10839, 846, 20, 69, "Input"],
Cell[458558, 10861, 176, 3, 30, "Output"]
}, Open  ]],
Cell[458749, 10867, 3981, 98, 316, "Input"],
Cell[CellGroupData[{
Cell[462755, 10969, 2402, 58, 240, "Input"],
Cell[465160, 11029, 712, 10, 221, "Output"]
}, Open  ]],
Cell[465887, 11042, 4041, 99, 316, "Input"],
Cell[469931, 11143, 1164, 22, 69, "Input"],
Cell[CellGroupData[{
Cell[471120, 11169, 109, 1, 30, "Input"],
Cell[471232, 11172, 88287, 1135, 46695, "Output"]
}, Open  ]]
}
]
*)

